"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.arrayItemKeyFunctions = exports.arrayKeyFunctions = exports.ArrayFieldTemplateWithoutKeyHandling = exports.onDelete = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require("babel-runtime/helpers/get");

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

exports.beforeAdd = beforeAdd;
exports.getButton = getButton;
exports.getButtons = getButtons;
exports.getButtonElems = getButtonElems;
exports.getButtonsForPosition = getButtonsForPosition;
exports.handlesArrayKeys = handlesArrayKeys;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _components = require("./components");

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _utils = require("../utils");

var _reactBootstrap = require("react-bootstrap");

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

var _reactSortableHoc = require("react-sortable-hoc");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function onAdd(e, props) {
	if (!(0, _utils.canAdd)(props)) return;
	props.onAddClick(e);
	(0, _setImmediate3.default)(function () {
		return new _Context2.default(props.formContext.contextId).sendCustomEvent(props.idSchema.$id, "resize");
	});
}

var onDelete = exports.onDelete = function onDelete(item, props) {
	return function (e) {
		item.onDropIndexClick(item.index)(e);
		(0, _setImmediate3.default)(function () {
			return new _Context2.default(props.formContext.contextId).sendCustomEvent(props.idSchema.$id, "resize");
		});
	};
};

function beforeAdd(props) {
	if (!(0, _utils.canAdd)(props)) return;
	var contextId = props.formContext.contextId;

	var startIdx = props.startIdx || (0, _utils.getUiOptions)(props.uiSchema).startIdx;

	var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema || {}),
	    _getUiOptions$idToScr = _getUiOptions.idToScrollAfterAdd,
	    idToScrollAfterAdd = _getUiOptions$idToScr === undefined ? props.idSchema.$id + "-add" : _getUiOptions$idToScr,
	    idxOffsets = _getUiOptions.idxOffsets,
	    totalOffset = _getUiOptions.totalOffset;

	var idx = (props.items || props.formData || []).length;
	var offset = startIdx !== undefined ? startIdx : idxOffsets ? (0, _utils.getIdxWithOffset)(idx, idxOffsets, totalOffset) - idx : 0;
	idx = offset + idx;
	var idToFocus = props.idSchema.$id + "_" + idx;
	new _Context2.default(contextId).idToFocus = idToFocus;
	new _Context2.default(contextId).idToScroll = idToScrollAfterAdd;
}

var buttonDefinitions = {
	add: {
		glyph: "plus",
		fn: function fn(e) {
			return function (props) {
				onAdd(e, props);
			};
		},
		beforeFn: beforeAdd
	}
};

function getButton(button) {
	var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	function handleButton(button) {
		function rulesSatisfied() {
			var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			return (0, _keys2.default)(rules || {}).every(function (ruleName) {
				var ruleVal = rules[ruleName];
				if (ruleName === "minLength") {
					return (props.formData || []).length >= ruleVal;
				} else if (ruleName === "canAdd") {
					return button.id && button.id !== props.idSchema.$id || (0, _utils.canAdd)(props);
				}
			});
		}

		var fnName = button.fnName || button.fn;
		var _buttonDefinitions = props.uiSchema && (0, _utils.getUiOptions)(props.uiSchema).buttonDefinitions ? (0, _deepmerge2.default)(buttonDefinitions, (0, _utils.getUiOptions)(props.uiSchema).buttonDefinitions) : buttonDefinitions;
		var definition = _buttonDefinitions[fnName];
		var _button = (0, _extends3.default)({}, definition || {}, button);

		if (!rulesSatisfied(_button.rules)) return;

		if (!_button.fnName) _button.fnName = fnName;
		if (definition && typeof _button.fn !== "function") _button.fn = _buttonDefinitions[fnName].fn;
		if (fnName !== "add" || (0, _utils.getUiOptions)(props.uiSchema).renderAdd !== false && (button.id && button.id !== props.idSchema.$id || (0, _utils.canAdd)(props))) return _button;
	}

	button = handleButton(button);

	if (!button) return;

	var _button2 = button,
	    fn = _button2.fn,
	    fnName = _button2.fnName,
	    glyph = _button2.glyph,
	    label = _button2.label,
	    className = _button2.className,
	    callforward = _button2.callforward,
	    beforeFn = _button2.beforeFn,
	    callback = _button2.callback,
	    render = _button2.render,
	    _button2$bsStyle = _button2.bsStyle,
	    bsStyle = _button2$bsStyle === undefined ? "primary" : _button2$bsStyle,
	    tooltip = _button2.tooltip,
	    tooltipPlacement = _button2.tooltipPlacement,
	    tooltipClass = _button2.tooltipClass,
	    changesFormData = _button2.changesFormData,
	    key = _button2.key,
	    disabled = _button2.disabled,
	    help = _button2.help,
	    options = (0, _objectWithoutProperties3.default)(_button2, ["fn", "fnName", "glyph", "label", "className", "callforward", "beforeFn", "callback", "render", "bsStyle", "tooltip", "tooltipPlacement", "tooltipClass", "changesFormData", "key", "disabled", "help"]);

	var id = button.id || (props.idSchema || {}).$id;

	label = label !== undefined ? glyph ? " " + label : label : "";

	var onClick = function onClick(e) {
		var onClickProps = button.getProps ? button.getProps() : props;
		var _fn = function _fn() {
			return fn(e)(onClickProps, options);
		};
		var __fn = function __fn() {
			beforeFn && beforeFn(onClickProps, options);
			_fn();
			callback && callback();
		};
		if (callforward) {
			e.persist();
			callforward(__fn);
		} else {
			__fn();
		}
	};

	var buttonId = id + "-" + fnName + (key ? "-" + key : "");
	return render ? render(onClick, button) : _react2.default.createElement(
		_components.Button,
		{ key: buttonId, id: buttonId, className: className, onClick: onClick, bsStyle: bsStyle, tooltip: tooltip || help, tooltipPlacement: tooltipPlacement, tooltipClass: tooltipClass, disabled: disabled || (fnName === "add" || changesFormData) && (props.disabled || props.readonly), style: button.style },
		glyph && _react2.default.createElement("i", { className: "glyphicon glyphicon-" + glyph }),
		_react2.default.createElement(
			"strong",
			null,
			glyph ? " " + label : label
		),
		help && _react2.default.createElement(_components.Help, null)
	);
}

function getButtons() {
	var buttons = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	var addBtnAdded = buttons.some(function (button) {
		return button.fn === "add";
	});

	if (!addBtnAdded && (!props || (0, _utils.canAdd)(props))) buttons = [{ fn: "add", id: props.idSchema.$id }].concat((0, _toConsumableArray3.default)(buttons));
	return buttons;
}

function getButtonElems() {
	var buttons = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	buttons = getButtons(buttons, props);
	var buttonElems = buttons.map(function (button) {
		return getButton(button, props);
	});

	if (props.uiSchema["ui:buttons"]) {
		buttonElems = [].concat((0, _toConsumableArray3.default)(buttonElems), (0, _toConsumableArray3.default)(props.uiSchema["ui:buttons"]));
	}

	return getButtonsElem(buttonElems, props);
}

function getButtonsElem() {
	var buttonElems = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	if (!Array.isArray(buttonElems) || buttonElems.length === 0) {
		return null;
	}

	return _react2.default.createElement(
		_reactBootstrap.ButtonToolbar,
		{ className: (0, _utils.getUiOptions)(props.uiSchema)["ui:buttonsDesktopLayout"] ? "desktop-layout" : undefined, key: "buttons" },
		buttonElems
	);
}

function getButtonsForPosition(props) {
	var buttonDescriptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
	var position = arguments[2];
	var defaultPosition = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "bottom";

	buttonDescriptions = buttonDescriptions.filter(function (button) {
		return button.position === position || !button.position && position === defaultPosition;
	});
	return buttonDescriptions && buttonDescriptions.length ? buttonDescriptions.map(function (buttonDescription) {
		return getButton(buttonDescription, props);
	}).filter(function (button) {
		return button;
	}) : null;
}

function handlesArrayKeys(ComposedComponent) {
	var _class, _temp2;

	return _temp2 = _class = function (_ComposedComponent) {
		(0, _inherits3.default)(ArrayFieldTemplateField, _ComposedComponent);

		function ArrayFieldTemplateField() {
			var _ref;

			var _temp, _this, _ret;

			(0, _classCallCheck3.default)(this, ArrayFieldTemplateField);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ArrayFieldTemplateField.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField)).call.apply(_ref, [this].concat(args))), _this), _this.onFocus = function (target) {
				var context = new _Context2.default(_this.props.formContext.contextId);
				if (target === "last") {
					context.idToFocus = _this.props.idSchema.$id + "_" + (_this.props.formData.length - 1);
					context.idToScroll = "_laji-form_" + _this.props.formContext.contextId + "_" + _this.props.idSchema.$id + "_" + (_this.props.formData.length - 2);
				} else {
					console.warn("custom event \"focus\" has only \"last\" implemented. Target value was: " + target);
				}
			}, _this.onCopy = function () {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				var _options$type = options.type,
				    type = _options$type === undefined ? "blacklist" : _options$type,
				    _options$filter = options.filter,
				    filter = _options$filter === undefined ? [] : _options$filter;

				var _getUiOptions2 = (0, _utils.getUiOptions)(_this.props.uiSchema),
				    _getUiOptions2$button = _getUiOptions2.buttonDefinitions,
				    buttonDefinitions = _getUiOptions2$button === undefined ? {} : _getUiOptions2$button;

				var copy = buttonDefinitions.copy;

				if (copy) {
					copy.fn()(_this.props, { type: type, filter: filter });
					if (copy.callback) {
						copy.callback();
					}
				}
			}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
		}

		(0, _createClass3.default)(ArrayFieldTemplateField, [{
			key: "componentDidMount",
			value: function componentDidMount() {
				this.addKeyHandlers(this.props);
				this.addChildKeyHandlers(this.props);
				this.addCustomEventListeners(this.props);
				if ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentDidMount", this)) (0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentDidMount", this).call(this);
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate(prevProps, prevState) {
				this.removeKeyHandlers(prevProps);
				this.addKeyHandlers(this.props);
				this.removeChildKeyHandlers(prevProps);
				this.addChildKeyHandlers(this.props);
				this.removeCustomEventListeners(prevProps);
				this.addCustomEventListeners(this.props);
				if ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentDidUpdate", this)) (0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentDidUpdate", this).call(this, prevProps, prevState);
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				this.removeKeyHandlers(this.props);
				this.removeChildKeyHandlers(this.props);
				this.removeCustomEventListeners(this.props);
				if ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentWillUnmount", this)) (0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "componentWillUnmount", this).call(this);
			}
		}, {
			key: "addKeyHandlers",
			value: function addKeyHandlers() {
				var context = new _Context2.default(this.props.formContext.contextId);

				var _call = ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "getKeyHandlers", this) || this.getKeyHandlers).call(this, this.props),
				    _call2 = (0, _slicedToArray3.default)(_call, 2),
				    keys = _call2[0],
				    options = _call2[1];

				this.arrayKeyFunctions = keys;
				context.addKeyHandler(this.props.idSchema.$id, keys, options);
			}
		}, {
			key: "removeKeyHandlers",
			value: function removeKeyHandlers(props) {
				var context = new _Context2.default(props.formContext.contextId);
				context.removeKeyHandler(props.idSchema.$id, this.arrayKeyFunctions);
			}
		}, {
			key: "getKeyHandlers",
			value: function getKeyHandlers(props) {
				var _this2 = this;

				var _getUiOptions3 = (0, _utils.getUiOptions)(props.uiSchema),
				    _arrayKeyFunctions = _getUiOptions3.arrayKeyFunctions;

				return [_arrayKeyFunctions ? (0, _extends3.default)({}, _arrayKeyFunctions) : (0, _extends3.default)({}, arrayKeyFunctions), {
					getProps: function getProps() {
						return _this2.props;
					}
				}];
			}
		}, {
			key: "addChildKeyHandlers",
			value: function addChildKeyHandlers(props) {
				var context = new _Context2.default(props.formContext.contextId);
				this.childKeyHandlers = ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "getChildKeyHandlers", this) || this.getChildKeyHandlers).call(this, props);
				this.childKeyHandlers.forEach(function (handler) {
					context.addKeyHandler.apply(context, (0, _toConsumableArray3.default)(handler));
				});
			}
		}, {
			key: "removeChildKeyHandlers",
			value: function removeChildKeyHandlers(props) {
				var context = new _Context2.default(props.formContext.contextId);
				this.childKeyHandlers.forEach(function (handler) {
					context.removeKeyHandler.apply(context, (0, _toConsumableArray3.default)(handler));
				});
			}
		}, {
			key: "getChildKeyHandlers",
			value: function getChildKeyHandlers(props) {
				var _this3 = this;

				return props.items.map(function (item, i) {
					var id = props.idSchema.$id + "_" + i;
					return [id, arrayItemKeyFunctions, { getProps: function getProps() {
							return _this3.props;
						}, id: id, getDeleteButton: function getDeleteButton() {
							return _this3.deleteButtonRefs[i];
						} }];
				});
			}
		}, {
			key: "getCustomEventListeners",
			value: function getCustomEventListeners() {
				return [["focus", this.onFocus], ["copy", this.onCopy]];
			}
		}, {
			key: "addCustomEventListeners",
			value: function addCustomEventListeners(props) {
				var context = new _Context2.default(props.formContext.contextId);
				var customEventListeners = ((0, _get3.default)(ArrayFieldTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateField.prototype), "getCustomEventListeners", this) || this.getCustomEventListeners).call(this, props);
				this.customEventListeners = customEventListeners;
				customEventListeners.forEach(function (params) {
					return context.addCustomEventListener.apply(context, [props.idSchema.$id].concat((0, _toConsumableArray3.default)(params)));
				});
			}
		}, {
			key: "removeCustomEventListeners",
			value: function removeCustomEventListeners(props) {
				var context = new _Context2.default(props.formContext.contextId);
				this.customEventListeners.forEach(function (params) {
					return context.removeCustomEventListener.apply(context, [props.idSchema.$id].concat((0, _toConsumableArray3.default)(params)));
				});
			}
		}]);
		return ArrayFieldTemplateField;
	}(ComposedComponent), _class.displayName = (0, _utils.getReactComponentName)(ComposedComponent), _temp2;
}

var SortableList = (0, _reactSortableHoc.SortableContainer)(function (_ref2) {
	var items = _ref2.items,
	    itemProps = _ref2.itemProps,
	    nonOrderables = _ref2.nonOrderables,
	    formData = _ref2.formData;
	return _react2.default.createElement(
		"div",
		null,
		items.map(function (item, i) {
			return _react2.default.createElement(SortableItem, { key: (0, _utils.isObject)(formData[i]) ? (0, _utils.getUUID)(formData[i]) : i, index: i, item: item, disabled: !itemProps[i].hasMoveDown && !itemProps[i].hasMoveUp || nonOrderables.indexOf(i) !== -1 });
		})
	);
});

var SortableItem = (0, _reactSortableHoc.SortableElement)(function (_ref3) {
	var item = _ref3.item;
	return item;
});

var ArrayFieldTemplateWithoutKeyHandling = exports.ArrayFieldTemplateWithoutKeyHandling = function (_Component) {
	(0, _inherits3.default)(ArrayFieldTemplateWithoutKeyHandling, _Component);

	function ArrayFieldTemplateWithoutKeyHandling() {
		var _ref4;

		var _temp3, _this4, _ret2;

		(0, _classCallCheck3.default)(this, ArrayFieldTemplateWithoutKeyHandling);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp3 = (_this4 = (0, _possibleConstructorReturn3.default)(this, (_ref4 = ArrayFieldTemplateWithoutKeyHandling.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldTemplateWithoutKeyHandling)).call.apply(_ref4, [this].concat(args))), _this4), _this4.onSort = function (_ref5) {
			var oldIndex = _ref5.oldIndex,
			    newIndex = _ref5.newIndex;

			_this4.props.items[oldIndex].onReorderClick(oldIndex, newIndex)();
		}, _this4.onFocuses = [], _this4.getOnFocus = function (i) {
			return function () {
				new _Context2.default(_this4.props.formContext.contextId)[_this4.props.idSchema.$id + ".activeIdx"] = i + ((0, _utils.getUiOptions)(_this4.props.uiSchema).startIdx || 0);
			};
		}, _temp3), (0, _possibleConstructorReturn3.default)(_this4, _ret2);
	}

	(0, _createClass3.default)(ArrayFieldTemplateWithoutKeyHandling, [{
		key: "render",
		value: function render() {
			var _this5 = this;

			var props = this.props;

			var _getUiOptions4 = (0, _utils.getUiOptions)(props.uiSchema),
			    confirmDelete = _getUiOptions4.confirmDelete,
			    renderTitleAsLabel = _getUiOptions4.renderTitleAsLabel,
			    deleteCorner = _getUiOptions4.deleteCorner,
			    _getUiOptions4$remova = _getUiOptions4.removable,
			    removable = _getUiOptions4$remova === undefined ? true : _getUiOptions4$remova,
			    orderable = _getUiOptions4.orderable,
			    _getUiOptions4$nonRem = _getUiOptions4.nonRemovables,
			    nonRemovables = _getUiOptions4$nonRem === undefined ? [] : _getUiOptions4$nonRem,
			    _getUiOptions4$nonOrd = _getUiOptions4.nonOrderables,
			    nonOrderables = _getUiOptions4$nonOrd === undefined ? [] : _getUiOptions4$nonOrd,
			    deleteHelp = _getUiOptions4["ui:deleteHelp"],
			    titleFormatters = _getUiOptions4.titleFormatters,
			    _getUiOptions4$button = _getUiOptions4.buttons,
			    buttons = _getUiOptions4$button === undefined ? [] : _getUiOptions4$button;

			var _props2 = this.props,
			    readonly = _props2.readonly,
			    disabled = _props2.disabled;
			var Label = this.props.formContext.Label;

			var Title = renderTitleAsLabel ? Label : props.TitleField;
			var Description = props.DescriptionField;
			if (!this.deleteButtonRefs) this.deleteButtonRefs = [];

			var _buttons = getButtons(buttons, props);

			var topButtons = getButtonsElem(getButtonsForPosition(props, _buttons, "top"), props);
			var bottomButtons = getButtonsElem(getButtonsForPosition(props, _buttons, "bottom"), props);

			var getRefFor = function getRefFor(i) {
				return function (elem) {
					_this5.deleteButtonRefs[i] = elem;
				};
			};

			var items = props.items.map(function (item, i) {
				var getDeleteButton = function getDeleteButton() {
					return _react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-buttons" },
						_react2.default.createElement(_components.DeleteButton, { id: props.idSchema.$id + "_" + i,
							disabled: disabled || readonly,
							ref: getRefFor(i),
							onClick: onDelete(item, props),
							confirm: confirmDelete,
							corner: deleteCorner,
							tooltip: deleteHelp,
							translations: props.formContext.translations })
					);
				};
				if (!_this5.onFocuses[i]) {
					_this5.onFocuses[i] = _this5.getOnFocus(i);
				}

				return _react2.default.createElement(
					"div",
					{ key: (0, _utils.getUUID)(props.formData[i]) || item.key, className: "laji-form-field-template-item keep-vertical field-array-row", onFocus: _this5.onFocuses[i] },
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-schema" },
						item.children
					),
					item.hasRemove && !(nonRemovables.indexOf(item.index) !== -1) && removable && getDeleteButton()
				);
			});

			var title = "ui:title" in props.uiSchema ? props.uiSchema["ui:title"] : props.title;

			return _react2.default.createElement(
				"div",
				{ className: props.className },
				_react2.default.createElement(Title, { title: title, label: title, help: props.uiSchema["ui:help"], formatters: titleFormatters }),
				topButtons,
				props.description && _react2.default.createElement(Description, { description: props.description }),
				orderable ? _react2.default.createElement(SortableList, { helperClass: "laji-form reorder-active",
					distance: 5,
					items: items,
					formData: props.formData,
					onSortEnd: this.onSort,
					itemProps: props.items,
					nonOrderables: nonOrderables }) : items,
				bottomButtons
			);
		}
	}]);
	return ArrayFieldTemplateWithoutKeyHandling;
}(_react.Component);

exports.default = handlesArrayKeys(ArrayFieldTemplateWithoutKeyHandling);
var arrayKeyFunctions = exports.arrayKeyFunctions = {
	navigateArray: function navigateArray(e, _ref6) {
		var reverse = _ref6.reverse,
		    getProps = _ref6.getProps,
		    navigateCallforward = _ref6.navigateCallforward,
		    getCurrentIdx = _ref6.getCurrentIdx,
		    focusByIdx = _ref6.focusByIdx,
		    getIdToScrollAfterNavigate = _ref6.getIdToScrollAfterNavigate;

		function focusIdx(idx, prop) {
			function callback() {
				var options = (0, _utils.getUiOptions)(getProps().uiSchema);
				var _options$focusOnNavig = options.focusOnNavigate,
				    focusOnNavigate = _options$focusOnNavig === undefined ? true : _options$focusOnNavig,
				    idToFocusAfterNavigate = options.idToFocusAfterNavigate,
				    _options$keepPropFocu = options.keepPropFocusOnNavigate,
				    keepPropFocusOnNavigate = _options$keepPropFocu === undefined ? false : _options$keepPropFocu;

				var idByIdx = getProps().idSchema.$id + "_" + idx;
				var _idToFocusAfterNavigate = idToFocusAfterNavigate || prop && keepPropFocusOnNavigate ? idByIdx + "_" + prop : idByIdx;
				var idToScrollAfterNavigate = options.idToScrollAfterNavigate ? options.idToScrollAfterNavigate : getIdToScrollAfterNavigate ? getIdToScrollAfterNavigate() : undefined;
				(0, _utils.focusAndScroll)(getProps().formContext, _idToFocusAfterNavigate, idToScrollAfterNavigate, focusOnNavigate);
			}
			if (focusByIdx) {
				focusByIdx(idx, prop, callback);
			} else {
				callback();
			}
		}

		var nearestSchemaElemId = (0, _utils.findNearestParentSchemaElemId)(getProps().formContext.contextId, document.activeElement);
		// Should contain all nested array item ids. We want the last one, which is focused.
		var activeItemQuery = nearestSchemaElemId.match(new RegExp(getProps().idSchema.$id + "_\\d+", "g"));
		var focusedIdx = activeItemQuery ? (0, _utils.getIdxWithoutOffset)(+activeItemQuery[0].replace(/^.*_(\d+)$/, "$1"), (0, _utils.getUiOptions)(getProps().uiSchema).idxOffsets) : undefined;
		var lastId = nearestSchemaElemId.substring((getProps().idSchema.$id + "_" + focusedIdx).length + 1, nearestSchemaElemId.length);
		var focusedProp = isNaN(lastId) ? lastId : undefined;

		var currentIdx = getCurrentIdx ? getCurrentIdx() : focusedIdx;

		var arrayLength = getProps().formData ? getProps().formData.length : 0;

		if ((0, _utils.isNullOrUndefined)(currentIdx) && arrayLength > 0) {
			focusIdx(reverse ? arrayLength - 1 : 0, focusedProp);
			return true;
		} else {
			var amount = 0;
			if (focusedIdx === currentIdx) amount = reverse ? -1 : 1;

			var nextIdx = currentIdx + amount;

			if (amount === 0 || amount < 0 && nextIdx >= 0 || amount > 0 && nextIdx < arrayLength) {
				if (navigateCallforward) {
					e.persist();
					navigateCallforward(function () {
						return focusIdx(nextIdx, focusedProp);
					}, nextIdx);
				} else {
					focusIdx(nextIdx, focusedProp);
				}
				return true;
			}
		}
		return false;
	},
	insert: function insert(e, _props) {
		var getProps = _props.getProps,
		    insertCallforward = _props.insertCallforward;

		var props = getProps();
		function afterInsert() {
			onAdd(e, props);
		}

		if (!props.disabled && !props.readonly && (0, _utils.canAdd)(props) && (0, _utils.getUiOptions)(props.uiSchema).canAddByKey !== false) {
			if (e.target) {
				e.target.blur();
			}
			if (insertCallforward) {
				e.persist();
				beforeAdd(props);
				insertCallforward(function () {
					afterInsert();
				});
			} else {
				beforeAdd(props);
				afterInsert();
			}
			return true;
		}
		return false;
	}
};

var arrayItemKeyFunctions = exports.arrayItemKeyFunctions = {
	delete: function _delete(e, _ref7) {
		var getDeleteButton = _ref7.getDeleteButton,
		    id = _ref7.id,
		    getProps = _ref7.getProps;

		var _getProps = getProps(),
		    items = _getProps.items,
		    idSchema = _getProps.idSchema,
		    formContext = _getProps.formContext,
		    readonly = _getProps.readonly,
		    disabled = _getProps.disabled;

		var getFormRef = formContext.getFormRef,
		    contextId = formContext.contextId;


		if (readonly || disabled || !(0, _utils.isDescendant)((0, _utils.getSchemaElementById)(contextId, id), e.target)) {
			return;
		}

		if (!getDeleteButton) return;

		var deleteButton = getDeleteButton();
		if (!deleteButton || !deleteButton.onClick) return;

		var activeId = (0, _utils.findNearestParentSchemaElemId)(contextId, document.activeElement);
		var idxsMatch = activeId.match(/_\d+/g);
		var idx = +idxsMatch[idxsMatch.length - 1].replace("_", "");
		var elem = (0, _utils.getSchemaElementById)(contextId, idSchema.$id + "_" + idx);
		var prevElem = elem ? (0, _utils.getNextInput)(getFormRef(), (0, _utils.getTabbableFields)(elem)[0], !!"reverse") : null;

		deleteButton.onClick(e, function (deleted) {
			if (deleted) {
				var idxToFocus = idx === items.length - 1 ? idx - 1 : idx;
				if (idxToFocus >= 0) {
					(0, _utils.focusById)(formContext, idSchema.$id + "_" + idxToFocus);
				} else if (prevElem) {
					prevElem.focus();
				}
			} else {
				(0, _utils.focusById)(formContext, "" + activeId);
			}
		});
		return true;
	}
};