"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _components = require("./components");

var _reactBootstrap = require("react-bootstrap");

var _utils = require("../utils");

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ErrorListTemplate = function (_Component) {
	(0, _inherits3.default)(ErrorListTemplate, _Component);

	function ErrorListTemplate(props) {
		(0, _classCallCheck3.default)(this, ErrorListTemplate);

		var _this = (0, _possibleConstructorReturn3.default)(this, (ErrorListTemplate.__proto__ || (0, _getPrototypeOf2.default)(ErrorListTemplate)).call(this, props));

		_this.expand = function () {
			if (!_this.state.popped) _this.setState({ popped: true });
			_this.refs.errorPanel.expand();
			_this.refs.warningPanel.expand();
		};

		_this.poppedToggle = function (e) {
			e.stopPropagation();
			_this.setState({ popped: !_this.state.popped, poppedTouched: true });
		};

		_this.revalidate = function () {
			var that = new _Context2.default(_this.props.formContext.contextId).formInstance;
			that.validate();
			_this.refs.errorPanel.expand();
			_this.refs.warningPanel.expand();
		};

		_this.submitWithWarnings = function () {
			var that = new _Context2.default(_this.props.formContext.contextId).formInstance;
			that.validateAndSubmit(!"warnings");
		};

		_this.state = { popped: false };
		new _Context2.default(_this.props.formContext.contextId).errorList = _this;
		return _this;
	}

	(0, _createClass3.default)(ErrorListTemplate, [{
		key: "render",
		value: function render() {
			var _props = this.props,
			    errorSchema = _props.errorSchema,
			    schema = _props.schema,
			    formContext = _props.formContext,
			    uiSchema = _props.uiSchema;
			var disabled = uiSchema["ui:disabled"],
			    readonly = uiSchema["ui:readonly"];
			var contextId = formContext.contextId,
			    translations = formContext.translations;

			var that = new _Context2.default(contextId).formInstance;
			var clickHandler = that.errorClickHandler;

			function walkErrors(path, id, errorSchema) {
				var __errors = errorSchema.__errors,
				    properties = (0, _objectWithoutProperties3.default)(errorSchema, ["__errors"]);

				var _reduce = (__errors || []).reduce(function (_ref, _error) {
					var errors = _ref.errors,
					    warnings = _ref.warnings;

					var _schema = (0, _utils.parseJSONPointer)(schema, path);
					if (_error.indexOf("[warning]") !== -1) {
						warnings.push({
							label: _schema.title,
							error: (0, _utils.formatErrorMessage)(_error),
							id: id
						});
					} else {
						errors.push({
							label: _schema.title,
							error: (0, _utils.formatErrorMessage)(_error),
							id: id
						});
					}
					return { errors: errors, warnings: warnings };
				}, { errors: [], warnings: [] }),
				    errors = _reduce.errors,
				    warnings = _reduce.warnings;

				(0, _keys2.default)(properties).forEach(function (prop) {
					var _path = path;
					if (prop.match(/^\d+$/)) _path = _path + "/items";else _path = _path + "/properties/" + prop;
					var childErrors = walkErrors(_path, id + "_" + prop, errorSchema[prop]);
					errors = [].concat((0, _toConsumableArray3.default)(errors), (0, _toConsumableArray3.default)(childErrors.errors));
					warnings = [].concat((0, _toConsumableArray3.default)(warnings), (0, _toConsumableArray3.default)(childErrors.warnings));
				});
				return { errors: errors, warnings: warnings };
			}

			var _walkErrors = walkErrors("", "root", errorSchema),
			    errors = _walkErrors.errors,
			    warnings = _walkErrors.warnings;

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-error-list" + (this.state.popped ? " laji-form-popped" : "") + (errors.length === 0 ? " laji-form-warning-list" : ""),
					style: this.state.popped ? { top: (this.props.formContext.topOffset || 0) + 5 } : null },
				_react2.default.createElement(_components.ErrorPanel, { classNames: "error-panel",
					ref: "errorPanel",
					errors: errors,
					title: translations.Errors,
					clickHandler: clickHandler,
					showToggle: true,
					poppedToggle: this.poppedToggle }),
				_react2.default.createElement(_components.ErrorPanel, { classNames: "warning-panel",
					ref: "warningPanel",
					errors: warnings,
					title: translations.Warnings,
					clickHandler: clickHandler,
					showToggle: errors.length === 0,
					poppedToggle: this.poppedToggle }),
				_react2.default.createElement(
					"div",
					{ className: "panel-footer" },
					_react2.default.createElement(
						"div",
						null,
						errors.length > 0 ? _react2.default.createElement(
							_components.Button,
							{ onClick: this.revalidate },
							_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "refresh" }),
							" ",
							translations.Revalidate
						) : _react2.default.createElement(
							_components.Button,
							{ onClick: this.submitWithWarnings, disabled: disabled || readonly },
							translations.SubmitWithWarnings
						)
					)
				)
			);
		}
	}]);
	return ErrorListTemplate;
}(_react.Component);

exports.default = ErrorListTemplate;