"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

var _components = require("./components");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldTemplate = function (_Component) {
	(0, _inherits3.default)(FieldTemplate, _Component);

	function FieldTemplate(props) {
		(0, _classCallCheck3.default)(this, FieldTemplate);

		var _this = (0, _possibleConstructorReturn3.default)(this, (FieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(FieldTemplate)).call(this, props));

		_initialiseProps.call(_this);

		if ((0, _utils.getUiOptions)(props.uiSchema).reserveId === false) {
			_this.state = {};
			return (0, _possibleConstructorReturn3.default)(_this);
		}
		var id = _this.props.formContext.reserveId(_this.props.id, _this.receiveId);
		if (id) {
			_this.state = { id: id };
		} else {
			_this.state = {};
		}
		return _this;
	}

	(0, _createClass3.default)(FieldTemplate, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var formContext = this.props.formContext;

			var contextId = formContext.contextId;
			var _context = new _Context2.default(contextId);
			var idToFocus = _context.idToFocus,
			    idToScroll = _context.idToScroll;

			if (this.canFocus() && idToFocus !== undefined && this.state.id === idToFocus) {
				if ((0, _utils.focusAndScroll)(formContext, idToFocus, idToScroll)) {
					_context.idToFocus = undefined;
					_context.idToScroll = undefined;
				}
			}
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			if ((0, _utils.getUiOptions)(props.uiSchema).reserveId !== false && this.props.id !== props.id) {
				this.props.formContext.releaseId(this.props.id, this.receiveId);
				var id = props.formContext.reserveId(props.id, this.receiveId);
				id && this.receiveId(id);
			}
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			if ((0, _utils.getUiOptions)(this.props.uiSchema).reserveId === false) {
				return;
			}
			this.props.formContext.releaseId(this.props.id, this.receiveId);
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    id = _props.id,
			    classNames = _props.classNames,
			    label = _props.label,
			    children = _props.children,
			    rawErrors = _props.rawErrors,
			    rawHelp = _props.rawHelp,
			    description = _props.description,
			    hidden = _props.hidden,
			    required = _props.required,
			    displayLabel = _props.displayLabel,
			    schema = _props.schema,
			    uiSchema = _props.uiSchema,
			    formContext = _props.formContext;


			if (hidden || uiSchema["ui:field"] === "HiddenField" || uiSchema["ui:widget"] === "HiddenWidget") {
				return children;
			}
			var inlineHelp = uiSchema["ui:inlineHelp"];
			var belowHelp = uiSchema["ui:belowHelp"];
			var htmlId = this.state.id ? "_laji-form_" + formContext.contextId + "_" + this.state.id : undefined;

			var _displayLabel = schema.items && schema.items.enum && !(0, _utils.isMultiSelect)(schema, uiSchema) ? false : displayLabel;

			var warnings = [];
			var errors = (rawErrors || []).reduce(function (arr, err) {
				if (err.indexOf("[warning]") !== -1) {
					warnings.push((0, _utils.formatErrorMessage)(err));
				} else {
					arr.push((0, _utils.formatErrorMessage)(err));
				}
				return arr;
			}, []);
			var warningClassName = warnings.length > 0 && errors.length === 0 ? " laji-form-warning-container" : "";

			var _props$formContext = this.props.formContext,
			    Label = _props$formContext.Label,
			    errorsAsPopup = _props$formContext.errorsAsPopup;

			var component = function component(errorsComponent) {
				return _react2.default.createElement(
					"div",
					{ className: classNames + warningClassName, id: htmlId },
					label && _displayLabel ? _react2.default.createElement(Label, { label: label, help: rawHelp, helpHoverable: uiSchema["ui:helpHoverable"], helpPlacement: uiSchema["ui:helpPlacement"], id: id, required: required || uiSchema["ui:required"], _context: new _Context2.default(formContext.contextId) }) : null,
					_displayLabel && description ? description : null,
					_react2.default.createElement(
						"div",
						null,
						inlineHelp ? _react2.default.createElement(
							"div",
							{ className: "pull-left" },
							children
						) : children,
						inlineHelp ? _react2.default.createElement(
							"div",
							{ className: "pull-left" },
							_react2.default.createElement(_components.Help, { help: inlineHelp, id: htmlId + "-inline-help" })
						) : null
					),
					belowHelp ? _react2.default.createElement("div", { className: "small text-muted", dangerouslySetInnerHTML: { __html: belowHelp } }) : null,
					errorsComponent
				);
			};

			var errorsComponent = _react2.default.createElement(
				_react2.default.Fragment,
				null,
				errors.length > 0 ? _react2.default.createElement(
					"ul",
					{ id: "laji-form-error-container-" + id, className: "laji-form-error-container" },
					errors.map(function (error, i) {
						return _react2.default.createElement(
							"li",
							{ key: i },
							error
						);
					})
				) : null,
				warnings.length > 0 ? _react2.default.createElement(
					"ul",
					{ id: "laji-form-warning-container-" + id, className: "laji-form-warning-container" },
					warnings.map(function (warning, i) {
						return _react2.default.createElement(
							"li",
							{ key: i },
							warning
						);
					})
				) : null
			);

			if (errorsAsPopup && (rawErrors || []).length) {
				return _react2.default.createElement(
					_components.TooltipComponent,
					{ placement: "bottom", tooltip: errorsComponent, className: "location-chooser-errors" },
					component()
				);
			}
			return component(errorsComponent);
		}
	}]);
	return FieldTemplate;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.canFocus = function () {
		var formContext = _this2.props.formContext;
		var _props$uiSchema = (formContext.getFormRef() || { props: {} }).props.uiSchema,
		    uiSchema = _props$uiSchema === undefined ? {} : _props$uiSchema;

		return uiSchema.autoFocus !== false;
	};

	this.receiveId = function (id) {
		_this2.setState({ id: id }, function () {
			var _ref = new _Context2.default(_this2.props.formContext.contextId),
			    idToFocus = _ref.idToFocus,
			    idToScroll = _ref.idToScroll;

			if (_this2.canFocus() && idToFocus === id) {
				(0, _utils.focusAndScroll)(_this2.props.formContext, idToFocus, idToScroll);
			}
		});
	};
};

exports.default = FieldTemplate;