"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _clearImmediate2 = require("babel-runtime/core-js/clear-immediate");

var _clearImmediate3 = _interopRequireDefault(_clearImmediate2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise2 = require("babel-runtime/core-js/promise");

var _promise3 = _interopRequireDefault(_promise2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _validation = require("../validation");

var _validation2 = _interopRequireDefault(_validation);

var _components = require("./components");

var _reactBootstrap = require("react-bootstrap");

var _PanelHeading = require("react-bootstrap/lib/PanelHeading");

var _PanelHeading2 = _interopRequireDefault(_PanelHeading);

var _utils = require("../utils");

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _validate = require("@rjsf/core/dist/cjs/validate");

var _validate2 = _interopRequireDefault(_validate);

var _utils2 = require("@rjsf/core/dist/cjs/utils");

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _core = require("@rjsf/core");

var _core2 = _interopRequireDefault(_core);

var _ArrayFieldTemplate = require("./ArrayFieldTemplate");

var _ArrayFieldTemplate2 = _interopRequireDefault(_ArrayFieldTemplate);

var _FieldTemplate = require("./FieldTemplate");

var _FieldTemplate2 = _interopRequireDefault(_FieldTemplate);

var _ErrorListTemplate = require("./ErrorListTemplate");

var _ErrorListTemplate2 = _interopRequireDefault(_ErrorListTemplate);

var _ApiClient = require("../ApiClient");

var _ApiClient2 = _interopRequireDefault(_ApiClient);

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

var _translations = require("../translations.js");

var _translations2 = _interopRequireDefault(_translations);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fields = importLocalComponents("fields", ["SchemaField", "TitleField", "ArrayField", "ObjectField", "NestField", "ArrayBulkField", "ArrayBulkField", "ScopeField", "SelectTreeField", "GridLayoutField", "TableField", "InjectField", "InjectDefaultValueField", "ArrayCombinerField", "DependentBooleanField", "DependentDisableField", "MapArrayField", "AutoArrayField", "AutosuggestField", "HiddenField", "InitiallyHiddenField", "ContextInjectionField", "ImageArrayField", "SplitField", "FlatField", "SingleActiveArrayField", "SingleItemArrayField", "UnitShorthandField", "CombinedValueDisplayField", "UiFieldMapperArrayField", "ExtraLabelRowField", "SumField", "NamedPlaceChooserField", "NamedPlaceSaverField", "MapField", "GeocoderField", "TagArrayField", "StringToArrayField", "ConditionalOnChangeField", "ConditionalUiSchemaField", "AnnotationField", "PrefillingArrayField", "AnyToBooleanField", "EnumRangeArrayField", "UnitListShorthandArrayField", "LocationChooserField", "DataLeakerField", "LocalityField", "ImageDisplayField", "DescriptionField", "FakePropertyField", "SectionArrayField", "MultiArrayField", "AudioArrayField", "FilterArrayField", "MultiAnyToBooleanField", "UnitCountShorthandField", "ToggleAdditionalArrayFieldsField", { "InputTransformerField": "ConditionalOnChangeField" }, // Alias for backward compatibility.
{ "ConditionalField": "ConditionalUiSchemaField" }, // Alias for backward compatibility.
{ "UnitRapidField": "UnitShorthandField" }, // Alias for backward compatibility.
{ "AccordionArrayField": "SingleActiveArrayField" // Alias for backward compatibility.
}]);

var widgets = importLocalComponents("widgets", ["BaseInput", "CheckboxWidget", "SelectWidget", "TextareaWidget", "DateTimeWidget", "DateWidget", "TimeWidget", "SeparatedDateTimeWidget", "AutosuggestWidget", "HiddenWidget", "PlainTextWidget", "TextSelectWidget", "ImageSelectWidget", "AnyToBooleanWidget", "URLWidget", "InformalTaxonGroupChooserWidget", "TaxonImageWidget", "UpperCaseWidget"]);

function importLocalComponents(dir, fieldNames) {
	return fieldNames.reduce(function (fields, field) {
		if (typeof field === "string") {
			fields[field] = require("./" + dir + "/" + field).default;
		} else {
			var fieldName = (0, _keys2.default)(field)[0];
			if (typeof field[fieldName] === "string") {
				fields[fieldName] = require("./" + dir + "/" + field[fieldName]).default;
			} else {
				fields[fieldName] = field[fieldName];
			}
		}
		return fields;
	}, {});
}

// Each form should have a unique id to keep Context private.
var id = 0;
function getNewId() {
	var _id = id;
	id++;
	return _id;
}

var LajiForm = function (_Component) {
	(0, _inherits3.default)(LajiForm, _Component);

	function LajiForm(props) {
		(0, _classCallCheck3.default)(this, LajiForm);

		var _this = (0, _possibleConstructorReturn3.default)(this, (LajiForm.__proto__ || (0, _getPrototypeOf2.default)(LajiForm)).call(this, props));

		_this.constructTranslations = function () {
			return (0, _utils.constructTranslations)(_translations2.default);
		};

		_this.getDefaultNotifier = function () {
			if (_this.defaultNotifier) return _this.defaultNotifier;
			_this.defaultNotifier = ["success", "info", "warning", "error"].reduce(function (notifier, method) {
				return notifier[method] = function (msg) {
					return console.warn("Notification component not specified for LajiForm! Got '" + method + "'notification: '" + msg + "'");
				};
			}, {});
		};

		_this.setTmpIdTree = function (schema) {
			function walk(_schema) {
				if (_schema.properties) {
					var _walked = (0, _keys2.default)(_schema.properties).reduce(function (paths, key) {
						var walked = walk(_schema.properties[key]);
						if (walked) {
							paths[key] = walked;
						}
						return paths;
					}, {});
					if ((0, _keys2.default)(_walked).length) return _walked;
				} else if (_schema.type === "array" && _schema.items.type === "object") {
					return (0, _keys2.default)(_schema.items.properties).reduce(function (paths, key) {
						var walked = walk(_schema.items.properties[key]);
						if (walked) {
							paths[key] = walked;
						}
						return paths;
					}, { _hasId: true });
				}
			}
			_this.tmpIdTree = walk(schema);
		};

		_this.addLajiFormIds = function (formData) {
			return (0, _utils.addLajiFormIds)(formData, _this.tmpIdTree)[0];
		};

		_this.removeLajiFormIds = function (formData) {
			function walk(_formData, tree) {
				if (tree && (0, _utils.isObject)(_formData)) {
					return (0, _keys2.default)(_formData).reduce(function (f, k) {
						if (k === "_lajiFormId") return f;
						if (tree[k]) {
							f[k] = walk(_formData[k], tree[k]);
						} else {
							f[k] = _formData[k];
						}
						return f;
					}, {});
				} else if (tree && Array.isArray(_formData)) {
					return _formData.map(function (item) {
						return walk(item, tree);
					});
				}
				return _formData;
			}

			return walk(formData, _this.tmpIdTree);
		};

		_this.onChange = function (_ref) {
			var formData = _ref.formData;

			_this.setState({ formData: formData }, function () {
				if (_this.props.onChange) {
					var _formData = _this.props.optimizeOnChange ? formData : _this.removeLajiFormIds(formData);
					_this.props.onChange(_formData);
				}
				_this._context.formData = formData;
				!_this.validating && _this.validate(!!"warnings", !"nonlive");
			});
		};

		_this.getRef = function (form) {
			_this.formRef = form;
		};

		_this.getBlockerRef = function (elem) {
			_this.blockingLoaderRef = elem;
		};

		_this.getPanelRef = function (elem) {
			_this.shortcutHelpRef = elem;
		};

		_this.getFormRef = function () {
			return _this.formRef;
		};

		_this.getFields = function (_fields) {
			return (0, _extends4.default)({}, fields, _fields || {});
		};

		_this.getWidgets = function (_widgets) {
			return (0, _extends4.default)({}, widgets, _widgets || {});
		};

		_this.renderSubmitHooks = function () {
			if (!_this.state || !_this.state.submitHooks) return;
			var jobsAmount = _this.state.submitHooks.filter(function (_ref2) {
				var failed = _ref2.failed;
				return !failed;
			}).length;
			var runningAmount = _this.state.submitHooks.reduce(function (count, _ref3) {
				var running = _ref3.running;
				return running ? count + 1 : count;
			}, 0);
			if (!_this.state.runningSubmitHooks) return null;

			return _react2.default.createElement(
				"div",
				{ className: "running-jobs" },
				_this.state.translations.PendingRunningJobs,
				"... (",
				jobsAmount - runningAmount + 1,
				" / ",
				jobsAmount,
				")",
				_react2.default.createElement(_reactBootstrap.ProgressBar, { now: 100 / jobsAmount * (jobsAmount - runningAmount) })
			);
		};

		_this.validateAndSubmit = function () {
			var warnings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
			var formData = _this.state.formData;
			var _this$props = _this.props,
			    onSubmit = _this$props.onSubmit,
			    onValidationError = _this$props.onValidationError;

			return _this.validate(warnings, true).then(function (valid) {
				if (formData !== _this.state.formData) {
					_this.validateAndSubmit(warnings);
				} else if (valid) {
					onSubmit && onSubmit({ formData: _this.removeLajiFormIds(formData) });
				} else {
					onValidationError && onValidationError(_this.state.extraErrors);
				}
			});
		};

		_this.validate = function () {
			var warnings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
			var nonlive = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

			_this.validating = true;
			var formData = _this.state.formData;

			var _splitLive = splitLive(_this.props.validators, _this.props.schema.properties),
			    liveErrorValidators = _splitLive.live,
			    errorValidators = _splitLive.rest;

			var _splitLive2 = splitLive(_this.props.warnings, _this.props.schema.properties),
			    liveWarningValidators = _splitLive2.live,
			    warningValidators = _splitLive2.rest;

			var liveValidations = { errors: liveErrorValidators };
			var validations = {};
			if (nonlive) {
				validations.errors = errorValidators;
			}
			if (warnings) {
				liveValidations.warnings = liveWarningValidators;
				if (nonlive) {
					validations.warnings = warningValidators;
				}
			}
			var schemaErrors = nonlive ? (0, _validate2.default)(formData, _this.props.schema, undefined, function (e) {
				return (0, _validation.transformErrors)(_this.state.translations, e);
			}).errorSchema : {};
			nonlive && _this.pushBlockingLoader();
			return new _promise3.default(function (resolve) {
				return _promise3.default.all([(0, _validation2.default)(validations, formData), (0, _validation2.default)(liveValidations, formData)]).then(function (_ref4) {
					var _ref5 = (0, _slicedToArray3.default)(_ref4, 2),
					    _validations = _ref5[0],
					    _liveValidations = _ref5[1];

					if (nonlive) {
						_this.cachedNonliveValidations = (0, _deepmerge2.default)(schemaErrors, _validations);
						nonlive && _this.popBlockingLoader();
					}
					var merged = (0, _deepmerge2.default)(_liveValidations, !nonlive ? _this.cachedNonliveValidations || {} : (0, _deepmerge2.default)(_validations, schemaErrors));
					_this.validating = false;
					resolve(!(0, _keys2.default)(merged).length);
					!(0, _deepEqual2.default)(_this.state.extraErrors, merged) && _this.setState({ extraErrors: merged }, _this.popErrorListIfNeeded);
				}).catch(function (e) {
					nonlive && _this.popBlockingLoader();
					throw e;
				});
			});

			function splitLive() {
				var validators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				var schema = arguments[1];
				var live = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
				var rest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

				(0, _keys2.default)(validators).forEach(function (key) {
					if (schema[key]) {
						live[key] = {};
						rest[key] = {};
						splitLive(validators[key], schema[key], live[key], rest[key]);
						if ((0, _keys2.default)(live[key]).length === 0) delete live[key];
						if ((0, _keys2.default)(rest[key]).length === 0) delete rest[key];
					} else {
						var container = validators[key].options && validators[key].options._live ? live : rest;
						container[key] = validators[key];
					}
				});
				return { live: live, rest: rest };
			}
		};

		_this.onSubmit = function () {
			var uiSchema = _this.props.uiSchema;

			if (uiSchema["ui:disabled"] || uiSchema["ui:readonly"]) {
				return false;
			}

			_this.pushBlockingLoader();
			_this.setState({ runningSubmitHooks: true, submitHooks: (_this.state.submitHooks || []).map(function (hookItem) {
					return (0, _extends4.default)({}, hookItem, { running: true });
				}) });
			_promise3.default.all((_this.state.submitHooks || []).map(function (_ref6) {
				var promise = _ref6.promise,
				    hook = _ref6.hook;

				var setNotRunning = function setNotRunning() {
					_this.setState({ submitHooks: (_this.state.submitHooks || []).map(function (hookItem) {
							return (0, _extends4.default)({}, hookItem, { running: hookItem.hook === hook ? false : hookItem.running });
						})
					});
				};
				return promise.then(setNotRunning).catch(setNotRunning);
			})).then(function () {
				_this.popBlockingLoader();
				_this.setState({ runningSubmitHooks: false });
				_this.validateAndSubmit();
			}).catch(function () {
				_this.setState({ runningSubmitHooks: false });
				_this.popBlockingLoader();
				(0, _utils.highlightElem)((0, _reactDom.findDOMNode)(_this.bgJobRef.current));
			});
		};

		_this.popErrorListIfNeeded = function () {
			var errorListElem = void 0;
			try {
				errorListElem = (0, _reactDom.findDOMNode)(_this._context.errorList);
			} catch (e) {
				// Empty
			}
			if (!errorListElem) return;
			var wouldScrollTo = (0, _utils.getScrollPositionForScrollIntoViewIfNeeded)(errorListElem, _this.props.topOffset, _this.props.bottomOffset);
			var scrollAmount = wouldScrollTo - (0, _utils.getWindowScrolled)();

			if (!_this._context.errorList.state.poppedTouched && scrollAmount !== 0) {
				_this._context.errorList.expand();
			}
			(0, _utils.highlightElem)(errorListElem);
		};

		_this._onDefaultSubmit = function (e) {
			e.preventDefault();
			_this.submit();
		};

		_this.submit = function () {
			_this.onSubmit();
		};

		_this.getShorcutButtonTooltip = function () {
			var translations = _this.state.formContext.translations;

			if (_this.keyCombo && _this.keyComboDelay) {
				return translations.ShortcutHelp((0, _utils.stringifyKeyCombo)(_this.keyCombo));
			}
		};

		_this.toggleHelp = function (e) {
			_this.helpVisible ? _this.dismissHelp(e) : _this.showHelp(e);
		};

		_this.showHelp = function () {
			var node = (0, _reactDom.findDOMNode)(_this.shortcutHelpRef);
			if (!_this.helpVisible) {
				if (node) node.className = node.className.replace(" hidden", "");
				_this.helpVisible = true;
			}
		};

		_this.dismissHelp = function (e) {
			var node = (0, _reactDom.findDOMNode)(_this.shortcutHelpRef);
			e.preventDefault();
			e.stopPropagation();
			if (_this.helpVisible) {
				node.className += " hidden";
			}
			_this.helpVisible = false;
			_this.helpStarted = false;
			document.removeEventListener("keyup", _this.dismissHelp);
			window.removeEventListener("blur", _this.dismissHelp);
			clearTimeout(_this.helpTimeout);
		};

		_this.keyFunctions = {
			navigate: function navigate(e, _ref7) {
				var reverse = _ref7.reverse;

				return (0, _utils.focusNextInput)(_this.formRef, e.target, reverse);
			},
			help: function help(e, _ref8) {
				var delay = _ref8.delay;

				if (_this.helpStarted) return false;

				_this.helpStarted = true;

				_this.helpTimeout = setTimeout(function () {
					_this.showHelp();
				}, delay * 1000);
				_this.addEventListener(document, "keyup", _this.dismissHelp);
				_this.addEventListener(window, "blur", _this.dismissHelp);
				return false;
			},

			revalidate: function revalidate() {
				_this.submit(!"don't propagate");
			}
		};

		_this.getKeyHandlers = function () {
			var shortcuts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			return (0, _keys2.default)(shortcuts).reduce(function (list, keyCombo) {
				var shortcut = shortcuts[keyCombo];
				var specials = {
					alt: false,
					ctrl: false,
					shift: false
				};

				list.push(keyCombo.split("+").reduce(function (keyHandler, key) {
					if (specials.hasOwnProperty(key)) {
						specials[key] = true;
					}

					keyHandler.conditions.push(function (e) {
						return e.key === key || specials.hasOwnProperty(key) && (specials[key] && e[key + "Key"] || !specials[key] && !e[key + "Key"]);
					});

					return keyHandler;
				}, (0, _extends4.default)({}, shortcut, { conditions: [] })));

				var _loop = function _loop(special) {
					if (!specials[special]) list[list.length - 1].conditions.push(function (e) {
						return !e[special + "Key"];
					});
				};

				for (var special in specials) {
					_loop(special);
				}

				return list;
			}, []);
		};

		_this.onKeyDown = function (e) {
			if ("keyTimeouts" in _this._context && _this._context.keyTimeouts) {
				_this._context.keyTimeouts.forEach(function (timeout) {
					return clearTimeout(timeout);
				});
			}
			_this._context.keyTimeouts = [];

			var currentId = (0, _utils.findNearestParentSchemaElemId)(_this._id, e.target) || "";

			var order = (0, _keys2.default)(_this._context.keyHandleListeners).filter(function (id) {
				if (currentId.startsWith(id)) return true;
				return;
			}).sort(function (a, b) {
				return b.length - a.length;
			});

			var targets = _this.keyHandlerTargets.filter(function (_ref9) {
				var handler = _ref9.handler;
				return handler.conditions.every(function (condition) {
					return condition(e);
				});
			}).map(function (_ref10) {
				var id = _ref10.id;
				return (0, _utils.getKeyHandlerTargetId)(id, _this._context);
			});
			order = [].concat((0, _toConsumableArray3.default)(targets), (0, _toConsumableArray3.default)(order));

			var handled = order.some(function (id) {
				return _this._context.keyHandleListeners[id] && _this._context.keyHandleListeners[id].some(function (keyHandleListener) {
					return keyHandleListener(e);
				});
			});

			var activeElement = document.activeElement;
			if (!handled && e.key === "Enter" && (!activeElement || activeElement.tagName.toLowerCase() !== "textarea" && !(activeElement.className.indexOf("laji-map-input") !== -1))) {
				e.preventDefault();
			}
		};

		_this.pushBlockingLoader = function () {
			_this.blockingLoaderCounter++;
			_this._context.blockingLoaderCounter = _this.blockingLoaderCounter;
			if (_this.mounted && _this.blockingLoaderCounter === 1) {
				_this.blockingLoaderRef.className = "laji-form blocking-loader entering";
			}
		};

		_this.popBlockingLoader = function () {
			_this.blockingLoaderCounter--;
			_this._context.blockingLoaderCounter = _this.blockingLoaderCounter;
			if (_this.blockingLoaderCounter < 0) {
				console.warn("laji-form: Blocking loader was popped before pushing!");
			} else if (_this.blockingLoaderCounter === 0) {
				_this.blockingLoaderRef.className = "laji-form blocking-loader leave-start";
				_this.setImmediate(function () {
					if (_this.blockingLoaderCounter > 0) {
						_this.blockingLoaderRef.className = "laji-form blocking-loader entering";
						return;
					}
					if (_this.blockingLoaderRef) _this.blockingLoaderRef.className = "laji-form blocking-loader leaving";
					_this.setTimeout(function () {
						if (!_this.blockingLoaderRef) {
							return;
						}
						if (_this.blockingLoaderCounter > 0) {
							_this.blockingLoaderRef.className = "laji-form blocking-loader entering";
						} else {
							_this.blockingLoaderRef.className = "laji-form blocking-loader";
						}
					}, 200); // should match css transition time.
				});
			}
		};

		_this.getSettings = function () {
			var global = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

			var settingSavers = global ? _this.globalSettingSavers : _this.settingSavers;
			return (0, _keys2.default)(settingSavers).reduce(function (settings, key) {
				try {
					return (0, _extends4.default)({}, settings, (0, _defineProperty3.default)({}, key, settingSavers[key]()));
				} catch (e) {
					// Swallow failing settings parsing.
				}
				return settings;
			}, _this.props.settings || {});
		};

		_this.onSettingsChange = function () {
			var global = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

			var settings = _this.getSettings(global);
			if (!(0, _deepEqual2.default)(_this.state.formContext.settings, settings)) {
				// setImmediate because we wait for a possible formData onChange event to bubble, which would be lost otherwise.
				(0, _setImmediate3.default)(function () {
					_this.setState({ formContext: (0, _extends4.default)({}, _this.state.formContext, { settings: JSON.parse((0, _stringify2.default)(settings)) }) });
				});
				if (_this.props.onSettingsChange) _this.props.onSettingsChange(settings, global);
			}
		};

		_this.addEventListener = function (target, name, fn) {
			if (!_this.eventListeners) _this.eventListeners = [];
			target.addEventListener(name, fn);
			_this.eventListeners.push([target, name, fn]);
		};

		_this.setTimeout = function (fn, time) {
			if (!_this.timeouts) _this.timeouts = [];

			var timeout = setTimeout(fn, time);
			_this.timeouts.push(timeout);
			return timeout;
		};

		_this.setImmediate = function (fn) {
			if (!_this.immediates) _this.immediates = [];

			_this.immediates.push((0, _setImmediate3.default)(fn));
		};

		_this.destroy = function () {
			if (_this.eventListeners) _this.eventListeners.forEach(function (_ref11) {
				var _ref12 = (0, _slicedToArray3.default)(_ref11, 3),
				    target = _ref12[0],
				    name = _ref12[1],
				    fn = _ref12[2];

				target.removeEventListener(name, fn);
			});
			if (_this.timeouts) _this.timeouts.forEach(function (timeout) {
				clearTimeout(timeout);
			});
			if (_this.immediates) _this.immediates.forEach(function (immediate) {
				(0, _clearImmediate3.default)(immediate);
			});
			_this.eventListeners = undefined;
		};

		_this.bgJobRef = _react2.default.createRef();
		_this.translations = _this.constructTranslations();
		_this.apiClient = new _ApiClient2.default(props.apiClient, props.lang, _this.translations);
		(0, _validation.initializeValidation)(_this.apiClient);
		_this._id = getNewId();

		_this._context = new _Context2.default(_this._id);
		_this._context.formInstance = _this;
		_this._context.formData = props.formData;
		_this.propagateSubmit = true;

		_this.blockingLoaderCounter = 0;
		_this._context.blockingLoaderCounter = _this.blockingLoaderCounter;
		_this._context.pushBlockingLoader = _this.pushBlockingLoader;
		_this._context.popBlockingLoader = _this.popBlockingLoader;

		_this._context.keyHandleListeners = {};
		_this._context.keyHandleIdFunctions = [];
		_this._context.addKeyHandler = function (id, keyFunctions, additionalParams) {
			if (!_this._context.keyHandleListeners[id]) _this._context.keyHandleListeners[id] = [];
			var handleKey = function handleKey(e) {
				return (0, _utils.handleKeysWith)(_this._context, id, keyFunctions, e, additionalParams);
			};
			_this._context.keyHandleIdFunctions.push({ id: id, keyFunctions: keyFunctions, handleKey: handleKey });
			_this._context.keyHandleListeners[id].push(handleKey);
		};

		_this._context.removeKeyHandler = function (_id, _keyFunctions) {
			var _loop2 = function _loop2(i) {
				var idFunction = _this._context.keyHandleIdFunctions[i];
				var id = idFunction.id,
				    keyFunctions = idFunction.keyFunctions,
				    handleKey = idFunction.handleKey;

				if (id === _id && _keyFunctions === keyFunctions) {
					_this._context.keyHandleIdFunctions.splice(i, 1);
					_this._context.keyHandleListeners[id] = _this._context.keyHandleListeners[id].filter(function (_handleKey) {
						return _handleKey !== handleKey;
					});
				}
			};

			for (var i in _this._context.keyHandleIdFunctions) {
				_loop2(i);
			}
		};

		_this.resetShortcuts((props.uiSchema || {})["ui:shortcuts"]);

		_this.settingSavers = {};
		_this.globalSettingSavers = {};
		_this._context.addSettingSaver = function (key, fn) {
			var global = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

			var settingSavers = global ? _this.globalSettingSavers : _this.settingSavers;
			settingSavers[key] = fn;
		};
		_this._context.removeSettingSaver = function (key) {
			var global = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

			var settingSavers = global ? _this.globalSettingSavers : _this.settingSavers;
			delete settingSavers[key];
		};
		_this._context.onSettingsChange = _this.onSettingsChange;

		_this.errorClickHandler = function (id) {
			var idParts = id.split("_");

			// Some components focus asynchronously (due to state changes etc), so we reduce
			// the focus handlers to a promise chain.
			var _id = "";
			idParts.reduce(function (promise, idPart) {
				return promise.then(function () {
					_id = _id ? _id + "_" + idPart : idPart;
					return (_this.focusHandlers[_id] || []).reduce(function (_promise, fn) {
						var status = fn(); // Either undefined or a Promise.
						return status && status.then ? status : _promise3.default.resolve();
					}, _promise3.default.resolve());
				});
			}, _promise3.default.resolve()).then(function () {
				var container = (0, _utils.getSchemaElementById)(_this._id, id);
				var elem = container || document.querySelector("#laji-form-error-container-" + id);
				var input = document.querySelector("#" + id);

				if (elem) (0, _utils.scrollIntoViewIfNeeded)(elem, _this.props.topOffset, _this.props.bottomOffset);
				if (input) input.focus();

				if (!elem) return;

				(0, _utils.highlightElem)(elem);
			});
		};

		_this.focusHandlers = {};
		_this._context.addFocusHandler = function (id, fn) {
			if (!_this.focusHandlers[id]) _this.focusHandlers[id] = [];
			_this.focusHandlers[id].push(fn);
		};
		_this._context.removeFocusHandler = function (id, fn) {
			if (!_this.focusHandlers[id]) {
				console.warn("laji-form warning: removing focus handler that isn't registered for id " + id + ".");
				return;
			}
			_this.focusHandlers[id] = _this.focusHandlers[id].filter(function (_fn) {
				return fn !== _fn;
			});
		};

		_this._context.setImmediate = _this.setImmediate;
		_this._context.setTimeout = _this.setTimeout;
		_this._context.addEventListener = _this.addEventListener;

		_this.customEventListeners = {};
		_this._context.addCustomEventListener = function (id, eventName, fn) {
			if (!_this.customEventListeners[eventName]) _this.customEventListeners[eventName] = {};
			if (!_this.customEventListeners[eventName][id]) _this.customEventListeners[eventName][id] = [];
			_this.customEventListeners[eventName][id].push(fn);
			//this.customEventListeners[eventName][id] = [fn, ...this.customEventListeners[eventName][id]];
		};
		_this._context.removeCustomEventListener = function (id, eventName, fn) {
			_this.customEventListeners[eventName][id] = _this.customEventListeners[eventName][id].filter(function (_fn) {
				return _fn !== fn;
			});
		};
		_this._context.sendCustomEvent = function (id, eventName, data, callback) {
			var _ref13 = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {},
			    _ref13$bubble = _ref13.bubble,
			    bubble = _ref13$bubble === undefined ? true : _ref13$bubble;

			var ids = (0, _keys2.default)(_this.customEventListeners[eventName] || {}).filter(function (_id) {
				return id.startsWith(_id);
			}).sort().reverse();

			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				outer: for (var _iterator = (0, _getIterator3.default)(ids), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var _id = _step.value;
					var _iteratorNormalCompletion2 = true;
					var _didIteratorError2 = false;
					var _iteratorError2 = undefined;

					try {
						for (var _iterator2 = (0, _getIterator3.default)(_this.customEventListeners[eventName][_id]), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
							var listener = _step2.value;

							var result = listener(data, callback);
							if (!bubble) break outer;
							if (result === true || result === undefined) {
								return;
							}
						}
					} catch (err) {
						_didIteratorError2 = true;
						_iteratorError2 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion2 && _iterator2.return) {
								_iterator2.return();
							}
						} finally {
							if (_didIteratorError2) {
								throw _iteratorError2;
							}
						}
					}
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}

			callback && callback();
		};

		_this._globalEventsRootHandler = {};
		_this._globalEventHandlers = {};
		_this._context.addGlobalEventHandler = function (name, fn) {
			if (!_this._globalEventHandlers[name]) {
				_this._globalEventsRootHandler[name] = function (e) {
					if (!e.persist) e.persist = function () {};
					var origStopPropagation = e.stopPropagation;
					e.stopPropagation = function () {
						e._lajiFormStoppedFlag = true;
						origStopPropagation.call(e);
					};
					_this._globalEventHandlers[name].some(function (h) {
						if (e._lajiFormStoppedFlag) {
							return true;
						}
						h(e);
					});
				};
				document.addEventListener(name, _this._globalEventsRootHandler[name]);
				_this._globalEventHandlers[name] = [];
			}
			_this._globalEventHandlers[name].push(fn);
		};
		_this._context.removeGlobalEventHandler = function (name, fn) {
			_this._globalEventHandlers[name] = _this._globalEventHandlers[name].filter(function (_fn) {
				return _fn !== fn;
			});
			if (_this._globalEventHandlers[name].length === 0) {
				delete _this._globalEventHandlers[name];
				document.removeEventListener(name, _this._globalEventsRootHandler[name]);
			}
		};

		_this.ids = {};

		// First call returns id, next call (and only the very next) reserves the id until it is released.
		_this.reserveId = function (id, sendId) {
			if (_this.ids[id] && _this.ids[id].length) {
				_this.ids[id].push(sendId);
			} else {
				_this.ids[id] = [sendId]; // Just mark that the id is now used. It isn't reserved yet.
				return id;
			}
		};

		_this.releaseId = function (id, sendId) {
			if (_this.ids[id]) {
				var idx = _this.ids[id].indexOf(sendId);
				_this.ids[id].splice(idx, 1);
				if (_this.ids[id].length > 0) {
					_this.ids[id][0](id);
				}
			}
		};

		_this._context.addSubmitHook = function (lajiFormId, relativePointer, hook, description) {
			lajiFormId = "" + lajiFormId;
			var promise = void 0;
			var _hook = function _hook() {
				promise = new _promise3.default(function (resolve) {
					var isRetry = false;
					var hooks = (_this.state.submitHooks || []).map(function (hookItem) {
						if (hookItem.hook === _hook) {
							isRetry = true;
							return (0, _extends4.default)({}, hookItem, { running: true, promise: promise });
						}
						return hookItem;
					});
					if (isRetry) {
						_this.setState({ submitHooks: hooks });
					}
					resolve(hook());
				}).then(function () {
					_this._context.removeSubmitHook(lajiFormId, _hook);
				}).catch(function (e) {
					_this.setState({ submitHooks: _this.state.submitHooks.map(function (hookItem) {
							return hookItem.hook === _hook ? (0, _extends4.default)({}, hookItem, { e: e, running: false, failed: true }) : hookItem;
						}) });
					throw e;
				});
			};

			_hook();

			_this.setState({ submitHooks: [].concat((0, _toConsumableArray3.default)(_this.state.submitHooks || []), [{ hook: _hook, promise: promise, lajiFormId: lajiFormId, description: description, relativePointer: relativePointer, running: true }]) });
			return _hook;
		};
		_this._context.removeSubmitHook = function (lajiFormId, hook) {
			return new _promise3.default(function (resolve) {
				lajiFormId = "" + lajiFormId;
				var newHooks = (_this.state.submitHooks || []).filter(function (_ref14) {
					var _hook = _ref14.hook,
					    _lajiFormId = _ref14.lajiFormId;
					return hook ? _hook !== hook : lajiFormId !== _lajiFormId;
				});
				newHooks.length !== (_this.state.submitHooks || []).length ? _this.setState({ submitHooks: newHooks }, resolve) : resolve();
			});
		};
		_this._context.removeAllSubmitHook = function () {
			_this.setState({ submitHooks: [] });
		};

		_this.state = _this.getStateFromProps(props);
		return _this;
	}

	(0, _createClass3.default)(LajiForm, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			if (props.hasOwnProperty("lang") && this.props.lang !== props.lang) {
				this.apiClient.setLang(props.lang);
			}
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			if (props.staticImgPath) new _Context2.default().staticImgPath = props.staticImgPath;
			var translations = this.translations[props.lang];
			if (!this.tmpIdTree || props.schema !== this.props.schema) {
				this.setTmpIdTree(props.schema);
			}
			var state = {
				translations: translations,
				formContext: (0, _extends4.default)({}, this.props.formContext, {
					translations: translations,
					lang: props.lang,
					uiSchemaContext: props.uiSchemaContext,
					settings: JSON.parse((0, _stringify2.default)((this.state && this.state.formContext ? this.state.formContext.settings : props.settings) || {})),
					contextId: this._id,
					getFormRef: this.getFormRef,
					topOffset: props.topOffset || 0,
					bottomOffset: props.bottomOffset || 0,
					formID: props.id,
					googleApiKey: props.googleApiKey,
					reserveId: this.reserveId,
					releaseId: this.releaseId,
					notifier: props.notifier || this.getDefaultNotifier(),
					apiClient: this.apiClient,
					Label: (props.fields || {}).Label || _components.Label
				})
			};
			if (!this.state || props.formData && props.formData !== this.props.formData) {
				state.formData = this.addLajiFormIds((0, _utils2.getDefaultFormState)(props.schema, props.formData, undefined), this.tmpIdTree);
				this._context.formData = state.formData;
			} else {
				state.formData = this.formRef.state.formData;
			}
			if (this.state && props.schema !== this.props.schema) {
				state.extraErrors = {};
			}
			return state;
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.props.autoFocus && (0, _utils.focusById)(this.state.formContext, "root");

			this.blockingLoaderRef = document.createElement("div");
			this.blockingLoaderRef.className = "laji-form blocking-loader";
			if (this.blockingLoaderCounter > 0) this.blockingLoaderRef.className = "laji-form blocking-loader entering";
			document.body.appendChild(this.blockingLoaderRef);

			this._context.addGlobalEventHandler("keydown", this.onKeyDown);

			if (this.props.componentDidMount) this.props.componentDidMount();
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			if (this._context.singletonMap) this._context.singletonMap.destroy();
			document.body.removeChild(this.blockingLoaderRef);
			this._context.removeGlobalEventHandler("keydown", this.onKeyDown);
		}
	}, {
		key: "componentDidCatch",
		value: function componentDidCatch(e, i) {
			this.setState({ error: true });
			if (this.props.onError) {
				this.props.onError(e, i);
			}
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			if ((prevProps.uiSchema || {})["ui:shortcuts"] !== (this.props.uiSchema || {})["ui:shortcuts"]) {
				this.resetShortcuts((this.props.uiSchema || {})["ui:shortcuts"]);
			}
		}
	}, {
		key: "resetShortcuts",
		value: function resetShortcuts() {
			var _this2 = this;

			var shortcuts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			this._context.keyHandleListeners = {};
			this._context.keyHandleIdFunctions = [];

			this.keyHandlers = this.getKeyHandlers(shortcuts);
			this._context.keyHandlers = this.keyHandlers;
			this._context.addKeyHandler("root", this.keyFunctions);
			this.keyHandlerTargets = (0, _keys2.default)(this.keyHandlers).reduce(function (targets, keyCombo) {
				var handler = _this2.keyHandlers[keyCombo];
				if ("target" in handler) targets.push({ id: handler.target, handler: handler });
				return targets;
			}, []);

			(0, _keys2.default)(shortcuts).some(function (keyCombo) {
				if (shortcuts[keyCombo].fn == "help") {
					_this2.keyCombo = keyCombo;
					_this2.keyComboDelay = shortcuts[keyCombo].fn;
					return true;
				}
			});

			this._context.shortcuts = shortcuts;
		}
	}, {
		key: "render",
		value: function render() {
			if (this.state.error) return null;
			var translations = this.state.translations;
			var _props$uiSchema = this.props.uiSchema,
			    shortcuts = _props$uiSchema["ui:shortcuts"],
			    _props$uiSchema$uiSh = _props$uiSchema["ui:showShortcutsButton"],
			    showShortcutsButton = _props$uiSchema$uiSh === undefined ? true : _props$uiSchema$uiSh,
			    readonly = _props$uiSchema["ui:readonly"],
			    disabled = _props$uiSchema["ui:disabled"];


			return _react2.default.createElement(
				"div",
				{ className: "laji-form" },
				showShortcutsButton && this.props.showShortcutButton !== false && shortcuts && _react2.default.createElement(
					_components.TooltipComponent,
					{ tooltip: this.getShorcutButtonTooltip() },
					_react2.default.createElement(
						_components.Button,
						{ bsStyle: undefined, onClick: this.toggleHelp },
						translations.Shortcuts
					)
				),
				_react2.default.createElement(_components.FailedBackgroundJobsPanel, { jobs: this.state.submitHooks,
					schema: this.props.schema,
					uiSchema: this.props.uiSchema,
					context: this._context,
					formContext: this.state.formContext,
					errorClickHandler: this.errorClickHandler,
					tmpIdTree: this.tmpIdTree,
					ref: this.bgJobRef
				}),
				_react2.default.createElement(
					_core2.default,
					(0, _extends4.default)({}, this.props, {
						formData: this.state.formData,
						ref: this.getRef,
						onChange: this.onChange,
						onSubmit: this.onSubmit,
						fields: this.getFields(this.props.fields),
						widgets: this.getWidgets(this.props.widgets),
						FieldTemplate: _FieldTemplate2.default,
						ArrayFieldTemplate: _ArrayFieldTemplate2.default,
						ErrorList: _ErrorListTemplate2.default,
						formContext: this.state.formContext,
						noValidate: true,
						extraErrors: this.state.extraErrors,
						noHtml5Validate: true,
						liveValidate: true,
						autoComplete: "off"
					}),
					_react2.default.createElement(
						"div",
						null,
						this.props.children,
						!this.props.children && this.props.renderSubmit !== false ? _react2.default.createElement(
							_components.Button,
							{ id: "submit", type: "submit", disabled: readonly || disabled },
							this.props.submitText || translations.Submit
						) : null
					)
				),
				shortcuts && _react2.default.createElement(
					_reactBootstrap.Panel,
					{
						ref: this.getPanelRef,
						className: "shortcut-help laji-form-popped z-depth-3 hidden",
						style: { top: (this.props.topOffset || 0) + 5, bottom: (this.props.bottomOffset || 0) + 5 },
						bsStyle: "info"
					},
					_react2.default.createElement(
						_PanelHeading2.default,
						null,
						_react2.default.createElement(
							"h3",
							null,
							translations.Shortcuts,
							_react2.default.createElement(
								"button",
								{ type: "button", className: "close pull-right", onClick: this.dismissHelp },
								"\xD7"
							)
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Table,
						null,
						_react2.default.createElement(
							"tbody",
							{ className: "well" },
							(0, _keys2.default)(shortcuts).map(function (keyCombo, idx) {
								var _shortcuts$keyCombo = shortcuts[keyCombo],
								    fn = _shortcuts$keyCombo.fn,
								    targetLabel = _shortcuts$keyCombo.targetLabel,
								    label = _shortcuts$keyCombo.label,
								    rest = (0, _objectWithoutProperties3.default)(_shortcuts$keyCombo, ["fn", "targetLabel", "label"]);

								if (["help", "textareaRowInsert", "autosuggestToggle"].indexOf(fn) !== -1 || fn === "navigateSection" && rest.goOverRow) return;
								var translation = "";
								if (translation) translation = label;else translation = translations[[fn].concat((0, _toConsumableArray3.default)((0, _keys2.default)(rest))).map(_utils.capitalizeFirstLetter).join("")];
								if (targetLabel) translation = translation + " " + targetLabel;
								return _react2.default.createElement(
									"tr",
									{ key: idx },
									_react2.default.createElement(
										"td",
										null,
										(0, _utils.stringifyKeyCombo)(keyCombo)
									),
									_react2.default.createElement(
										"td",
										null,
										translation
									)
								);
							})
						)
					)
				),
				this.renderSubmitHooks()
			);
		}
	}]);
	return LajiForm;
}(_react.Component);

LajiForm.propTypes = {
	lang: _propTypes2.default.oneOf(["fi", "en", "sv"]),
	uiSchemaContext: _propTypes2.default.object,
	settings: _propTypes2.default.object,
	validators: _propTypes2.default.object,
	warnings: _propTypes2.default.object
};
LajiForm.defaultProps = {
	lang: "en",
	schema: {},
	uiSchema: {}
};
exports.default = LajiForm;