"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require("babel-runtime/helpers/get");

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

exports.getPropsWithInnerUiSchema = getPropsWithInnerUiSchema;
exports.default = VirtualSchemaField;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("../utils");

var _BaseComponent = require("./BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPropsWithInnerUiSchema(props) {
	return (0, _extends4.default)({}, props, {
		uiSchema: (0, _utils.getInnerUiSchema)(props.uiSchema)
	});
}

/**
 * Virtual SchemaFields are components which are just state transforming machines.
 */
function VirtualSchemaField(ComposedComponent) {
	var _class;

	var VirtualSchemaField = (0, _BaseComponent2.default)(_class = function (_ComposedComponent) {
		(0, _inherits3.default)(VirtualSchemaField, _ComposedComponent);

		function VirtualSchemaField() {
			(0, _classCallCheck3.default)(this, VirtualSchemaField);
			return (0, _possibleConstructorReturn3.default)(this, (VirtualSchemaField.__proto__ || (0, _getPrototypeOf2.default)(VirtualSchemaField)).apply(this, arguments));
		}

		(0, _createClass3.default)(VirtualSchemaField, [{
			key: "getUiOptions",
			value: function getUiOptions() {
				return (0, _utils.getUiOptions)(this.props.uiSchema);
			}
		}, {
			key: "getStateFromProps",
			value: function getStateFromProps(props) {
				var propsWithInnerUiSchema = getPropsWithInnerUiSchema(props);
				var state = (0, _get3.default)(VirtualSchemaField.prototype.__proto__ || (0, _getPrototypeOf2.default)(VirtualSchemaField.prototype), "getStateFromProps", this) ? (0, _get3.default)(VirtualSchemaField.prototype.__proto__ || (0, _getPrototypeOf2.default)(VirtualSchemaField.prototype), "getStateFromProps", this).call(this, propsWithInnerUiSchema, props) : propsWithInnerUiSchema;
				["readonly", "disabled"].forEach(function (prop) {
					if (props[prop]) {
						state.uiSchema = (0, _extends4.default)({}, state.uiSchema || propsWithInnerUiSchema.uiSchema, (0, _defineProperty3.default)({}, "ui:" + prop, true));
					}
				});
				return (0, _extends4.default)({}, propsWithInnerUiSchema, state, {
					onChange: this.onChange
				});
			}
		}, {
			key: "render",
			value: function render() {
				if ((0, _get3.default)(VirtualSchemaField.prototype.__proto__ || (0, _getPrototypeOf2.default)(VirtualSchemaField.prototype), "render", this)) return (0, _get3.default)(VirtualSchemaField.prototype.__proto__ || (0, _getPrototypeOf2.default)(VirtualSchemaField.prototype), "render", this).call(this);

				var SchemaField = this.props.registry.fields.SchemaField;

				var filterProps = function filterProps(props) {
					return ["schema", "uiSchema", "idSchema", "formData", "errorSchema", "formContext", "registry", "onChange"].reduce(function (_props, prop) {
						if (prop in props) _props[prop] = props[prop];
						return _props;
					}, {});
				};

				return _react2.default.createElement(SchemaField, filterProps((0, _extends4.default)({}, this.props, this.state)));
			}
		}]);
		return VirtualSchemaField;
	}(ComposedComponent)) || _class;

	VirtualSchemaField.displayName = (0, _utils.getReactComponentName)(ComposedComponent);


	if (ComposedComponent.getName) {
		var name = ComposedComponent.getName();
		new _Context2.default("VIRTUAL_SCHEMA_NAMES")[name] = true;
		if (process.env.NODE_ENV !== "production" && ComposedComponent.getName() !== (0, _utils.getReactComponentName)(ComposedComponent)) {
			console.warn((0, _utils.getReactComponentName)(ComposedComponent) + " getName() doesn't return it's component name! (It returned '" + name + "')");
		}
	} else {
		console.warn((0, _utils.getReactComponentName)(ComposedComponent) + " is missing static getName() method!");
	}

	return VirtualSchemaField;
}