"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = exports.ArrayFieldAddRemovePatched = exports.copyItemFunction = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

exports.onArrayFieldChange = onArrayFieldChange;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _ArrayField3 = require("@rjsf/core/dist/cjs/components/fields/ArrayField");

var _ArrayField4 = _interopRequireDefault(_ArrayField3);

var _utils = require("@rjsf/core/dist/cjs/utils");

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _utils2 = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Doesn't work with arrays properly since uses JSON Pointers but not JSON path.
// e.g. "copy all array item values expect these" is impossible.
var copyItemFunction = exports.copyItemFunction = function copyItemFunction(that, copyItem) {
	return function (props, _ref) {
		var type = _ref.type,
		    filter = _ref.filter;
		var _that$props = that.props,
		    schema = _that$props.schema,
		    registry = _that$props.registry,
		    formContext = _that$props.formContext;

		var defaultItem = (0, _utils.getDefaultFormState)(schema.items, undefined, registry.definitions);

		copyItem = (0, _utils2.filterItemIdsDeeply)(copyItem, formContext.contextId, that.props.idSchema.$id);

		var source = type === "blacklist" ? defaultItem : copyItem;

		var filtered = filter.sort().reverse().reduce(function (target, f) {
			var sourceValue = void 0;
			try {
				sourceValue = (0, _utils2.parseJSONPointer)(source, f);
			} catch (e) {
				var _schema = (0, _utils2.schemaJSONPointer)(_schema.items, f);
				sourceValue = (0, _utils.getDefaultFormState)(_schema, undefined, registry.definitions);
			}
			return (0, _utils2.updateFormDataWithJSONPointer)({ schema: schema.items, formData: target, registry: registry }, sourceValue, f);
		}, type === "blacklist" ? copyItem : defaultItem);

		return filtered;
	};
};

function onArrayFieldChange(formData, props) {
	var tmpIdTree = (0, _utils2.getRelativeTmpIdTree)(props.formContext.contextId, props.idSchema.$id);
	return (0, _utils2.addLajiFormIds)(formData, tmpIdTree, false)[0];
}

var ArrayFieldAddRemovePatched = exports.ArrayFieldAddRemovePatched = function (_ArrayField2) {
	(0, _inherits3.default)(ArrayFieldAddRemovePatched, _ArrayField2);

	function ArrayFieldAddRemovePatched() {
		var _ref2;

		(0, _classCallCheck3.default)(this, ArrayFieldAddRemovePatched);

		for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
			params[_key] = arguments[_key];
		}

		var _this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = ArrayFieldAddRemovePatched.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldAddRemovePatched)).call.apply(_ref2, [this].concat(params)));

		var _getNewFormDataRow = _this._getNewFormDataRow;

		_this._getNewFormDataRow = function () {
			var tmpIdTree = (0, _utils2.getRelativeTmpIdTree)(_this.props.formContext.contextId, _this.props.idSchema.$id);

			var _addLajiFormIds = (0, _utils2.addLajiFormIds)(_getNewFormDataRow.call(_this), tmpIdTree, false),
			    _addLajiFormIds2 = (0, _slicedToArray3.default)(_addLajiFormIds, 1),
			    item = _addLajiFormIds2[0];

			return item;
		};

		var onDropIndexClick = _this.onDropIndexClick;

		_this.onDropIndexClick = function (index) {
			return function (event) {
				var item = _this.props.formData[index];
				var tmpIdTree = (0, _utils2.getRelativeTmpIdTree)(_this.props.formContext.contextId, _this.props.idSchema.$id + "_" + index);
				var oldIds = (0, _utils2.getAllLajiFormIdsDeeply)(item, tmpIdTree);

				(0, _keys2.default)(oldIds).forEach(function (id) {
					return new _Context2.default(_this.props.formContext.contextId).removeSubmitHook(id);
				}, []);
				onDropIndexClick.call(_this, index)(event);
			};
		};
		return _this;
	}

	return ArrayFieldAddRemovePatched;
}(_ArrayField4.default);

var _ArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(_ArrayField, _Component);

	function _ArrayField() {
		var _ref3;

		var _temp, _this2, _ret;

		(0, _classCallCheck3.default)(this, _ArrayField);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref3 = _ArrayField.__proto__ || (0, _getPrototypeOf2.default)(_ArrayField)).call.apply(_ref3, [this].concat(args))), _this2), _this2.onChange = function (formData) {
			_this2.props.onChange(onArrayFieldChange(formData, _this2.props));
		}, _this2.buttonDefinitions = {
			copy: {
				glyph: "duplicate",
				fn: function fn() {
					return function () {
						(0, _ArrayFieldTemplate.beforeAdd)(_this2.props);
						_this2.onChange([].concat((0, _toConsumableArray3.default)(_this2.props.formData), [copyItemFunction(_this2, _this2.props.formData[_this2.props.formData.length - 1]).apply(undefined, arguments)]));
					};
				},
				rules: {
					minLength: 1,
					canAdd: true
				},
				changesFormData: true
			},
			addPredefined: {
				fn: function fn() {
					return function (onClickProps, _ref4) {
						var _default = _ref4.default;

						(0, _ArrayFieldTemplate.beforeAdd)(_this2.props);
						_this2.onChange([].concat((0, _toConsumableArray3.default)(_this2.props.formData || []), [(0, _utils.getDefaultFormState)(_this2.props.schema.items, _default, _this2.props.registry.definitions)]));
					};
				},
				rules: {
					canAdd: true
				},
				changesFormData: true
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
	}

	(0, _createClass3.default)(_ArrayField, [{
		key: "render",
		value: function render() {
			var props = this.props;
			var schema = props.schema;

			if (props.uiSchema.items && props.uiSchema.items["ui:field"]) {
				schema = (0, _extends3.default)({}, schema, { uniqueItems: false });
			}

			// MultiArrayField needs to intercept default ArrayField internals, the instance is passed in formContext.
			var _ArrayField = props.formContext.ArrayField;

			var Component = _ArrayField || ArrayFieldAddRemovePatched;

			// Reset formContext.ArrayField
			var formContext = _ArrayField ? (0, _extends3.default)({}, props.formContext, { ArrayField: undefined }) : props.formContext;
			var registry = _ArrayField ? (0, _extends3.default)({}, props.registry, { formContext: formContext }) : props.registry;

			return _react2.default.createElement(Component, (0, _extends3.default)({}, props, {
				formContext: formContext,
				registry: registry,
				schema: schema,
				uiSchema: (0, _extends3.default)({}, props.uiSchema, {
					"ui:options": (0, _extends3.default)({
						orderable: false
					}, props.uiSchema["ui:options"], {
						buttonDefinitions: (0, _utils2.getUiOptions)(props.uiSchema).buttonDefinitions ? (0, _deepmerge2.default)(this.buttonDefinitions, (0, _utils2.getUiOptions)(props.uiSchema).buttonDefinitions) : this.buttonDefinitions
					})
				}),
				onChange: this.onChange
			}));
		}
	}]);
	return _ArrayField;
}(_react.Component)) || _class;

exports.default = _ArrayField;