"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _ImageArrayField = require("./ImageArrayField");

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FILE_TYPES = ["audio/mp3", "audio/mpeg", "audio/x-wav", "audio/wav", "audio/wave", "audio/vnd.wave"];

var AudioArrayField = (0, _ImageArrayField.MediaArrayField)(_class = function (_Component) {
	(0, _inherits3.default)(AudioArrayField, _Component);

	function AudioArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, AudioArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AudioArrayField.__proto__ || (0, _getPrototypeOf2.default)(AudioArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.ALLOWED_FILE_TYPES = FILE_TYPES, _this.ACCEPT_FILE_TYPES = ["audio/*"], _this.MAX_FILE_SIZE = 20000000, _this.KEY = "AUDIO", _this.ENDPOINT = "audio", _this.GLYPH = "headphones", _this.TRANSLATION_TAKE_NEW = "TakeNewRecording", _this.TRANSLATION_SELECT_FILE = "SelectRecording", _this.TRANSLATION_NO_MEDIA = "NoRecording", _this.CONTAINER_CLASS = "audios-container", _this.METADATA_FORM_ID = "MHL.63", _this.renderMedia = function (id, idx) {
			return _react2.default.createElement(
				"div",
				{ className: "audio-container" },
				_react2.default.createElement(AudioButton, { id: id,
					idx: idx,
					apiClient: _this.props.formContext.apiClient,
					translations: _this.props.formContext.translations
				}),
				_react2.default.createElement(
					_components.GlyphButton,
					{ className: "audio-metadata-button", bsStyle: "info", glyph: "pencil", onClick: _this.openModalFor(idx) },
					" ",
					_this.props.formContext.translations.Edit
				)
			);
		}, _this.renderLoadingMedia = function () {
			return null;
		}, _this.renderLoadingMedia = function () {
			return _react2.default.createElement(
				"div",
				{ className: "audio-container loading" },
				_react2.default.createElement(_reactSpinner2.default, null)
			);
		}, _this.onMediaClick = function () {
			return null;
		}, _this.renderModalMedia = function (idx) {
			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement("img", { src: _this.state.modalMediaSrc }),
				_react2.default.createElement(LajiAudio, { id: _this.props.formData[idx], style: { width: "100%" }, apiClient: _this.props.formContext.apiClient, downloadLinks: true, translations: _this.props.formContext.translations })
			);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(AudioArrayField, [{
		key: "formatValue",
		value: function formatValue(value) {
			return (value || []).map(function (id, idx) {
				return _react2.default.createElement(_reactBootstrap.Glyphicon, { key: idx, glyph: "headphones" });
			});
		}
	}]);
	return AudioArrayField;
}(_react.Component)) || _class;

exports.default = AudioArrayField;


var AudioButton = _react2.default.forwardRef(function (props, ref) {
	var _useState = (0, _react.useState)(null),
	    _useState2 = (0, _slicedToArray3.default)(_useState, 2),
	    loaded = _useState2[0],
	    setLoaded = _useState2[1];

	var _useState3 = (0, _react.useState)(null),
	    _useState4 = (0, _slicedToArray3.default)(_useState3, 2),
	    playing = _useState4[0],
	    setPlaying = _useState4[1];

	var audioRef = _react2.default.useRef();
	var play = _react2.default.useCallback(function () {
		setPlaying(true);
		audioRef.current.play();
	});
	var stop = _react2.default.useCallback(function () {
		audioRef.current.pause();
		audioRef.current.currentTime = 0;
		setPlaying(false);
	});
	var onKeyDown = _react2.default.useCallback(function (e) {
		if (e.key === " ") {
			playing ? stop() : play();
			e.preventDefault();
			e.stopPropagation();
		}
	});
	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		!loaded ? _react2.default.createElement(
			"div",
			{ className: "media-loading" },
			_react2.default.createElement(_reactSpinner2.default, null)
		) : _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: playing ? "pause" : "play", onClick: playing ? stop : play, ref: ref, tabIndex: 0, onKeyDown: onKeyDown }),
		_react2.default.createElement(LajiAudio, { style: { display: "none" }, ref: audioRef, id: props.id, onLoaded: setLoaded, onStop: stop, apiClient: props.apiClient, translations: props.translations })
	);
});

var LajiAudio = _react2.default.forwardRef(function (props, ref) {
	var _useState5 = (0, _react.useState)(null),
	    _useState6 = (0, _slicedToArray3.default)(_useState5, 2),
	    mp3Url = _useState6[0],
	    setMp3Url = _useState6[1];

	var _useState7 = (0, _react.useState)(null),
	    _useState8 = (0, _slicedToArray3.default)(_useState7, 2),
	    wavUrl = _useState8[0],
	    setWavUrl = _useState8[1];

	(0, _react.useEffect)(function () {
		props.apiClient.fetchCached("/audio/" + props.id, undefined, { failSilently: true }).then(function (response) {
			setMp3Url(response.mp3URL);
			setWavUrl(response.wavURL);
			props.onLoaded && props.onLoaded(true);
		});
	});
	return !mp3Url ? _react2.default.createElement(_reactSpinner2.default, { style: props.style }) : _react2.default.createElement(
		"div",
		null,
		_react2.default.createElement(
			"audio",
			{ controls: true, style: props.style, ref: ref, onPause: props.onStop },
			_react2.default.createElement("source", { src: mp3Url })
		),
		props.downloadLinks && _react2.default.createElement(
			_react2.default.Fragment,
			null,
			_react2.default.createElement(
				"a",
				{ href: mp3Url, download: true },
				props.translations.Download + " mp3"
			),
			wavUrl && _react2.default.createElement(
				_react2.default.Fragment,
				null,
				" | ",
				_react2.default.createElement(
					"a",
					{ href: wavUrl, download: true },
					props.translations.Download + " wav"
				)
			)
		)
	);
});