"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require("babel-runtime/helpers/extends");

var _extends5 = _interopRequireDefault(_extends4);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _utils2 = require("@rjsf/core/dist/cjs/utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Combines values of two fields into one value which can be used for displaying (editing that value doesn't change formData)
 * Combine types:
 * timeDifference: combines the values by calculating their time difference
 * stringJoin (default): combines the values by joining them. delimiter is added between if given
 */

var combinedPropType = _propTypes2.default.shape({
	firstField: _propTypes2.default.string.isRequired,
	secondField: _propTypes2.default.string.isRequired,
	name: _propTypes2.default.string,
	title: _propTypes2.default.string,
	combineType: _propTypes2.default.string,
	delimiter: _propTypes2.default.string
});

var CombinedValueDisplayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(CombinedValueDisplayField, _Component);

	function CombinedValueDisplayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, CombinedValueDisplayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CombinedValueDisplayField.__proto__ || (0, _getPrototypeOf2.default)(CombinedValueDisplayField)).call.apply(_ref, [this].concat(args))), _this), _this.toMinutes = function (time) {
			var parts = time.split(":");
			return Number(parts[0]) * 60 + Number(parts[1]);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(CombinedValueDisplayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			var uiOptions = this.getUiOptions();
			var schema = props.schema,
			    idSchema = props.idSchema,
			    formData = props.formData;


			var combined = Array.isArray(uiOptions.combined) ? uiOptions.combined : [uiOptions.combined];

			combined.forEach(function (options) {
				var name = options.name,
				    title = options.title,
				    combineType = options.combineType,
				    firstField = options.firstField,
				    secondField = options.secondField;


				schema = (0, _extends5.default)({}, schema, { properties: (0, _extends5.default)({}, schema.properties, (0, _defineProperty3.default)({}, name || "", { title: title || "", type: "string" })) });
				idSchema = (0, _utils2.toIdSchema)(schema, idSchema.$id, props.registry.definitions);

				var value = undefined;

				var firstValue = firstField[0] === "/" ? (0, _utils.parseJSONPointer)(formData, firstField, !!"safely") : formData[firstField];
				var secondValue = secondField[0] === "/" ? (0, _utils.parseJSONPointer)(formData, secondField, !!"safely") : formData[secondField];
				if (combineType === "timeDifference") {
					if (firstValue && secondValue) {
						var difference = _this2.toMinutes(secondValue) - _this2.toMinutes(formData[firstField]);
						if (difference >= 0) {
							var hours = Math.floor(difference / 60);
							var minutes = difference % 60;
							value = hours + " h " + minutes + " min";
						}
					}
				} else {
					var delimiter = options.delimiter || "";
					value = [];
					if (firstValue) value.push(firstValue);
					if (secondValue) value.push(secondValue);
					value = value.join(delimiter);
				}

				formData = (0, _extends5.default)({}, formData, (0, _defineProperty3.default)({}, name, value));
			});

			return { schema: schema, idSchema: idSchema, formData: formData };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var uiOptions = this.getUiOptions();
			var combined = Array.isArray(uiOptions.combined) ? uiOptions.combined : [uiOptions.combined];

			var combinedFields = combined.map(function (options) {
				return options.name || "";
			}, []);

			combinedFields.forEach(function (field) {
				formData = (0, _utils.immutableDelete)(formData, field);
			});

			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "CombinedValueDisplayField";
		}
	}]);
	return CombinedValueDisplayField;
}(_react.Component)) || _class;

CombinedValueDisplayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			combined: _propTypes2.default.oneOfType([combinedPropType, _propTypes2.default.arrayOf(combinedPropType)])
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = CombinedValueDisplayField;