"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

exports.getInjectedUiSchema = getInjectedUiSchema;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ContextInjectionField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ContextInjectionField, _Component);

	function ContextInjectionField() {
		(0, _classCallCheck3.default)(this, ContextInjectionField);
		return (0, _possibleConstructorReturn3.default)(this, (ContextInjectionField.__proto__ || (0, _getPrototypeOf2.default)(ContextInjectionField)).apply(this, arguments));
	}

	(0, _createClass3.default)(ContextInjectionField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _getUiOptions = this.getUiOptions(),
			    injections = _getUiOptions.injections,
			    _getUiOptions$target = _getUiOptions.target,
			    target = _getUiOptions$target === undefined ? "uiSchema" : _getUiOptions$target;

			var container = props[target];
			return (0, _defineProperty3.default)({}, target, getInjectedUiSchema(container, injections, props.formContext.uiSchemaContext));
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "ContextInjectionField";
		}
	}]);
	return ContextInjectionField;
}(_react.Component)) || _class;

ContextInjectionField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			injections: _propTypes2.default.object.isRequired,
			target: _propTypes2.default.oneOf(["uiSchema", "schema"])
		}).isRequired,
		uiSchema: _propTypes2.default.object
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array])
};
exports.default = ContextInjectionField;
function getInjectedUiSchema(uiSchema, injections, uiSchemaContext) {
	var injected = false;
	var updateObject = {};
	for (var injectionPath in injections) {
		var splitted = injectionPath.substring(1).split("/");
		var last = splitted.pop();
		var tail = splitted.reduce(function (pointer, path) {
			if (!pointer[path]) pointer[path] = {};
			return pointer[path];
		}, updateObject);
		var value = injections[injectionPath];
		if (value.match(/%{.*}/)) {
			while (value.match(/%{.*}/)) {
				var _value$match = value.match(/%{(.*)}/),
				    _value$match2 = (0, _slicedToArray3.default)(_value$match, 2),
				    match = _value$match2[0],
				    innerValue = _value$match2[1];

				value = value.replace(match, (0, _utils.parseJSONPointer)(uiSchemaContext, innerValue));
			}
		} else {
			value = (0, _utils.parseJSONPointer)(uiSchemaContext, value);
		}
		tail[last] = { $set: value };
		injected = true;
	}
	if (injected) uiSchema = (0, _immutabilityHelper2.default)(uiSchema, updateObject);

	return uiSchema;
}