"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require("babel-runtime/helpers/extends");

var _extends5 = _interopRequireDefault(_extends4);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Disables object field's value according a regexp rule that is matched against another field's value.
 * uiSchema = { "ui:options": {
 *  disableField: <object field name>, (field to disable if disableDefiner's value doesn't match the regexp)
 *  disableDefiner: <object field name>, (field that the regexp is matched against)
 *  uiSchema: <uiSchema> (uiSchema used for each object).
 * }}
 */
var DependentDisableField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(DependentDisableField, _Component);

	function DependentDisableField() {
		(0, _classCallCheck3.default)(this, DependentDisableField);
		return (0, _possibleConstructorReturn3.default)(this, (DependentDisableField.__proto__ || (0, _getPrototypeOf2.default)(DependentDisableField)).apply(this, arguments));
	}

	(0, _createClass3.default)(DependentDisableField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var uiSchema = props.uiSchema,
			    formData = props.formData;

			var newFormData = formData;

			this.getUiOptions().rules.forEach(function (rule) {
				var disableField = rule.disableField,
				    disableDefiner = rule.disableDefiner,
				    regexp = rule.regexp;
				var formData = props.formData;


				var fieldToMatch = formData && !(0, _utils.isNullOrUndefined)(formData[disableDefiner]) ? formData[disableDefiner] : "";

				if (fieldToMatch.match(regexp)) {
					if (!uiSchema[disableField]) {
						uiSchema = (0, _extends5.default)({}, uiSchema, (0, _defineProperty3.default)({}, disableField, {}));
					}
					uiSchema = (0, _immutabilityHelper2.default)(uiSchema, (0, _defineProperty3.default)({}, disableField, {
						$merge: {
							"ui:disabled": true,
							"ui:inlineHelp": rule.inlineHelp
						}
					}));
					if (rule.hasOwnProperty("disabledValueToDisplay")) {
						newFormData = (0, _extends5.default)({}, formData, (0, _defineProperty3.default)({}, disableField, rule.disabledValueToDisplay));
					}
				}
			});

			return { uiSchema: uiSchema, formData: newFormData };
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "DependentDisableField";
		}
	}]);
	return DependentDisableField;
}(_react.Component)) || _class;

DependentDisableField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			rules: _propTypes2.default.arrayOf(_propTypes2.default.shape({
				disableField: _propTypes2.default.string.isRequired,
				disableDefiner: _propTypes2.default.string.isRequired,
				regexp: _propTypes2.default.string.isRequired
			})).isRequired
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = DependentDisableField;