"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = DescriptonField;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _utils = require("../../utils");

var _leaflet = require("leaflet");

var _leaflet2 = _interopRequireDefault(_leaflet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function DescriptonField(props) {
	var description = props.description;

	if (!description) {
		return null;
	}
	var replacePatterns = description.match(/%{.*?}/g) || [];
	var _description = replacePatterns.reduce(function (desc, replacePattern) {
		replacePattern = replacePattern.replace(/%|{|}/g, "");
		var replacement = void 0;
		if (replacePattern[0] === "#") {
			replacement = (0, _utils.parseJSONPointer)(new _Context2.default(props.formContext.contextId).formData, replacePattern.substr(1));
			// TODO DescriptionField doesn't receive formData
			//} else if (replacePattern[0] === "/") {
			//	replacement = parseJSONPointer(props.formData, replacePattern);
		} else if (replacePattern.startsWith("bbox")) {
			var field = replacePattern.match(/\((.*)\)/)[1];
			var value = (0, _utils.parseJSONPointer)(new _Context2.default(props.formContext.contextId).formData, field.substr(1));
			var bounds = _leaflet2.default.geoJSON(value).getBounds();
			var sw = bounds.getSouthWest();
			var ne = bounds.getNorthEast();
			replacement = sw.lat + ":" + ne.lat + ":" + sw.lng + ":" + ne.lng + ":WGS84";
		} else if (replacePattern === "lang") {
			replacement = props.formContext.lang;
		}
		return desc.replace("%{" + replacePattern + "}", replacement);
	}, description);
	return _react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: _description } });
}