"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ArrayFieldIdFixed = exports.default = undefined;

var _get2 = require("babel-runtime/helpers/get");

var _get3 = _interopRequireDefault(_get2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _ArrayField = require("./ArrayField");

var _utils2 = require("@rjsf/core/dist/cjs/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FilterArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(FilterArrayField, _Component);

	function FilterArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, FilterArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FilterArrayField.__proto__ || (0, _getPrototypeOf2.default)(FilterArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.getOnActiveChange = function (idx, prop, callback) {
			var offset = idx === undefined ? 0 : idx in _this.filteredToOffsets ? _this.filteredToOffsets[idx] : _this.filteredTotal;
			_this.cachedOnActiveChange(idx === undefined ? undefined : idx + offset, prop, callback);
		}, _this.onChange = function (formData) {
			_this.props.onChange((0, _keys2.default)(_this.filteredIdxs).sort().reduce(function (_formData, idx) {
				var updated = [].concat((0, _toConsumableArray3.default)(_formData));
				updated.splice(idx, 0, _this.filteredIdxs[idx]);
				return updated;
			}, formData));
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(FilterArrayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			if (props.schema.items.type !== "object") {
				throw new Error("Can't use FilterArrayField if items aren't objects");
			}
			this.cache = this.cache || {};

			var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
			    rules = _getUiOptions.rules,
			    cache = _getUiOptions.cache;

			this.filteredIdxs = {};
			this.filteredToOffsets = {};
			this.idxToOffsets = {};
			var filteredCount = 0;
			var store = function store(idx, item) {
				_this2.filteredIdxs[idx] = item;
				filteredCount++;
			};
			var formData = (props.formData || []).filter(function (item, idx) {
				var passes = void 0;
				if (cache) {
					var _checkArrayRules = (0, _utils.checkArrayRules)(rules, { formData: props.formData }, idx, _this2.cache),
					    _passes = _checkArrayRules.passes,
					    _cache = _checkArrayRules.cache;

					passes = _passes;
					_this2.cache = _cache;
					!passes && store(idx, item);
				} else {
					passes = (0, _utils.checkArrayRules)(rules, { formData: props.formData }, idx);
					!passes && store(idx, item);
				}
				if (passes) {
					_this2.filteredToOffsets[idx - filteredCount] = filteredCount;
					_this2.filteredToOffsets["_" + idx] = filteredCount;
				}
				_this2.idxToOffsets[idx] = filteredCount;
				return passes;
			});
			this.filteredTotal = filteredCount;
			var errorSchema = (0, _keys2.default)(props.errorSchema).reduce(function (errorSchema, idx) {
				errorSchema[idx - _this2.idxToOffsets[idx]] = props.errorSchema[idx];
				return errorSchema;
			}, {});

			var formContext = (0, _extends3.default)({}, props.formContext, { ArrayField: ArrayFieldIdFixed });
			var registry = (0, _extends3.default)({}, props.registry, { formContext: formContext });

			var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			var uiSchema = (0, _extends3.default)({}, innerUiSchema, {
				"ui:options": this.getActiveProps((0, _extends3.default)({}, (0, _utils.getUiOptions)(innerUiSchema), {
					idxOffsets: this.filteredToOffsets,
					totalOffset: this.filteredTotal
				}))
			});

			return (0, _extends3.default)({}, props, {
				formData: formData,
				uiSchema: uiSchema,
				errorSchema: errorSchema,
				formContext: formContext,
				registry: registry,
				onChange: this.onChange
			});
		}
	}, {
		key: "getActiveProps",
		value: function getActiveProps(options) {
			var _options = options,
			    onActiveChange = _options.onActiveChange,
			    activeIdx = _options.activeIdx;

			if (onActiveChange) {
				if (this.cachedOnActiveChange !== onActiveChange) {
					this.cachedOnActiveChange = onActiveChange;
				}
				options = (0, _extends3.default)({}, options, {
					onActiveChange: this.getOnActiveChange
				});
			}
			if (activeIdx !== undefined) {
				options = (0, _extends3.default)({}, options, {
					activeIdx: options.activeIdx - this.idxToOffsets[options.activeIdx]
				});
			}
			return options;
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;
			return _react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, this.state));
		}
	}]);
	return FilterArrayField;
}(_react.Component)) || _class;

exports.default = FilterArrayField;

var ArrayFieldIdFixed = exports.ArrayFieldIdFixed = function (_ArrayFieldAddRemoveP) {
	(0, _inherits3.default)(ArrayFieldIdFixed, _ArrayFieldAddRemoveP);

	function ArrayFieldIdFixed() {
		(0, _classCallCheck3.default)(this, ArrayFieldIdFixed);
		return (0, _possibleConstructorReturn3.default)(this, (ArrayFieldIdFixed.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldIdFixed)).apply(this, arguments));
	}

	(0, _createClass3.default)(ArrayFieldIdFixed, [{
		key: "renderArrayFieldItem",
		value: function renderArrayFieldItem(props) {
			var idWithoutIdx = props.itemIdSchema.$id.replace(/(.*)_[0-9]+/, "$1");

			var _getUiOptions2 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    idxOffsets = _getUiOptions2.idxOffsets;

			var index = (idxOffsets[props.index] || 0) + props.index;
			var idSchema = (0, _utils2.toIdSchema)(props.itemSchema, idWithoutIdx + "_" + index, this.props.registry.definitions, props.itemData, this.props.idPrefix);
			return (0, _get3.default)(ArrayFieldIdFixed.prototype.__proto__ || (0, _getPrototypeOf2.default)(ArrayFieldIdFixed.prototype), "renderArrayFieldItem", this).call(this, (0, _extends3.default)({}, props, { itemIdSchema: idSchema }));
		}
	}]);
	return ArrayFieldIdFixed;
}(_ArrayField.ArrayFieldAddRemovePatched);