"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends9 = require("babel-runtime/helpers/extends");

var _extends10 = _interopRequireDefault(_extends9);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _utils = require("@rjsf/core/dist/cjs/utils");

var _utils2 = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPropName(field, innerField, isArray) {
	return field + "_" + (isArray ? "0_" : "") + innerField;
}

var FlatField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(FlatField, _Component);

	function FlatField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, FlatField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FlatField.__proto__ || (0, _getPrototypeOf2.default)(FlatField)).call.apply(_ref, [this].concat(args))), _this), _this._onChange = function (formData, schema, fields) {
			var _fields = [],
			    deepFields = [];
			fields.forEach(function (f) {
				(f.indexOf("_") !== -1 ? deepFields : _fields).push(f);
			});
			(0, _keys2.default)(formData).sort().forEach(function (prop) {
				if (prop.indexOf("_") !== -1) _fields.forEach(function (field) {
					if (prop.indexOf(field + "_") !== -1) {
						var isArray = schema.properties[field].type === "array";
						var newItemName = prop.replace(field + "_" + (isArray ? "0_" : ""), "");
						var newItemBase = isArray ? formData[field] && formData[field][0] ? formData[field][0] : {} : formData[field] || {};
						var updatedItem = (0, _extends10.default)({}, newItemBase, (0, _defineProperty3.default)({}, newItemName, formData[prop]));
						formData = (0, _extends10.default)({}, formData, (0, _defineProperty3.default)({}, field, isArray ? [updatedItem] : updatedItem));
						formData = (0, _utils2.immutableDelete)(formData, prop);
					}
				});
			});
			deepFields.forEach(function (deepField) {
				var deepContainerName = deepField.match(/^[^_]*/)[0];
				var deepContainer = formData[deepContainerName][0] || formData[deepContainerName];
				deepField = deepField.replace(/^[^_]*_(0_)?/, "");
				var deepSchema = schema.properties[deepContainerName];
				var changedDeep = _this._onChange(deepContainer, deepSchema.items || deepSchema, [deepField]);
				formData = (0, _extends10.default)({}, formData, (0, _defineProperty3.default)({}, deepContainerName, deepSchema.type === "array" ? [changedDeep] : changedDeep));
			});
			return formData;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(FlatField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props, origProps) {
			var state = {
				schema: props.schema,
				uiSchema: props.uiSchema,
				errorSchema: props.errorSchema,
				formData: props.formData,
				idSchema: props.idSchema
			};

			var _getUiOptions = this.getUiOptions(),
			    fields = _getUiOptions.fields;

			fields.sort().forEach(function (field) {
				var innerSchema = state.schema.properties[field];
				var isArray = innerSchema.type === "array";
				if (isArray) innerSchema = innerSchema.items;
				var _innerSchema = innerSchema,
				    properties = _innerSchema.properties;


				if (properties) (0, _keys2.default)(properties).forEach(function (innerField) {
					state.schema = (0, _immutabilityHelper2.default)(state.schema, { properties: { $merge: (0, _defineProperty3.default)({}, getPropName(field, innerField, isArray), properties[innerField]) } });
					if (innerSchema.required && innerSchema.required.indexOf(innerField) !== -1) {
						state.schema.required = (0, _immutabilityHelper2.default)(state.schema.required || [], { $push: [getPropName(field, innerField, isArray)] });
					}

					if (state.uiSchema[field]) {
						if (!isArray && state.uiSchema[field][innerField]) {
							state.uiSchema = (0, _immutabilityHelper2.default)(state.uiSchema, { $merge: (0, _defineProperty3.default)({}, getPropName(field, innerField, isArray), state.uiSchema[field][innerField]) });
						} else if (isArray && state.uiSchema[field].items && state.uiSchema[field].items[innerField]) {
							state.uiSchema = (0, _immutabilityHelper2.default)(state.uiSchema, { $merge: (0, _defineProperty3.default)({}, getPropName(field, innerField, isArray), state.uiSchema[field].items[innerField]) });
						}
					}

					state.idSchema = (0, _extends10.default)({}, state.idSchema, (0, _defineProperty3.default)({}, field, (0, _utils.toIdSchema)(state.schema.properties[field], state.idSchema.$id + "_" + field, props.registry.definitions)));
					var innerId = state.idSchema[field][innerField].$id;
					if (isArray) {
						innerId = innerId.replace(/(.*)_(.*)$/, "$1_0_$2");
					}
					state.idSchema = (0, _immutabilityHelper2.default)(state.idSchema, { $merge: (0, _defineProperty3.default)({}, getPropName(field, innerField, isArray), { $id: innerId }) });
				});

				state.schema.properties = (0, _utils2.immutableDelete)(state.schema.properties, field);
				state.idSchema = (0, _utils2.immutableDelete)(state.idSchema, field);

				var _state$uiSchema$uiOr = state.uiSchema["ui:order"],
				    order = _state$uiSchema$uiOr === undefined ? [] : _state$uiSchema$uiOr;

				var orderIdxs = order.reduce(function (obj, field, idx) {
					obj[field] = idx;
					return obj;
				}, {});

				if (field in orderIdxs) {
					var head = order.slice(0, orderIdxs[field]);
					var tail = order.slice(orderIdxs[field] + 1);
					state.uiSchema["ui:order"] = [].concat((0, _toConsumableArray3.default)(head), (0, _toConsumableArray3.default)((0, _keys2.default)(properties).map(function (innerField) {
						return getPropName(field, innerField, isArray);
					})), (0, _toConsumableArray3.default)(tail));
				}

				if (state.formData && state.formData[field]) {
					var innerData = state.formData[field];

					if (!innerData && state.schema.properties[field].type === "object") {
						innerData = (0, _utils.getDefaultFormState)(state.schema.properties[field], undefined, props.registry);
					} else if (!innerData && state.schema.properties[field].type === "array") {
						innerData = [(0, _utils.getDefaultFormState)(state.schema.properties[field].items, undefined, props.registry)];
					}

					if (Array.isArray(innerData)) {
						innerData = innerData[0];
					}

					(0, _keys2.default)(innerData || {}).forEach(function (innerField) {
						state.formData = (0, _extends10.default)({}, state.formData, (0, _defineProperty3.default)({}, getPropName(field, innerField, isArray), innerData[innerField]));
					});
					state.formData = (0, _utils2.immutableDelete)(state.formData, field);
				}

				if (state.errorSchema) {
					(0, _keys2.default)(state.errorSchema).forEach(function (errorField) {
						if (errorField === field) {
							if (isArray) {
								(0, _keys2.default)(state.errorSchema[errorField]).filter(function (key) {
									return key !== "__errors";
								}).map(function (key) {
									return state.errorSchema[errorField][key];
								}).forEach(function (error) {
									(0, _keys2.default)(error).forEach(function (innerError) {
										state.errorSchema = (0, _extends10.default)({}, state.errorSchema, (0, _defineProperty3.default)({}, getPropName(field, innerError, isArray), (0, _extends10.default)({}, state.errorSchema[getPropName(field, innerError, isArray)] || {}, error[innerError])));
									});
								});
								state.errorSchema = (0, _utils2.immutableDelete)(state.errorSchema, field);
								if (state.errorSchema[field] && state.errorSchema[field].__errors) {
									state.errorSchema = (0, _extends10.default)({}, state.errorSchema, { __errors: state.errorSchema[field].__errors });
								}
							} else {
								(0, _keys2.default)(state.errorSchema[errorField]).forEach(function (innerError) {
									state.errorSchema = (0, _extends10.default)({}, state.errorSchema, (0, _defineProperty3.default)({}, getPropName(field, innerError, isArray), (0, _extends10.default)({}, state.errorSchema[getPropName(field, innerError, isArray)] || {}, state.errorSchema[errorField][innerError])));
								});
								state.errorSchema = (0, _utils2.immutableDelete)(state.errorSchema, errorField);
							}
						}
					});
				}
			});

			var _props$formContext$fo = props.formContext.formDataTransformers,
			    formDataTransformers = _props$formContext$fo === undefined ? [] : _props$formContext$fo;

			state.formContext = (0, _extends10.default)({}, props.formContext, {
				formDataTransformers: [].concat((0, _toConsumableArray3.default)(formDataTransformers), [{ "ui:field": "FlatField", props: origProps }]) });

			return state;
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _formData = this._onChange(formData, this.props.schema, this.getUiOptions().fields);
			this.props.onChange(_formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "FlatField";
		}
	}]);
	return FlatField;
}(_react.Component)) || _class;

FlatField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			"fields": _propTypes2.default.arrayOf(_propTypes2.default.string)
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object
};
exports.default = FlatField;