"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GridLayoutField = function GridLayoutField(props) {
	var schema = props.schema,
	    uiSchema = props.uiSchema;
	var SchemaField = props.registry.fields.SchemaField;

	uiSchema = (0, _extends3.default)({}, uiSchema, {
		"ui:grid": uiSchema["ui:options"]
	});
	delete uiSchema["ui:field"];

	if ((0, _utils.getUiOptions)(uiSchema).label === false) {
		(0, _keys2.default)(schema.properties).forEach(function (propertyName) {
			var propertyUiSchema = uiSchema[propertyName] || {};
			uiSchema[propertyName] = (0, _extends3.default)({}, propertyUiSchema, {
				"ui:options": (0, _extends3.default)({}, propertyUiSchema["ui:options"] || {}, {
					label: false
				})
			});
		});
	}

	return _react2.default.createElement(SchemaField, (0, _extends3.default)({}, props, { schema: schema, uiSchema: uiSchema }));
};
GridLayoutField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:grid": _propTypes2.default.shape({
			lg: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			md: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			sm: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			xs: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object])
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired
};
exports.default = GridLayoutField;