"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Inject a schema object property to nested schema.
 * uiSchema = { "ui:options": {
 *  "injections": [
 *    {
 *      "fields": [field1, field2...],
 *      "target": fieldName
 *    }
 *    ...
 *  ]
 * }}
 */
var InjectField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(InjectField, _Component);

	function InjectField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, InjectField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = InjectField.__proto__ || (0, _getPrototypeOf2.default)(InjectField)).call.apply(_ref, [this].concat(args))), _this), _this.formatToOriginal = function (formData, props, fields) {
			fields.forEach(function (fieldPath) {
				var splits = fieldPath.split("/").filter(function (s) {
					return s;
				});
				var fieldName = splits[splits.length - 1];
				formData = (0, _immutabilityHelper2.default)(formData, _this.getFormDataPath(splits, { $set: props.formData[fieldName] }));
			});
			return formData;
		}, _this.getUpdateSchemaPropertiesPath = function (schema, $operation) {
			if (schema.type === "object") return { properties: $operation };else if (schema.type === "array") return { items: { properties: $operation } };else throw "schema is not object or array";
		}, _this.getSchemaProperties = function (schema, splits) {
			return (0, _utils.parseSchemaFromFormDataPointer)(schema, splits.join("/"));
		}, _this.getUpdateUiSchemaPropertiesPath = function (uiSchema, $operation) {
			return uiSchema.items ? { items: $operation } : $operation;
		}, _this.getUiSchemaProperties = function (uiSchema, splits) {
			return (0, _utils.parseUiSchemaFromFormDataPointer)(uiSchema, splits.join("/"));
		}, _this.getInnerData = function (data, splits) {
			if (!data) return data;
			return splits.reduce(function (o, s, i) {
				if (i === splits.length - 1) {
					return o[s];
				}
				return o[s] || {};
			}, data);
		}, _this.getSchemaPath = function (splits, $operation) {
			var path = {};
			splits.reduce(function (o, s, i) {
				if (i === splits.length - 1) {
					for (var k in $operation) {
						o[k] = $operation[k];
					}return $operation;
				} else if (!isNaN(s)) {
					o["items"] = {};
					return o["items"];
				} else {
					o["properties"] = {};
					o["properties"][s] = {};
					return o["properties"][s];
				}
			}, path);
			return path;
		}, _this.getFormDataPath = function (splits, $operation) {
			var path = {};
			splits.reduce(function (o, s, i) {
				if (i === splits.length - 1) {
					o[s] = $operation;
				} else {
					o[s] = {};
				}
				return o[s];
			}, path);
			return path;
		}, _this.getIdSchemaPath = function (splits, $operation) {
			var path = {};
			splits.reduce(function (o, s, i) {
				if (i === splits.length - 1) {
					o[s] = $operation;
				} else if (isNaN(s)) {
					o[s] = {};
					return o[s];
				}
				return o;
			}, path);

			return path;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(InjectField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			var options = this.getUiOptions();
			var injections = options.injections;
			var schema = props.schema,
			    uiSchema = props.uiSchema,
			    idSchema = props.idSchema,
			    formData = props.formData,
			    errorSchema = props.errorSchema;


			(Array.isArray(injections) ? injections : [injections]).forEach(function (injection) {
				var fields = injection.fields,
				    target = injection.target;


				fields.forEach(function (fieldPath) {
					var splits = fieldPath.split("/").filter(function (s) {
						return s;
					});
					var fieldName = splits[splits.length - 1];

					var parentProperties = _this2.getSchemaProperties(schema, splits.slice(0, splits.length - 1));
					schema = (0, _immutabilityHelper2.default)(schema, { properties: (0, _defineProperty3.default)({}, target, _this2.getUpdateSchemaPropertiesPath(schema.properties[target], { $merge: (0, _defineProperty3.default)({}, fieldName, parentProperties.properties[fieldName]) })) });
					if (splits.length === 1) parentProperties = schema;
					schema = (0, _immutabilityHelper2.default)(schema, _this2.getSchemaPath(splits, { properties: { $set: (0, _utils.immutableDelete)(parentProperties.properties, fieldName) } }));
					var idx = parentProperties.required ? parentProperties.required.indexOf(fieldName) : -1;
					if (idx > -1) {
						schema = (0, _immutabilityHelper2.default)(schema, { properties: (0, _defineProperty3.default)({}, target, { required: { $push: [fieldName] } }) });
						schema = (0, _immutabilityHelper2.default)(schema, _this2.getSchemaPath(splits, { required: { $splice: [[idx, 1]] } }));
					}

					var parentUiSchemaProperties = _this2.getUiSchemaProperties(uiSchema, splits.slice(0, splits.length - 1));
					uiSchema = (0, _utils.updateSafelyWithJSONPointer)(uiSchema, parentUiSchemaProperties[fieldName], "/" + target + "/" + fieldName);

					idSchema = (0, _immutabilityHelper2.default)(idSchema, (0, _defineProperty3.default)({}, target, { $merge: (0, _defineProperty3.default)({}, fieldName, { $id: idSchema.$id + "_" + fieldPath.replace(/\//g, "_") }) }));
					idSchema = (0, _immutabilityHelper2.default)(idSchema, _this2.getIdSchemaPath(splits, { $set: undefined }));
					if (formData && formData[target] && Array.isArray(formData[target])) {
						formData[target].forEach(function (item, i) {
							var data = _this2.getInnerData(formData, splits);
							var updatedItem = (0, _immutabilityHelper2.default)(item, { $merge: (0, _defineProperty3.default)({}, fieldName, null) });
							updatedItem = (0, _immutabilityHelper2.default)(updatedItem, (0, _defineProperty3.default)({}, fieldName, { $set: data }));
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, target, (0, _defineProperty3.default)({}, i, { $set: updatedItem })));
						});
					} else if (formData && formData[target]) {
						var data = _this2.getInnerData(formData, splits);
						formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, target, { $merge: (0, _defineProperty3.default)({}, fieldName, null) }));
						formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, target, (0, _defineProperty3.default)({}, fieldName, { $set: data })));
					}

					formData = (0, _utils.updateFormDataWithJSONPointer)((0, _extends3.default)({}, props, { formData: formData }), undefined, splits.join("/"));

					var errors = _this2.getInnerData(errorSchema, splits);
					if (errors && schema.properties[target].type === "array") {
						if (!errorSchema[target]) errorSchema = (0, _immutabilityHelper2.default)(errorSchema, { $merge: (0, _defineProperty3.default)({}, target, []) });
						for (var i = 0; i < formData[target].length; i++) {
							if (!errorSchema[target]) errorSchema = (0, _immutabilityHelper2.default)(errorSchema, { $merge: (0, _defineProperty3.default)({}, target, {}) });
							if (!errorSchema[target][i]) errorSchema = (0, _immutabilityHelper2.default)(errorSchema, (0, _defineProperty3.default)({}, target, { $merge: (0, _defineProperty3.default)({}, i, {}) }));
							errorSchema = (0, _immutabilityHelper2.default)(errorSchema, (0, _defineProperty3.default)({}, target, (0, _defineProperty3.default)({}, i, { $merge: (0, _defineProperty3.default)({}, fieldName, errors) })));
						}
						errorSchema = (0, _utils.immutableDelete)(errorSchema, fieldName);
					} else if (errors && schema.properties[target].type === "object") {
						if (!errorSchema[target]) errorSchema = (0, _immutabilityHelper2.default)(errorSchema, { $merge: (0, _defineProperty3.default)({}, target, {}) });
						errorSchema = (0, _immutabilityHelper2.default)(errorSchema, (0, _defineProperty3.default)({}, target, { $merge: (0, _defineProperty3.default)({}, fieldName, errors) }));
					}
				});
			});

			return { schema: schema, uiSchema: uiSchema, idSchema: idSchema, formData: formData, errorSchema: errorSchema };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _this3 = this;

			var options = this.getUiOptions();

			(Array.isArray(options.injections) ? options.injections : [options.injections]).forEach(function (injection) {
				var fields = injection.fields,
				    target = injection.target;


				if (!formData || !formData[target]) {
					formData = _this3.formatToOriginal(formData, _this3.props, fields);
					return;
				}

				var formDataChanged = false;
				fields.forEach(function (fieldPath) {
					var splits = fieldPath.split("/");
					var fieldName = splits[splits.length - 1];

					if (formData && formData[target] && Array.isArray(formData[target])) {
						for (var i in formData[target]) {
							var item = formData[target][i];
							if (item[fieldName] !== formData[fieldName]) {
								formData = (0, _immutabilityHelper2.default)(formData, _this3.getFormDataPath(splits, { $set: item[fieldName] }));
								formDataChanged = true;
							}
							item = (0, _utils.immutableDelete)(item, fieldName);
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, target, (0, _defineProperty3.default)({}, i, { $set: item })));
						}
					} else if (formData && formData[target] && formData[target][fieldName] !== undefined) {
						formData = (0, _immutabilityHelper2.default)(formData, _this3.getFormDataPath(splits, { $set: formData[target][fieldName] }));
						delete formData[target][fieldName];
						formDataChanged = true;
					}
				});
				if (!formDataChanged) {
					formData = _this3.formatToOriginal(formData, _this3.props, fields);
				}
			});

			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "InjectField";
		}
	}]);
	return InjectField;
}(_react.Component)) || _class;

InjectField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			injections: _propTypes2.default.shape({
				fields: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
				target: _propTypes2.default.string.isRequired
			}).isRequired
		}).isRequired,
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = InjectField;