"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.getFeatureStyleWithHighlight = exports.getFeatureStyleWithLowerOpacity = exports.Map = exports.MapComponent = exports.default = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _get3 = require("babel-runtime/helpers/get");

var _get4 = _interopRequireDefault(_get3);

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _class, _class2, _class3, _class4;

exports.parseGeometries = parseGeometries;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _lajiMap = require("laji-map");

var _lajiMap2 = _interopRequireDefault(_lajiMap);

var _utils = require("laji-map/lib/utils");

var _globals = require("laji-map/lib/globals");

var _reactBootstrap = require("react-bootstrap");

var _PanelHeading = require("react-bootstrap/lib/PanelHeading");

var _PanelHeading2 = _interopRequireDefault(_PanelHeading);

var _PanelBody = require("react-bootstrap/lib/PanelBody");

var _PanelBody2 = _interopRequireDefault(_PanelBody);

var _components = require("../components");

var _utils2 = require("../../utils");

var _utils3 = require("@rjsf/core/dist/cjs/utils");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _NestField = require("./NestField");

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

var _ArrayField = require("./ArrayField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseGeometries(geometry) {
	return (geometry && geometry.type === "GeometryCollection" ? geometry.geometries : [geometry]).filter(function (geometry) {
		return geometry;
	}).reduce(function (geometries, _geometry) {
		if (geometry.type === "GeometryCollection") {
			geometries = [].concat((0, _toConsumableArray3.default)(geometries), (0, _toConsumableArray3.default)(parseGeometries(_geometry)));
		} else if ("type" in geometry) {
			geometries.push(geometry);
		}
		return geometries;
	}, []);
}

var MapArrayField = function (_Component) {
	(0, _inherits3.default)(MapArrayField, _Component);

	function MapArrayField() {
		(0, _classCallCheck3.default)(this, MapArrayField);
		return (0, _possibleConstructorReturn3.default)(this, (MapArrayField.__proto__ || (0, _getPrototypeOf2.default)(MapArrayField)).apply(this, arguments));
	}

	(0, _createClass3.default)(MapArrayField, [{
		key: "render",
		value: function render() {
			var _getUiOptions = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    _getUiOptions$geometr = _getUiOptions.geometryMapper,
			    geometryMapper = _getUiOptions$geometr === undefined ? "default" : _getUiOptions$geometr;

			switch (geometryMapper) {
				case "default":
					return _react2.default.createElement(DefaultMapArrayField, this.props);
				case "units":
					return _react2.default.createElement(UnitsMapArrayField, this.props);
				case "lineTransect":
					return _react2.default.createElement(LineTransectMapArrayField, this.props);
				case "lolife":
					return _react2.default.createElement(LolifeMapArrayField, this.props);
			}
		}
	}]);
	return MapArrayField;
}(_react.Component);

MapArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			geometryField: _propTypes2.default.string,
			// Strategy for getting geometry data.
			geometryMapper: _propTypes2.default.oneOf(["default", "units", "lineTransect", "lolife", "lolifeNamedPlace"]),
			topOffset: _propTypes2.default.number,
			bottomOffset: _propTypes2.default.number,
			popupFields: _propTypes2.default.arrayOf(_propTypes2.default.object),
			computeAreaField: _propTypes2.default.string,
			areaInHectares: _propTypes2.default.bool,
			mapSizes: _propTypes2.default.shape({
				lg: _propTypes2.default.number,
				md: _propTypes2.default.number,
				sm: _propTypes2.default.number,
				xs: _propTypes2.default.number
			}),
			data: _propTypes2.default.arrayOf(_propTypes2.default.shape({
				geometryField: _propTypes2.default.string.isRequired
			})),
			help: _propTypes2.default.string
		}).isRequired
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object])
};
exports.default = MapArrayField;

var DefaultMapArrayField = _MapArrayField(_class = function (_Component2) {
	(0, _inherits3.default)(DefaultMapArrayField, _Component2);

	function DefaultMapArrayField(props) {
		(0, _classCallCheck3.default)(this, DefaultMapArrayField);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (DefaultMapArrayField.__proto__ || (0, _getPrototypeOf2.default)(DefaultMapArrayField)).call(this, props));

		_this2.onMapChangeCreateGathering = _this2.onMapChangeCreateGathering.bind(_this2);
		_this2.onChange = _this2.onChange.bind(_this2);
		_this2.getGeometry = _this2.getGeometry.bind(_this2);
		return _this2;
	}

	(0, _createClass3.default)(DefaultMapArrayField, [{
		key: "getOptions",
		value: function getOptions(options) {
			var _this3 = this;

			var formData = this.props.formData;

			var geometries = this.getData();

			var emptyMode = !formData || !formData.length;

			var draw = options.draw === false || (0, _utils2.isNullOrUndefined)(this.state.activeIdx) && !emptyMode ? false : (0, _extends4.default)({
				featureCollection: {
					type: "FeatureCollection",
					features: (geometries || []).map(function (geometry) {
						return { type: "Feature", properties: {}, geometry: geometry };
					})
				},
				getDraftStyle: this.getDraftStyle,
				onChange: emptyMode ? this.onMapChangeCreateGathering : this.onChange
			}, options.draw && options.draw.constructor === Object && options.draw !== null ? options.draw : {});

			var controls = emptyMode || this.state.activeIdx !== undefined ? { drawCopy: true } : { draw: false };

			var data = geometries && geometries.length || !options.placeholderGeometry ? [] : [{
				geoData: options.placeholderGeometry,
				getFeatureStyle: this._getPlaceholderStyle
			}];

			var extraData = (options.data || []).map(function (dataItem) {
				return { geoData: dataItem.geometryField ? _this3.getGeometry(formData, dataItem.geometryField) : dataItem };
			});

			return { draw: draw, controls: controls, emptyMode: emptyMode, data: [].concat(data, (0, _toConsumableArray3.default)(extraData)) };
		}
	}, {
		key: "onMapChangeCreateGathering",
		value: function onMapChangeCreateGathering(events) {
			var _this4 = this;

			var _getUiOptions2 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions2.geometryField;

			if (!geometryField) {
				return;
			}
			var formData = (0, _utils3.getDefaultFormState)(this.props.schema.items, undefined, this.props.registry.definitions);
			var geometries = events.filter(function (e) {
				return e.type === "create";
			}).map(function (e) {
				return e.feature.geometry;
			});

			var splittedPath = geometryField.split("/").filter(function (s) {
				return !(0, _utils2.isEmptyString)(s);
			});

			var _cumulatedPointer = "";
			var _schema = this.props.schema.items;
			formData = splittedPath.reduce(function (_formData, split, i) {
				_cumulatedPointer += "/" + split;
				_schema = _schema.properties ? _schema.properties[split] : _schema.items;
				return (0, _immutabilityHelper2.default)(_formData, (0, _utils2.getUpdateObjectFromJSONPointer)(_cumulatedPointer, { $set: i === splittedPath.length - 1 ? {
						type: "GeometryCollection",
						geometries: geometries
					} : (0, _utils3.getDefaultFormState)(_schema, undefined, _this4.props.registry.definitions)
				}));
			}, formData);

			this.props.onChange((0, _ArrayField.onArrayFieldChange)([formData], this.props));
			this.setState({ activeIdx: 0 });
		}
	}, {
		key: "getGeometry",
		value: function getGeometry(formData, _geometryField) {
			var uiSchema = this.props.uiSchema;

			var _getUiOptions3 = (0, _utils2.getUiOptions)(uiSchema),
			    geometryField = _getUiOptions3.geometryField;

			var activeIdx = this.state.activeIdx;

			if (!formData) {
				return;
			}
			var item = formData[activeIdx];
			if (activeIdx === undefined || !item) {
				return;
			}
			var geometryItem = (0, _utils2.parseJSONPointer)(formData[activeIdx], _geometryField || geometryField);
			return geometryItem;
		}
	}, {
		key: "getGeometries",
		value: function getGeometries() {
			return this.getData();
		}
	}, {
		key: "getData",
		value: function getData() {
			var geometryItem = this.getGeometry(this.props.formData);
			if (geometryItem && geometryItem.type) {
				return parseGeometries(geometryItem);
			}
			return [];
		}
	}, {
		key: "onChange",
		value: function onChange(events) {
			var _this5 = this;

			var formData = this.props.formData || [(0, _utils3.getDefaultFormState)(this.props.schema.items, undefined, this.props.registry.definitions)];
			var addOrDelete = false;
			events.forEach(function (e) {
				switch (e.type) {
					case "create":
						addOrDelete = true;
						formData = _this5.onAdd(e, formData);
						break;
					case "delete":
						addOrDelete = true;
						formData = _this5.onRemove(e, formData);
						break;
					case "edit":
						formData = _this5.onEdited(e, formData);
						break;
					case "insert":
						addOrDelete = true;
						formData = _this5.onInsert(e, formData);
						break;
				}
			});
			this.props.onChange(addOrDelete ? (0, _ArrayField.onArrayFieldChange)(formData, this.props) : formData);
		}
	}, {
		key: "onAdd",
		value: function onAdd(_ref, formData) {
			var geometry = _ref.feature.geometry;

			var _getUiOptions4 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions4.geometryField;

			return (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, this.state.activeIdx, (0, _utils2.getUpdateObjectFromJSONPointer)(geometryField, { $set: { type: "GeometryCollection", geometries: [].concat((0, _toConsumableArray3.default)(parseGeometries(this.getGeometry(formData))), [geometry]) } })));
		}
	}, {
		key: "onRemove",
		value: function onRemove(_ref2, formData) {
			var idxs = _ref2.idxs;

			var _getUiOptions5 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions5.geometryField;

			var splices = [];
			idxs.sort().reverse().forEach(function (idx) {
				splices.push([idx, 1]);
			});
			var geometry = this.getGeometry(formData);
			return (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, this.state.activeIdx, (0, _utils2.getUpdateObjectFromJSONPointer)(geometryField, geometry && geometry.type === "GeometryCollection" ? { geometries: { $splice: splices } } : { $set: undefined })));
		}
	}, {
		key: "onEdited",
		value: function onEdited(_ref3, formData) {
			var features = _ref3.features;

			var _getUiOptions6 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions6.geometryField;

			var geometry = this.getGeometry(formData);
			return (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, this.state.activeIdx, (0, _utils2.getUpdateObjectFromJSONPointer)(geometryField, geometry.type === "GeometryCollection" ? {
				geometries: (0, _keys2.default)(features).reduce(function (obj, idx) {
					obj[idx] = { $set: features[idx].geometry };
					return obj;
				}, {})
			} : { $set: features[0].geometry })));
		}
	}, {
		key: "onInsert",
		value: function onInsert(_ref4, formData) {
			var idx = _ref4.idx,
			    feature = _ref4.feature;

			var _getUiOptions7 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions7.geometryField;

			return (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, this.state.activeIdx, (0, _utils2.getUpdateObjectFromJSONPointer)(geometryField, {
				geometries: { $splice: [[idx, 0, feature.geometry]] }
			})));
		}
	}, {
		key: "afterActiveChange",
		value: function afterActiveChange(idx) {
			if (idx === undefined) return;
			this.map.zoomToData();
		}
	}]);
	return DefaultMapArrayField;
}(_react.Component)) || _class;

var UnitsMapArrayField = _MapArrayField(_class2 = function (_Component3) {
	(0, _inherits3.default)(UnitsMapArrayField, _Component3);

	function UnitsMapArrayField(props) {
		(0, _classCallCheck3.default)(this, UnitsMapArrayField);

		var _this6 = (0, _possibleConstructorReturn3.default)(this, (UnitsMapArrayField.__proto__ || (0, _getPrototypeOf2.default)(UnitsMapArrayField)).call(this, props));

		_this6.field = "units";

		_this6.isGeometryCollection = function (idx) {
			return _this6.props.formData[_this6.state.activeIdx].units[idx].unitGathering.geometry.type === "GeometryCollection";
		};

		_this6.getOptions = function (options) {
			var formData = _this6.props.formData;

			var _this6$getData = _this6.getData(),
			    _this6$getData$gather = _this6$getData.gatherings,
			    gatherings = _this6$getData$gather === undefined ? [] : _this6$getData$gather,
			    _this6$getData$units = _this6$getData.units,
			    units = _this6$getData$units === undefined ? [] : _this6$getData$units;

			var emptyMode = !formData || !formData.length;

			var draw = options.draw === false || (0, _utils2.isNullOrUndefined)(_this6.state.activeIdx) && !emptyMode ? false : (0, _extends4.default)({
				featureCollection: {
					type: "FeatureCollection",
					features: gatherings.map(function (geometry) {
						return { type: "Feature", properties: {}, geometry: geometry };
					})
				},
				getDraftStyle: _this6.getDraftStyle,
				onChange: emptyMode ? _this6.onMapChangeCreateGathering : _this6.onChange
			}, options.draw && options.draw.constructor === Object && options.draw !== null ? options.draw : {});

			// Separate non geometry collections and geometry collections with single geometry to
			// unitGeometries, and put the rest to unitGeometryCollections. This is for optimization.
			var unitGeometryCollections = {},
			    unitGeometries = {};
			units.forEach(function (geometry, idx) {
				var target = geometry.type !== "GeometryCollection" || geometry.geometries.length === 1 ? unitGeometries : unitGeometryCollections;
				target[idx] = geometry.type === "GeometryCollection" && geometry.geometries.length === 1 ? geometry.geometries[0] : geometry;
			});

			_this6.unitIdxToGeometryIdx = {};
			_this6.geometryIdxUnitIdx = {};
			_this6.unitIdxToGeometryCollectionIdx = {};
			_this6.geometryCollectionIdxUnitIdx = {};
			var reducer = function reducer(_ref5, idx, _idx) {
				var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
				    uToG = _ref6[0],
				    gToU = _ref6[1];

				uToG[idx] = _idx;
				gToU[_idx] = idx;
				return [uToG, gToU];
			};
			(0, _keys2.default)(unitGeometries).reduce(reducer, [_this6.unitIdxToGeometryIdx, _this6.geometryIdxUnitIdx]);
			(0, _keys2.default)(unitGeometryCollections).reduce(reducer, [_this6.unitIdxToGeometryCollectionIdx, _this6.geometryCollectionIdxUnitIdx]);

			if (!_this6.unitChangeHandlers) {
				_this6.unitChangeHandlers = { onChange: {}, mouseOver: {}, mouseOut: {} };
			}

			var getCommonOptions = function getCommonOptions(unitIdx) {
				// Store so change detection doesn't think it's a new function.
				var unitChangeHandler = _this6.unitChangeHandlers.onChange[unitIdx] || _this6.onUnitChange(unitIdx ? +unitIdx : undefined);
				_this6.unitChangeHandlers.onChange[unitIdx] = unitChangeHandler;
				var mouseOver = _this6.unitChangeHandlers.mouseOver[unitIdx] || _this6.onMouseOver(unitIdx ? +unitIdx : undefined);
				_this6.unitChangeHandlers.mouseOver[unitIdx] = mouseOver;
				var mouseOut = _this6.unitChangeHandlers.mouseOut[unitIdx] || _this6.onMouseOut(unitIdx ? +unitIdx : undefined);
				_this6.unitChangeHandlers.mouseOut[unitIdx] = mouseOut;
				return {
					getPopup: _this6.getPopup,
					getFeatureStyle: _this6.getUnitFeatureStyle,
					getDraftStyle: _this6.getDraftStyle,
					editable: true,
					onChange: unitChangeHandler,
					on: {
						mouseover: mouseOver,
						mouseout: mouseOut
					}
				};
			};

			var data = [(0, _extends4.default)({
				featureCollection: {
					type: "FeatureCollection",
					features: (0, _keys2.default)(unitGeometries).reduce(function (units, idx) {
						idx = +idx;
						var geometry = unitGeometries[idx];
						if (geometry) units.push({ type: "Feature", properties: { idx: idx }, geometry: geometry });
						return units;
					}, [])
				}
			}, getCommonOptions())].concat((0, _toConsumableArray3.default)((0, _keys2.default)(unitGeometryCollections).map(function (idx) {
				idx = +idx;
				var geometryCollection = unitGeometryCollections[idx];
				return (0, _extends4.default)({
					featureCollection: {
						type: "FeatureCollection",
						features: geometryCollection.geometries.map(function (geometry) {
							return {
								type: "Feature", properties: { idx: idx }, geometry: geometry
							};
						})
					}
				}, getCommonOptions(_this6.geometryCollectionIdxUnitIdx[idx]));
			})));

			_this6.unitFeatures = data[0].featureCollection.features;

			var controls = emptyMode || !(0, _utils2.isNullOrUndefined)(_this6.state.activeIdx) ? {} : { draw: false };

			return { draw: draw, data: data, controls: controls, emptyMode: emptyMode };
		};

		_this6.getUnitFeatureStyle = function () {
			var color = "#55AEFA";
			if (_this6._highlightedUnit !== undefined) {
				color = (0, _utils.combineColors)(color, "#ffffff", 30);
			}
			return { color: color, fillColor: color, weight: 4 };
		};

		_this6.startHighlight = function (_ref7) {
			var idx = _ref7.idx;

			var color = (0, _utils.combineColors)(_this6.getUnitFeatureStyle().color, "#ffffff", 30);
			if (idx in _this6.unitIdxToGeometryCollectionIdx) {
				var _idx = _this6.unitIdxToGeometryCollectionIdx[idx];
				_this6.map.data[_idx + 1].group.getLayers().forEach(function (layer) {
					_this6.map.setLayerStyle(layer, { color: color });
				});
			} else {
				var _idx2 = _this6.unitIdxToGeometryIdx[idx];
				var layer = _this6.map.getLayerByIdxTuple([0, _idx2]);
				layer && _this6.map.setLayerStyle(layer, { color: color });
			}
		};

		_this6.endHighlight = function (_ref8) {
			var idx = _ref8.idx;

			var color = _this6.getUnitFeatureStyle().color;
			if (idx in _this6.unitIdxToGeometryCollectionIdx) {
				var _idx = _this6.unitIdxToGeometryCollectionIdx[idx];
				_this6.map.data[_idx + 1].group.getLayers().forEach(function (layer) {
					_this6.map.setLayerStyle(layer, { color: color });
				});
			} else {
				var _idx3 = _this6.unitIdxToGeometryIdx[idx];
				var layer = _this6.map.getLayerByIdxTuple([0, _idx3]);
				layer && _this6.map.setLayerStyle(layer, { color: color });
			}
		};

		_this6.onMouseOver = function (unitIdx) {
			return function (e, _ref9) {
				var feature = _ref9.feature;

				var idx = unitIdx !== undefined ? unitIdx : feature.properties.idx;

				if (idx === undefined) {
					return;
				}

				_this6._highlightedUnit = idx;
				_this6.startHighlight(idx);

				var id = _this6.props.idSchema.$id + "_" + _this6.state.activeIdx + "_units_" + idx;
				_this6.highlightedElem = (0, _utils2.getSchemaElementById)(_this6.props.formContext.contextId, id);

				if (_this6.highlightedElem) {
					_this6.highlightedElem.className += " map-highlight";
				}
			};
		};

		_this6.onMouseOut = function (unitIdx) {
			return function (e, _ref10) {
				var feature = _ref10.feature;

				var idx = unitIdx !== undefined ? unitIdx : feature.properties.idx;

				if (idx === undefined) {
					return;
				}

				_this6._highlightedUnit = undefined;
				_this6.endHighlight(idx);

				if (_this6.highlightedElem) {
					_this6.highlightedElem.className = _this6.highlightedElem.className.replace(" map-highlight", "");
				}
			};
		};

		_this6.onUnitChange = function (unitIdx) {
			return function (events) {
				events.forEach(function (e) {
					switch (e.type) {
						case "delete":
							_this6.onUnitRemove(e, unitIdx);
							break;
						case "edit":
							_this6.onUnitEdited(e, unitIdx);
							break;
					}
				});
			};
		};

		_this6.onUnitRemove = function (e, unitIdx) {
			if (unitIdx === undefined) {
				// Isn't a geometry collection (unitIdx stored in feature properties)
				var idxs = e.idxs.map(function (idx) {
					return _this6.unitFeatures[idx].properties.idx;
				});
				var formData = _this6.props.formData;


				var unitIdxs = idxs;

				var updateObject = (0, _defineProperty3.default)({}, _this6.state.activeIdx, {
					units: unitIdxs.reduce(function (obj, idx) {
						obj[idx] = {
							unitGathering: {
								geometry: {
									$set: (0, _utils3.getDefaultFormState)(_this6.props.schema.items.properties.units.items.properties.unitGathering.properties.geometry, undefined, _this6.props.registry.definitions)
								}
							}
						};
						return obj;
					}, {})
				});

				_this6.props.onChange((0, _immutabilityHelper2.default)(formData, updateObject));
			} else {
				// Is a geometry collection.
				var _idxs = e.idxs;

				_this6.props.onChange((0, _immutabilityHelper2.default)(_this6.props.formData, (0, _defineProperty3.default)({}, _this6.state.activeIdx, {
					units: (0, _defineProperty3.default)({}, unitIdx, {
						unitGathering: {
							geometry: {
								geometries: {
									$splice: _idxs.sort().reverse().map(function (idx) {
										return [idx, 1];
									})
								}
							}
						}
					})
				})));
			}
		};

		_this6.onUnitEdited = function (_ref11, unitIdx) {
			var features = _ref11.features;

			if (unitIdx === undefined) {
				// Isn't a geometry collection (unitIdx stored in feature properties)
				var unitEditGeometries = (0, _keys2.default)(features).reduce(function (unitEditGeometries, idx) {
					unitEditGeometries[features[idx].properties.idx] = features[idx].geometry;
					return unitEditGeometries;
				}, {});

				var updateObject = (0, _defineProperty3.default)({}, _this6.state.activeIdx, {
					units: (0, _keys2.default)(unitEditGeometries).reduce(function (o, i) {
						o[i] = { unitGathering: { geometry: { $set: unitEditGeometries[i] } } };
						return o;
					}, {})
				});
				_this6.props.onChange((0, _immutabilityHelper2.default)(_this6.props.formData, updateObject));
			} else {
				// Is a geometry collection.
				_this6.props.onChange((0, _immutabilityHelper2.default)(_this6.props.formData, (0, _defineProperty3.default)({}, _this6.state.activeIdx, {
					units: (0, _defineProperty3.default)({}, unitIdx, {
						unitGathering: {
							geometry: { $set: (0, _keys2.default)(features).reduce(function (geometryCollection, idx) {
									var feature = features[idx];
									geometryCollection.geometries[idx] = feature.geometry;
									return geometryCollection;
								}, _this6.props.formData[_this6.state.activeIdx].units[unitIdx].unitGathering.geometry)
							}
						}
					})
				})));
			}
		};

		_this6.onMapChangeCreateGathering = DefaultMapArrayField.prototype.onMapChangeCreateGathering.bind(_this6);
		_this6.onChange = DefaultMapArrayField.prototype.onChange.bind(_this6);
		_this6.onAdd = DefaultMapArrayField.prototype.onAdd.bind(_this6);
		_this6.onRemove = DefaultMapArrayField.prototype.onRemove.bind(_this6);
		_this6.onEdited = DefaultMapArrayField.prototype.onEdited.bind(_this6);
		_this6.onInsert = DefaultMapArrayField.prototype.onInsert.bind(_this6);
		_this6.afterActiveChange = DefaultMapArrayField.prototype.afterActiveChange.bind(_this6);
		_this6.getGeometry = DefaultMapArrayField.prototype.getGeometry.bind(_this6);
		return _this6;
	}

	(0, _createClass3.default)(UnitsMapArrayField, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "startHighlight", this.startHighlight);
			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "endHighlight", this.endHighlight);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "startHighlight", this.startHighlight);
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "endHighlight", this.endHighlight);
		}
	}, {
		key: "getData",
		value: function getData() {
			var formData = this.props.formData;

			var idx = this.state.activeIdx;
			if (!formData) return {};

			var item = formData[idx];

			var gatherings = DefaultMapArrayField.prototype.getData.call(this);

			var units = (item && item.units ? item.units : []).reduce(function (units, unit, idx) {
				if (unit.unitGathering) {
					var geometry = unit.unitGathering.geometry;

					if (geometry && (0, _utils2.hasData)(geometry)) {
						units[idx] = geometry;
					}
					return units;
				}
			}, []);
			return { gatherings: gatherings, units: units };
		}
	}, {
		key: "getGeometries",
		value: function getGeometries() {
			var _getData = this.getData(),
			    gatherings = _getData.gatherings,
			    units = _getData.units;

			return [].concat((0, _toConsumableArray3.default)(parseGeometries(gatherings)), (0, _toConsumableArray3.default)(parseGeometries(units)));
		}
	}, {
		key: "parsePopupPointer",
		value: function parsePopupPointer(col, options) {
			return col.replace("[idx]", options.feature.properties.idx);
		}
	}]);
	return UnitsMapArrayField;
}(_react.Component)) || _class2;

var LineTransectMapArrayField = _MapArrayField(_class3 = function (_Component4) {
	(0, _inherits3.default)(LineTransectMapArrayField, _Component4);

	function LineTransectMapArrayField(props) {
		(0, _classCallCheck3.default)(this, LineTransectMapArrayField);

		var _this7 = (0, _possibleConstructorReturn3.default)(this, (LineTransectMapArrayField.__proto__ || (0, _getPrototypeOf2.default)(LineTransectMapArrayField)).call(this, props));

		_this7.onLineCreate = function (_ref12) {
			var _ref13 = (0, _slicedToArray3.default)(_ref12, 1),
			    event = _ref13[0];

			_this7.props.onChange((0, _ArrayField.onArrayFieldChange)((0, _immutabilityHelper2.default)(_this7.props.formData, { 0: { geometry: { $set: event.feature.geometry
					} } }), _this7.props));
		};

		_this7.onChange = function (events) {
			var _getUiOptions8 = (0, _utils2.getUiOptions)(_this7.props.uiSchema),
			    geometryField = _getUiOptions8.geometryField;

			var state = {};
			var formData = _this7.props.formData;

			var formDataChanged = false;
			var addOrDelete = false;
			events.forEach(function (e) {
				switch (e.type) {
					case "insert":
						{
							formDataChanged = true;
							addOrDelete = true;
							var newItem = (0, _utils3.getDefaultFormState)(_this7.props.schema.items, undefined, _this7.props.registry.definitions);
							newItem[geometryField] = e.geometry;
							formData = (0, _immutabilityHelper2.default)(formData, {
								$splice: [[e.idx, 0, newItem]]
							});
							break;
						}
					case "edit":
						{
							formDataChanged = true;
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, e.idx, (0, _defineProperty3.default)({}, geometryField, { $set: e.geometry })));
							break;
						}
					case "delete":
						{
							formDataChanged = true;
							addOrDelete = true;
							formData = (0, _immutabilityHelper2.default)(formData, { $splice: [[e.idx, 1]] });
							break;
						}
					case "merge":
						{
							formDataChanged = true;
							addOrDelete = true;

							var _e$idxs = (0, _slicedToArray3.default)(e.idxs, 2),
							    first = _e$idxs[0],
							    second = _e$idxs[1];

							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, first, { units: { $set: [].concat((0, _toConsumableArray3.default)(formData[first].units || []), (0, _toConsumableArray3.default)(formData[second].units || [])) } }));
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, first, (0, _defineProperty3.default)({}, geometryField, { $set: e.geometry })));
							formData = (0, _immutabilityHelper2.default)(formData, { $splice: [[second, 1]] });
							break;
						}
					case "move":
						{
							formDataChanged = true;
							var idx = e.idx,
							    target = e.target;


							var splices = [[idx, 1], [target, 0, formData[idx]]];
							// Splices must be executed in reverse order to keep idxs correct.
							if (target > idx) splices = splices.reverse();
							formData = (0, _immutabilityHelper2.default)(formData, { $splice: splices });
							break;
						}
					case "active":
						{
							state.activeIdx = e.idx;
						}
				}
			});
			var afterState = function afterState() {
				if (formDataChanged) {
					_this7.props.onChange(addOrDelete ? (0, _ArrayField.onArrayFieldChange)(formData, _this7.props) : formData);
				}
				if ("activeIdx" in state) {
					_this7.afterActiveChange(state.activeIdx);
				}
			};
			(0, _keys2.default)(state).length ? _this7.setState(state, afterState()) : afterState();
		};

		_this7.getFeatureStyle = function (_ref14) {
			var lineIdx = _ref14.lineIdx,
			    style = _ref14.style,
			    type = _ref14.type;

			if (_this7.props.errorSchema[lineIdx]) {
				return type === L.CircleMarker ? // eslint-disable-line no-undef
				style : (0, _extends4.default)({}, style, { fillColor: "#f33" });
			}

			var _ref15 = _this7.props.formData[lineIdx] || {},
			    _ref15$gatheringFact = _ref15.gatheringFact,
			    gatheringFact = _ref15$gatheringFact === undefined ? {} : _ref15$gatheringFact;

			var lineTransectSegmentCounted = gatheringFact.lineTransectSegmentCounted;

			if (!lineTransectSegmentCounted) {
				return (0, _extends4.default)({}, style, { fillColor: "#444444" });
			}
		};

		_this7.getTooltip = function (lineIdx, content) {
			var translations = _this7.props.formContext.translations;

			if (_this7.props.errorSchema[lineIdx]) {
				content = content + "<br/><span class=\"text-danger\">" + translations.LineTransectSegmentHasErrors + "!</span>";
			}
			var _this7$props$formData = _this7.props.formData[lineIdx].gatheringFact,
			    gatheringFact = _this7$props$formData === undefined ? {} : _this7$props$formData;
			var lineTransectSegmentCounted = gatheringFact.lineTransectSegmentCounted;

			if (!lineTransectSegmentCounted) content = content + "<br/>" + translations.LineTransectSegmentNotCounted;
			return content;
		};

		_this7.focusOnMap = function (idx) {
			if (!_this7.hasLineTransectFeature(_this7.props)) {
				(0, _setImmediate3.default)(function () {
					return _this7.map.zoomToData({ paddingInMeters: 200 });
				});
				return;
			}
			_this7.getContext().setImmediate(function () {
				_this7.map && _this7.map.fitBounds(L.featureGroup(_this7.map._corridorLayers[idx]).getBounds(), { paddingInMeters: 100 }); // eslint-disable-line no-undef
			});
		};

		_this7.state = { showLTTools: false };
		return _this7;
	}

	(0, _createClass3.default)(LineTransectMapArrayField, [{
		key: "getOptions",
		value: function getOptions() {
			var _this8 = this;

			var _props2 = this.props,
			    formData = _props2.formData,
			    disabled = _props2.disabled,
			    readonly = _props2.readonly;

			var _getUiOptions9 = (0, _utils2.getUiOptions)(this.props.uiSchema),
			    geometryField = _getUiOptions9.geometryField,
			    placeholderGeometry = _getUiOptions9.placeholderGeometry;

			var lineTransect = this.hasLineTransectFeature(this.props) ? { type: "MultiLineString", coordinates: formData.map(function (item) {
					return item[geometryField].coordinates;
				}) } : undefined;
			return {
				lineTransect: lineTransect ? {
					feature: { geometry: lineTransect },
					activeIdx: this.state.activeIdx,
					onChange: this.onChange,
					getFeatureStyle: this.getFeatureStyle,
					getTooltip: this.getTooltip,
					editable: !disabled && !readonly
				} : undefined,
				draw: lineTransect ? false : {
					line: true,
					marker: false,
					circle: false,
					rectangle: false,
					polygon: false,
					onChange: this.onLineCreate
				},
				data: lineTransect || !placeholderGeometry ? false : {
					geoData: placeholderGeometry,
					getFeatureStyle: this._getPlaceholderStyle
				},
				controls: {
					lineTransect: {
						split: true,
						splitByMeters: this.state.showLTTools,
						createPoint: this.state.showLTTools,
						shiftPoint: this.state.showLTTools,
						deletePoints: this.state.showLTTools,
						undo: this.state.showLTTools,
						redo: this.state.showLTTools
					},
					draw: {
						undo: false,
						redo: false
					}
				},
				customControls: [{
					iconCls: "glyphicon glyphicon-" + (this.state.showLTTools ? "menu-up" : "option-vertical"),
					fn: function fn() {
						_this8.setState({ showLTTools: !_this8.state.showLTTools });
					},
					text: this.props.formContext.translations[this.state.showLTTools ? "HideLineTransectControls" : "ShowLineTransectControls"],
					group: "lineTransect"
				}]

			};
		}
	}, {
		key: "afterActiveChange",
		value: function afterActiveChange(idx) {
			this.focusOnMap(idx);
		}
	}, {
		key: "hasLineTransectFeature",
		value: function hasLineTransectFeature(props) {
			var _getUiOptions10 = (0, _utils2.getUiOptions)(props.uiSchema),
			    geometryField = _getUiOptions10.geometryField;

			return props.formData && props.formData[0] && (0, _keys2.default)(props.formData[0][geometryField] || {}).length;
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			if (!this.hasLineTransectFeature(prevProps) || !this.hasLineTransectFeature(this.props)) return;
			for (var lineIdx = 0; lineIdx < this.props.formData.length; lineIdx++) {
				this.map._updateLTStyleForLineIdx(lineIdx);
			}
		}
	}]);
	return LineTransectMapArrayField;
}(_react.Component)) || _class3;

var LolifeMapArrayField = _MapArrayField(_class4 = function (_Component5) {
	(0, _inherits3.default)(LolifeMapArrayField, _Component5);

	function LolifeMapArrayField(props) {
		(0, _classCallCheck3.default)(this, LolifeMapArrayField);

		var _this9 = (0, _possibleConstructorReturn3.default)(this, (LolifeMapArrayField.__proto__ || (0, _getPrototypeOf2.default)(LolifeMapArrayField)).call(this, props));

		_this9.onChangeForGathering = function (idx) {
			return function (events) {
				var formData = _this9.getGatherings ? _this9.getGatherings() : _this9.props.formData;
				events.forEach(function (e) {
					switch (e.type) {
						case "edit":
							formData = (0, _immutabilityHelper2.default)(formData, formData[idx].geometry.type === "GeometryCollection" ? (0, _keys2.default)(e.features).reduce(function (updates, _idx) {
								return (0, _extends4.default)({}, updates, (0, _defineProperty3.default)({}, idx, { geometry: { geometries: (0, _defineProperty3.default)({}, _idx, { $set: e.features[_idx].geometry }) } }));
							}, {}) : (0, _defineProperty3.default)({}, idx, { geometry: { $set: e.features[0].geometry } }));
							break;
						case "create":
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, idx, { geometry: { $set: e.feature.geometry } }));
							break;
						case "delete":
							if (formData[idx].geometry.type === "GeometryCollection") {
								var splices = [];
								e.idxs.sort().reverse().forEach(function (idx) {
									splices.push([idx, 1]);
								});
								formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, idx, { geometry: { geometries: { $splice: splices } } }));
							} else {
								formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, idx, { geometry: { $set: undefined } }));
							}
							break;
					}
				});
				_this9.props.onChange(formData);
			};
		};

		_this9.onChangeForUnits = function (events) {
			var formData = _this9.props.formData[0].units;
			events.forEach(function (e) {
				switch (e.type) {
					case "edit":
						formData = (0, _utils2.updateSafelyWithJSONPointer)(formData, e.features[0].geometry, "/" + e.features[0].properties.idx + "/unitGathering/geometry");
						break;
					case "create":
						throw new Error("Lolife map shouldn't me able to send create for unit");
					case "delete":
						formData = (0, _utils2.updateSafelyWithJSONPointer)(formData, undefined, "/" + e.features[0].properties.idx + "/unitGathering/geometry");
						break;
				}
			});
			_this9.props.onChange((0, _utils2.updateSafelyWithJSONPointer)(_this9.props.formData, formData, "/0/units"));
		};

		_this9.getFeatureStyle = function (_ref17, highlight) {
			var feature = _ref17.feature;

			if (!feature) {
				return {};
			}
			var namedPlaceStyle = { color: "#777777", fillOpacity: 0.2, weight: 6 };
			var foragingStyle = { color: "#FFCD38" };
			var breedingAndRestingStyle = { color: "#a9d18e" };
			var accessStyle = { color: "#F489A7" };
			var coreZoneStyle = { color: "#F2764D" };
			var habitatZoneStyle = { color: "#937D32" };
			var applicableZoneStyle = { color: "#8EC0D1" };
			var idx = undefined;
			var gathering = _this9.props.formData.find(function (item, _idx) {
				idx = _idx;
				return (0, _utils2.getUUID)(item) === feature.properties.id;
			});
			if (!gathering) {
				return {};
			}
			var style = void 0;
			var gatheringType = gathering.gatheringType;

			switch (gatheringType) {
				case "MY.gatheringTypeForagingArea":
					style = foragingStyle;
					break;
				case "MY.gatheringTypeBreedingAndRestingArea":
					style = breedingAndRestingStyle;
					break;
				case "MY.gatheringTypeLolifeAccess":
					style = accessStyle;
					break;
				case "MY.gatheringTypeLolifeCoreZone":
					style = coreZoneStyle;
					break;
				case "MY.gatheringTypeLolifeHabitatZone":
					style = habitatZoneStyle;
					break;
				case "MY.gatheringTypeLolifeApplicableZone":
					style = applicableZoneStyle;
					break;
				default:
					style = namedPlaceStyle;
			}

			var activeIdx = _this9.state.activeIdx;

			if (highlight || activeIdx !== undefined) {
				if (idx !== activeIdx) {
					return getFeatureStyleWithLowerOpacity(style);
				}
				return getFeatureStyleWithHighlight(style);
			}
			return style;
		};

		_this9.getUnitFeatureStyle = function (_ref18) {
			var feature = _ref18.feature;

			var droppingsTreeStyle = { color: "#b89220" };
			var nestTreeStyle = { color: "#9e713b" };
			var observationStyle = { color: _globals.NORMAL_COLOR };

			var unit = _this9.props.formData[0].units.find(function (item) {
				return (0, _utils2.getUUID)(item) === feature.properties.id;
			});
			if (!unit) {
				return {};
			}
			var nestType = unit.nestType,
			    indirectObservationType = unit.indirectObservationType;

			var style = observationStyle;
			if (nestType) {
				style = nestTreeStyle;
			} else if (indirectObservationType) {
				style = droppingsTreeStyle;
			}

			var activeIdx = _this9.state.activeIdx;

			if (activeIdx !== undefined) {
				return getFeatureStyleWithLowerOpacity(style);
			}
			return style;
		};

		_this9.startHighlight = function (_ref19) {
			var id = _ref19.id;

			var mapIdx = _this9.map.data.findIndex(function (d) {
				return ((d.featureCollection.features[0] || {}).properties || {}).id === id;
			});
			var style = _this9.map.data[mapIdx].getFeatureStyle({ dataIdx: mapIdx, feature: _this9.map.data[mapIdx].featureCollection.features[0] });
			if (!style.color) {
				return;
			}
			var color = (0, _utils.combineColors)(style.color, "#ffffff", 150);
			var layer = _this9.map.getLayerByIdxTuple([mapIdx, 0]);
			layer && _this9.map.setLayerStyle(layer, (0, _extends4.default)({}, style, { color: color, fillColor: color }));
		};

		_this9.endHighlight = function (_ref20) {
			var id = _ref20.id;

			var mapIdx = _this9.map.data.findIndex(function (d) {
				return ((d.featureCollection.features[0] || {}).properties || {}).id === id;
			});
			var style = _this9.map.data[mapIdx].getFeatureStyle({ dataIdx: mapIdx, feature: _this9.map.data[mapIdx].featureCollection.features[0] });
			if (!style) {
				return;
			}
			if (!style.fillOpacity) {
				style.fillOpacity = 0.4; // LajiMap default fill opacity.
			}
			var layer = _this9.map.getLayerByIdxTuple([mapIdx, 0]);
			layer && _this9.map.setLayerStyle(layer, style);
		};

		_this9.onClick = function (e, _ref21) {
			var feature = _ref21.feature;
			var _feature$properties = feature.properties,
			    idx = _feature$properties.idx,
			    unit = _feature$properties.unit;


			if (!unit && !idx) {
				return;
			}

			var _this9$props$formCont = _this9.props.formContext,
			    topOffset = _this9$props$formCont.topOffset,
			    bottomOffset = _this9$props$formCont.bottomOffset;

			if (!unit) {
				_this9.setState({ activeIdx: idx });
			}
			var elem = _this9.getHighlightElem(idx, unit);
			(0, _utils2.scrollIntoViewIfNeeded)(elem, topOffset, bottomOffset);
			(0, _utils2.highlightElem)(elem);
		};

		_this9.onMouseOver = _this9.onMouseOver.bind(_this9);
		_this9.onMouseOut = _this9.onMouseOut.bind(_this9);
		_this9.startHighlight = _this9.startHighlight.bind(_this9);
		_this9.endHighlight = _this9.endHighlight.bind(_this9);
		_this9.onChanges = {};
		return _this9;
	}

	(0, _createClass3.default)(LolifeMapArrayField, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "startHighlight", this.startHighlight);
			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "endHighlight", this.endHighlight);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "startHighlight", this.startHighlight);
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "endHighlight", this.endHighlight);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			if (this.highlightedElem && prevState.activeIdx !== this.state.activeIdx) {
				this.highlightedElem.className = this.highlightedElem.className.replace(" map-highlight", "");
			}
		}
	}, {
		key: "getOptions",
		value: function getOptions() {
			var data = this.getData();
			return {
				draw: this.getDraw(),
				data: data,
				controls: {
					draw: {
						undo: false,
						redo: false
					}
				}
			};
		}
	}, {
		key: "getDraftStyle",
		value: function getDraftStyle() {
			return this.getFeatureStyle({ feature: { properties: { id: (0, _utils2.getUUID)(this.props.formData[this.state.activeIdx]) } } }, !!"higlight");
		}
	}, {
		key: "getDraw",
		value: function getDraw() {
			var active = this.props.formData[this.state.activeIdx];
			if (!active) {
				return false;
			}

			return {
				geoData: this.getFeatureCollection(active, { idx: this.state.activeIdx }),
				onChange: this.getOnChangeForIdx(this.state.activeIdx),
				getFeatureStyle: this.getFeatureStyle,
				getDraftStyle: this.getDraftStyle,
				marker: false,
				on: {
					mouseover: this.onMouseOver,
					mouseout: this.onMouseOut
				}
			};
		}
	}, {
		key: "getOnChangeForIdx",
		value: function getOnChangeForIdx(idx) {
			// Store so change detection doesn't think it's a new function.
			var onChangeForIdx = this.onChanges[idx] || this.onChangeForGathering(idx);
			this.onChanges[idx] = onChangeForIdx;
			return onChangeForIdx;
		}
	}, {
		key: "getFeatureCollection",
		value: function getFeatureCollection(geometryContainer) {
			var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var geometryField = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "/geometry";

			return { type: "FeatureCollection", features: parseGeometries((0, _utils2.parseJSONPointer)(geometryContainer, geometryField)).map(function (g) {
					return { type: "Feature", properties: (0, _extends4.default)({ id: (0, _utils2.getUUID)(geometryContainer) }, properties), geometry: g };
				}) };
		}
	}, {
		key: "getData",
		value: function getData() {
			return this._getData(this.props.formData);
		}
	}, {
		key: "_getData",
		value: function _getData(formData) {
			var _this10 = this;

			var gatherings = (formData || []).map(function (gathering, idx) {
				return {
					featureCollection: _this10.getFeatureCollection(gathering, { idx: idx }),
					getFeatureStyle: _this10.getFeatureStyle,
					on: {
						mouseover: _this10.onMouseOver,
						mouseout: _this10.onMouseOut,
						click: _this10.onClick
					},
					onChange: idx && _this10.getOnChangeForIdx(idx),
					editable: !!idx,
					getPopup: idx && _this10.getPopup
				};
			});

			var activeIdx = this.state.activeIdx;

			if (activeIdx !== undefined) {
				gatherings.splice(activeIdx, 1);
			}

			var units = (formData[0].units || []).map(function (unit, idx) {
				return {
					featureCollection: _this10.getFeatureCollection(unit, { unit: true, idx: idx }, "/unitGathering/geometry"),
					editable: true,
					onChange: _this10.onChangeForUnits,
					getFeatureStyle: _this10.getUnitFeatureStyle,
					on: {
						mouseover: _this10.onMouseOver,
						mouseout: _this10.onMouseOut,
						click: _this10.onClick
					},
					getPopup: _this10.getPopup
				};
			}).filter(function (item) {
				return item.featureCollection.features.length;
			});

			return [].concat((0, _toConsumableArray3.default)(gatherings), (0, _toConsumableArray3.default)(units));
		}
	}, {
		key: "getGeometries",
		value: function getGeometries() {
			return this._getGeometries(this.getData());
		}
	}, {
		key: "_getGeometries",
		value: function _getGeometries(data) {
			return data.reduce(function (geometries, _ref22) {
				var featureCollection = _ref22.featureCollection;
				return [].concat((0, _toConsumableArray3.default)(geometries), (0, _toConsumableArray3.default)(featureCollection.features.map(function (f) {
					return f.geometry;
				})));
			}, []);
		}
	}, {
		key: "cavityTreeStyle",
		value: function cavityTreeStyle() {
			return { color: "#9e713b" };
		}
	}, {
		key: "droppingsTreeStyle",
		value: function droppingsTreeStyle() {
			return { color: "#b89220" };
		}
	}, {
		key: "nestTreeStyle",
		value: function nestTreeStyle() {
			return { color: "#ff0000" };
		}
	}, {
		key: "observationStyle",
		value: function observationStyle() {
			return { color: _globals.NORMAL_COLOR };
		}
	}, {
		key: "getHighlightElem",
		value: function getHighlightElem(idx, unit) {
			if (unit) {
				return (0, _utils2.getSchemaElementById)(this.props.formContext.contextId, this.props.idSchema.$id + "_0_units_" + idx);
			} else {
				return document.getElementById(this.props.idSchema.$id + "_" + idx + "-panel");
			}
		}
	}, {
		key: "onMouseOver",
		value: function onMouseOver(e, _ref23) {
			var feature = _ref23.feature;
			var _feature$properties2 = feature.properties,
			    idx = _feature$properties2.idx,
			    unit = _feature$properties2.unit;


			if (!unit && !idx) {
				return;
			}

			this.highlightedElem = this.getHighlightElem(idx, unit);

			if (this.highlightedElem) {
				this.highlightedElem.className += " map-highlight";
			}
		}
	}, {
		key: "onMouseOut",
		value: function onMouseOut(e, _ref24) {
			var feature = _ref24.feature;
			var _feature$properties3 = feature.properties,
			    idx = _feature$properties3.idx,
			    unit = _feature$properties3.unit;


			if (!unit && !idx) {
				return;
			}

			this.highlightedElem = this.getHighlightElem(idx, unit);

			if (this.highlightedElem) {
				this.highlightedElem.className = this.highlightedElem.className.replace(" map-highlight", "");
			}
		}
	}, {
		key: "getFormDataForPopup",
		value: function getFormDataForPopup(_ref25) {
			var feature = _ref25.feature;

			if (feature.properties.unit) {
				return this.props.formData[0].units.find(function (item) {
					return (0, _utils2.getUUID)(item) === feature.properties.id;
				});
			}
			return this.props.formData.find(function (item) {
				return (0, _utils2.getUUID)(item) === feature.properties.id;
			});
		}
	}]);
	return LolifeMapArrayField;
}(_react.Component)) || _class4;

function _MapArrayField(ComposedComponent) {
	var _class5, _temp, _initialiseProps, _class6;

	return _temp = _class5 = (0, _BaseComponent2.default)(_class6 = function (_ComposedComponent) {
		(0, _inherits3.default)(_MapArrayField, _ComposedComponent);

		function _MapArrayField(props) {
			(0, _classCallCheck3.default)(this, _MapArrayField);

			var _this11 = (0, _possibleConstructorReturn3.default)(this, (_MapArrayField.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField)).call(this, props));

			_initialiseProps.call(_this11);

			_this11._context = new _Context2.default(props.formContext.contextId + "_MAP_CONTAINER");
			_this11._context.featureIdxsToItemIdxs = {};
			_this11._context.setState = function (state, callback) {
				return _this11.setState(state, callback);
			};

			var initialState = { activeIdx: (_this11.props.formData || []).length === 1 ? 0 : undefined };
			var options = (0, _utils2.getUiOptions)(props.uiSchema);
			if ((_this11.props.formData || []).length && "activeIdx" in options) initialState.activeIdx = options.activeIdx;
			_this11.state = (0, _extends4.default)({}, initialState, _this11.state || {});

			_this11.getDraftStyle = _this11.getDraftStyle.bind(_this11);
			return _this11;
		}

		(0, _createClass3.default)(_MapArrayField, [{
			key: "componentDidMount",
			value: function componentDidMount() {
				var _this12 = this;

				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "componentDidMount", this)) (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "componentDidMount", this).call(this);
				this.setState({ mounted: true });
				this.getContext().addKeyHandler("" + this.props.idSchema.$id, this.mapKeyFunctions);
				this.map = this.refs.map.refs.map.map;
				this._setActiveEventHandler = function (idx) {
					_this12.setState({ activeIdx: idx });
				};
				this._zoomToDataEventHandler = function () {
					_this12._zoomToDataOnNextTick = true;
				};
				this._tileLayersEventHandler = function (tileLayerOptions, callback) {
					_this12._tileLayerNameOnNextTick = tileLayerOptions;
					_this12._tileLayerNameOnNextTickCallback = callback;
				};
				this._resizeEventHandler = function () {
					_this12.refs.stretch.invalidate();
				};
				new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "activeIdx", this._setActiveEventHandler);
				new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "zoomToData", this._zoomToDataEventHandler);
				new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "tileLayers", this._tileLayersEventHandler);

				new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "resize", this._resizeEventHandler);

				if (this.state.activeIdx !== undefined) {
					this.afterActiveChange(this.state.activeIdx, !!"initial call");
				}
			}
		}, {
			key: "afterActiveChange",
			value: function afterActiveChange(idx) {
				(0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "afterActiveChange", this) && (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "afterActiveChange", this).call(this, idx);
				this.onLocateOrAddNew();
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				this.setState({ mounted: false });
				this.getContext().removeKeyHandler("" + this.props.idSchema.$id, this.mapKeyFunctions);
				new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "activeIdx", this._setActiveEventHandler);
				new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "zoomToData", this._zoomToDataEventHandler);
				new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "tileLayers", this._tileLayersEventHandler);
				new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "resize", this._resizeEventHandler);
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate() {
				var _get2;

				for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
					params[_key] = arguments[_key];
				}

				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "componentDidUpdate", this)) (_get2 = (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "componentDidUpdate", this)).call.apply(_get2, [this].concat(params));

				var prevProps = params[0],
				    prevState = params[1]; // eslint-disable-line no-unused-vars

				if (prevState.activeIdx !== this.state.activeIdx) {
					if (!this.nestedHandledActiveChange && this.state.activeIdx !== undefined) {
						var _getUiOptions11 = (0, _utils2.getUiOptions)(this.props.uiSchema),
						    idToFocusAfterNavigate = _getUiOptions11.idToFocusAfterNavigate,
						    idToScrollAfterNavigate = _getUiOptions11.idToScrollAfterNavigate;

						(0, _utils2.focusAndScroll)(this.props.formContext, idToFocusAfterNavigate || this.props.idSchema.$id + "_" + this.state.activeIdx, idToScrollAfterNavigate);
					}
					this.nestedHandledActiveChange = false;
					this.afterActiveChange(this.state.activeIdx);
				}

				if (this.refs.stretch) {
					var _getUiOptions12 = (0, _utils2.getUiOptions)(this.props.uiSchema),
					    resizeTimeout = _getUiOptions12.resizeTimeout;

					if (resizeTimeout) {
						this.getContext().setTimeout(this.refs.stretch.update, resizeTimeout);
					} else {
						this.refs.stretch.update();
					}
				}
				if (this._zoomToDataOnNextTick) {
					this._zoomToDataOnNextTick = false;
					this.map.zoomToData();
				}
				if (this._tileLayerNameOnNextTick) {
					var tileLayerName = this._tileLayerNameOnNextTick;
					this._tileLayerNameOnNextTick = false;
					this.map.setTileLayerByName(tileLayerName);
				}

				this.computeArea(prevProps);
			}
		}, {
			key: "_getPlaceholderStyle",
			value: function _getPlaceholderStyle() {
				return {
					color: "#999999",
					fillOpacity: 0,
					weight: 8
				};
			}
		}, {
			key: "getSchemas",
			value: function getSchemas() {
				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getSchemas", this)) return (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getSchemas", this).call(this);
				return this.props;
			}
		}, {
			key: "render",
			value: function render() {
				var _this13 = this;

				var SchemaField = this.props.registry.fields.SchemaField;

				var _getSchemas = this.getSchemas(),
				    uiSchema = _getSchemas.uiSchema,
				    errorSchema = _getSchemas.errorSchema,
				    schema = _getSchemas.schema;

				var options = (0, _utils2.getUiOptions)(this.props.uiSchema);
				var popupFields = options.popupFields,
				    geometryField = options.geometryField,
				    topOffset = options.topOffset,
				    bottomOffset = options.bottomOffset,
				    belowFields = options.belowFields,
				    _options$propsToPassT = options.propsToPassToInlineSchema,
				    propsToPassToInlineSchema = _options$propsToPassT === undefined ? [] : _options$propsToPassT,
				    emptyHelp = options.emptyHelp,
				    _options$passActiveId = options.passActiveIdxToBelow,
				    passActiveIdxToBelow = _options$passActiveId === undefined ? true : _options$passActiveId;
				var _options$belowUiSchem = options.belowUiSchemaRoot,
				    belowUiSchemaRoot = _options$belowUiSchem === undefined ? {} : _options$belowUiSchem,
				    _options$inlineUiSche = options.inlineUiSchemaRoot,
				    inlineUiSchemaRoot = _options$inlineUiSche === undefined ? {} : _options$inlineUiSche,
				    idToFocusAfterNavigate = options.idToFocusAfterNavigate,
				    idToScrollAfterNavigate = options.idToScrollAfterNavigate;
				var activeIdx = this.state.activeIdx;


				var activeIdxProps = {
					activeIdx: activeIdx,
					onActiveChange: this.onActiveChange,
					idToFocusAfterNavigate: idToFocusAfterNavigate,
					idToScrollAfterNavigate: idToScrollAfterNavigate
				};

				uiSchema = (0, _utils2.getInnerUiSchema)(uiSchema);
				if ((0, _utils2.getUiOptions)(this.props.uiSchema).buttons) {
					uiSchema = (0, _extends4.default)({}, uiSchema, {
						"ui:options": (0, _extends4.default)({}, uiSchema["ui:options"], {
							buttons: [].concat((0, _toConsumableArray3.default)(uiSchema["ui:options"]), (0, _toConsumableArray3.default)((0, _utils2.getUiOptions)(this.props.uiSchema).buttons))
						})
					});
				}

				var mapOptions = this.getMapOptions();

				var mapSizes = options.mapSizes || (0, _utils2.getBootstrapCols)(6);

				var schemaSizes = ["lg", "md", "sm", "xs"].reduce(function (sizes, size) {
					sizes[size] = 12 - mapSizes[size] || 12;
					return sizes;
				}, {});

				var getChildProps = function getChildProps() {
					return {
						schema: schema.items,
						uiSchema: uiSchema.items || {},
						idSchema: (0, _utils3.toIdSchema)(schema.items, _this13.props.idSchema.$id + "_" + activeIdx, _this13.props.registry.definitions),
						formData: (_this13.props.formData || [])[activeIdx],
						errorSchema: _this13.props.errorSchema[activeIdx] || {},
						registry: _this13.props.registry,
						formContext: _this13.props.formContext
					};
				};

				var putChildsToParents = function putChildsToParents(props, key) {
					if (!_this13.onChangeFor) {
						_this13.onChangeFor = {};
					}
					if (!_this13.onChangeFor[key]) {
						_this13.onChangeFor[key] = function (formData) {
							_this13.props.onChange(formData.map(function (item, idx) {
								return (0, _extends4.default)({}, _this13.props.formData[idx] || (0, _utils3.getDefaultFormState)(_this13.props.schema.items, undefined, _this13.props.registry.definitions), item);
							}));
						};
					}
					return (0, _extends4.default)({}, _this13.props, {
						schema: (0, _extends4.default)({}, schema, { items: props.schema }),
						uiSchema: (0, _extends4.default)({}, uiSchema, { items: props.uiSchema }),
						onChange: _this13.onChangeFor[key]
					});
				};

				var defaultProps = (0, _extends4.default)({}, this.props, { schema: schema, uiSchema: uiSchema });
				var overrideProps = propsToPassToInlineSchema.reduce(function (_props, field) {
					_props[field] = _this13.props[field];
					return _props;
				}, {});

				var childProps = getChildProps();
				var inlineSchemaProps = putChildsToParents((0, _NestField.getPropsForFields)(childProps, (0, _keys2.default)(schema.items.properties).filter(function (field) {
					return !((belowFields || []).indexOf(field) !== -1);
				})));

				var belowSchemaProps = belowFields ? putChildsToParents((0, _NestField.getPropsForFields)(childProps, belowFields)) : null;

				var inlineItemsUiSchema = (0, _extends4.default)({}, uiSchema.items, inlineSchemaProps.uiSchema.items);
				var inlineUiSchema = (0, _extends4.default)({}, inlineSchemaProps.uiSchema);
				if (inlineUiSchemaRoot) {
					inlineUiSchema = (0, _extends4.default)({}, inlineUiSchema, inlineUiSchemaRoot);
					inlineUiSchema.items = (0, _extends4.default)({}, inlineItemsUiSchema, inlineUiSchemaRoot.items || {});
				} else {
					inlineUiSchema.items = inlineItemsUiSchema;
				}

				var belowUiSchema = belowSchemaProps ? (0, _extends4.default)({}, belowSchemaProps.uiSchema, belowUiSchemaRoot) : {};

				inlineUiSchema = (0, _extends4.default)({}, inlineUiSchema, { "ui:options": (0, _extends4.default)({}, inlineUiSchema["ui:options"] || {}, activeIdxProps) });
				belowUiSchema = (0, _extends4.default)({}, belowUiSchema, { "ui:options": (0, _extends4.default)({}, belowUiSchema["ui:options"] || {}, passActiveIdxToBelow ? activeIdxProps : {}) });

				if (!belowUiSchema.items) {
					belowUiSchema.items = {};
				}
				if (!belowUiSchema.items["ui:options"]) {
					belowUiSchema.items["ui:options"] = {};
				}
				belowUiSchema.items["ui:options"].reserveId = false;

				var _getUiOptions13 = (0, _utils2.getUiOptions)(this.props.uiSchema),
				    buttonsPath = _getUiOptions13.buttonsPath,
				    addButtonPath = _getUiOptions13.addButtonPath,
				    _getUiOptions13$showE = _getUiOptions13.showErrors,
				    showErrors = _getUiOptions13$showE === undefined ? true : _getUiOptions13$showE;

				if (addButtonPath) console.warn("addButtonPath option for MapArrayField is deprecated - use buttonsPath instead!");
				var _buttonsPath = buttonsPath || addButtonPath;

				var appendAddButton = function appendAddButton(buttons) {
					var addButton = buttons.find(function (_ref26) {
						var fn = _ref26.fn;
						return fn === "add";
					});
					return [(0, _extends4.default)({}, addButton || {}, {
						fn: _this13.customAdd,
						fnName: "add",
						glyph: "plus",
						id: _this13.props.idSchema.$id
					})].concat((0, _toConsumableArray3.default)(buttons.filter(function (button) {
						return button !== addButton;
					})));
				};

				var buttons = undefined;
				var renderButtonsBelow = false;
				if (((this.props.formData || []).length === 0 || activeIdx !== undefined) && options.buttons) {
					if (_buttonsPath) {
						buttons = appendAddButton(options.buttons);
						belowUiSchema = (0, _utils2.injectButtons)(belowUiSchema, buttons, _buttonsPath);
						inlineUiSchema["ui:options"].renderAdd = false;
					} else if (options.renderButtonsBelow) {
						buttons = appendAddButton(options.buttons);
						inlineUiSchema["ui:options"].renderAdd = false;
						renderButtonsBelow = true;
					}
				}

				if (activeIdx === undefined || !_buttonsPath && !renderButtonsBelow) {
					inlineUiSchema["ui:options"].buttons = options.buttons || [];
				}

				var inlineSchema = _react2.default.createElement(SchemaField, (0, _extends4.default)({}, defaultProps, inlineSchemaProps, { uiSchema: inlineUiSchema }, overrideProps));
				var belowSchema = belowFields ? _react2.default.createElement(SchemaField, (0, _extends4.default)({}, this.props, belowSchemaProps, { uiSchema: belowUiSchema })) : null;

				buttons = buttons && (!_buttonsPath || mapOptions.emptyMode) ? buttons.map(function (button) {
					return (0, _ArrayFieldTemplate.getButton)(button, {
						canAdd: mapOptions.emptyMode ? button.fnName === "addNamedPlace" : true,
						uiSchema: _this13.props.uiSchema,
						idSchema: _this13.props.idSchema,
						formData: _this13.props.formData,
						formContext: _this13.props.formContext,
						disabled: _this13.props.disabled,
						readonly: _this13.props.readonly
					});
				}).filter(function (button) {
					return button;
				}) : undefined;

				var _errors = errorSchema && (0, _utils2.parseJSONPointer)(errorSchema[activeIdx] || {}, geometryField);
				var errors = _errors ? _errors.__errors.map(_utils2.formatErrorMessage) : null;

				var errorId = geometryField && geometryField[0] === "/" ? geometryField.replace(/\//g, "_") : "_" + geometryField;
				var wholeErrorId = this.props.idSchema.$id + "_" + activeIdx + errorId;
				var mapPropsToPass = (0, _extends4.default)({
					formContext: this.props.formContext,
					onPopupClose: this.onPopupClose,
					markerPopupOffset: 45,
					featurePopupOffset: 5,
					popupOnHover: true,
					onFocusGrab: this.onFocusGrab,
					onFocusRelease: this.onFocusRelease,
					panel: errors && errors.length && showErrors ? {
						header: this.props.formContext.translations.Error,
						panelTextContent: _react2.default.createElement(
							"div",
							null,
							errors
						),
						bsStyle: "danger",
						id: "laji-form-error-container-" + wholeErrorId
					} : null,
					draw: false,
					zoomToData: true,
					onOptionsChanged: this.onOptionsChanged,
					fullscreenable: true,
					help: options.help
				}, mapOptions);

				var map = _react2.default.createElement(MapComponent, (0, _extends4.default)({
					ref: "map"
				}, mapPropsToPass));

				var wrapperProps = {
					getContainer: this.getContainer,
					topOffset: topOffset === undefined ? this.props.formContext.topOffset : topOffset,
					bottomOffset: bottomOffset === undefined ? this.props.formContext.bottomOffset : bottomOffset,
					onResize: this.onResize,
					mounted: this.state.mounted,
					className: this.state.focusGrabbed ? "pass-block" : "",
					minHeight: (0, _utils2.getUiOptions)(this.props.uiSchema).minHeight,
					onEnterViewPort: this.onEnterViewPort,
					enterViewPortTreshold: 200
				};

				var wrappedMap = _react2.default.createElement(
					_components.Stretch,
					(0, _extends4.default)({}, wrapperProps, { ref: "stretch" }),
					map
				);
				var TitleField = this.props.registry.fields.TitleField;


				return _react2.default.createElement(
					_react2.default.Fragment,
					null,
					_react2.default.createElement(
						_reactBootstrap.Row,
						null,
						_react2.default.createElement(
							_reactBootstrap.Col,
							mapSizes,
							wrappedMap
						),
						_react2.default.createElement(
							_reactBootstrap.Col,
							(0, _extends4.default)({}, schemaSizes, { ref: "_stretch" }),
							mapOptions.emptyMode ? !emptyHelp && (!buttons || !buttons.length) ? null : _react2.default.createElement(
								_reactBootstrap.Popover,
								{ placement: "right", id: this.props.idSchema.$id + "-help" },
								_react2.default.createElement(
									"div",
									null,
									emptyHelp,
									buttons && buttons.length ? " " + this.props.formContext.translations.or : null,
									buttons
								)
							) : inlineSchema
						)
					),
					popupFields ? _react2.default.createElement(
						"div",
						{ style: { display: "none" }, ref: "popupContainer" },
						_react2.default.createElement(Popup, { data: this.getPopupData(this.state.popupIdx), ref: "popup" })
					) : null,
					_react2.default.createElement(
						_reactBootstrap.Row,
						null,
						mapOptions.emptyMode ? null : belowSchema
					),
					renderButtonsBelow && !mapOptions.emptyMode && buttons.length ? _react2.default.createElement(
						_reactBootstrap.Row,
						{ className: "map-array-field-below-buttons" },
						_react2.default.createElement(TitleField, { title: (0, _utils2.getUiOptions)(uiSchema).buttonsTitle }),
						_react2.default.createElement(
							_reactBootstrap.ButtonToolbar,
							null,
							buttons
						)
					) : null
				);
			}
		}, {
			key: "getDraftStyle",
			value: function getDraftStyle() {
				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getDraftStyle", this)) {
					return (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getDraftStyle", this).call(this);
				}
				return { color: "#25B4CA", opacity: 1 };
			}
		}, {
			key: "filterPopupOptions",
			value: function filterPopupOptions(_ref27) {
				var dataIdx = _ref27.dataIdx,
				    featureIdx = _ref27.featureIdx,
				    feature = _ref27.feature;

				return { dataIdx: dataIdx, featureIdx: featureIdx, feature: feature };
			}
		}, {
			key: "getPopupData",
			value: function getPopupData(options) {
				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getPopupData", this)) {
					return (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getPopupData", this).call(this, options);
				} else {
					return this.getFeaturePopupData(options);
				}
			}
		}, {
			key: "getFormDataForPopup",
			value: function getFormDataForPopup(options) {
				if ((0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getFormDataForPopup", this)) {
					return (0, _get4.default)(_MapArrayField.prototype.__proto__ || (0, _getPrototypeOf2.default)(_MapArrayField.prototype), "getFormDataForPopup", this).call(this, options);
				} else {
					return this.state.activeIdx !== undefined ? this.props.formData[this.state.activeIdx] : undefined;
				}
			}
		}]);
		return _MapArrayField;
	}(ComposedComponent)) || _class6, _initialiseProps = function _initialiseProps() {
		var _this14 = this;

		this.geocode = function () {
			// Zoom map to area. Area ID is accessed from schema field defined in options.areaField
			var item = (_this14.props.formData || [])[_this14.state.activeIdx];

			var _getUiOptions14 = (0, _utils2.getUiOptions)(_this14.props.uiSchema),
			    areaField = _getUiOptions14.areaField;

			if (!item || !areaField) {
				return;
			}
			var area = item[areaField];
			if (area instanceof Array) {
				area = area[0];
			}
			var geometries = _this14.getGeometries();
			if (geometries.length === 0 && area && area.length > 0) {
				_this14.props.formContext.apiClient.fetch("/areas/" + area, undefined, undefined).then(function (result) {
					_this14.map.geocode(result.name, undefined, 8);
				});
			}
		};

		this.computeArea = function () {
			var activeIdx = _this14.state.activeIdx;

			if (activeIdx === undefined) return;

			var _getUiOptions15 = (0, _utils2.getUiOptions)(_this14.props.uiSchema),
			    computeAreaField = _getUiOptions15.computeAreaField,
			    areaInHectares = _getUiOptions15.areaInHectares;

			var formData = _this14.props.formData;


			if (!computeAreaField) return;
			var geometries = _this14.getGeometries();
			var polygonsArea = geometries.filter(function (_ref28) {
				var type = _ref28.type;
				return type === "Polygon";
			}).map(function (_ref29) {
				var coordinates = _ref29.coordinates;
				return coordinates[0].slice(1).map(function (c) {
					return L.latLng(c.slice(0).reverse());
				});
			}).reduce(function (area, latLngs) {
				return area + L.GeometryUtil.geodesicArea(latLngs);
			}, 0);
			var circlesArea = geometries.filter(function (_ref30) {
				var type = _ref30.type,
				    radius = _ref30.radius;
				return type === "Point" && radius;
			}).reduce(function (_area, _ref31) {
				var radius = _ref31.radius;
				return _area + Math.PI * (radius * radius);
			}, 0);
			var sumArea = polygonsArea + circlesArea;
			var area = sumArea === 0 ? undefined : Math.round(areaInHectares ? sumArea / 10000 : sumArea);

			var currentArea = (0, _utils2.parseJSONPointer)(formData[activeIdx], computeAreaField, true);
			currentArea !== area && _this14.props.onChange((0, _utils2.updateSafelyWithJSONPointer)(formData, area, "/" + activeIdx + "/" + computeAreaField));
		};

		this.getContainer = function () {
			return (0, _reactDom.findDOMNode)(_this14.refs._stretch);
		};

		this.onResize = function () {
			return _this14.refs.map.map.map.invalidateSize({ debounceMoveend: true });
		};

		this.onPopupClose = function () {
			// Move popup content back to the React container so React won't crash.
			if (_this14.refs.popupContainer && _this14.refs.popup.refs.popup) {
				(0, _reactDom.findDOMNode)(_this14.refs.popupContainer).appendChild(_this14.refs.popup.refs.popup);
			}
			_this14.setState({ popupIdx: undefined });
		};

		this.onFocusGrab = function () {
			return _this14.setState({ focusGrabbed: true });
		};

		this.onFocusRelease = function () {
			return _this14.setState({ focusGrabbed: false });
		};

		this.onOptionsChanged = function (options) {
			return _this14.setState({ mapOptions: (0, _extends4.default)({}, _this14.state.mapOptions, options) }, function () {
				if (_this14._tileLayerNameOnNextTickCallback) {
					_this14._tileLayerNameOnNextTickCallback();
					_this14._tileLayerNameOnNextTickCallback = undefined;
				}
			});
		};

		this.getAlignmentAnchor = function () {
			return _this14.refs._stretch;
		};

		this.onEnterViewPort = function () {
			_this14.afterActiveChange(_this14.state.activeIdx, !!"initial call");
		};

		this.getMapOptions = function () {
			var options = (0, _utils2.getUiOptions)(_this14.props.uiSchema);
			var _options = _deepmerge2.default.all([{ clickBeforeZoomAndPan: true }, options.mapOptions || {}, _this14.getOptions(options) || {}, _this14.state.mapOptions || {}]);
			var changes = {};
			if (options.createOnLocate && !_options.locate) {
				changes.locate = [_this14.onLocate];
			}
			var _props3 = _this14.props,
			    readonly = _props3.readonly,
			    disabled = _props3.disabled;

			if (readonly || disabled) {
				if ((0, _utils2.isObject)(_options.draw)) {
					changes.draw = (0, _extends4.default)({}, _options.draw, {
						editable: false
					});
				}
				if (_options.data) {
					if (_options.data instanceof Array) {
						changes.data = _options.data.map(function (d) {
							return (0, _extends4.default)({}, d, { editable: false });
						});
					} else if ((0, _utils2.isObject)(_options.data)) {
						changes.data = (0, _extends4.default)({}, _options.data, { editable: false });
					}
				}
			}
			if ((0, _keys2.default)(changes).length) {
				_options = (0, _extends4.default)({}, _options, changes);
			}
			return _options;
		};

		this.onActiveChange = function (idx, prop, callback) {
			_this14.nestedHandledActiveChange = true;
			_this14.setState({ activeIdx: idx }, function () {
				if (!callback) return;
				callback();
			});
		};

		this.customAdd = function () {
			return function () {
				var nextActive = _this14.props.formData.length;
				_this14.props.onChange((0, _ArrayField.onArrayFieldChange)([].concat((0, _toConsumableArray3.default)(_this14.props.formData), [(0, _utils3.getDefaultFormState)(_this14.props.schema.items, undefined, _this14.props.registry.definitions)]), _this14.props));
				_this14.setState({ activeIdx: nextActive });
			};
		};

		this.mapKeyFunctions = {
			splitLineTransectByMeters: function splitLineTransectByMeters() {
				_this14.map.splitLTByMeters(_this14.state.activeIdx);
			}
		};

		this.getPopup = function (options, openPopupCallback) {
			if (!_this14.refs.popup) return;
			_this14.setState({ popupIdx: _this14.filterPopupOptions(options) }, function () {
				_this14.refs.popup && (0, _utils2.hasData)(_this14.getPopupData(options)) && openPopupCallback(_this14.refs.popup.refs.popup);
			});
		};

		this.popupStrategies = {
			lolifeUnit: function lolifeUnit(formData) {
				var nestType = formData.nestType,
				    indirectObservationType = formData.indirectObservationType,
				    identifications = formData.identifications;

				if (nestType) {
					return { value: _this14.props.formContext.translations.NestObservation };
				} else if (indirectObservationType) {
					return { value: _this14.props.formContext.translations.TraceObservation };
				} else if (identifications) {
					return { value: _this14.props.formContext.translations.Observation };
				}
			}
		};

		this.getFeaturePopupData = function (options) {
			if (!options) return [];

			var _getUiOptions16 = (0, _utils2.getUiOptions)(_this14.props.uiSchema),
			    popupFields = _getUiOptions16.popupFields;

			var formData = _this14.getFormDataForPopup(options);

			var data = [];

			popupFields.forEach(function (_ref32) {
				var col = _ref32.field,
				    template = _ref32.template,
				    _value = _ref32.value,
				    _title = _ref32.title,
				    _if = _ref32.if,
				    strategy = _ref32.strategy;

				var value = void 0,
				    title = void 0;
				if (strategy) {
					var strategyResult = _this14.popupStrategies[strategy](formData);
					if (strategyResult) {
						value = strategyResult.value;
						title = strategyResult.title;
					}
				} else if (_value) {
					value = _value;
					title = _title;
				} else if (col) {
					if (_this14.parsePopupPointer) {
						col = _this14.parsePopupPointer(col, options);
					}
					var _formData = (0, _utils2.parseJSONPointer)(formData, col);
					var schema = (0, _utils2.parseSchemaFromFormDataPointer)(_this14.props.schema.items || _this14.props.schema, col);
					var uiSchema = (0, _utils2.parseUiSchemaFromFormDataPointer)(_this14.props.uiSchema.items || _this14.props.uiSchema, col);
					title = schema.title;
					value = (0, _utils2.formatValue)((0, _extends4.default)({}, _this14.props, { formData: _formData, schema: schema, uiSchema: uiSchema }));
				}

				if (!(0, _utils2.isEmptyString)(value)) {
					var result = void 0;
					if (_if) {
						result = ["dataIdx", "featureIdx"].every(function (opt) {
							return !_if.hasOwnProperty(opt) || options[opt] === _if[opt];
						});
						if (_if.reverse) {
							result = !result;
						}
					}
					if (!_if || result) {
						data.push({ title: title, template: template, value: value });
					}
				}
			});
			return data;
		};

		this.onLocate = function (latlng, radius) {
			_this14.location = latlng ? { latlng: latlng, radius: radius } : undefined;
			_this14.onLocateOrAddNew();
		};

		this.onLocateOrAddNew = function () {
			if (!_this14.location) return;

			var _location = _this14.location,
			    latlng = _location.latlng,
			    radius = _location.radius;

			var _getUiOptions17 = (0, _utils2.getUiOptions)(_this14.props.uiSchema),
			    createOnLocate = _getUiOptions17.createOnLocate;

			if (!createOnLocate) return;

			var geometry = _this14.getGeometry(_this14.props.formData);
			if (_this14.props.formData.length === 0 || !geometry || !(0, _keys2.default)(geometry).length) {
				var _geometry2 = undefined;
				if (createOnLocate === "marker") {
					_geometry2 = { type: "Point", coordinates: [latlng.lng, latlng.lat] };
				}
				if (createOnLocate === "circle") {
					_geometry2 = { type: "Point", coordinates: [latlng.lng, latlng.lat], radius: radius };
				}
				_this14.map.addFeatureToDraw({
					type: "Feature",
					properties: {},
					geometry: _geometry2
				});
			}
		};
	}, _temp;
}

var Popup = function (_Component6) {
	(0, _inherits3.default)(Popup, _Component6);

	function Popup() {
		(0, _classCallCheck3.default)(this, Popup);
		return (0, _possibleConstructorReturn3.default)(this, (Popup.__proto__ || (0, _getPrototypeOf2.default)(Popup)).apply(this, arguments));
	}

	(0, _createClass3.default)(Popup, [{
		key: "render",
		value: function render() {
			var data = this.props.data;

			return data && data.length && _react2.default.createElement(
				"ul",
				{ ref: "popup", className: "map-data-tooltip" },
				data.map(function (_ref33, i) {
					var value = _ref33.value,
					    title = _ref33.title,
					    template = _ref33.template;

					switch (template) {
						case "title":
							return _react2.default.createElement(
								"li",
								{ key: title || i },
								_react2.default.createElement(
									"strong",
									null,
									Array.isArray(value) ? value.join(", ") : value
								)
							);
						case "description":
							return _react2.default.createElement(
								"li",
								{ key: title || i },
								_react2.default.createElement(
									"i",
									null,
									Array.isArray(value) ? value.join(", ") : value
								)
							);
						default:
							return _react2.default.createElement(
								"li",
								{ key: title || i },
								_react2.default.createElement(
									"strong",
									null,
									title,
									":"
								),
								" ",
								Array.isArray(value) ? value.join(", ") : value
							);
					}
				})
			);
		}
	}]);
	return Popup;
}(_react.Component);

var MapComponent = exports.MapComponent = function (_Component7) {
	(0, _inherits3.default)(MapComponent, _Component7);

	function MapComponent(props) {
		(0, _classCallCheck3.default)(this, MapComponent);

		var _this16 = (0, _possibleConstructorReturn3.default)(this, (MapComponent.__proto__ || (0, _getPrototypeOf2.default)(MapComponent)).call(this, props));

		_this16.tileLayerChange = function (_ref34) {
			var tileLayers = _ref34.tileLayers;

			_this16.setState({ mapOptions: (0, _extends4.default)({}, _this16.state.mapOptions, { tileLayers: tileLayers }) });
		};

		_this16.overlaysChange = function (_ref35) {
			var overlayNames = _ref35.overlayNames;

			_this16.setState({ mapOptions: (0, _extends4.default)({}, _this16.state.mapOptions, { overlayNames: overlayNames }) });
		};

		_this16.tileLayerOpacityChangeEnd = function (_ref36) {
			var tileLayerOpacity = _ref36.tileLayerOpacity;

			_this16.setState({ mapOptions: (0, _extends4.default)({}, _this16.state.mapOptions, { tileLayerOpacity: tileLayerOpacity }) });
		};

		_this16.locateToggle = function (_ref37) {
			var locate = _ref37.locate;

			_this16.setState({ mapOptions: (0, _extends4.default)({}, _this16.state.mapOptions, { locate: locate }) });
		};

		_this16.grabFocus = function () {
			_this16.mainContext.pushBlockingLoader();
			_this16.setState({ focusGrabbed: true }, function () {
				if (_this16.props.onFocusGrab) _this16.props.onFocusGrab();
			});
		};

		_this16.releaseFocus = function () {
			_this16.mainContext.popBlockingLoader();
			_this16.setState({ focusGrabbed: false }, function () {
				if (_this16.props.onFocusRelease) _this16.props.onFocusRelease();
			});
		};

		_this16.showPanel = function (options) {
			_this16.setState((0, _extends4.default)({ panel: true }, options));
		};

		_this16.hidePanel = function () {
			_this16.setState({ panel: false });
		};

		_this16.showHelp = function () {
			_this16.setState({ showHelp: true });
		};

		_this16.hideHelp = function () {
			_this16.setState({ showHelp: false });
		};

		_this16.setMapState = function (options, callback) {
			_this16._callback = callback;
			_this16.setState({ mapOptions: options });
		};

		_this16.setOnUpdateMap = function (fn) {
			_this16._permaCallback = fn;
		};

		_this16.state = { mapOptions: {} };
		_this16.mainContext = new _Context2.default(props.formContext.contextId);
		_this16._context = new _Context2.default(props.formContext.contextId + "_MAP");
		_this16._context.grabFocus = _this16.grabFocus;
		_this16._context.releaseFocus = _this16.releaseFocus;
		_this16._context.showPanel = _this16.showPanel;
		_this16._context.hidePanel = _this16.hidePanel;
		_this16._context.setMapState = _this16.setMapState;
		_this16._context.setOnUpdateMap = _this16.setOnUpdateMap;
		return _this16;
	}

	(0, _createClass3.default)(MapComponent, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.map = this.refs.map.map;
			var map = this.map.map;

			this._context.map = this.map;

			map.on("tileLayersChange", this.tileLayerChange);
			map.on("locateToggle", this.locateToggle);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			var map = this.map.map;

			if (!map) return;
			map.off("tileLayersChange", this.tileLayerChange);
			map.off("locateToggle", this.locateToggle);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			var _this17 = this;

			if (this._callback) this._callback();
			this._callback = undefined;

			if (this.props.onOptionsChanged && ["tileLayers", "locate"].some(function (name) {
				return !_deepEqual2.default.apply(undefined, (0, _toConsumableArray3.default)([_this17.state, prevState].map(function (state) {
					return state.mapOptions[name];
				})));
			})) {
				this.props.onOptionsChanged(this.state.mapOptions);
			}

			if (this._permaCallback) this._permaCallback();
		}
	}, {
		key: "render",
		value: function render() {
			var _props4 = this.props,
			    panel = _props4.panel,
			    onFocusGrab = _props4.onFocusGrab,
			    onFocusRelease = _props4.onFocusRelease,
			    onOptionsChanged = _props4.onOptionsChanged,
			    mapOptions = (0, _objectWithoutProperties3.default)(_props4, ["panel", "onFocusGrab", "onFocusRelease", "onOptionsChanged"]); // eslint-disable-line

			var controlledPanel = panel ? _react2.default.createElement(MapPanel, { id: panel.id,
				bsStyle: panel.bsStyle || undefined,
				buttonBsStyle: panel.buttonBsStyle,
				header: panel.header,
				text: panel.panelTextContent }) : null;

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-map-container" + (this.state.focusGrabbed ? " pass-block" : "") },
				controlledPanel,
				this.state.panel && _react2.default.createElement(MapPanel, { id: panel.id,
					show: this.state.panel,
					text: this.state.panelTextContent,
					onClick: this.state.panelButtonOnClick,
					buttonText: this.state.panelButtonContent,
					buttonBsStyle: this.state.panelButtonBsStyle
				}),
				this.state.showHelp && _react2.default.createElement(
					_reactBootstrap.Modal,
					{ dialogClassName: "laji-form", show: true, onHide: this.hideHelp },
					_react2.default.createElement(_reactBootstrap.Modal.Header, { closeButton: true }),
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						_react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: mapOptions.help } })
					)
				),
				_react2.default.createElement(Map, (0, _extends4.default)({ className: this.props.className,
					style: this.props.style,
					ref: "map",
					showHelp: this.showHelp,
					hideHelp: this.hideHelp
				}, (0, _extends4.default)({}, mapOptions, this.state.mapOptions)))
			);
		}
	}]);
	return MapComponent;
}(_react.Component);

var Map = exports.Map = function (_Component8) {
	(0, _inherits3.default)(Map, _Component8);

	function Map(props) {
		(0, _classCallCheck3.default)(this, Map);

		var _this18 = (0, _possibleConstructorReturn3.default)(this, (Map.__proto__ || (0, _getPrototypeOf2.default)(Map)).call(this, props));

		_initialiseProps2.call(_this18);

		_this18.state = { fullscreen: false };
		return _this18;
	}

	(0, _createClass3.default)(Map, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			var options = (0, _extends4.default)({}, this.props);

			// Backward compatibility for bad settings.
			["tileLayerName", "overlayNames", "tileLayerOpacity"].forEach(function (prop) {
				if (prop in options && options[prop] === undefined) {
					options = (0, _utils2.immutableDelete)(options, prop);
				}
			});

			if (this.props.hidden) {
				return;
			}

			this.initializeMap(options);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			!this.props.singleton && this.map && this.map.destroy();
			if (this.hasSingletonHandle) {
				new _Context2.default(this.props.formContext.contextId).onSingletonHandleGrabbed = undefined;
			}
			this.mounted = false;
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			var _props5 = this.props,
			    hidden = _props5.hidden,
			    onComponentDidMount = _props5.onComponentDidMount,
			    singleton = _props5.singleton;
			var props = (0, _objectWithoutProperties3.default)(this.props, []);

			if (!singleton || this.hasSingletonHandle) {

				if (this.map && prevProps.lineTransect && props.lineTransect && "activeIdx" in props.lineTransect) {
					this.map.setLTActiveIdx(props.lineTransect.activeIdx);
				}
				if (prevProps.lineTransect) delete props.lineTransect;

				this.setMapOptions(prevProps, this.props);
			}

			if (!hidden && !this.map) {
				this.initializeMap(props);
				if (onComponentDidMount) onComponentDidMount(this.map);
			}

			if (this.state.fullscreen && !prevState.fullscreen) {
				this._mapContainer = this.map.rootElem;
				this.map.setRootElem((0, _reactDom.findDOMNode)(this.fullscreenRef));
				this.map.map.getContainer().focus();
				this.origBodyAsDialogRoot = this.map._dialogRoot === document.body;
				this.map.setOption("bodyAsDialogRoot", false);
				this.props.clickBeforeZoomAndPan && this.map.setOption("clickBeforeZoomAndPan", false);
				this._bodyOverflowYWas = document.body.style.overflowY;
				document.body.style.overflowY = "hidden";
			} else if (!this.state.fullscreen && prevState.fullscreen) {
				this.map.setRootElem(this._mapContainer);
				this.map.setOption("bodyAsDialogRoot", this.origBodyAsDialogRoot);
				this.props.clickBeforeZoomAndPan && this.map.setOption("clickBeforeZoomAndPan", true);
				document.body.style.overflowY = this._bodyOverflowYWas;
			}
		}
	}, {
		key: "render",
		value: function render() {
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement("div", { key: "map",
					className: "laji-form-map" + (this.props.className ? " " + this.props.className : ""),
					style: this.props.style, ref: "map" }),
				this.state.fullscreen && _react2.default.createElement(_components.Fullscreen, { ref: this.setFullscreenRef, on: this.state.fullscreen, onKeyDown: this.onFullscreenKeyDown, contextId: this.props.formContext.contextId })
			);
		}
	}]);
	return Map;
}(_react.Component);

Map.defaultProps = {
	tileLayerName: "maastokartta",
	availableTileLayerNamesBlacklist: ["pohjakartta"]
};

var _initialiseProps2 = function _initialiseProps2() {
	var _this20 = this;

	this.toggleFullscreen = function () {
		_this20.setState({ fullscreen: !_this20.state.fullscreen });
	};

	this.getMapOptions = function (props) {
		var className = props.className,
		    style = props.style,
		    hidden = props.hidden,
		    singleton = props.singleton,
		    emptyMode = props.emptyMode,
		    onComponentDidMount = props.onComponentDidMount,
		    fullscreenable = props.fullscreenable,
		    formContext = props.formContext,
		    controlSettings = props.controlSettings,
		    mapOptions = (0, _objectWithoutProperties3.default)(props, ["className", "style", "hidden", "singleton", "emptyMode", "onComponentDidMount", "fullscreenable", "formContext", "controlSettings"]);

		return mapOptions;
	};

	this.getEnhancedMapOptions = function (props) {
		var mapOptions = _this20.getMapOptions(props);
		var fullscreenable = props.fullscreenable,
		    help = props.help,
		    _props$formContext = props.formContext,
		    formContext = _props$formContext === undefined ? {} : _props$formContext;


		if (fullscreenable) {
			mapOptions.customControls = [].concat((0, _toConsumableArray3.default)(mapOptions.customControls || []), [{
				iconCls: "glyphicon glyphicon-resize-" + (_this20.state.fullscreen ? "small" : "full"),
				fn: _this20.toggleFullscreen,
				position: "bottomright",
				text: formContext.translations[_this20.state.fullscreen ? "MapExitFullscreen" : "MapFullscreen"]
			}]);
		}
		if (help) {
			mapOptions.customControls = [].concat((0, _toConsumableArray3.default)(mapOptions.customControls || []), [{
				iconCls: "glyphicon glyphicon-question-sign",
				fn: _this20.props.showHelp,
				position: "bottomright",
				text: formContext.translations.Instructions
			}]);
		}
		mapOptions.lang = mapOptions.lang || formContext.lang;
		mapOptions.googleApiKey = formContext.googleApiKey;
		mapOptions.rootElem = _this20.refs.map;
		return mapOptions;
	};

	this.setMapOptions = function (prevOptions, options) {
		if (!_this20.map) {
			return;
		}

		var mapOptions = _this20.getMapOptions(options);
		var prevMapOptions = _this20.getMapOptions(prevOptions);
		(0, _keys2.default)(mapOptions).forEach(function (key) {
			switch (key) {
				case "draw":
					// More optimal way of updating draw data than setting the draw option
					if (!(0, _deepEqual2.default)(mapOptions.draw, prevMapOptions.draw)) {
						_this20.map.updateDrawData(mapOptions.draw);
					}
					break;
				case "rootElem":
					// deeqEquals on DOM node causes maximum call stack size exceeding.
					if (mapOptions[key] !== prevMapOptions[key]) {
						_this20.map.setOption(key, mapOptions[key]);
					}
					break;
				default:
					if (!(0, _deepEqual2.default)(mapOptions[key], prevMapOptions[key])) {
						_this20.map.setOption(key, mapOptions[key]);
						if (_this20.props.singleton && mapOptions.zoomToData && key === "data") {
							_this20.map.zoomToData(mapOptions.zoomToData);
						}
					}
			}
		});
	};

	this.initializeMap = function (props) {
		var mapOptions = _this20.getEnhancedMapOptions(props);
		if (props.singleton) {
			var context = new _Context2.default(props.formContext.contextId);
			context.onSingletonHandleGrabbed && context.onSingletonHandleGrabbed();
			_this20.hasSingletonHandle = true;
			if (!context.singletonMap) {
				context.singletonMap = new _lajiMap2.default(mapOptions);
				_this20.map = context.singletonMap;
				_this20.mounted && props.singleton && _this20.hasSingletonHandle && props.zoomToData && _this20.map.zoomToData(props.zoomToData);
			} else {
				_this20.map = context.singletonMap;
				_this20.setMapOptions(context.singletonMap.getOptions(), mapOptions);
			}
			context.onSingletonHandleGrabbed = function () {
				_this20.hasSingletonHandle = false;
			};
		} else {
			_this20.map = new _lajiMap2.default(mapOptions);
		}
		_this20.map.map.invalidateSize();
		if (props.onComponentDidMount) props.onComponentDidMount(_this20.map);
	};

	this.setFullscreenRef = function (elem) {
		_this20.fullscreenRef = elem;
	};

	this.onFullscreenKeyDown = function (e) {
		if (e.key === "Escape") {
			_this20.setState({ fullscreen: false });
		}
	};
};

var MapPanel = function (_Component9) {
	(0, _inherits3.default)(MapPanel, _Component9);

	function MapPanel() {
		(0, _classCallCheck3.default)(this, MapPanel);
		return (0, _possibleConstructorReturn3.default)(this, (MapPanel.__proto__ || (0, _getPrototypeOf2.default)(MapPanel)).apply(this, arguments));
	}

	(0, _createClass3.default)(MapPanel, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(
				_reactBootstrap.Panel,
				{ bsStyle: this.props.bsStyle || undefined, className: "laji-form-popped", id: this.props.id },
				this.props.header ? _react2.default.createElement(
					_PanelHeading2.default,
					null,
					this.props.header
				) : null,
				_react2.default.createElement(
					_PanelBody2.default,
					null,
					this.props.text,
					this.props.buttonText ? _react2.default.createElement(
						_components.Button,
						{ bsStyle: this.props.buttonBsStyle || "default", onClick: this.props.onClick },
						this.props.buttonText
					) : null
				)
			);
		}
	}]);
	return MapPanel;
}(_react.Component);

var saneOpacityRange = function saneOpacityRange(opacity) {
	return Math.min(1, Math.max(0, opacity || 0));
};

var getFeatureStyleWithLowerOpacity = exports.getFeatureStyleWithLowerOpacity = function getFeatureStyleWithLowerOpacity(style) {
	return (0, _extends4.default)({}, style, {
		opacity: saneOpacityRange(style.opacity || 1 - 0.5),
		fillOpacity: saneOpacityRange(style.fillOpacity || 0.4 - 0.3)
	});
};

var getFeatureStyleWithHighlight = exports.getFeatureStyleWithHighlight = function getFeatureStyleWithHighlight(style) {
	var color = style.color ? (0, _utils.combineColors)(style.color, "#ffffff", 30) : undefined;
	return (0, _extends4.default)({}, style, { color: color, fillOpacity: saneOpacityRange(style.fillOpacity || 0.4 + 0.4) });
};