"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _AnyToBooleanField = require("./AnyToBooleanField");

var _AnyToBooleanField2 = _interopRequireDefault(_AnyToBooleanField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultiAnyToBooleanField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(MultiAnyToBooleanField, _Component);

	function MultiAnyToBooleanField(props) {
		(0, _classCallCheck3.default)(this, MultiAnyToBooleanField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (MultiAnyToBooleanField.__proto__ || (0, _getPrototypeOf2.default)(MultiAnyToBooleanField)).call(this, props));

		_this.onChange = function (index) {
			return function (value) {
				var groupsFormData = _this.state.groupsFormData;
				groupsFormData[index] = value;
				_this.setState({ groupsFormData: groupsFormData });

				var formData = groupsFormData.reduce(function (arr, val) {
					if (val !== undefined) {
						arr.push(val);
					}
					return arr;
				}, []);

				_this.props.onChange(formData);
			};
		};

		_this.state = _this.getInitialState(props);
		return _this;
	}

	(0, _createClass3.default)(MultiAnyToBooleanField, [{
		key: "getInitialState",
		value: function getInitialState(props) {
			var _ref = (0, _utils.getUiOptions)(props.uiSchema) || [],
			    groups = _ref.groups;

			var formData = props.formData;


			var trueValues = groups.map(function (group) {
				return group.trueValue;
			});
			var falseValues = groups.map(function (group) {
				return group.falseValue;
			});
			var groupsFormData = [];

			if (formData) {
				formData.forEach(function (value) {
					if (value === undefined) {
						return;
					}
					var trueIndex = trueValues.findIndex(function (trueValue) {
						return (0, _utils.formDataEquals)(value, trueValue, props.formContext, props.idSchema.$id);
					});
					if (trueIndex !== -1) {
						groupsFormData[trueIndex] = value;
					} else {
						var falseIndex = falseValues.findIndex(function (falseValue) {
							return (0, _utils.formDataEquals)(value, falseValue, props.formContext, props.idSchema.$id);
						});
						if (falseIndex !== -1) {
							groupsFormData[falseIndex] = value;
						}
					}
				});
			}

			return { groupsFormData: groupsFormData };
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var TitleField = this.props.registry.fields.TitleField;

			var _ref2 = (0, _utils.getUiOptions)(this.props.uiSchema) || [],
			    groups = _ref2.groups;

			var help = this.props.uiSchema["ui:help"];

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(TitleField, { title: this.props.schema.title, help: help }),
				_react2.default.createElement(
					"div",
					{ className: "checkbox-row" },
					groups.map(function (group, idx) {
						var help = group["ui:help"],
						    helpHoverable = group["ui:helpHoverable"],
						    helpPlacement = group.helpPlacement,
						    _group = (0, _objectWithoutProperties3.default)(group, ["ui:help", "ui:helpHoverable", "helpPlacement"]);

						var groupProps = (0, _extends3.default)({}, _this2.props, {
							schema: (0, _extends3.default)({}, _this2.props.schema.items, { title: group.label }),
							uiSchema: (0, _extends3.default)({}, _this2.props.uiSchema, { "ui:options": _group, "ui:help": help, "ui:helpHoverable": helpHoverable, "ui:helpPlacement": helpPlacement }),
							formData: _this2.state.groupsFormData[idx],
							onChange: _this2.onChange(idx)
						});

						return _react2.default.createElement(
							_react2.default.Fragment,
							{ key: idx },
							(0, _AnyToBooleanField2.default)(groupProps)
						);
					})
				)
			);
		}
	}]);
	return MultiAnyToBooleanField;
}(_react.Component)) || _class;

MultiAnyToBooleanField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			groups: _propTypes2.default.arrayOf(_propTypes2.default.shape({
				label: _propTypes2.default.string,
				trueValue: _propTypes2.default.any,
				falseValue: _propTypes2.default.any,
				allowUndefined: _propTypes2.default.bool
			}))
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = MultiAnyToBooleanField;