"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ConditionalUiSchemaField = require("./ConditionalUiSchemaField");

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

var _FilterArrayField = require("./FilterArrayField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultiArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(MultiArrayField, _Component);

	function MultiArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, MultiArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MultiArrayField.__proto__ || (0, _getPrototypeOf2.default)(MultiArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.itemIds = {}, _this.onChange = function (idx) {
			return function (formData) {
				var offset = 0;
				for (var i = 0; i < idx; i++) {
					offset += (0, _keys2.default)(_this.groupedItems[i]).length;
				}

				var _getUiOptions = (0, _utils.getUiOptions)(_this.props.uiSchema),
				    persistenceKey = _getUiOptions.persistenceKey;

				var lengthChange = formData.length - _this.groupedItems[idx].length;
				var context = new _Context2.default(persistenceKey + "_MULTI");

				// Fix idxs map for items after this group.
				if (lengthChange && context.nonGroupedMap) {
					var changes = {};
					var changeFrom = {};
					for (var _i = offset + (0, _keys2.default)(_this.groupedItems[idx]).length; _i < _this.props.formData.length; _i++) {
						if (context.nonGroupedMap[_i]) {
							changes[_i + lengthChange] = context.nonGroupedMap[_i];
							changeFrom[_i] = true;
						}
					}
					context.nonGroupedMap = (0, _extends3.default)({}, context.nonGroupedMap, changes);
					(0, _keys2.default)(changeFrom).filter(function (idx) {
						return !(idx in changes);
					}).forEach(function (idx) {
						delete context.nonGroupedMap[idx];
					});
				}

				if (typeof persistenceKey === "string" && formData.length !== _this.groupedItems[idx].length) {
					if (!context.nonGroupedMap) {
						context.nonGroupedMap = {};
					}
					context.nonGroupedMap[offset + formData.length - 1] = idx;
				}

				formData.forEach(function (item) {
					_this.groupItemIds[idx][(0, _utils.getUUID)(item)] = true;
				});
				var newFormData = _this.groupedItems.reduce(function (flat, groupItems, _idx) {
					if (_idx === idx) return [].concat((0, _toConsumableArray3.default)(flat), (0, _toConsumableArray3.default)(formData));
					return [].concat((0, _toConsumableArray3.default)(flat), (0, _toConsumableArray3.default)(groupItems));
				}, []);
				_this.props.onChange(newFormData);
			};
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(MultiArrayField, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var props = this.props;

			var _getUiOptions2 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    groups = _getUiOptions2.groups,
			    _getUiOptions2$cache = _getUiOptions2.cache,
			    cache = _getUiOptions2$cache === undefined ? true : _getUiOptions2$cache,
			    arrayMerge = _getUiOptions2.arrayMerge,
			    persistenceKey = _getUiOptions2.persistenceKey,
			    _getUiOptions2$render = _getUiOptions2.renderNonGrouped,
			    renderNonGrouped = _getUiOptions2$render === undefined ? false : _getUiOptions2$render,
			    nonGroupedOperations = _getUiOptions2.nonGroupedOperations;

			if (groups.length && !this.cache) {
				this.cache = Array(groups.length).fill(undefined).map(function (_) {
					return {};
				}); // eslint-disable-line no-unused-vars
				this.arrayKeyFunctions = Array(groups.length + 1).fill(undefined).map(function (_, idx) {
					return getArrayKeyFunctions(_this2, idx);
				});
			}

			if (groups.length && !this.groupItemIds) {
				var getGroupItemIds = function getGroupItemIds() {
					return Array(groups.length + 1).fill(undefined).map(function (_) {
						return {};
					});
				}; // eslint-disable-line no-unused-vars
				if (typeof persistenceKey === "string") {
					var context = new _Context2.default(persistenceKey + "_MULTI");
					this.groupItemIds = context.groupItemIds || getGroupItemIds();
					context.groupItemIds = this.groupItemIds;
				} else {
					this.groupItemIds = getGroupItemIds();
				}
			}

			var itemGroups = Array(groups.length + 1).fill(undefined).map(function (_) {
				return [];
			}); // eslint-disable-line no-unused-vars
			var addToGroup = function addToGroup(idx, item) {
				var id = (0, _utils.getUUID)(item);
				itemGroups[idx].push(item);
				_this2.groupItemIds[idx][id] = true;
				_this2.itemIds[id] = true;
				return true;
			};

			(props.formData || []).forEach(function (item) {
				_this2.groupItemIds.forEach(function (_, groupIdx) {
					if (_this2.groupItemIds[groupIdx][(0, _utils.getUUID)(item)]) {
						addToGroup(groupIdx, item);
					}
				});
			});

			var nonGrouped = [];
			var groupedItems = (props.formData || []).reduce(function (itemGroups, item, idx) {
				var addedToGroup = groups.some(function (group, groupIdx) {
					if (_this2.itemIds[(0, _utils.getUUID)(item)]) {
						return true;
					}

					var _group$rules = group.rules,
					    rules = _group$rules === undefined ? [] : _group$rules;

					var passes = void 0;
					if (cache) {
						var check = (0, _utils.checkArrayRules)(rules, { formData: props.formData || [] }, idx, _this2.cache[groupIdx]);
						var _cache = check.cache;

						passes = check.passes;
						_this2.cache[groupIdx] = _cache;
					} else {
						passes = (0, _utils.checkArrayRules)(rules, { formData: props.formData || [] }, idx);
					}

					if (passes) {
						return addToGroup(groupIdx, item);
					}
				});

				if (!addedToGroup) {
					nonGrouped.push([item, idx]);
				}
				return itemGroups;
			}, itemGroups);

			nonGrouped.forEach(function (_ref2) {
				var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
				    item = _ref3[0],
				    idx = _ref3[1];

				var context = new _Context2.default(persistenceKey + "_MULTI");
				var groupIdx = _this2.groupItemIds.length - 1;
				if (typeof persistenceKey === "string" && (context.nonGroupedMap || {})[idx] !== undefined && _this2.groupItemIds[groupIdx]) {
					addToGroup(context.nonGroupedMap[idx], item);
				} else {
					addToGroup(groupIdx, item);
				}
			});

			this.groupedItems = groupedItems;
			var withoutNonGrouped = [].concat((0, _toConsumableArray3.default)(groupedItems));
			withoutNonGrouped.pop();

			var offset = 0;
			var offsets = (renderNonGrouped ? groupedItems : withoutNonGrouped).map(function (group, idx) {
				var idxOffsets = void 0;
				if (!idx) {
					idxOffsets = {};
				} else {
					idxOffsets = group.reduce(function (g, i, _idx) {
						g[_idx] = offset;
						return g;
					}, {});
				}
				offset += group.length;
				return idxOffsets;
			}, []);

			return (renderNonGrouped ? groupedItems : withoutNonGrouped).map(function (items, idx) {
				var operations = renderNonGrouped && idx === groupedItems.length - 1 ? nonGroupedOperations : groups[idx].operations;
				var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
				var uiSchema = operations ? (0, _ConditionalUiSchemaField.computeUiSchema)(innerUiSchema, operations, arrayMerge) : innerUiSchema;

				uiSchema = (0, _utils.updateSafelyWithJSONPointer)(uiSchema, _this2.arrayKeyFunctions[idx], "/ui:options/arrayKeyFunctions");
				uiSchema = (0, _utils.updateSafelyWithJSONPointer)(uiSchema, offsets[idx], "/ui:options/idxOffsets");

				var offset = 0;
				for (var i = 0; i < idx; i++) {
					offset += _this2.groupedItems[i].length;
				}

				uiSchema = (0, _extends3.default)({}, uiSchema, { "ui:options": (0, _extends3.default)({}, (0, _utils.getUiOptions)(uiSchema), { startIdx: offset }) });
				var errorSchema = {};
				for (var key in props.errorSchema) {
					if (key >= offset && key < offset + _this2.groupedItems[idx].length) {
						errorSchema[key - offset] = (0, _extends3.default)({}, props.errorSchema[key]);
					}
				}

				var formContext = (0, _extends3.default)({}, _this2.props.formContext, { ArrayField: _FilterArrayField.ArrayFieldIdFixed });

				var SchemaField = _this2.props.registry.fields.SchemaField;

				return _react2.default.createElement(SchemaField, (0, _extends3.default)({
					key: idx
				}, props, {
					formContext: formContext,
					registry: (0, _extends3.default)({}, _this2.props.registry, { formContext: formContext }),
					uiSchema: uiSchema,
					errorSchema: errorSchema,
					formData: items,
					onChange: _this2.onChange(idx)
				}));
			});
		}
	}]);
	return MultiArrayField;
}(_react.Component)) || _class;

MultiArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			rules: _propTypes2.default.oneOfType([_ConditionalUiSchemaField.rulePropType, _propTypes2.default.arrayOf(_ConditionalUiSchemaField.rulePropType)]),
			itemsOperations: _propTypes2.default.oneOfType([_ConditionalUiSchemaField.operationPropType, _propTypes2.default.arrayOf(_ConditionalUiSchemaField.operationPropType)]),
			cache: _propTypes2.default.boolean
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = MultiArrayField;


var getArrayKeyFunctions = function getArrayKeyFunctions(that) {
	var _getUiOptions3 = (0, _utils.getUiOptions)(that.props.uiSchema),
	    optionsArrayKeyFunctions = _getUiOptions3.arrayKeyFunctions;

	var _arrayKeyFunctions = optionsArrayKeyFunctions || _ArrayFieldTemplate.arrayKeyFunctions;
	return (0, _extends3.default)({}, _arrayKeyFunctions, {
		insert: function insert(e, _props) {
			var props = _props.getProps();
			var inputElem = (0, _utils.findNearestParentTabbableElem)(document.activeElement);
			if (!inputElem) {
				return false;
			}
			if (!inputElem.id.startsWith(props.idSchema.$id)) {
				return false;
			}
			var itemIdx = inputElem.id.replace(props.idSchema.$id, "").replace(/^_?([0-9]+).*$/, "$1");

			var _getUiOptions4 = (0, _utils.getUiOptions)(props.uiSchema),
			    startIdx = _getUiOptions4.startIdx;

			if (itemIdx < startIdx || itemIdx >= startIdx + props.formData.length) {
				return false;
			}
			return _arrayKeyFunctions.insert(e, _props);
		},
		navigateArray: function navigateArray(e, options) {
			var _options = (0, _extends3.default)({}, options, { getProps: function getProps() {
					return (0, _extends3.default)({}, options.getProps(), { formData: that.props.formData });
				} });
			return _arrayKeyFunctions.navigateArray(e, _options);
		}
	});
};