"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _reactBootstrap = require("react-bootstrap");

var _Dropdown = require("react-bootstrap/lib/Dropdown");

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _DropdownMenu = require("react-bootstrap/lib/DropdownMenu");

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _components = require("../components");

var _utils = require("../../utils");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _ConditionalUiSchemaField = require("./ConditionalUiSchemaField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var scopeFieldSettings = {
	taxonGroups: {
		translate: function translate(props, taxonGroup) {
			return props.formContext.apiClient.fetchCached("/informal-taxon-groups/" + taxonGroup).then(function (response) {
				return response.name;
			}).catch(function () {
				return "";
			});
		}
	}
};

/**
 * Field with fields, which are shown according to recursive scope.
 * uiSchema = {"ui:options": {
 * additionalsGroupingPath: path to the field scope that defines groups
 * additionalsGroupsTranslator: one of scopeFieldsSettings translator
 * additionalsPersistenceKey: instances with same persistence id use the same additional fields
 * additionalsPersistenceField: form data property value for more fine grained persistence behaviour
 * uiSchema: <uiSchema> (ui schema for inner schema)
 * fields: [<string>] (fields that are always shown)
 * fieldScopes: {
 *  fieldName: {
 *    fieldValue: {
 *      fields: [<string>] (fields that are shown if fieldName[fieldValue} == true)
 *      additionalFields: [<string>] (if grouping is enabled, additional fields are shown only if selected from the list)
 *      excludeFields: [<string>] (exclude fields from showing)
 *      excludeFields: [<string>] (fields that are shown by default)
 *      refs: [<string>] (root definitions that are merged recursively to this fieldScope)
 *      uiSchema: <uiSchema> (merged recursively to inner uiSchema)
 *      uiSchemaMergeType: See documentation for ConditionalUiSchemaField
 *      fieldScopes: {fieldName: <fieldScope>, fieldName2 ...}
 *    },
 *    fieldValue2, ...
 *  }
 * },
 * definitions: {
 *   defName: <fieldScope>,
 *   defname2: ...
 * }
 * }
 *
 * Field scope values accept asterisk (*) and plus (+) as field scope selector.
 */

var ScopeField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ScopeField, _Component);

	function ScopeField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ScopeField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ScopeField.__proto__ || (0, _getPrototypeOf2.default)(ScopeField)).call.apply(_ref, [this].concat(args))), _this), _this.getAdditionalPersistenceValue = function (props) {
			var includeUndefined = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

			var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
			    additionalsPersistenceField = _getUiOptions.additionalsPersistenceField,
			    additionalPersistenceContextKey = _getUiOptions.additionalPersistenceContextKey;

			var formDataItem = props.formData[additionalsPersistenceField];
			if (additionalPersistenceContextKey && (formDataItem === undefined || Array.isArray(formDataItem) && formDataItem.length === 0)) {
				formDataItem = new _Context2.default(_this.props.formContext.contextId)[additionalPersistenceContextKey];
			}
			var items = Array.isArray(formDataItem) ? formDataItem : [formDataItem];
			if (includeUndefined) items = ["undefined"].concat((0, _toConsumableArray3.default)(items));
			return items;
		}, _this.getSchemasAndAdditionals = function (props, state) {
			var schema = props.schema,
			    uiSchema = props.uiSchema,
			    formData = props.formData;

			var additionalFields = state && state.additionalFields ? (0, _extends4.default)({}, state.additionalFields) : {};
			(0, _keys2.default)(additionalFields).forEach(function (key) {
				if (!props.schema.properties[key]) {
					delete additionalFields[key];
				}
			});
			var defaultFields = state && state.defaultFields ? (0, _extends4.default)({}, state.defaultFields) : {};

			var options = (0, _utils.getUiOptions)(uiSchema);
			var fields = options.fields,
			    definitions = options.definitions,
			    _options$glyphFields = options.glyphFields,
			    glyphFields = _options$glyphFields === undefined ? [] : _options$glyphFields,
			    _options$geometryFiel = options.geometryField,
			    geometryField = _options$geometryFiel === undefined ? "unitGathering_geometry" : _options$geometryFiel,
			    taxonField = options.taxonField;

			var generatedUiSchema = (0, _utils.getInnerUiSchema)(uiSchema);

			var fieldsToShow = {};

			(fields || []).forEach(function (field) {
				fieldsToShow[field] = schema.properties[field];
			});

			var hasSetLocation = false;

			glyphFields.reduce(function (additionalFields, _ref2) {
				var show = _ref2.show,
				    open = _ref2.open,
				    fn = _ref2.fn;

				if (fn === "setLocation") {
					hasSetLocation = true;
				}
				if (!(show in additionalFields) && show && open) {
					additionalFields[show] = open;
				}
				return additionalFields;
			}, additionalFields);

			function addFieldSelectorsValues(scopes, fieldSelector, fieldSelectorValue) {
				var fieldScope = scopes[fieldSelector][fieldSelectorValue];
				if (!fieldScope) return;

				while (fieldScope.refs) {
					var refs = fieldScope.refs;
					fieldScope = (0, _extends4.default)({}, fieldScope, { refs: undefined });
					refs.forEach(function (ref) {
						fieldScope = (0, _deepmerge2.default)(fieldScope, definitions[ref]);
					});
				}

				var _fieldScope = fieldScope,
				    _fieldScope$excludeFi = _fieldScope.excludeFields,
				    excludeFields = _fieldScope$excludeFi === undefined ? [] : _fieldScope$excludeFi,
				    _fieldScope$fields = _fieldScope.fields,
				    _fields = _fieldScope$fields === undefined ? [] : _fieldScope$fields,
				    _fieldScope$defaultFi = _fieldScope.defaultFields,
				    _defaultFields = _fieldScope$defaultFi === undefined ? [] : _fieldScope$defaultFi;

				excludeFields.forEach(function (fieldName) {
					delete fieldsToShow[fieldName];
				});

				_defaultFields.forEach(function (fieldName) {
					if (additionalFields[fieldName] !== false) fieldsToShow[fieldName] = schema.properties[fieldName];
				});

				_fields.forEach(function (fieldName) {
					fieldsToShow[fieldName] = schema.properties[fieldName];
					if (additionalFields[fieldName]) {
						delete additionalFields[fieldName];
					}
				});

				if (fieldScope.uiSchema) {
					var _fieldScope2 = fieldScope,
					    _fieldScope2$uiSchema = _fieldScope2.uiSchemaMergeType,
					    uiSchemaMergeType = _fieldScope2$uiSchema === undefined ? "merge" : _fieldScope2$uiSchema;

					generatedUiSchema = (0, _ConditionalUiSchemaField.computeUiSchema)(generatedUiSchema, { type: uiSchemaMergeType, uiSchema: fieldScope.uiSchema });
				}

				if (fieldScope.fieldScopes) {
					addFieldScopeFieldsToFieldsToShow(fieldScope);
				}
			}

			var that = _this;
			function addFieldScopeFieldsToFieldsToShow(fieldScope) {
				if (!fieldScope) return;
				var scopes = fieldScope.fieldScopes;

				if (scopes) (0, _keys2.default)(scopes).forEach(function (fieldSelector) {
					var fieldSelectorValues = formData[fieldSelector];
					if (!fieldSelectorValues || Array.isArray(fieldSelectorValues) && !fieldSelectorValues.length) {
						fieldSelectorValues = that.getAdditionalPersistenceValue(props);
					}
					if (!Array.isArray(fieldSelectorValues)) fieldSelectorValues = [fieldSelectorValues];
					if (scopes[fieldSelector]["+"] && fieldSelectorValues.length > 0 && fieldSelectorValues.some(function (_fieldSelectorValue) {
						return _fieldSelectorValue !== "undefined" && (0, _utils.hasData)(_fieldSelectorValue) && !(0, _utils.isDefaultData)(_fieldSelectorValue, schema.properties[fieldSelector], props.registry.definitions);
					})) {
						addFieldSelectorsValues(scopes, fieldSelector, "+");
					}
					if (scopes[fieldSelector]["*"]) {
						addFieldSelectorsValues(scopes, fieldSelector, "*");
					}
					fieldSelectorValues.forEach(function (fieldSelectorValue) {
						if ((0, _utils.hasData)(fieldSelectorValue) && !(0, _utils.isDefaultData)(fieldSelectorValue, schema.properties[fieldSelector].type === "array" ? schema.properties[fieldSelector].items : schema.properties[fieldSelector], props.registry.definitions)) {
							addFieldSelectorsValues(scopes, fieldSelector, fieldSelectorValue);
						}
					});
				});
			}

			function findScopedFields() {
				var fieldScope = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				var _fields = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

				var _fieldScope$fields2 = fieldScope.fields,
				    fields = _fieldScope$fields2 === undefined ? [] : _fieldScope$fields2,
				    _fieldScope$additiona = fieldScope.additionalFields,
				    additionalFields = _fieldScope$additiona === undefined ? [] : _fieldScope$additiona,
				    _fieldScope$fieldScop = fieldScope.fieldScopes,
				    fieldScopes = _fieldScope$fieldScop === undefined ? {} : _fieldScope$fieldScop;

				[].concat((0, _toConsumableArray3.default)(fields), (0, _toConsumableArray3.default)(additionalFields)).forEach(function (f) {
					_fields[f] = true;
				});
				(0, _keys2.default)(fieldScopes).forEach(function (f) {
					return (0, _keys2.default)(fieldScopes[f]).forEach(function (_f) {
						return findScopedFields(fieldScopes[f][_f], _fields);
					});
				});
				return _fields;
			}

			// If no root fields defined, show all fields that aren't in any scopes' fields or additional fields.
			if (!fields) {
				var scopedFields = findScopedFields(options);
				glyphFields.forEach(function (_ref3) {
					var show = _ref3.show,
					    open = _ref3.open;

					if (open === false) {
						scopedFields[show] = true;
					}
				});
				fieldsToShow = (0, _keys2.default)(props.schema.properties).reduce(function (_fields, f) {
					if (!scopedFields[f]) {
						_fields[f] = props.schema.properties[f];
					}
					return _fields;
				}, {});
			}

			addFieldScopeFieldsToFieldsToShow(options);

			if (additionalFields) {
				(0, _keys2.default)(additionalFields).filter(function (field) {
					return additionalFields[field];
				}).forEach(function (property) {
					if (additionalFields[property]) {
						fieldsToShow[property] = props.schema.properties[property];
					}
				});
			}

			if (formData) {
				(0, _keys2.default)(formData).forEach(function (property) {
					if (!schema.properties[property]) return;
					var isDefault = (0, _utils.isDefaultData)(formData[property], schema.properties[property], _this.props.registry.definitions);
					if (!isDefault) {
						fieldsToShow[property] = props.schema.properties[property];
					}
				});
			}

			(0, _keys2.default)(schema.properties).forEach(function (prop) {
				if (!fieldsToShow[prop]) {
					generatedUiSchema[prop] = { "ui:field": "HiddenField" };
				}
			});

			if (hasSetLocation) {
				console.warn("ScopeField's glyphField fn 'setLocation' is deprecated and will be removed in the future. The functionality is separated to a new component function 'LocationChooserField', use it instead.");
				var locationFn = {
					"ui:field": "LocationChooserField",
					"ui:options": {
						geometryField: geometryField,
						taxonField: taxonField
					}
				};
				var uiFunctions = generatedUiSchema["ui:functions"] ? (0, _utils.isObject)(generatedUiSchema["ui:functions"]) ? [generatedUiSchema["ui:functions"], locationFn] : [].concat((0, _toConsumableArray3.default)(generatedUiSchema["ui:functions"]), [locationFn]) : [locationFn];
				generatedUiSchema = (0, _extends4.default)({}, generatedUiSchema, {
					"ui:functions": uiFunctions
				});
			}

			return {
				schema: schema,
				uiSchema: generatedUiSchema,
				additionalFields: additionalFields,
				defaultFields: defaultFields,
				fieldsToShow: fieldsToShow
			};
		}, _this.onToggleAdditionals = function () {
			_this.setState({ additionalsOpen: !_this.state.additionalsOpen });
		}, _this.renderAdditionalsButtons = function () {
			var glyphButtons = _this.renderGlyphFields();
			if (!_this.state.includeAdditionalFieldsChooserButton || (0, _keys2.default)(_this.props.formData || {}).length === 0) {
				if (glyphButtons) {
					return glyphButtons;
				}
				return [];
			}

			var _getUiOptions2 = (0, _utils.getUiOptions)(_this.props.uiSchema),
			    additionalsGroupingPath = _getUiOptions2.additionalsGroupingPath;

			var additionalProperties = {};
			(0, _keys2.default)(_this.props.schema.properties).forEach(function (property) {
				if (!_this.state.fieldsToShow[property] || _this.state.fieldsToShow[property] && _this.state.additionalFields[property]) additionalProperties[property] = _this.props.schema.properties[property];
			});

			return [additionalsGroupingPath ? _this.renderFieldsModal(additionalProperties) : _this.renderFieldsDropdown(additionalProperties)].concat((0, _toConsumableArray3.default)(glyphButtons ? glyphButtons : []));
		}, _this.renderFieldsModal = function (additionalProperties) {
			var translations = _this.props.formContext.translations;


			var list = [];

			var options = (0, _utils.getUiOptions)(_this.props.uiSchema);
			var additionalsGroupingPath = options.additionalsGroupingPath;


			var groupTranslations = _this.state.additionalsGroupsTranslations || {};

			var groups = additionalsGroupingPath ? (0, _utils.parseJSONPointer)(options, additionalsGroupingPath) : {};

			var additionalsPersistenceValue = _this.getAdditionalPersistenceValue(_this.props);
			var groupNames = (0, _keys2.default)(groups);
			if (additionalsPersistenceValue) groupNames = groupNames.sort(function (a, b) {
				return additionalsPersistenceValue.indexOf(b) - additionalsPersistenceValue.indexOf(a);
			});

			groupNames.forEach(function (groupName) {
				var group = groups[groupName] || {};
				var groupFields = {};
				var _group$fields = group.fields,
				    fields = _group$fields === undefined ? [] : _group$fields,
				    _group$additionalFiel = group.additionalFields,
				    additionalFields = _group$additionalFiel === undefined ? [] : _group$additionalFiel;

				var additionalFieldsDict = (0, _utils.dictionarify)(additionalFields);
				var combinedFields = (0, _keys2.default)((0, _extends4.default)({}, (0, _utils.dictionarify)(fields), additionalFieldsDict));
				combinedFields.forEach(function (field) {
					if (additionalProperties[field]) {
						groupFields[field] = additionalProperties[field];
					} else if (additionalFieldsDict[field]) {
						groupFields[field] = _this.props.schema.properties[field];
					}
				});
				var groupsList = _this.additionalPropertiesToList(groupFields, _reactBootstrap.ListGroupItem);
				if (groupsList.length) {
					var someActive = (0, _keys2.default)(groupFields).some(_this.propertyIsIncluded);

					var onListGroupClick = function onListGroupClick() {
						_this.toggleAdditionalProperty((0, _keys2.default)(groupFields).filter(function (field) {
							return _this.propertyIsIncluded(field) === someActive;
						}));
					};

					var listGroup = [groupTranslations[groupName] !== undefined ? _react2.default.createElement(
						_reactBootstrap.ListGroupItem,
						{ key: groupName + "-list", active: someActive, onClick: onListGroupClick },
						_react2.default.createElement(
							"strong",
							null,
							groupTranslations[groupName]
						)
					) : _react2.default.createElement(_reactSpinner2.default, { key: groupName + "-list" })].concat((0, _toConsumableArray3.default)(groupsList));
					list.push(_react2.default.createElement(
						"div",
						{ key: groupName, className: "scope-field-modal-item" },
						_react2.default.createElement(
							_reactBootstrap.ListGroup,
							null,
							listGroup
						)
					));
				}
			});

			if (_this.state.additionalsOpen) _this.modal = _react2.default.createElement(
				_reactBootstrap.Modal,
				{ key: "fields-modal", show: true, onHide: _this.onToggleAdditionals, dialogClassName: "laji-form scope-field-modal" },
				_react2.default.createElement(
					_reactBootstrap.Modal.Header,
					{ closeButton: true },
					_react2.default.createElement(
						_reactBootstrap.Modal.Title,
						null,
						translations.SelectMoreFields
					)
				),
				_react2.default.createElement(
					_reactBootstrap.Modal.Body,
					null,
					list
				)
			);

			return _this.renderFieldsButton();
		}, _this.renderFieldsButton = function (bsRole) {
			var tooltip = _react2.default.createElement(
				_reactBootstrap.Tooltip,
				{ id: _this.props.idSchema.$id + "-additionals-tooltip" },
				_this.props.formContext.translations.SelectMoreFields
			);

			return _react2.default.createElement(
				_reactBootstrap.OverlayTrigger,
				{ key: _this.props.idSchema.$id + "-scope", overlay: tooltip, placement: "left", bsRole: bsRole },
				_react2.default.createElement(_components.GlyphButton, { glyph: "cog", onClick: _this.onToggleAdditionals, id: _this.props.idSchema.$id + "-additionals" })
			);
		}, _this.renderGlyphFields = function () {
			var _getUiOptions3 = (0, _utils.getUiOptions)(_this.props.uiSchema),
			    glyphFields = _getUiOptions3.glyphFields;

			var idSchema = _this.props.idSchema;


			return glyphFields ? glyphFields.filter(function (settings) {
				return !settings.fn || settings.fn !== "setLocation";
			}).map(function (settings) {
				var glyph = settings.glyph,
				    label = settings.label,
				    show = settings.show;

				if (show) {
					var property = show;
					var isIncluded = _this.propertyIsIncluded(property);
					var _hasData = (0, _utils.propertyHasData)(property, _this.props.formData) && (!_this.props.formData || !(0, _utils.isDefaultData)(_this.props.formData[property], _this.props.schema.properties[property], _this.props.registry.definitions));

					var tooltip = _react2.default.createElement(
						_reactBootstrap.Tooltip,
						{ id: idSchema.$id + "-" + property + "-tooltip-" + glyph },
						label
					);
					var onButtonClick = function onButtonClick() {
						return _this.toggleAdditionalProperty(property);
					};
					return _react2.default.createElement(
						_reactBootstrap.OverlayTrigger,
						{ key: property, overlay: tooltip, placement: "left" },
						_react2.default.createElement(_components.GlyphButton, { glyph: glyph,
							disabled: _hasData,
							bsStyle: isIncluded ? "primary" : "default",
							onClick: onButtonClick
						})
					);
				}
			}) : null;
		}, _this.propertyIsIncluded = function (property) {
			var additionalFields = _this.state.additionalFields;

			var isIncluded = additionalFields[property] === true || _this.state.fieldsToShow[property];
			return !!isIncluded;
		}, _this.toggleAdditionalProperty = function (fields) {
			var _getUiOptions4 = (0, _utils.getUiOptions)(_this.props.uiSchema),
			    additionalsPersistenceField = _getUiOptions4.additionalsPersistenceField,
			    additionalsPersistenceKey = _getUiOptions4.additionalsPersistenceKey;

			if (!Array.isArray(fields)) fields = [fields];
			var additionalFields = fields.reduce(function (additionalFields, field) {
				return (0, _extends4.default)({}, additionalFields, (0, _defineProperty3.default)({}, field, !_this.propertyIsIncluded(field)));
			}, _this.state.additionalFields);

			if (_this.context) {
				var additionalsPersistenceVal = _this.getAdditionalPersistenceValue(_this.props, !"don't include undefined");
				var contextEntry = _this._context || {};
				if (additionalsPersistenceField) {
					var additionalsKeys = _this.props.schema.properties[additionalsPersistenceField].type === "array" ? additionalsPersistenceVal : [additionalsPersistenceVal];
					if (additionalsKeys.length === 0) additionalsKeys = ["undefined"];
					additionalsKeys.forEach(function (persistenceKey) {
						contextEntry[persistenceKey] = additionalFields;
					});
					_this.getContext()["scopeField_" + additionalsPersistenceKey] = contextEntry;
				} else if (additionalsPersistenceKey) {
					_this.getContext()["scopeField_" + additionalsPersistenceKey] = additionalFields;
				}
			}
			_this.setState((0, _extends4.default)({ additionalFields: additionalFields }, _this.getSchemasAndAdditionals(_this.props, (0, _extends4.default)({}, _this.state, { additionalFields: additionalFields }))));
		}, _this.additionalPropertiesToList = function (properties, ElemType) {
			var titles = (0, _utils.getUiOptions)(_this.props.uiSchema).titles || {};
			return (0, _keys2.default)(properties).map(function (property) {
				var isIncluded = _this.propertyIsIncluded(property);
				var hasData = (0, _utils.propertyHasData)(property, _this.props.formData) && (!_this.props.formData || !(0, _utils.isDefaultData)(_this.props.formData[property], _this.props.schema.properties[property], _this.props.registry.definitions));
				var onClick = function onClick() {
					return _this.toggleAdditionalProperty(property);
				};
				return _react2.default.createElement(
					ElemType,
					{
						key: property,
						disabled: hasData,
						active: isIncluded,
						onClick: onClick },
					titles[property] || properties[property].title || property
				);
			});
		}, _this.translateAdditionalsGroups = function (props) {
			var options = (0, _utils.getUiOptions)(props.uiSchema);
			var additionalsGroupingPath = options.additionalsGroupingPath,
			    additionalsGroupsTranslator = options.additionalsGroupsTranslator;

			if (!additionalsGroupingPath) return;
			var groups = (0, _utils.parseJSONPointer)(options, additionalsGroupingPath);
			var groupNames = (0, _keys2.default)(groups).filter(function (groupName) {
				return !(0, _utils.isNullOrUndefined)(groups[groupName]);
			});

			var translations = {};
			var translationsToKeys = {};
			var translationCount = 0;
			groupNames.forEach(function (groupName) {
				var title = groups[groupName].title;

				var promise = !(0, _utils.isNullOrUndefined)(title) ? new _promise2.default(function (resolve) {
					return resolve(title);
				}) : scopeFieldSettings[additionalsGroupsTranslator].translate(props, groupName);

				promise.then(function (translation) {
					translations[groupName] = translation;
					translationsToKeys[translation] = groupName;
					translationCount++;
					if (_this.mounted && translationCount == groupNames.length) {
						_this.setState({
							additionalsGroupsTranslations: translations,
							additionalsGroupsTranslationsToKeys: translationsToKeys
						});
					}
				});
			});
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ScopeField, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;

			var _getUiOptions5 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    additionalsGroupingPath = _getUiOptions5.additionalsGroupingPath;

			var uiSchema = (0, _extends4.default)({}, this.state.uiSchema, {
				"ui:buttons": [].concat((0, _toConsumableArray3.default)(this.props.uiSchema["ui:buttons"] || []), (0, _toConsumableArray3.default)(this.renderAdditionalsButtons()))
			});

			var addButton = function addButton(button) {
				uiSchema = (0, _extends4.default)({}, uiSchema, {
					"ui:buttons": [].concat((0, _toConsumableArray3.default)(uiSchema["ui:buttons"]), [button])
				});
			};

			if (this.state.additionalsOpen && additionalsGroupingPath) {
				addButton(this.modal);
			}

			return _react2.default.createElement(SchemaField, (0, _extends4.default)({}, this.props, this.state, { uiSchema: uiSchema }));
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			if (this.state.additionalsOpen && (!this.state.additionalsGroupsTranslations || prevProps.formContext.lang !== this.props.formContext.lang || (0, _utils.getUiOptions)(prevProps.uiSchema).additionalsGroupsTranslator !== (0, _utils.getUiOptions)(this.props.uiSchema).additionalsGroupsTranslator)) {
				this.translateAdditionalsGroups(this.props);
			}
			if (!(0, _deepEqual2.default)(prevState.fieldsToShow, this.state.fieldsToShow)) {
				var context = new _Context2.default(this.props.formContext.contextId);
				(0, _utils.syncScroll)(this.props.formContext);
				context.sendCustomEvent(this.props.idSchema.$id, "resize");
			}
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			var options = (0, _utils.getUiOptions)(props.uiSchema);

			var includeAdditionalFieldsChooserButton = !!options.includeAdditionalFieldsChooserButton;

			var state = {
				includeAdditionalFieldsChooserButton: includeAdditionalFieldsChooserButton
			};

			var _getUiOptions6 = (0, _utils.getUiOptions)(props.uiSchema),
			    additionalsPersistenceField = _getUiOptions6.additionalsPersistenceField,
			    additionalsPersistenceKey = _getUiOptions6.additionalsPersistenceKey;

			var additionalFields = additionalsPersistenceField ? {} : this.state ? this.state.additionalFields : {};

			if (additionalsPersistenceKey) {
				var mainContext = this.getContext();
				this._context = mainContext["scopeField_" + additionalsPersistenceKey];
			}

			if (this._context) {
				var additionalsToAdd = {};
				if (additionalsPersistenceField) {
					var additionalPersistenceValue = this.getAdditionalPersistenceValue(props);
					additionalPersistenceValue.forEach(function (item) {
						if (_this2._context && _this2._context[item]) additionalsToAdd = (0, _extends4.default)({}, additionalsToAdd, _this2._context[item]);
					});
				} else {
					if (this._context) additionalsToAdd = this._context;
				}
				additionalFields = (0, _extends4.default)({}, additionalFields, additionalsToAdd);
			}
			state.additionalFields = additionalFields;

			state = (0, _extends4.default)({}, state, this.getSchemasAndAdditionals(props, state));

			return state;
		}
	}, {
		key: "renderFieldsDropdown",
		value: function renderFieldsDropdown(additionalProperties) {
			var _this3 = this;

			var onSelect = function onSelect() {
				_this3.preventCloseDropdown = true;
			};

			var onToggle = function onToggle(isOpen) {
				if (!_this3.preventCloseDropdown) _this3.onToggleAdditionals(isOpen);
				_this3.preventCloseDropdown = false;
			};

			return _react2.default.createElement(
				"div",
				{ key: "scope-additionals-dropdown" },
				_react2.default.createElement(
					_Dropdown2.default,
					{ id: this.props.idSchema.$id + "-scope-field-dropdown",
						bsStyle: "primary",
						pullRight: true,
						open: this.state.additionalsOpen,
						onSelect: onSelect,
						onToggle: onToggle },
					this.renderFieldsButton("toggle"),
					_react2.default.createElement(
						_reactBootstrap.Collapse,
						{ "in": this.state.additionalsOpen, bsRole: "menu" },
						_react2.default.createElement(
							_DropdownMenu2.default,
							null,
							this.additionalPropertiesToList(additionalProperties, _reactBootstrap.MenuItem)
						)
					)
				)
			);
		}
	}]);
	return ScopeField;
}(_react.Component)) || _class;

ScopeField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			includeAdditionalFieldsChooserButton: _propTypes2.default.boolean,
			additionalsGroupingPath: _propTypes2.default.string,
			additionalsGroupsTranslator: _propTypes2.default.oneOf((0, _keys2.default)(scopeFieldSettings)),
			additionalsPersistenceKey: _propTypes2.default.string,
			additionalsPersistenceField: _propTypes2.default.string,
			fieldScopes: _propTypes2.default.object,
			fields: _propTypes2.default.arrayOf(_propTypes2.default.string),
			definitions: _propTypes2.default.object,
			uiSchema: _propTypes2.default.object
		}).isRequired
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = ScopeField;


new _Context2.default("SCHEMA_FIELD_WRAPPERS").ScopeField = true;