"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _extends6 = require("babel-runtime/helpers/extends");

var _extends7 = _interopRequireDefault(_extends6);

var _class, _class2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

var _TitleField = require("./TitleField");

var _TitleField2 = _interopRequireDefault(_TitleField);

var _components = require("../components");

var _utils2 = require("@rjsf/core/dist/cjs/utils");

var _reactBootstrap = require("react-bootstrap");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getOptions = function getOptions(options) {
	var _options$sectionField = options.sectionField,
	    sectionField = _options$sectionField === undefined ? "/section" : _options$sectionField,
	    _options$rowDefinerFi = options.rowDefinerField,
	    rowDefinerField = _options$rowDefinerFi === undefined ? "/units/%{row}/identifications/0/taxonVerbatim" : _options$rowDefinerFi,
	    _options$rowDefinerFi2 = options.rowDefinerFields,
	    rowDefinerFields = _options$rowDefinerFi2 === undefined ? ["/units/%{row}/identifications/0/taxonID"] : _options$rowDefinerFi2,
	    _options$rowValueFiel = options.rowValueField,
	    rowValueField = _options$rowValueFiel === undefined ? "/units/%{row}/individualCount" : _options$rowValueFiel;

	return (0, _extends7.default)({}, options, { sectionField: sectionField, rowDefinerField: rowDefinerField, rowDefinerFields: rowDefinerFields, rowValueField: rowValueField });
};

var hideFields = function hideFields(schema, uiSchema, fields) {
	return fields.reduce(function (_uiSchema, field) {
		return (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, { "ui:field": "HiddenField" }, (0, _utils.uiSchemaJSONPointer)(schema, field.replace("%{row}", "0")));
	}, uiSchema);
};

var walkUiOrder = function walkUiOrder(schema, uiSchema, pathToShouldBeLast) {
	var _pathToShouldBeLast$s = pathToShouldBeLast.split("/").filter(function (s) {
		return !(0, _utils.isEmptyString)(s);
	}),
	    _pathToShouldBeLast$s2 = (0, _toArray3.default)(_pathToShouldBeLast$s),
	    prop = _pathToShouldBeLast$s2[0],
	    next = _pathToShouldBeLast$s2.slice(1);

	if (!prop) {
		return uiSchema;
	}
	var nextPath = "/" + next.join("/");
	var nextSchema = (0, _utils.parseSchemaFromFormDataPointer)(schema, prop);
	var nextUiSchema = (0, _utils.parseUiSchemaFromFormDataPointer)(uiSchema, prop);
	if (!isNaN(prop)) {
		return (0, _extends7.default)({}, uiSchema, { items: walkUiOrder(nextSchema, nextUiSchema, nextPath) });
	}
	if (schema.items && schema.items.properties) {
		var _extends2;

		return (0, _extends7.default)({}, uiSchema, { items: (0, _extends7.default)({}, uiSchema.items || {}, (_extends2 = {}, (0, _defineProperty3.default)(_extends2, prop, walkUiOrder(nextSchema, nextUiSchema, nextPath)), (0, _defineProperty3.default)(_extends2, "ui:order", ["*", prop]), _extends2)) });
	}
	if (schema.properties) {
		var _extends3;

		return (0, _extends7.default)({}, uiSchema, (_extends3 = {}, (0, _defineProperty3.default)(_extends3, prop, walkUiOrder(nextSchema, nextUiSchema, nextPath)), (0, _defineProperty3.default)(_extends3, "ui:order", ["*", prop]), _extends3));
	}
};

var walkFieldTemplate = function walkFieldTemplate(schema) {
	var uiSchema = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	var template = arguments[2];

	if (schema.items && schema.items.properties) {
		return (0, _extends7.default)({}, uiSchema, { items: walkFieldTemplate(schema.items, uiSchema.items, template) });
	}
	if (schema.properties) {
		return (0, _extends7.default)({}, uiSchema, {
			"ui:ObjectFieldTemplate": template
		}, (0, _keys2.default)(schema.properties).reduce(function (props, prop) {
			return (0, _extends7.default)({}, props, (0, _defineProperty3.default)({}, prop, walkFieldTemplate(schema.properties[prop], uiSchema[prop], template)));
		}, uiSchema.properties));
	}
	return uiSchema;
};

var InvisibleTitle = function InvisibleTitle(props) {
	return _react2.default.createElement(_TitleField2.default, (0, _extends7.default)({}, props, { className: "hidden-title-text" }));
};

var NoLineBreakTitle = function NoLineBreakTitle(props) {
	return _react2.default.createElement(_TitleField2.default, (0, _extends7.default)({}, props, { className: "no-line-break" }));
};

var SectionArrayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(SectionArrayField, _Component);

	function SectionArrayField(props) {
		(0, _classCallCheck3.default)(this, SectionArrayField);

		// Assume that options don't change.
		var _this = (0, _possibleConstructorReturn3.default)(this, (SectionArrayField.__proto__ || (0, _getPrototypeOf2.default)(SectionArrayField)).call(this, props));

		_this.arrayKeyFunctions = _arrayKeyFunctions(getOptions(_this.getUiOptions()));
		return _this;
	}

	(0, _createClass3.default)(SectionArrayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var uiSchema = props.uiSchema,
			    schema = props.schema,
			    registry = props.registry;

			var _getOptions = getOptions(this.getUiOptions()),
			    sectionField = _getOptions.sectionField,
			    rowDefinerField = _getOptions.rowDefinerField;

			var formContext = (0, _extends7.default)({}, props.formContext, {
				Label: function Label() {
					return null;
				},
				this: this,
				originalUiSchema: uiSchema,
				errorSchema: props.errorSchema,
				errorsAsPopup: true
			});
			var _uiSchema = hideFields(schema, (0, _extends7.default)({}, uiSchema, {
				"ui:ArrayFieldTemplate": SectionArrayFieldTemplate
			}), [sectionField, rowDefinerField]);

			var _rowDefinerField$spli = rowDefinerField.split("%{row}"),
			    _rowDefinerField$spli2 = (0, _slicedToArray3.default)(_rowDefinerField$spli, 1),
			    containerPointer = _rowDefinerField$spli2[0];

			_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, false, "/" + (0, _utils.uiSchemaJSONPointer)(schema, containerPointer) + "/ui:options/removable");

			_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, [{ fn: "add", className: "invisible" }], "/" + (0, _utils.uiSchemaJSONPointer)(schema, containerPointer) + "/ui:options/buttons");
			_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, containerArrayKeyFunctions, "/" + (0, _utils.uiSchemaJSONPointer)(schema, containerPointer) + "/ui:options/arrayKeyFunctions");
			_uiSchema = walkFieldTemplate(schema, _uiSchema, NoLabelsObjectFieldTemplate);
			//_uiSchema = updateSafelyWithJSONPointer(_uiSchema, {"ui:functions": [{"ui:field": "SingleItemArrayField"}, ...currentUiFunctions], ...contentUiSchema }, uiSchemaJSONPointer(schema, containerPointer));

			_uiSchema = walkUiOrder(schema, _uiSchema, rowDefinerField.replace("%{row}", 0));

			_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, this.arrayKeyFunctions, "/ui:options/arrayKeyFunctions");
			_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, true, "/ui:options/keepPropFocusOnNavigate");

			return {
				uiSchema: _uiSchema,
				formContext: formContext,
				registry: (0, _extends7.default)({}, registry, { formContext: formContext, fields: (0, _extends7.default)({}, registry.fields, { TitleField: InvisibleTitle }) })
			};
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "SectionArrayField";
		}
	}]);
	return SectionArrayField;
}(_react.Component)) || _class;

SectionArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = SectionArrayField;


var Section = function Section(_ref) {
	var children = _ref.children,
	    rest = (0, _objectWithoutProperties3.default)(_ref, ["children"]),
	    style = _ref.style;
	return _react2.default.createElement(
		"div",
		(0, _extends7.default)({ style: (0, _extends7.default)({ flexGrow: 1, width: 0, flexBasis: 0, minWidth: 1 }, style) }, rest),
		children
	);
};

var SectionArrayFieldTemplate = (0, _ArrayFieldTemplate.handlesArrayKeys)(_class2 = function (_Component2) {
	(0, _inherits3.default)(SectionArrayFieldTemplate, _Component2);

	function SectionArrayFieldTemplate(props) {
		(0, _classCallCheck3.default)(this, SectionArrayFieldTemplate);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (SectionArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(SectionArrayFieldTemplate)).call(this, props));

		_this2.onFocuses = [];

		_this2.getOnFocus = function (i) {
			return function () {
				_this2.props.formContext.this.getContext()[_this2.props.idSchema.$id + ".activeIdx"] = i + ((0, _utils.getUiOptions)(_this2.props.uiSchema).startIdx || 0);
			};
		};

		_this2.getElemsForRowIdx = function (rowIdx) {
			var _getOptions2 = getOptions((0, _utils.getUiOptions)(_this2.props.uiSchema)),
			    rowValueField = _getOptions2.rowValueField,
			    rowDefinerField = _getOptions2.rowDefinerField;

			return [_this2.props.idSchema.$id + "_0_" + (0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", rowIdx))].concat((0, _toConsumableArray3.default)(_this2.props.formData.map(function (_, idx) {
				return _this2.props.idSchema.$id + "_" + idx + "_" + (0, _utils.JSONPointerToId)(rowValueField.replace("%{row}", rowIdx));
			}))).map(function (id) {
				return document.getElementById(id);
			});
		};

		_this2.onContainerFocus = function (e) {
			var id = e.target.id;

			var _getIdxsFromId = getIdxsFromId(_this2.props.idSchema, getOptions((0, _utils.getUiOptions)(_this2.props.uiSchema)), id),
			    _getIdxsFromId2 = (0, _slicedToArray3.default)(_getIdxsFromId, 1),
			    rowIdx = _getIdxsFromId2[0];

			if (rowIdx !== undefined) {
				_this2.focusedRowIdx = rowIdx;
				_this2.getElemsForRowIdx(rowIdx).forEach(function (elem) {
					if (elem) {
						elem.className += " input-highlight";
					}
				});
			}
		};

		_this2.onContainerBlur = function () {
			if (_this2.focusedRowIdx !== undefined) {
				_this2.getElemsForRowIdx(_this2.focusedRowIdx).forEach(function (elem) {
					if (elem) {
						elem.className = elem.className.replace(" input-highlight", "");
					}
				});
			}
		};

		_this2.getContainerElem = function () {
			return _this2.ref.current;
		};

		_this2.getAddButtonElem = function () {
			return (0, _reactDom.findDOMNode)(_this2.addButtonRef.current);
		};

		_this2.showAddSection = function () {
			_this2.setState({ showAddSection: true }, function () {
				(0, _setImmediate3.default)(function () {
					(0, _reactDom.findDOMNode)(_this2.sectionInputRef.current).focus();
				});
			});
		};

		_this2.hideAddSection = function () {
			_this2.setState({ showAddSection: false, newSection: undefined });
		};

		_this2.getAddSectionPopup = function () {
			var translations = _this2.props.formContext.translations;
			var _this2$state$newSecti = _this2.state.newSection,
			    newSection = _this2$state$newSecti === undefined ? "" : _this2$state$newSecti;

			return _react2.default.createElement(
				"div",
				{ className: "laji-form" },
				_react2.default.createElement(
					"div",
					null,
					_react2.default.createElement(
						"strong",
						null,
						translations.AddNewSection
					)
				),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 3 },
						_react2.default.createElement(
							"label",
							{ className: "row-height not-strong", htmlFor: _this2.props.idSchema.$id + "-section-input" },
							translations.Number,
							":"
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 9 },
						_react2.default.createElement("input", { className: "form-control", id: _this2.props.idSchema.$id + "-section-input", type: "text", value: newSection, onChange: _this2.onNewSectionChange, onKeyDown: _this2.onNewSectionKeyDown, ref: _this2.sectionInputRef })
					)
				),
				_react2.default.createElement(
					"div",
					null,
					translations.EnterNewSectionNumber
				),
				_react2.default.createElement(
					_components.Button,
					{ disabled: !_this2.sectorIsValid(newSection), onClick: _this2.addSection },
					translations.Add
				),
				_react2.default.createElement(
					_components.Button,
					{ onClick: _this2.hideAddSection, bsStyle: "default" },
					translations.Cancel
				)
			);
		};

		_this2.sectorIsValid = function (newSection) {
			var _getOptions3 = getOptions((0, _utils.getUiOptions)(_this2.props.uiSchema)),
			    sectionField = _getOptions3.sectionField;

			var existingNumbers = _this2.props.formData.map(function (item) {
				return "" + (0, _utils.parseJSONPointer)(item, sectionField);
			});
			return !(isNaN(parseInt(newSection)) || parseInt(newSection) < 0 || parseInt(newSection) > 50 || existingNumbers.indexOf(newSection) !== -1);
		};

		_this2.onNewSectionChange = function (e) {
			_this2.setState({ newSection: e.target.value.replace(/[^0-9/-]/g, "") });
		};

		_this2.onNewSectionKeyDown = function (e) {
			if (e.key === "Enter") {
				_this2.sectorIsValid(_this2.state.newSection) && _this2.addSection();
				_this2.hideAddSection();
			}
		};

		_this2.addSection = function () {
			var _this2$props = _this2.props,
			    registry = _this2$props.registry,
			    formContext = _this2$props.formContext,
			    uiSchema = _this2$props.uiSchema,
			    schema = _this2$props.schema;
			var newSection = _this2.state.newSection;

			var _getOptions4 = getOptions((0, _utils.getUiOptions)(uiSchema)),
			    rowDefinerField = _getOptions4.rowDefinerField,
			    rowDefinerFields = _getOptions4.rowDefinerFields,
			    sectionField = _getOptions4.sectionField;

			var _rowDefinerField$spli3 = rowDefinerField.split("/%{row}"),
			    _rowDefinerField$spli4 = (0, _slicedToArray3.default)(_rowDefinerField$spli3, 1),
			    containerPointer = _rowDefinerField$spli4[0];

			var copiedRowDefinerData = ((0, _utils.parseJSONPointer)(_this2.props.formData[0] || {}, containerPointer) || []).reduce(function (result, item, idx) {
				return [rowDefinerField].concat((0, _toConsumableArray3.default)(rowDefinerFields)).reduce(function (_result, field) {
					var _field$split = field.split("/%{row}"),
					    _field$split2 = (0, _slicedToArray3.default)(_field$split, 2),
					    _ = _field$split2[0],
					    parsedField = _field$split2[1]; // eslint-disable-line no-unused-vars


					return (0, _utils.updateFormDataWithJSONPointer)({
						schema: schema.items,
						formData: _result,
						registry: registry
					}, (0, _utils.parseJSONPointer)(item, parsedField), field.replace(/%{row}/g, idx));
				}, result);
			}, (0, _utils2.getDefaultFormState)(schema.items, undefined, registry));
			var tmpIdTree = (0, _utils.getRelativeTmpIdTree)(formContext.contextId, _this2.props.idSchema.$id);
			var _item = copiedRowDefinerData;

			var _addLajiFormIds = (0, _utils.addLajiFormIds)(_item, tmpIdTree, _this2.props.idSchema.$id),
			    _addLajiFormIds2 = (0, _slicedToArray3.default)(_addLajiFormIds, 1),
			    item = _addLajiFormIds2[0];

			item = (0, _utils.updateFormDataWithJSONPointer)({ schema: schema.items, formData: item, registry: registry }, parseInt(newSection), sectionField);
			var items = [].concat((0, _toConsumableArray3.default)(_this2.props.formData), [item]);
			var idx = items.findIndex(function (i) {
				return i === item;
			});

			var idToFocus = _this2.props.idSchema.$id + "_" + idx;

			var _getUiOptions = (0, _utils.getUiOptions)(uiSchema || {}),
			    _getUiOptions$idToScr = _getUiOptions.idToScrollAfterAdd,
			    idToScrollAfterAdd = _getUiOptions$idToScr === undefined ? _this2.props.idSchema.$id + "-add-section" : _getUiOptions$idToScr;

			new _Context2.default(formContext.contextId).idToFocus = idToFocus;
			new _Context2.default(formContext.contextId).idToScroll = idToScrollAfterAdd;

			formContext.this.props.onChange(items);
			_this2.hideAddSection();
		};

		_this2.doNothing = function () {};

		_this2.onRowDefinerChange = function (formData) {
			var _getOptions5 = getOptions((0, _utils.getUiOptions)(_this2.props.uiSchema)),
			    rowDefinerField = _getOptions5.rowDefinerField,
			    rowDefinerFields = _getOptions5.rowDefinerFields;

			var _rowDefinerField$spli5 = rowDefinerField.split("%{row}"),
			    _rowDefinerField$spli6 = (0, _slicedToArray3.default)(_rowDefinerField$spli5, 1),
			    containerPointer = _rowDefinerField$spli6[0];

			var rowDefinerItemIdsToContainerIdxs = ((0, _utils.parseJSONPointer)(_this2.props.formData[0] || {}, containerPointer) || []).reduce(function (map, item, idx) {
				map[(0, _utils.getUUID)(item)] = idx;
				return map;
			}, {});

			var tmpIdTree = (0, _utils.getRelativeTmpIdTree)(_this2.props.formContext.contextId, _this2.props.idSchema.$id + "_" + (0, _utils.JSONPointerToId)(containerPointer.substr(0, containerPointer.length - 1)));

			var oldIds = (0, _utils.getAllLajiFormIdsDeeply)(_this2.props.formData, tmpIdTree);
			var ids = {};

			var _formData = _this2.props.formData.map(function (item, containerIdx) {
				var items = (0, _utils.parseJSONPointer)(formData, containerPointer).map(function (unit, idx) {
					var rowDefinerItem = (0, _utils.parseJSONPointer)(item, containerPointer + "/" + rowDefinerItemIdsToContainerIdxs[(0, _utils.getUUID)(unit)]);
					if (!rowDefinerItem) {
						// If container is first and it has UUID, it's an item added to the definer column. It has a UUID already, so 
						var _ref2 = containerIdx === 0 && (0, _utils.getUUID)(unit) ? (0, _utils.addLajiFormIds)(unit, tmpIdTree) : (0, _utils.addLajiFormIds)((0, _utils.filterItemIdsDeeply)(unit, _this2.props.formContext.contextId, _this2.props.idSchema.$id), tmpIdTree, false),
						    _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
						    _rowDefinerItem = _ref3[0],
						    _ids = _ref3[1];

						rowDefinerItem = _rowDefinerItem;
						ids = (0, _extends7.default)({}, ids, _ids);
					}
					var updatedUnit = [rowDefinerField].concat((0, _toConsumableArray3.default)(rowDefinerFields)).reduce(function (updatedNewUnit, field) {
						var _field$split3 = field.split("%{row}"),
						    _field$split4 = (0, _slicedToArray3.default)(_field$split3, 2),
						    _ = _field$split4[0],
						    contentPointer = _field$split4[1]; // eslint-disable-line no-unused-vars


						var pointer = field.replace("%{row}", idx);
						var value = (0, _utils.parseJSONPointer)(formData, pointer);
						return (0, _utils.updateFormDataWithJSONPointer)({
							schema: (0, _utils.parseSchemaFromFormDataPointer)(_this2.props.schema.items, containerPointer).items,
							formData: updatedNewUnit,
							registry: _this2.props.registry
						}, value, contentPointer);
					}, rowDefinerItem);
					return (0, _utils.addLajiFormIds)(updatedUnit, tmpIdTree, false)[0];
				});
				return (0, _utils.updateFormDataWithJSONPointer)({
					schema: _this2.props.schema.items,
					formData: item,
					registry: _this2.props.registry
				}, items, containerPointer);
			});
			_this2.props.formContext.this.props.onChange(_formData);

			(0, _keys2.default)(oldIds).forEach(function (id) {
				if (!ids[id]) {
					new _Context2.default(_this2.props.formContext.contextId).removeSubmitHook(id);
				}
			});
		};

		_this2.addButtonRef = _react2.default.createRef();
		_this2.sectionInputRef = _react2.default.createRef();
		_this2.ref = _react2.default.createRef();
		return _this2;
	}

	(0, _createClass3.default)(SectionArrayFieldTemplate, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(
				"div",
				{ style: { display: "flex", width: "100%" }, ref: this.ref, onFocus: this.onContainerFocus, onBlur: this.onContainerBlur, tabIndex: 0 },
				_react2.default.createElement(
					Section,
					{ key: "definer", style: { flexGrow: "initial", maxWidth: 200 }, id: this.props.idSchema.$id + "-section-definer" },
					this.renderRowDefinerColumn()
				),
				this.renderSections(),
				_react2.default.createElement(
					Section,
					{ key: "sums", className: "bg-info" },
					this.renderRowDefinerSumColumn()
				),
				_react2.default.createElement(
					Section,
					{ key: "deletes", style: { flexGrow: "initial", maxWidth: 143 } },
					this.renderRowDefinerDeleteColumn()
				)
			);
		}
	}, {
		key: "renderRowDefinerColumn",
		value: function renderRowDefinerColumn() {
			var _props = this.props,
			    formData = _props.formData,
			    uiSchema = _props.uiSchema,
			    schema = _props.schema,
			    registry = _props.registry;

			var _getOptions6 = getOptions((0, _utils.getUiOptions)(uiSchema)),
			    rowDefinerField = _getOptions6.rowDefinerField,
			    rowValueField = _getOptions6.rowValueField,
			    sectionField = _getOptions6.sectionField;

			var _rowDefinerField$spli7 = rowDefinerField.split("/%{row}"),
			    _rowDefinerField$spli8 = (0, _slicedToArray3.default)(_rowDefinerField$spli7, 1),
			    containerPointer = _rowDefinerField$spli8[0];

			var SchemaField = this.props.registry.fields.SchemaField;
			var originalUiSchema = this.props.formContext.originalUiSchema;

			var _schema = schema.items;
			var _formData = formData[0];
			var __uiSchema = hideFields(schema, originalUiSchema, [rowValueField, sectionField]);
			__uiSchema = (0, _utils.updateSafelyWithJSONPointer)(__uiSchema.items, false, containerPointer + "/ui:options/removable");
			__uiSchema = walkUiOrder(schema.items, __uiSchema, rowDefinerField.replace("%{row}", 0));
			__uiSchema = walkFieldTemplate(schema.items, __uiSchema, RowDefinerObjectFieldTemplate);
			__uiSchema = walkUiOrder(schema.items, __uiSchema, containerPointer + "/0/identifications");
			var formContext = (0, _extends7.default)({}, this.props.formContext, {
				rowDefinerField: rowDefinerField,
				sectionPointer: (0, _utils.idSchemaIdToJSONPointer)(this.props.idSchema.$id)
			});

			var idSchema = (0, _utils2.toIdSchema)(this.props.schema.items, this.props.idSchema.$id + "_0", this.props.registry.definitions);

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(_components.DeleteButton, { style: { visibility: "hidden" }, className: "horizontally-centered", translations: this.props.formContext.translations, onClick: this.doNothing }),
				_react2.default.createElement(
					"label",
					{ style: { visibility: "hidden" } },
					"hidden"
				),
				_react2.default.createElement(SchemaField, (0, _extends7.default)({}, this.props, {
					schema: _schema,
					uiSchema: __uiSchema,
					formData: _formData,
					idSchema: idSchema,
					onChange: this.onRowDefinerChange,
					registry: (0, _extends7.default)({}, registry, { formContext: formContext, fields: (0, _extends7.default)({}, registry.fields, { TitleField: NoLineBreakTitle }) }),
					formContext: formContext,
					errorSchema: this.props.formContext.errorSchema[0] || {}
				}))
			);
		}
	}, {
		key: "renderSections",
		value: function renderSections() {
			var _this3 = this;

			var _getOptions7 = getOptions((0, _utils.getUiOptions)(this.props.uiSchema)),
			    sectionField = _getOptions7.sectionField;

			return (this.props.formData || []).map(function (item, idx) {
				if (!_this3.props.items[idx]) {
					return null;
				}
				var _props$items$idx = _this3.props.items[idx],
				    children = _props$items$idx.children,
				    hasRemove = _props$items$idx.hasRemove,
				    index = _props$items$idx.index,
				    disabled = _props$items$idx.disabled,
				    readonly = _props$items$idx.readonly,
				    onDropIndexClick = _props$items$idx.onDropIndexClick;

				return _react2.default.createElement(
					Section,
					{ onFocus: _this3.getOnFocus(idx), key: (0, _utils.getUUID)(item), className: index % 2 ? undefined : "darker nonbordered", id: _this3.props.idSchema.$id + "_" + idx + "-section" },
					hasRemove && _react2.default.createElement(_components.DeleteButton, {
						id: _this3.props.idSchema.$id + "_" + index,
						disabled: disabled || readonly,
						translations: _this3.props.formContext.translations,
						onClick: onDropIndexClick(index),
						className: "horizontally-centered"
					}),
					_react2.default.createElement(
						_components.Affix,
						{ getContainer: _this3.getContainerElem, topOffset: _this3.props.formContext.topOffset, bottomOffset: _this3.props.formContext.bottomOffset },
						_react2.default.createElement(
							"label",
							{ className: "horizontally-centered nonbordered " + (index % 2 ? "background" : " darker") },
							_this3.props.formContext.translations.Section,
							" ",
							(0, _utils.parseJSONPointer)(_this3.props.formData[index], sectionField)
						)
					),
					children
				);
			});
		}
	}, {
		key: "renderRowDefinerDeleteColumn",
		value: function renderRowDefinerDeleteColumn() {
			var _props2 = this.props,
			    schema = _props2.schema,
			    registry = _props2.registry,
			    formData = _props2.formData;

			var _getOptions8 = getOptions((0, _utils.getUiOptions)(this.props.uiSchema)),
			    rowDefinerField = _getOptions8.rowDefinerField,
			    rowValueField = _getOptions8.rowValueField,
			    sectionField = _getOptions8.sectionField;

			var _rowDefinerField$spli9 = rowDefinerField.split("/%{row}"),
			    _rowDefinerField$spli10 = (0, _slicedToArray3.default)(_rowDefinerField$spli9, 1),
			    containerPointer = _rowDefinerField$spli10[0];

			var SchemaField = this.props.registry.fields.SchemaField;
			var originalUiSchema = this.props.formContext.originalUiSchema;

			var _schema = schema.items;
			var _formData = formData[0];
			var __uiSchema = hideFields(schema, originalUiSchema, [rowValueField, sectionField]);
			__uiSchema = (0, _utils.updateSafelyWithJSONPointer)(__uiSchema, [{ fn: "add", className: "invisible" }], "/" + (0, _utils.uiSchemaJSONPointer)(schema, containerPointer) + "/ui:options/buttons");
			__uiSchema = walkUiOrder(schema.items, __uiSchema.items, rowDefinerField.replace("%{row}", 0));
			__uiSchema = walkFieldTemplate(schema.items, __uiSchema, InvisibleLabelObjectFieldTemplate);
			var formContext = (0, _extends7.default)({}, this.props.formContext, {
				containerPointer: containerPointer,
				sectionPointer: (0, _utils.idSchemaIdToJSONPointer)(this.props.idSchema.$id)
			});
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(
					_components.Affix,
					{ getContainer: this.getContainerElem, topOffset: this.props.formContext.topOffset, bottomOffset: this.props.formContext.bottomOffset },
					_react2.default.createElement(
						_components.Button,
						{ id: this.props.idSchema.$id + "-add", onClick: this.showAddSection, style: { whiteSpace: "nowrap", padding: "3.5px 12px" }, ref: this.addButtonRef },
						_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "plus" }),
						" ",
						this.props.formContext.translations.AddSection
					)
				),
				(this.state || {}).showAddSection && _react2.default.createElement(
					_reactBootstrap.Overlay,
					{ show: true, placement: "left", rootClose: true, onHide: this.hideAddSection, target: this.getAddButtonElem },
					_react2.default.createElement(
						_reactBootstrap.Popover,
						{ id: this.props.id + "-show-add-section" },
						this.getAddSectionPopup()
					)
				),
				_react2.default.createElement(
					"label",
					{ style: { visibility: "hidden" } },
					"hidden"
				),
				_react2.default.createElement(SchemaField, (0, _extends7.default)({}, this.props, {
					schema: _schema,
					uiSchema: __uiSchema,
					formData: _formData,
					onChange: this.onRowDefinerChange,
					registry: (0, _extends7.default)({}, registry, { formContext: formContext, fields: (0, _extends7.default)({}, registry.fields, { TitleField: InvisibleTitle }) }),
					formContext: formContext
				}))
			);
		}
	}, {
		key: "renderRowDefinerSumColumn",
		value: function renderRowDefinerSumColumn() {
			var _props3 = this.props,
			    schema = _props3.schema,
			    registry = _props3.registry,
			    formData = _props3.formData;

			var _getOptions9 = getOptions((0, _utils.getUiOptions)(this.props.uiSchema)),
			    rowDefinerField = _getOptions9.rowDefinerField,
			    rowDefinerFields = _getOptions9.rowDefinerFields,
			    rowValueField = _getOptions9.rowValueField,
			    sectionField = _getOptions9.sectionField;

			var _rowValueField$split = rowValueField.split("/%{row}"),
			    _rowValueField$split2 = (0, _slicedToArray3.default)(_rowValueField$split, 2),
			    containerPointer = _rowValueField$split2[0],
			    valueField = _rowValueField$split2[1];

			var SchemaField = this.props.registry.fields.SchemaField;
			var originalUiSchema = this.props.formContext.originalUiSchema;

			var _schema = (0, _utils.updateSafelyWithJSONPointer)(schema.items, { type: "integer" }, "/properties/" + containerPointer + "/items/properties/sum");

			var _formData = formData[0];
			var sums = formData.reduce(function (sums, item) {
				((0, _utils.parseJSONPointer)(item, containerPointer) || []).forEach(function (definerItem, idx) {
					sums[idx] = (sums[idx] || 0) + ((0, _utils.parseJSONPointer)(definerItem, valueField) || 0);
				});
				return sums;
			}, []);
			sums.forEach(function (sum, idx) {
				_formData = (0, _utils.updateSafelyWithJSONPointer)(_formData || {}, sum, containerPointer + "/" + idx + "/sum");
			});

			var containerUiSchema = (0, _keys2.default)((0, _utils.parseSchemaFromFormDataPointer)(_schema, containerPointer).items.properties).reduce(function (uiSchema, field) {
				if (field === "sum") {
					return uiSchema;
				}
				return (0, _extends7.default)({}, uiSchema, (0, _defineProperty3.default)({}, field, { "ui:field": "HiddenField" }));
			}, (0, _utils.parseUiSchemaFromFormDataPointer)(originalUiSchema, containerPointer).items);
			var __uiSchema = (0, _utils.updateSafelyWithJSONPointer)(originalUiSchema, containerUiSchema, "/items/" + containerPointer + "/items");
			__uiSchema = hideFields(schema, __uiSchema, [rowValueField, sectionField, rowDefinerField].concat((0, _toConsumableArray3.default)(rowDefinerFields)));

			__uiSchema = (0, _utils.updateSafelyWithJSONPointer)(__uiSchema.items, (0, _extends7.default)({}, (0, _utils.parseJSONPointer)(__uiSchema.items, containerPointer + "/ui:options"), { removable: false, buttons: [{ fn: "add", className: "invisible" }] }), containerPointer + "/ui:options");

			__uiSchema = (0, _utils.updateSafelyWithJSONPointer)(__uiSchema, {
				"ui:widget": "PlainTextWidget",
				"ui:options": { strong: true, centered: true }
			}, containerPointer + "/items/sum");

			__uiSchema = walkFieldTemplate(schema.items, __uiSchema, SumObjectFieldTemplate);
			__uiSchema = walkUiOrder(schema.items, __uiSchema, rowDefinerField.replace("%{row}", 0));
			var formContext = (0, _extends7.default)({}, this.props.formContext, {
				containerPointer: containerPointer,
				sectionPointer: (0, _utils.idSchemaIdToJSONPointer)(this.props.idSchema.$id),
				rowValueField: rowValueField,
				rowDefinerField: rowDefinerField
			});

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(_components.DeleteButton, { style: { visibility: "hidden" }, className: "horizontally-centered", translations: this.props.formContext.translations, onClick: this.doNothing }),
				_react2.default.createElement(
					_components.Affix,
					{ getContainer: this.getContainerElem, topOffset: this.props.formContext.topOffset, bottomOffset: this.props.formContext.bottomOffset },
					_react2.default.createElement(
						"label",
						{ className: "bg-info horizontally-centered" },
						this.props.formContext.translations.Sum
					)
				),
				_react2.default.createElement(SchemaField, (0, _extends7.default)({}, this.props, {
					schema: _schema,
					uiSchema: __uiSchema,
					formData: _formData,
					onChange: this.onRowDefinerChange,
					registry: (0, _extends7.default)({}, registry, { formContext: formContext, fields: (0, _extends7.default)({}, registry.fields, { TitleField: InvisibleTitle }) }),
					formContext: formContext
				}))
			);
		}
	}]);
	return SectionArrayFieldTemplate;
}(_react.Component)) || _class2;

var withoutItemPointers = function withoutItemPointers(pointer) {
	return pointer.replace(/\/([0-9]+|%{row})/g, "");
};

var InvisibleLabelObjectFieldTemplate = function InvisibleLabelObjectFieldTemplate(props) {
	var containerPointer = props.formContext.containerPointer;

	var pointer = (0, _utils.idSchemaIdToJSONPointer)(props.idSchema.$id);
	var containerPointerWithoutItemPointers = withoutItemPointers(containerPointer);
	var pointerWithoutItemPointers = withoutItemPointers(pointer);
	return props.properties.map(function (prop) {
		var propUiSchema = props.uiSchema[prop.name] || {};
		if (propUiSchema["ui:field"] === "HiddenField" || propUiSchema["ui:widget"] === "HiddenWidget") {
			return null;
		}
		if (containerPointerWithoutItemPointers.startsWith(pointerWithoutItemPointers.replace(props.formContext.sectionPointer, "") + "/" + prop.name)) {
			return _react2.default.createElement(
				_react2.default.Fragment,
				{ key: prop.name },
				prop.content
			);
		}
		return _react2.default.createElement(
			"div",
			{ key: prop.name, className: "form-group row-height" },
			_react2.default.createElement("label", null)
		);
	});
};

var SumObjectFieldTemplate = function SumObjectFieldTemplate(props) {
	var containerPointer = props.formContext.containerPointer;

	var pointer = (0, _utils.idSchemaIdToJSONPointer)(props.idSchema.$id);
	var containerPointerWithoutItemPointers = withoutItemPointers(containerPointer);
	var pointerWithoutItemPointers = withoutItemPointers(pointer);
	return props.properties.map(function (prop) {
		var propUiSchema = props.uiSchema[prop.name] || {};
		if (propUiSchema["ui:field"] === "HiddenField" || propUiSchema["ui:widget"] === "HiddenWidget") {
			return null;
		}
		if (containerPointerWithoutItemPointers.startsWith(pointerWithoutItemPointers.replace(props.formContext.sectionPointer, "") + "/" + prop.name) || prop.name === "sum") {
			return _react2.default.createElement(
				_react2.default.Fragment,
				{ key: prop.name },
				prop.content
			);
		}
		return _react2.default.createElement(
			"div",
			{ key: prop.name, className: "form-group row-height " + prop.name },
			_react2.default.createElement("label", null)
		);
	});
};

var NoLabelsObjectFieldTemplate = function NoLabelsObjectFieldTemplate(props) {
	return props.properties.map(function (prop) {
		return prop.content;
	});
};

var RowDefinerObjectFieldTemplate = function RowDefinerObjectFieldTemplate(props) {
	var pointer = (0, _utils.idSchemaIdToJSONPointer)(props.idSchema.$id);
	var rowDefinerFieldWithoutItemPointers = withoutItemPointers(props.formContext.rowDefinerField);
	var pointerWithoutItemPointers = withoutItemPointers(pointer);
	return props.properties.map(function (prop) {
		var propUiSchema = props.uiSchema[prop.name] || {};
		if (propUiSchema["ui:field"] === "HiddenField" || propUiSchema["ui:widget"] === "HiddenWidget") {
			return null;
		}
		if (rowDefinerFieldWithoutItemPointers.startsWith(pointerWithoutItemPointers.replace(props.formContext.sectionPointer, "") + "/" + prop.name)) {
			return _react2.default.createElement(
				_react2.default.Fragment,
				{ key: prop.name },
				prop.content
			);
		}
		var title = (props.uiSchema[prop.name] || {})["ui:title"] || props.schema.properties[prop.name].title || prop.name;
		return _react2.default.createElement(
			"div",
			{ key: prop.name, className: "form-group row-height" },
			_react2.default.createElement(
				"label",
				null,
				title
			)
		);
	});
};

var getIdxsFromId = function getIdxsFromId(idSchema, options, _id) {
	var rowDefinerField = options.rowDefinerField;

	var id = idSchema.$id;
	var sectionIdx = _id.match(new RegExp(id + "_(\\d+)")) && !_id.match(new RegExp(id + "_\\d+_" + (0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", "\\d+")))) ? +_id.match(new RegExp(id + "_(\\d+)"))[1] : undefined;

	var _rowDefinerField$spli11 = rowDefinerField.split("%{row}"),
	    _rowDefinerField$spli12 = (0, _slicedToArray3.default)(_rowDefinerField$spli11, 1),
	    containerPointer = _rowDefinerField$spli12[0];

	var horizontalIdx = _id.match(new RegExp(id + "_\\d+_" + (0, _utils.JSONPointerToId)(containerPointer))) ? +_id.match(new RegExp(id + "_\\d+_" + (0, _utils.JSONPointerToId)(containerPointer) + "(\\d+)"))[1] : undefined;
	return [horizontalIdx, sectionIdx];
};

var _arrayKeyFunctions = function _arrayKeyFunctions(options) {
	var keyFunctions = (0, _extends7.default)({}, _ArrayFieldTemplate.arrayKeyFunctions, {
		insert: function insert(e, props) {
			document.getElementById(props.getProps().idSchema.$id + "-add").click();
		},
		navigateSection: function navigateSection(e, _ref4) {
			var getProps = _ref4.getProps,
			    left = _ref4.left,
			    right = _ref4.right,
			    up = _ref4.up,
			    goOverRow = _ref4.goOverRow;
			var rowDefinerField = options.rowDefinerField,
			    rowValueField = options.rowValueField;

			var currentId = (0, _utils.findNearestParentSchemaElemId)(getProps().formContext.contextId, document.activeElement);
			var amount = left || up ? -1 : 1;
			var id = getProps().idSchema.$id;
			var nextId = void 0;

			var _getIdxsFromId3 = getIdxsFromId(getProps().idSchema, options, currentId),
			    _getIdxsFromId4 = (0, _slicedToArray3.default)(_getIdxsFromId3, 2),
			    currentRow = _getIdxsFromId4[0],
			    currentSection = _getIdxsFromId4[1];

			if (currentRow === undefined && currentSection === undefined) {
				return false;
			}

			var getNonRowSectionFieldsForSectionIdx = function getNonRowSectionFieldsForSectionIdx(sectionIdx) {
				var tabbable = (0, _utils.getTabbableFields)(document.getElementById(id + "_" + sectionIdx + "-section"));
				return tabbable.filter(function (elem) {
					return !elem.id.match(new RegExp((0, _utils.JSONPointerToId)(rowValueField.replace("%{row}", "\\d+"))));
				});
			};
			var goOverToNonRowLogic = function goOverToNonRowLogic(currentProp) {
				var reverse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
				var last = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

				var tabbableInSection = (0, _utils.getTabbableFields)(document.getElementById(id + "_" + (last ? getProps().formData.length - 1 : 0) + "-section"));
				if (reverse) {
					tabbableInSection = tabbableInSection.reverse();
				}
				var currentPropEncountered = false;
				var elem = tabbableInSection.find(function (elem) {
					if (!elem.id.match(new RegExp((0, _utils.JSONPointerToId)(rowValueField.replace("%{row}", "\\d+"))))) {
						if (!currentProp || currentPropEncountered) {
							return elem;
						}
						if (elem.id.match(currentProp)) {
							currentPropEncountered = true;
						}
					}
				});
				nextId = (0, _utils.findNearestParentSchemaElemId)(getProps().formContext.contextId, elem);
			};

			if (left || right) {
				// Horizontal navigation from row definer column to row value column.
				if (right && currentSection === undefined) {
					var idSuffix = (0, _utils.JSONPointerToId)(rowValueField.replace("%{row}", currentRow));
					nextId = id + "_0_" + idSuffix;
					// Horizontal navigation from row value column to row definer column.
				} else if (left && currentSection === 0 && currentRow !== undefined) {
					var _idSuffix = (0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", currentRow));
					nextId = id + "_" + currentSection + "_" + _idSuffix;
					// Horizontal navigation to next/prev row if goOverRow.
				} else if (right && currentSection === getProps().formData.length - 1) {
					if (!goOverRow) {
						return false;
					}
					// Horizontal navigation inside row matrix.
					if (currentRow !== undefined) {
						var _idSuffix2 = (0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", currentRow + 1));
						nextId = id + "_" + 0 + "_" + _idSuffix2;
					} else {
						var tabbableInSection = getNonRowSectionFieldsForSectionIdx(getProps().formData.length - 1);
						// Horizontal navigation inside non row section field.
						if (currentId === (0, _utils.findNearestParentSchemaElemId)(getProps().formContext.contextId, tabbableInSection[tabbableInSection.length - 1])) {
							nextId = id + "_0_" + (0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", 0));
							// Horizontal navigation from non row section to row field.
						} else {
							var currentProp = currentId.match(id + "_" + currentSection + "_(.+)")[1];
							goOverToNonRowLogic(currentProp, false, false);
						}
					}
				} else if (left && currentSection === undefined) {
					if (goOverRow) {
						// Horizontal navigation from row field to non row section field.
						if (currentRow === 0) {
							goOverToNonRowLogic();
							// Horizontal navigation inside row value fields.
						} else {
							var _idSuffix3 = (0, _utils.JSONPointerToId)(rowValueField.replace("%{row}", currentRow - 1));
							nextId = id + "_" + (getProps().formData.length - 1) + "_" + _idSuffix3;
						}
					}
					// Horizontal navigation inside non row section fields.
				} else if (left && currentRow === undefined && currentSection === 0) {
					if (goOverRow) {
						var _currentProp = currentId.match(id + "_" + currentSection + "_(.+)")[1];
						goOverToNonRowLogic(_currentProp);
					}
					// Horizontal navigation inside value matrix.
				} else {
					var _currentId$match = currentId.match(new RegExp(id + "_(\\d+)")),
					    _currentId$match2 = (0, _slicedToArray3.default)(_currentId$match, 1),
					    idPrefix = _currentId$match2[0];

					var _idSuffix4 = currentId.replace(idPrefix + "_", "");
					nextId = id + "_" + (+currentSection + amount) + "_" + _idSuffix4;
				}
			} else {
				// Vertical navigation.
				var containerId = currentSection !== undefined ? id + "_" + currentSection + "-section" : id + "-section-definer";
				var tabbableOutsideContainer = (0, _utils.getTabbableFields)(document.getElementById(containerId));
				var tabbableIdx = tabbableOutsideContainer.findIndex(function (e) {
					return e === document.activeElement;
				});
				nextId = (0, _utils.findNearestParentSchemaElemId)(getProps().formContext.contextId, tabbableOutsideContainer[tabbableIdx + amount]);
				if (nextId === "root") {
					return true;
				}
			}
			(0, _utils.focusAndScroll)(getProps().formContext, nextId);
		}
	});
	keyFunctions.navigate = function (e, props) {
		var getProps = props.getProps,
		    reverse = props.reverse;

		var id = getProps().idSchema.$id;
		if (!reverse) {
			var lastSectionElems = (0, _utils.getTabbableFields)(document.getElementById(id + "_" + (getProps().formData.length - 1) + "-section"));
			var lastElem = lastSectionElems[lastSectionElems.length - 1];
			if (document.activeElement === lastElem) {
				return false;
			}
		} else {
			var rowDefinerField = options.rowDefinerField;

			var firstElem = (0, _utils.getTabbableFields)(document.getElementById(id + "_0-section"))[0];
			if (document.activeElement === firstElem) {
				var allTabbableFields = (0, _utils.getTabbableFields)((0, _reactDom.findDOMNode)(getProps().formContext.getFormRef()));
				var matcher = new RegExp((0, _utils.JSONPointerToId)(rowDefinerField.replace("%{row}", "\\d+")));
				var allTabbableFieldsWithoutRowDefinerInputs = allTabbableFields.filter(function (f) {
					return !f.id.match(matcher);
				});
				var input = (0, _utils.getNextInputInInputs)(getProps().formContext.getFormRef(), undefined, true, allTabbableFieldsWithoutRowDefinerInputs);
				if (input) {
					input.focus();
				}
				return true;
			}
		}
		return keyFunctions.navigateSection(e, (0, _extends7.default)({}, props, { right: !props.reverse, left: props.reverse, goOverRow: true }));
	};
	return keyFunctions;
};

var containerArrayKeyFunctions = (0, _extends7.default)({}, _ArrayFieldTemplate.arrayKeyFunctions, {
	// Disable insert, insert should bubble to section adding.
	insert: function insert() {
		return false;
	}
});