"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Constructs selects from given tree.
 * uiSchema = {"ui:options": {
*   tree: {<enum key tree>}, (node object: {children: {key: {<node>}, key2:{<node>}}, order: ["key", "key2"]} (order is optional)
*   labels: [<string>]
 * }
 */
var SelectTreeField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(SelectTreeField, _Component);

	function SelectTreeField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, SelectTreeField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = SelectTreeField.__proto__ || (0, _getPrototypeOf2.default)(SelectTreeField)).call.apply(_ref, [this].concat(args))), _this), _this.onKeyDown = function (e) {
			if (e.key == "Enter" && !e.ctrlKey) {
				e.preventDefault();
				e.stopPropagation();
				_this.getContext().setImmediate(function () {
					(0, _utils.focusNextInput)(_this.props.formContext.getFormRef(), document.activeElement, e.shiftKey);
				});
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(SelectTreeField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var schema = { "type": "object", title: props.schema.title };
			var uiSchema = props.uiSchema;

			uiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			var formData = {};
			var idSchema = { $id: props.idSchema.$id };

			var dictionarifiedEnums = {};
			props.schema.enum.forEach(function (e, i) {
				dictionarifiedEnums[e] = props.schema.enumNames[i];
			});

			var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
			    tree = _getUiOptions.tree,
			    labels = _getUiOptions.labels;

			var levels = [];
			var parentsMap = {};
			var childrenMap = {};
			var orderMap = {};
			function getLevels(tree, depth, root) {
				childrenMap[root] = {};
				if (tree.children) (0, _keys2.default)(tree.children).forEach(function (key) {
					if (!levels[depth]) levels[depth] = {};
					levels[depth][key] = true;
					parentsMap[key] = root;
					childrenMap[root][key] = true;
					getLevels(tree.children[key], depth + 1, key);
				});
				if (tree.order) orderMap[root] = tree.order;
			}
			getLevels(tree, 0);

			var properties = {};
			function addSelect(depth, key, childrenKeys) {
				var select = { "type": "string", "enum": [""], enumNames: [""] };

				var order = orderMap[key];
				if (order) childrenKeys.sort(function (a, b) {
					return order.indexOf(a) - order.indexOf(b);
				});

				childrenKeys.forEach(function (key) {
					select.enum.push(key);
					select.enumNames.push(dictionarifiedEnums[key]);
				});
				if (labels && labels[depth]) {
					select.title = labels[depth];
				}
				select.title = labels && labels[depth] ? labels[depth] : "";

				properties[depth] = select;
				idSchema[depth] = { $id: idSchema.$id + "_" + depth };
			}

			var searchTerm = props.formData;

			var depth = 0;
			if (!(0, _utils.isEmptyString)(searchTerm)) for (var i in levels) {
				var level = levels[i];
				if (level[searchTerm]) break;
				depth++;
			}

			var n = searchTerm;
			var d = depth;
			while (d >= 0) {
				formData[d] = n;
				if ((0, _utils.isEmptyString)(n)) n = undefined; //object keys can't be "", so root key is in childrenMap 'undefined'.
				addSelect(d, n, (0, _keys2.default)(childrenMap[parentsMap[n]]));
				d--;
				n = parentsMap[n];
			}

			if (!(0, _utils.isEmptyString)(searchTerm) && childrenMap[searchTerm] && (0, _keys2.default)(childrenMap[searchTerm]).length) {
				addSelect(depth + 1, searchTerm, (0, _keys2.default)(childrenMap[searchTerm]));
				formData[depth + 1] = undefined;
			}

			schema.properties = properties;

			return { schema: schema, formData: formData, uiSchema: uiSchema, idSchema: idSchema };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var selectNames = (0, _keys2.default)(formData).sort(function (a, b) {
				return b - a;
			});

			for (var i in selectNames) {
				if (formData[i] !== this.state.formData[i]) {
					var value = void 0;
					if ((0, _utils.isEmptyString)(formData[i])) {
						value = i > 0 ? formData[i - 1] : undefined;
					} else {
						value = formData[i];
					}
					this.props.onChange(value);
					break;
				}
			}
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;
			return _react2.default.createElement(
				"div",
				{ onKeyDown: this.onKeyDown },
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, this.state, {
					onChange: this.onChange
				}))
			);
		}
	}]);
	return SelectTreeField;
}(_react.Component)) || _class;

SelectTreeField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			tree: _propTypes2.default.object.isRequired,
			labels: _propTypes2.default.arrayOf(_propTypes2.default.string),
			uiSchema: _propTypes2.default.object
		}).isRequired
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}).isRequired,
	value: _propTypes2.default.string
};
exports.default = SelectTreeField;