"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _get3 = require("babel-runtime/helpers/get");

var _get4 = _interopRequireDefault(_get3);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _class, _class4, _class5, _class6, _class7, _class8, _temp5, _initialiseProps2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _reactBootstrap = require("react-bootstrap");

var _PanelHeading = require("react-bootstrap/lib/PanelHeading");

var _PanelHeading2 = _interopRequireDefault(_PanelHeading);

var _PanelBody = require("react-bootstrap/lib/PanelBody");

var _PanelBody2 = _interopRequireDefault(_PanelBody);

var _utils = require("../../utils");

var _utils2 = require("@rjsf/core/dist/cjs/utils");

var _components = require("../components");

var _ArrayFieldTemplate2 = require("../ArrayFieldTemplate");

var _ArrayFieldTemplate3 = _interopRequireDefault(_ArrayFieldTemplate2);

var _ArrayField = require("./ArrayField");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _utils3 = require("laji-map/lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var popupMappers = {
	units: function units(schema, _units, options) {
		var identifications = _units.map(function (item) {
			return item && item.identifications && item.identifications[0] ? item.identifications[0] : undefined;
		}).filter(function (item) {
			return item;
		});

		return _promise2.default.all(identifications.map(function (identification) {
			return _promise2.default.resolve(identification.taxon);
		})).then(function (result) {
			return _promise2.default.resolve((0, _defineProperty3.default)({}, (schema.units ? schema.units.title : undefined) || options.label || options.field, result));
		});
	}
};

var SingleActiveArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(SingleActiveArrayField, _Component);

	function SingleActiveArrayField(props) {
		(0, _classCallCheck3.default)(this, SingleActiveArrayField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (SingleActiveArrayField.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayField)).call(this, props));

		_initialiseProps.call(_this);

		var formData = props.formData,
		    uiSchema = props.uiSchema,
		    schema = props.schema;

		_this.deleteButtonRefs = {};
		var options = (0, _utils.getUiOptions)(uiSchema);
		var formDataLength = (formData || []).length;
		_this.state = (0, _extends4.default)({
			activeIdx: formDataLength === 1 || formDataLength === 0 && schema.minItems ? 0 : options.initialActiveIdx
		}, _this.getStateFromProps(props), { popups: {}
		});
		var id = "" + _this.props.idSchema.$id;
		_this.getContext()[id + ".activeIdx"] = _this.state.activeIdx;
		return _this;
	}

	(0, _createClass3.default)(SingleActiveArrayField, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.updatePopups(this.props);
			if ((0, _utils.getUiOptions)(this.props.uiSchema).receiveActiveIdxEvents !== false) {
				new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "activeIdx", this.onActiveChange);
			}
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			if ((0, _utils.getUiOptions)(this.props.uiSchema).receiveActiveIdxEvents !== false) {
				new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "activeIdx", this.onActiveChange);
			}
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.prevActiveIdx = this.state.activeIdx;
			this.setState(this.getStateFromProps(props));
			this.updatePopups(props);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			var _this2 = this;

			var options = (0, _utils.getUiOptions)(this.props);
			var prevOptions = (0, _utils.getUiOptions)(prevProps);
			this.getContext()[this.props.idSchema.$id + ".activeIdx"] = this.state.activeIdx;

			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    idToFocusAfterNavigate = _getUiOptions.idToFocusAfterNavigate,
			    idToScrollAfterNavigate = _getUiOptions.idToScrollAfterNavigate,
			    _getUiOptions$focusOn = _getUiOptions.focusOnNavigate,
			    focusOnNavigate = _getUiOptions$focusOn === undefined ? true : _getUiOptions$focusOn,
			    _getUiOptions$rendere = _getUiOptions.renderer,
			    renderer = _getUiOptions$rendere === undefined ? "accordion" : _getUiOptions$rendere,
			    idxOffsets = _getUiOptions.idxOffsets,
			    totalOffset = _getUiOptions.totalOffset,
			    affixed = _getUiOptions.affixed;

			if (renderer === "uncontrolled") return;
			if ((prevProps.formData || []).length === (this.props.formData || []).length && ("activeIdx" in options && options.activeIdx !== prevOptions.activeIdx || !("activeIdx" in options) && this.state.activeIdx !== prevState.activeIdx)) {
				var idToScroll = idToScrollAfterNavigate ? idToScrollAfterNavigate : !affixed && (renderer === "accordion" || renderer === "pager") ? this.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(this.state.activeIdx, idxOffsets, totalOffset) + "-header" : this.props.idSchema.$id + "-add";
				(0, _setImmediate3.default)(function () {
					(0, _utils.focusAndScroll)(_this2.state.formContext || _this2.props.formContext, idToFocusAfterNavigate || _this2.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(_this2.state.activeIdx, idxOffsets, totalOffset), idToScroll, focusOnNavigate);
				});
			}
		}
	}, {
		key: "shouldComponentUpdate",
		value: function shouldComponentUpdate(prevProps, prevState) {
			if (this.state.formContext && !prevState.formContext || this.state.formContext && this.state.formContext.topOffset !== prevState.formContext.topOffset) {
				return false;
			}
			return true;
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var state = {};
			var options = (0, _utils.getUiOptions)(props.uiSchema);
			if (options.hasOwnProperty("activeIdx")) state.activeIdx = options.activeIdx;else if ((props.formData || []).length === 1 && (this.props.formData || []).length === 0) {
				state.activeIdx = 0;
			}

			return state;
		}
	}, {
		key: "render",
		value: function render() {
			var _getUiOptions2 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    _getUiOptions2$render = _getUiOptions2.renderer,
			    renderer = _getUiOptions2$render === undefined ? "accordion" : _getUiOptions2$render,
			    tableActiveItemClassNames = _getUiOptions2.tableActiveItemClassNames;

			var ArrayFieldTemplate = undefined;
			switch (renderer) {
				case "accordion":
					ArrayFieldTemplate = AccordionArrayFieldTemplate;
					break;
				case "pager":
					ArrayFieldTemplate = PagerArrayFieldTemplate;
					break;
				case "uncontrolled":
					ArrayFieldTemplate = UncontrolledArrayFieldTemplate;
					break;
				case "table":
					ArrayFieldTemplate = TableArrayFieldTemplate;
					break;
				default:
					throw new Error("Unknown renderer '" + renderer + "' for SingleActiveArrayField");
			}

			var formContext = (0, _extends4.default)({}, this.state.formContext || this.props.formContext, { this: this, prevActiveIdx: this.prevActiveIdx, activeIdx: this.state.activeIdx });

			var ArrayField = this.props.registry.fields.ArrayField;

			var _getUiOptions3 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    _getUiOptions3$button = _getUiOptions3.buttons,
			    buttons = _getUiOptions3$button === undefined ? [] : _getUiOptions3$button,
			    buttonDefinitions = _getUiOptions3.buttonDefinitions;

			var uiSchema = (0, _extends4.default)({}, this.props.uiSchema, {
				"ui:field": undefined,
				classNames: undefined,
				"ui:options": (0, _extends4.default)({}, (0, _utils.getUiOptions)(this.props.uiSchema), {
					buttons: buttons,
					buttonDefinitions: buttonDefinitions ? (0, _deepmerge2.default)(this.buttonDefinitions, buttonDefinitions) : this.buttonDefinitions
				})
			});

			if (renderer === "table" && tableActiveItemClassNames && !this.state.normalRendering) {
				uiSchema = (0, _extends4.default)({}, uiSchema, {
					items: (0, _extends4.default)({}, uiSchema.items, {
						classNames: tableActiveItemClassNames
					})
				});
			}

			return _react2.default.createElement(ArrayField, (0, _extends4.default)({}, this.props, {
				formContext: formContext,
				registry: (0, _extends4.default)({}, this.props.registry, {
					ArrayFieldTemplate: ArrayFieldTemplate,
					formContext: formContext
				}),
				uiSchema: uiSchema
			}));
		}
	}]);
	return SingleActiveArrayField;
}(_react.Component)) || _class;

SingleActiveArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			renderer: _propTypes2.default.oneOf(["accordion", "pager", "uncontrolled", "table"]),
			activeIdx: _propTypes2.default.number
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};

var _initialiseProps = function _initialiseProps() {
	var _this3 = this;

	this.updatePopups = function (props) {
		var _getUiOptions4 = (0, _utils.getUiOptions)(_this3.props.uiSchema),
		    popupFields = _getUiOptions4.popupFields;

		var popups = _this3.state.popups;

		var count = 0;
		if (popupFields) props.formData.forEach(function (item, idx) {
			_this3.getPopupDataPromise(idx, props, item).then(function (popupData) {
				count++;
				popups = (0, _extends4.default)({}, popups, (0, _defineProperty3.default)({}, idx, popupData));
				if (_this3.mounted && count === props.formData.length) _this3.setState({ popups: popups });
			}).catch(function () {
				count++;
			});
		});
	};

	this.getTitle = function (idx) {
		var options = (0, _utils.getUiOptions)(_this3.props.uiSchema);
		var titleFormat = options.titleFormat;


		var title = "ui:title" in _this3.props.uiSchema ? _this3.props.uiSchema["ui:title"] : _this3.props.schema.title;
		if (!titleFormat) return title;

		var formatters = {
			idx: idx + 1,
			title: _this3.props.schema.title
		};

		return (0, _keys2.default)(formatters).reduce(function (_title, key) {
			[key, (0, _utils.capitalizeFirstLetter)(key)].map(function (key) {
				return "%{" + key + "}";
			}).forEach(function (replacePattern) {
				while (_title.indexOf(replacePattern) !== -1) {
					var fn = replacePattern[2] === replacePattern[2].toLowerCase() ? _utils.decapitalizeFirstLetter : _utils.capitalizeFirstLetter;
					_title = _title.replace(replacePattern, fn("" + formatters[key]));
				}
			});
			return _title;
		}, titleFormat);
	};

	this.onHeaderAffixChange = function (elem, value) {
		if (value) {
			_this3.scrollHeightFixed = elem.scrollHeight;
			_this3.setState({ formContext: (0, _extends4.default)({}, _this3.props.formContext, { topOffset: _this3.props.formContext.topOffset + elem.scrollHeight }) }, function () {
				(0, _utils.syncScroll)(_this3.state.formContext, !!"force");
			});
		} else {
			_this3.scrollHeightFixed = 0;
			_this3.setState({ formContext: (0, _extends4.default)({}, _this3.props.formContext, { topOffset: _this3.props.formContext.topOffset }) });
		}
	};

	this.updateRenderingMode = function (normalRendering, callback) {
		_this3.setState({ normalRendering: normalRendering }, function () {
			return callback && callback(normalRendering);
		});
	};

	this.getPopupDataPromise = function (idx, props, itemFormData) {
		var _getUiOptions5 = (0, _utils.getUiOptions)(props.uiSchema),
		    popupFields = _getUiOptions5.popupFields;

		if (!_this3.props.formData) return _promise2.default.resolve({});

		return _promise2.default.all(popupFields.map(function (field) {
			var fieldName = field.field;
			var fieldData = itemFormData ? itemFormData[fieldName] : undefined;
			var fieldSchema = props.schema.items.properties;

			if (field.mapper && fieldData) {
				return popupMappers[field.mapper](fieldSchema, fieldData, field);
			} else if (fieldData) {
				return new _promise2.default(function (resolve) {
					return resolve((0, _defineProperty3.default)({}, fieldSchema && fieldSchema[fieldName] ? fieldSchema[fieldName].title : fieldName, fieldData));
				});
			}
		})).then(function (fields) {
			var popupData = fields.reduce(function (popup, item) {
				if (item) (0, _keys2.default)(item).forEach(function (label) {
					popup[label] = item[label];
				});
				return popup;
			}, {});
			return _promise2.default.resolve(popupData);
		});
	};

	this.onActiveChange = function (idx, prop, callback) {
		if (idx !== undefined) {
			idx = parseInt(idx);
		}

		if (_this3.state.activeIdx === idx) {
			idx = undefined;
		}

		var _getUiOptions6 = (0, _utils.getUiOptions)(_this3.props.uiSchema),
		    onActiveChange = _getUiOptions6.onActiveChange;

		onActiveChange ? onActiveChange(idx, prop, callback) : _this3.setState({ activeIdx: idx }, callback);
	};

	this.onDelete = function (idx, item) {
		return function (e) {
			var newLength = _this3.props.formData.length - 1;
			if (!newLength) {
				_this3.onActiveChange(undefined);
			} else if (_this3.state.activeIdx > newLength - 1) {
				_this3.onActiveChange(newLength - 1);
			}
			(0, _ArrayFieldTemplate2.onDelete)(item, _this3.props)(e);
		};
	};

	this.buttonDefinitions = {
		add: {
			callback: function callback() {
				return _this3.onActiveChange((_this3.props.formData || []).length);
			}
		},
		addPredefined: {
			callback: function callback() {
				return _this3.onActiveChange((_this3.props.formData || []).length);
			}
		},
		copy: {
			fn: function fn() {
				return function () {
					var _props$formData = _this3.props.formData,
					    formData = _props$formData === undefined ? [] : _props$formData;

					var idx = _this3.state.activeIdx !== undefined ? _this3.state.activeIdx : formData.length - 1;
					(0, _ArrayFieldTemplate2.beforeAdd)(_this3.props);
					_this3.props.onChange([].concat((0, _toConsumableArray3.default)(formData.slice(0, idx + 1)), [(0, _ArrayField.copyItemFunction)(_this3, formData[idx]).apply(undefined, arguments)], (0, _toConsumableArray3.default)(formData.slice(idx + 1))));
				};
			},
			callback: function callback() {
				var idx = _this3.state.activeIdx !== undefined ? _this3.state.activeIdx : (_this3.props.formData || []).length - 1;
				_this3.onActiveChange(idx + 1);
			},
			rules: {
				minLength: 1
			}
		}
	};
};

exports.default = SingleActiveArrayField;

var Popup = function (_Component2) {
	(0, _inherits3.default)(Popup, _Component2);

	function Popup() {
		(0, _classCallCheck3.default)(this, Popup);
		return (0, _possibleConstructorReturn3.default)(this, (Popup.__proto__ || (0, _getPrototypeOf2.default)(Popup)).apply(this, arguments));
	}

	(0, _createClass3.default)(Popup, [{
		key: "render",
		value: function render() {
			var data = this.props.data;

			return data && (0, _keys2.default)(data).length ? _react2.default.createElement(
				"ul",
				{ className: "map-data-tooltip" },
				data ? (0, _keys2.default)(data).map(function (fieldName) {
					var item = data[fieldName];
					return _react2.default.createElement(
						"li",
						{ key: fieldName },
						_react2.default.createElement(
							"strong",
							null,
							fieldName,
							":"
						),
						" ",
						Array.isArray(item) ? item.filter(_utils.hasData).join(", ") : item
					);
				}) : null
			) : null;
		}
	}]);
	return Popup;
}(_react.Component);

function handlesButtonsAndFocus(ComposedComponent) {
	var _class2, _temp2, _class3;

	return _temp2 = _class2 = (0, _ArrayFieldTemplate2.handlesArrayKeys)(_class3 = function (_ComposedComponent) {
		(0, _inherits3.default)(SingleActiveArrayTemplateField, _ComposedComponent);

		function SingleActiveArrayTemplateField() {
			var _ref;

			var _temp, _this5, _ret;

			(0, _classCallCheck3.default)(this, SingleActiveArrayTemplateField);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this5 = (0, _possibleConstructorReturn3.default)(this, (_ref = SingleActiveArrayTemplateField.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField)).call.apply(_ref, [this].concat(args))), _this5), _this5.getFocusHandlers = function (props) {
				var that = props.formContext.this;
				return props.items.map(function (_, i) {
					var idx = (0, _utils.getIdxWithOffset)(i, (0, _utils.getUiOptions)(that.props.uiSchema).idxOffsets);
					return [that.props.idSchema.$id + "_" + idx, function () {
						if (that.state.activeIdx !== i) return new _promise2.default(function (resolve) {
							that.onActiveChange(i, undefined, function () {
								return resolve();
							});
						});
					}];
				});
			}, _temp), (0, _possibleConstructorReturn3.default)(_this5, _ret);
		}

		(0, _createClass3.default)(SingleActiveArrayTemplateField, [{
			key: "getKeyHandlers",
			value: function getKeyHandlers(props) {
				var _this6 = this;

				var _getUiOptions7 = (0, _utils.getUiOptions)(props.uiSchema),
				    _getUiOptions7$render = _getUiOptions7.renderer,
				    renderer = _getUiOptions7$render === undefined ? "accordion" : _getUiOptions7$render;

				var that = props.formContext.this;
				return [_ArrayFieldTemplate2.arrayKeyFunctions, {
					getProps: function getProps() {
						return _this6.props;
					},
					insertCallforward: function insertCallforward(callback) {
						return that.onActiveChange((that.props.formData || []).length, undefined, callback);
					},
					getCurrentIdx: function getCurrentIdx() {
						return that.state.activeIdx;
					},
					focusByIdx: function focusByIdx(idx, prop, callback) {
						return idx === that.state.activeIdx ? callback() : that.onActiveChange(idx, prop, callback);
					},
					getIdToScrollAfterNavigate: renderer === "accordion" || renderer === "pager" ? function () {
						return props.idSchema.$id + "_" + that.state.activeIdx + "-header";
					} : undefined
				}];
			}
		}, {
			key: "componentDidMount",
			value: function componentDidMount() {
				this.addFocusHandlers();
				if ((0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentDidMount", this)) (0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentDidMount", this).call(this);
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate() {
				var _get2;

				this.removeFocusHandlers();
				this.addFocusHandlers();

				for (var _len2 = arguments.length, params = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
					params[_key2] = arguments[_key2];
				}

				if ((0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentDidUpdate", this)) (_get2 = (0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentDidUpdate", this)).call.apply(_get2, [this].concat(params));
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				this.removeFocusHandlers();
				if ((0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentWillUnmount", this)) (0, _get4.default)(SingleActiveArrayTemplateField.prototype.__proto__ || (0, _getPrototypeOf2.default)(SingleActiveArrayTemplateField.prototype), "componentWillUnmount", this).call(this);
			}
		}, {
			key: "addFocusHandlers",
			value: function addFocusHandlers() {
				var _this7 = this;

				this.focusHandlers = this.getFocusHandlers(this.props);
				this.focusHandlers.forEach(function (handler) {
					var _ref2;

					(_ref2 = new _Context2.default(_this7.props.formContext.contextId)).addFocusHandler.apply(_ref2, (0, _toConsumableArray3.default)(handler));
				});
			}
		}, {
			key: "removeFocusHandlers",
			value: function removeFocusHandlers() {
				var _this8 = this;

				this.focusHandlers.forEach(function (handler) {
					var _ref3;

					(_ref3 = new _Context2.default(_this8.props.formContext.contextId)).removeFocusHandler.apply(_ref3, (0, _toConsumableArray3.default)(handler));
				});
			}
		}, {
			key: "getChildKeyHandlers",
			value: function getChildKeyHandlers(props) {
				var _this9 = this;

				var that = props.formContext.this;
				var handlers = [];
				if (that.state.activeIdx !== undefined) {
					var id = props.idSchema.$id + "_" + that.state.activeIdx;
					handlers.push([id, _ArrayFieldTemplate2.arrayItemKeyFunctions, { id: id, getProps: function getProps() {
							return _this9.props;
						}, getDeleteButton: function getDeleteButton() {
							return that.deleteButtonRefs[that.state.activeIdx];
						} }]);
				}
				return handlers;
			}
		}]);
		return SingleActiveArrayTemplateField;
	}(ComposedComponent)) || _class3, _class2.displayName = (0, _utils.getReactComponentName)(ComposedComponent), _temp2;
}

// Swallow unknown prop warnings.
var ButtonsWrapper = function ButtonsWrapper(_ref4) {
	var props = _ref4.props;

	var buttons = (0, _utils.getUiOptions)(props.uiSchema).buttons;
	return _react2.default.createElement(
		"div",
		null,
		(0, _ArrayFieldTemplate2.getButtonElems)(buttons, props)
	);
};

var AccordionButtonsWrapper = function AccordionButtonsWrapper(_ref5) {
	var props = _ref5.props,
	    position = _ref5.position;

	var buttons = (0, _ArrayFieldTemplate2.getButtonsForPosition)(props, (0, _ArrayFieldTemplate2.getButtons)((0, _utils.getUiOptions)(props.uiSchema).buttons, props), position);
	if (!buttons) return null;

	var cols = (0, _keys2.default)((0, _utils.getBootstrapCols)()).reduce(function (cols, colType) {
		cols[colType] = colType === "xs" || buttons.length > 3 ? 12 : 12 / buttons.length;
		return cols;
	}, {});

	return _react2.default.createElement(
		_reactBootstrap.Row,
		{ className: "laji-form-accordion-buttons" },
		buttons.map(function (button, idx) {
			return _react2.default.createElement(
				_reactBootstrap.Col,
				(0, _extends4.default)({}, cols, { key: idx }),
				button
			);
		})
	);
};

var AccordionArrayFieldTemplate = handlesButtonsAndFocus(_class4 = function (_Component3) {
	(0, _inherits3.default)(AccordionArrayFieldTemplate, _Component3);

	function AccordionArrayFieldTemplate() {
		var _ref6;

		var _temp3, _this10, _ret2;

		(0, _classCallCheck3.default)(this, AccordionArrayFieldTemplate);

		for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
			args[_key3] = arguments[_key3];
		}

		return _ret2 = (_temp3 = (_this10 = (0, _possibleConstructorReturn3.default)(this, (_ref6 = AccordionArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(AccordionArrayFieldTemplate)).call.apply(_ref6, [this].concat(args))), _this10), _this10.setContainerRef = function (elem) {
			_this10.containerRef = elem;
		}, _this10.getContainerRef = function () {
			return (0, _reactDom.findDOMNode)(_this10.containerRef);
		}, _this10.setHeaderRef = function (elem) {
			_this10.headerRef = elem;
		}, _this10.setDeleteButtonRef = function (idx) {
			return function (elem) {
				_this10.props.formContext.this.deleteButtonRefs[idx] = elem;
			};
		}, _temp3), (0, _possibleConstructorReturn3.default)(_this10, _ret2);
	}

	(0, _createClass3.default)(AccordionArrayFieldTemplate, [{
		key: "render",
		value: function render() {
			var _this11 = this;

			var that = this.props.formContext.this;
			var arrayFieldTemplateProps = this.props;

			var activeIdx = that.state.activeIdx;

			var onSelect = function onSelect(key) {
				return that.onActiveChange(key);
			};

			var _getUiOptions8 = (0, _utils.getUiOptions)(arrayFieldTemplateProps.uiSchema),
			    confirmDelete = _getUiOptions8.confirmDelete,
			    closeButton = _getUiOptions8.closeButton,
			    affixed = _getUiOptions8.affixed;

			var translations = this.props.formContext.translations;
			var disabled = arrayFieldTemplateProps.disabled,
			    readonly = arrayFieldTemplateProps.readonly;


			var getHeader = function getHeader(item, idx) {
				var header = _react2.default.createElement(
					AccordionHeader,
					{
						ref: _this11.setHeaderRef,
						that: that,
						idx: idx,
						wrapperClassName: "panel-title",
						className: "laji-form-panel-header laji-form-clickable-panel-header laji-form-accordion-header" },
					item.hasRemove && _react2.default.createElement(_components.DeleteButton, { id: that.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(idx, (0, _utils.getUiOptions)(that.props.uiSchema).idxOffsets),
						disabled: disabled || readonly,
						ref: _this11.setDeleteButtonRef(idx),
						className: "pull-right",
						confirm: confirmDelete,
						translations: translations,
						onClick: that.onDelete(idx, item) })
				);

				if (affixed && activeIdx === idx) {
					var offset = _this11.props.formContext.topOffset - (that.scrollHeightFixed || 0);
					header = _react2.default.createElement(
						_components.Affix,
						{ getContainer: _this11.getContainerRef, topOffset: offset, onAffixChange: _this11.onHeaderAffixChange },
						header
					);
				}

				return header;
			};

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-single-active-array no-transition" },
				_react2.default.createElement(AccordionButtonsWrapper, { props: arrayFieldTemplateProps, position: "top" }),
				_react2.default.createElement(
					_reactBootstrap.Accordion,
					{ onSelect: onSelect, activeKey: activeIdx === undefined ? -1 : activeIdx, id: that.props.idSchema.$id + "-accordion" },
					arrayFieldTemplateProps.items.map(function (item, idx) {
						return _react2.default.createElement(
							_reactBootstrap.Panel,
							{ key: idx,
								ref: idx === activeIdx ? _this11.setContainerRef : undefined,
								id: _this11.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(idx, (0, _utils.getUiOptions)(that.props.uiSchema).idxOffsets) + "-panel",
								className: "laji-form-panel laji-form-clickable-panel",
								eventKey: idx,
								bsStyle: (0, _utils.filteredErrors)(that.props.errorSchema)[idx] ? "danger" : "default" },
							_react2.default.createElement(
								_PanelHeading2.default,
								null,
								getHeader(item, idx)
							),
							idx === activeIdx ? _react2.default.createElement(
								_PanelBody2.default,
								null,
								item.children,
								closeButton ? _react2.default.createElement(
									_components.Button,
									{ onClick: onSelect, bsSize: "small", className: "pull-right" },
									translations.Close
								) : null
							) : null
						);
					}),
					_react2.default.createElement(AccordionButtonsWrapper, { props: arrayFieldTemplateProps, position: "bottom" })
				)
			);
		}
	}]);
	return AccordionArrayFieldTemplate;
}(_react.Component)) || _class4;

var PagerArrayFieldTemplate = handlesButtonsAndFocus(_class5 = function (_Component4) {
	(0, _inherits3.default)(PagerArrayFieldTemplate, _Component4);

	function PagerArrayFieldTemplate() {
		var _ref7;

		var _temp4, _this12, _ret3;

		(0, _classCallCheck3.default)(this, PagerArrayFieldTemplate);

		for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
			args[_key4] = arguments[_key4];
		}

		return _ret3 = (_temp4 = (_this12 = (0, _possibleConstructorReturn3.default)(this, (_ref7 = PagerArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(PagerArrayFieldTemplate)).call.apply(_ref7, [this].concat(args))), _this12), _this12.setContainerRef = function (elem) {
			_this12.containerRef = elem;
		}, _this12.getContainerRef = function () {
			return _this12.containerRef;
		}, _this12.setHeaderRef = function (elem) {
			_this12.headerRef = elem;
		}, _this12.onHeaderAffixChange = function (value) {
			var elem = _this12.headerRef;
			var that = _this12.props.formContext.this;
			that.onHeaderAffixChange(elem, value);
		}, _this12.navigatePrev = function () {
			return _this12.props.formContext.this.onActiveChange(_this12.props.formContext.this.state.activeIdx - 1);
		}, _this12.navigateNext = function () {
			return _this12.props.formContext.this.onActiveChange(_this12.props.formContext.this.state.activeIdx + 1);
		}, _this12.setDeleteButtonRef = function (idx) {
			return function (elem) {
				_this12.props.formContext.this.deleteButtonRefs[idx] = elem;
			};
		}, _temp4), (0, _possibleConstructorReturn3.default)(_this12, _ret3);
	}

	(0, _createClass3.default)(PagerArrayFieldTemplate, [{
		key: "render",
		value: function render() {
			var that = this.props.formContext.this;
			var arrayTemplateFieldProps = this.props;
			var translations = that.props.formContext.translations;

			var _getUiOptions9 = (0, _utils.getUiOptions)(arrayTemplateFieldProps.uiSchema),
			    buttons = _getUiOptions9.buttons,
			    affixed = _getUiOptions9.affixed,
			    headerClassName = _getUiOptions9.headerClassName,
			    confirmDelete = _getUiOptions9.confirmDelete;

			var activeIdx = that.state.activeIdx;

			var header = _react2.default.createElement(
				"div",
				{ className: "laji-form-panel-header laji-form-accordion-header" + (headerClassName ? " " + headerClassName : ""), ref: this.setHeaderRef },
				_react2.default.createElement(
					_reactBootstrap.Pager,
					null,
					_react2.default.createElement(
						_reactBootstrap.Pager.Item,
						{ previous: true,
							href: "#",
							disabled: activeIdx <= 0 || activeIdx === undefined,
							onClick: this.navigatePrev },
						"\u2190 ",
						translations.Previous
					),
					activeIdx !== undefined ? _react2.default.createElement(AccordionHeader, {
						that: that,
						idx: activeIdx,
						className: "panel-title",
						canHaveUndefinedIdx: false
					}) : null,
					_react2.default.createElement(
						_reactBootstrap.Pager.Item,
						{ next: true,
							href: "#",
							disabled: activeIdx >= (that.props.formData || []).length - 1 || activeIdx === undefined,
							onClick: this.navigateNext },
						translations.Next,
						"  \u2192"
					)
				)
			);

			if (affixed) {
				var offset = this.props.formContext.topOffset - (that.scrollHeightFixed || 0);
				header = _react2.default.createElement(
					_components.Affix,
					{ getContainer: this.getContainerRef, topOffset: offset, onAffixChange: this.onHeaderAffixChange },
					header
				);
			}

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-single-active-array", ref: this.setContainerRef },
				_react2.default.createElement(
					"div",
					{ className: "laji-form-field-template-item" },
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-schema" },
						_react2.default.createElement(
							_reactBootstrap.Panel,
							{ className: "laji-form-panel" },
							_react2.default.createElement(
								_PanelHeading2.default,
								null,
								header
							),
							_react2.default.createElement(
								_PanelBody2.default,
								null,
								_react2.default.createElement(
									"div",
									{ key: activeIdx },
									activeIdx !== undefined && arrayTemplateFieldProps.items && arrayTemplateFieldProps.items[activeIdx] ? arrayTemplateFieldProps.items[activeIdx].children : null
								)
							)
						),
						(0, _ArrayFieldTemplate2.getButtonElems)(buttons, arrayTemplateFieldProps)
					),
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-buttons" },
						activeIdx !== undefined && arrayTemplateFieldProps.items[activeIdx].hasRemove ? _react2.default.createElement(_components.DeleteButton, {
							id: that.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(activeIdx, (0, _utils.getUiOptions)(that.props.uiSchema).idxOffsets),
							ref: this.setDeleteButtonRef(activeIdx),
							className: "pull-right",
							confirm: confirmDelete,
							translations: translations,
							onClick: that.onDelete(activeIdx, arrayTemplateFieldProps.items[activeIdx])
						}) : null
					)
				)
			);
		}
	}]);
	return PagerArrayFieldTemplate;
}(_react.Component)) || _class5;

var UncontrolledArrayFieldTemplate = handlesButtonsAndFocus(_class6 = function (_Component5) {
	(0, _inherits3.default)(UncontrolledArrayFieldTemplate, _Component5);

	function UncontrolledArrayFieldTemplate() {
		(0, _classCallCheck3.default)(this, UncontrolledArrayFieldTemplate);
		return (0, _possibleConstructorReturn3.default)(this, (UncontrolledArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(UncontrolledArrayFieldTemplate)).apply(this, arguments));
	}

	(0, _createClass3.default)(UncontrolledArrayFieldTemplate, [{
		key: "render",
		value: function render() {
			var that = this.props.formContext.this;
			var arrayTemplateFieldProps = this.props;
			var activeIdx = that.state.activeIdx;
			var TitleField = arrayTemplateFieldProps.TitleField,
			    DescriptionField = arrayTemplateFieldProps.DescriptionField;
			var Label = this.props.formContext.Label;

			var Title = (0, _utils.getUiOptions)(that.props.uiSchema).renderTitleAsLabel ? Label : TitleField;

			var _getUiOptions10 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    titleFormatters = _getUiOptions10.titleFormatters;

			var title = that.getTitle(activeIdx);

			return activeIdx !== undefined && arrayTemplateFieldProps.items && arrayTemplateFieldProps.items[activeIdx] ? _react2.default.createElement(
				"div",
				{ key: activeIdx },
				_react2.default.createElement(Title, { title: title, label: title, className: (0, _utils.getUiOptions)(arrayTemplateFieldProps.uiSchema).titleClassName, titleFormatters: titleFormatters, formData: that.props.formData, help: arrayTemplateFieldProps.uiSchema["ui:help"] }),
				_react2.default.createElement(DescriptionField, { description: this.props.uiSchema["ui:description"] }),
				arrayTemplateFieldProps.items[activeIdx].children
			) : null;
		}
	}]);
	return UncontrolledArrayFieldTemplate;
}(_react.Component)) || _class6;

var TableArrayFieldTemplate = handlesButtonsAndFocus(_class7 = function (_Component6) {
	(0, _inherits3.default)(TableArrayFieldTemplate, _Component6);

	function TableArrayFieldTemplate(props) {
		(0, _classCallCheck3.default)(this, TableArrayFieldTemplate);

		var _this14 = (0, _possibleConstructorReturn3.default)(this, (TableArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(TableArrayFieldTemplate)).call(this, props));

		_this14.onResize = function (data, callback) {
			_this14.updateLayout(null, callback);
		};

		_this14.updateRenderingMode = function (callback) {
			var _callback = function _callback() {
				var updateLayout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

				if (updateLayout && _this14._lastWidth && (0, _utils.pixelsToBsSize)(_this14._lastWidth) !== (0, _utils.pixelsToBsSize)(window.innerWidth)) {
					_this14.updateLayout(null, callback);
				}
			};
			var that = _this14.props.formContext.this;

			var _getUiOptions11 = (0, _utils.getUiOptions)(_this14.props.uiSchema),
			    normalRenderingTreshold = _getUiOptions11.normalRenderingTreshold;

			var initialized = false;
			if ((0, _keys2.default)(_this14.state).length === 0) {
				initialized = true;
				var state = _this14.getStyles();
				if (state) {
					_this14.setState(state, _callback);
				}
			}

			if (!normalRenderingTreshold) {
				if (!initialized) {
					_callback();
				}
				return;
			}

			var treshold = (0, _utils.bsSizeToPixels)(normalRenderingTreshold);

			requestAnimationFrame(function () {
				var normalRendering = undefined;
				if (!_this14.state.normalRendering && window.innerWidth <= treshold) {
					normalRendering = true;
				} else if (_this14.state.normalRendering && window.innerWidth > treshold) {
					normalRendering = false;
				}

				if (normalRendering !== undefined) {
					that.updateRenderingMode(normalRendering, function () {
						return _this14.setState({ normalRendering: normalRendering }, function () {
							return _this14.updateLayout(null, function () {
								return _callback(false);
							});
						});
					});
				} else if (!_this14.state.normalRendering) {
					_this14.updateLayout(null, _callback);
				}
			});
		};

		_this14.setActiveRef = function (elem) {
			_this14.activeElem = elem;
		};

		_this14.setTHeadRef = function (elem) {
			_this14.tHeadRef = elem;
		};

		_this14.updateLayout = function () {
			var idx = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
			var callback = arguments[1];

			requestAnimationFrame(function () {
				_this14._lastWidth = window.innerWidth;
				var scrollBack = (0, _utils.shouldSyncScroll)(_this14.props.formContext);
				var state = _this14.getStyles();
				if (!state) {
					return;
				}
				if (idx !== null) state.activeIdx = idx;
				var _callback = function _callback() {
					if (scrollBack) {
						(0, _utils.syncScroll)(_this14.props.formContext, !!"force");
					}
					if (callback) callback();
				};
				_this14.setState(state, _callback);
			});
		};

		_this14.getStyles = function () {
			var that = _this14.props.formContext.this;
			var activeIdx = that.state.activeIdx;

			var rowElem = _this14.itemElems[activeIdx];
			if (!rowElem || !_this14.activeElem) return;
			return {
				activeStyle: activeIdx !== undefined ? {
					position: "absolute",
					top: rowElem.offsetTop,
					width: "100%"
				} : {},
				activeTrStyle: activeIdx !== undefined ? {
					height: _this14.activeElem.offsetHeight
				} : {}
			};
		};

		_this14.state = {};
		_this14.itemElems = [];
		return _this14;
	}

	(0, _createClass3.default)(TableArrayFieldTemplate, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this15 = this;

			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "resize", this.onResize);
			this._updateRenderingMode = function () {
				return _this15.updateRenderingMode();
			};
			window.addEventListener("resize", this._updateRenderingMode);
			this.updateRenderingMode();
			this._prevCheckedLength = this.props.items.length;
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			window.removeEventListener("resize", this._updateRenderingMode);
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "resize", this.onResize);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			var that = this.props.formContext.this;
			var updated = false;
			if (this.props.items.length !== prevProps.items.length || this.state.activeIdx !== prevState.activeIdx) {
				if (!this.state.normalRendering && this.props.items.length === 1 && this.state.activeIdx === 0) {
					this.updateRenderingMode();
					updated = true;
				} else if (this.state.normalRendering && this.props.items.length > 1 || this.state.activeIdx !== 0) {
					this.updateRenderingMode();
					updated = true;
				}
			}

			if (!updated) {
				var activeChanged = this.state.activeIdx !== that.state.activeIdx;
				var itemsLengthChanged = this._prevCheckedLength !== this.props.items.length;

				var tHeadHeight = void 0,
				    tHeadHeightChanged = void 0;
				if (this.tHeadRef) {
					tHeadHeight = this.tHeadRef.scrollHeight;
					tHeadHeightChanged = this.prevTHeadHeight && tHeadHeight !== this.prevTHeadHeight;
				}

				if (activeChanged || itemsLengthChanged || tHeadHeightChanged) {
					this.updateLayout(this.props.formContext.this.state.activeIdx);
				}
				if (tHeadHeight) this.prevTHeadHeight = tHeadHeight;
				this._prevCheckedLength = this.props.items.length;
			}
		}

		// Sets state.normalRendering on if screen is too small for table layout.

	}, {
		key: "render",
		value: function render() {
			var _this16 = this;

			if (this.state.normalRendering) {
				return _react2.default.createElement(_ArrayFieldTemplate3.default, this.props);
			}

			var _props = this.props,
			    schema = _props.schema,
			    _props$uiSchema = _props.uiSchema,
			    uiSchema = _props$uiSchema === undefined ? {} : _props$uiSchema,
			    _props$formData2 = _props.formData,
			    formData = _props$formData2 === undefined ? [] : _props$formData2,
			    items = _props.items,
			    TitleField = _props.TitleField,
			    DescriptionField = _props.DescriptionField,
			    disabled = _props.disabled,
			    readonly = _props.readonly;

			var _getUiOptions12 = (0, _utils.getUiOptions)(uiSchema),
			    renderTitleAsLabel = _getUiOptions12.renderTitleAsLabel,
			    _getUiOptions12$forma = _getUiOptions12.formatters,
			    formatters = _getUiOptions12$forma === undefined ? {} : _getUiOptions12$forma,
			    _getUiOptions12$shown = _getUiOptions12.shownColumns,
			    shownColumns = _getUiOptions12$shown === undefined ? [] : _getUiOptions12$shown;

			var Label = this.props.formContext.Label;

			var Title = renderTitleAsLabel ? Label : TitleField;
			var foundProps = {};
			var shownColumnsDict = (0, _utils.dictionarify)(shownColumns);

			var _ref8 = new _Context2.default("IMAGE_ARRAY_FIELD"),
			    _ref8$tmpImgs = _ref8.tmpImgs,
			    tmpImgs = _ref8$tmpImgs === undefined ? {} : _ref8$tmpImgs;

			var cols = (0, _keys2.default)(schema.items.properties).reduce(function (_cols, prop) {
				if (formData.some(function (item) {
					var found = shownColumnsDict[prop] || foundProps[prop] || item.hasOwnProperty(prop) && !(0, _utils.isEmptyString)(item[prop]) && (!Array.isArray(item[prop]) || Array.isArray(item[prop]) && !item[prop].every(_utils.isEmptyString)) && !(0, _utils.isHidden)(uiSchema.items || {}, prop) && !(0, _utils.isHidden)((0, _utils.getNestedTailUiSchema)(uiSchema.items || {}), prop) || uiSchema.items && uiSchema.items[prop] && uiSchema.items[prop]["ui:field"] === "ImageArrayField" && (0, _utils.getUUID)(item) && tmpImgs[(0, _utils.getUUID)(item)];
					if (found) foundProps[prop] = true;
					return found;
				})) {
					_cols.push(prop);
				}
				return _cols;
			}, []);

			var _ref9 = uiSchema.items || {},
			    order = _ref9["ui:order"];

			if (order) cols = (0, _utils2.orderProperties)(cols, order.filter(function (field) {
				return field === "*" || foundProps[field];
			}));

			var that = this.props.formContext.this;
			var errorSchema = that.props.errorSchema;

			var activeIdx = that.state.activeIdx;

			var changeActive = function changeActive(idx) {
				return function () {
					idx !== that.state.activeIdx && that.onActiveChange(idx, undefined, _this16.updateLayout);
				};
			};

			var _getUiOptions13 = (0, _utils.getUiOptions)(uiSchema),
			    confirmDelete = _getUiOptions13.confirmDelete,
			    titleClassName = _getUiOptions13.titleClassName,
			    titleFormatters = _getUiOptions13.titleFormatters;

			var getDeleteButtonFor = function getDeleteButtonFor(idx, item) {
				var getDeleteButtonRef = function getDeleteButtonRef(elem) {
					that.deleteButtonRefs[idx] = elem;
				};
				return _react2.default.createElement(_components.DeleteButton, { id: that.props.idSchema.$id + "_" + idx,
					disabled: disabled || readonly,
					ref: getDeleteButtonRef,
					key: idx,
					confirm: confirmDelete,
					translations: _this16.props.formContext.translations,
					onClick: that.onDelete(idx, item) });
			};

			var setItemRef = function setItemRef(idx) {
				return function (elem) {
					_this16.itemElems[idx] = elem;
				};
			};

			var title = that.getTitle(that.state.activeIdx);

			var onMouseEnter = function onMouseEnter(idx) {
				return that.props.idSchema.$id.match(/units$/) ? function () {
					return new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "startHighlight", { idx: idx });
				} : undefined;
			};
			var onMouseLeave = function onMouseLeave(idx) {
				return that.props.idSchema.$id.match(/units$/) ? function () {
					return new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "endHighlight", { idx: idx });
				} : undefined;
			};

			return _react2.default.createElement(
				"div",
				{ style: { position: "relative" }, className: "single-active-array-table-container" },
				_react2.default.createElement(Title, { title: title, label: title, className: titleClassName, titleFormatters: titleFormatters, formData: formData }),
				_react2.default.createElement(DescriptionField, { description: uiSchema["ui:description"] }),
				_react2.default.createElement(
					"div",
					{ className: "laji-form-field-template-item" },
					_react2.default.createElement(
						"div",
						{ className: "table-responsive laji-form-field-template-schema" },
						_react2.default.createElement(
							_reactBootstrap.Table,
							{ hover: true, bordered: true, condensed: true, className: "single-active-array-table" },
							items.length > 1 || that.state.activeIdx !== undefined && that.state.activeIdx !== 0 ? _react2.default.createElement(
								"thead",
								{ ref: this.setTHeadRef },
								_react2.default.createElement(
									"tr",
									{ className: "darker" },
									cols.map(function (col) {
										return _react2.default.createElement(
											"th",
											{ key: col },
											schema.items.properties[col].title
										);
									}),
									_react2.default.createElement("th", { key: "_delete", className: "single-active-array-table-delete" })
								)
							) : null,
							_react2.default.createElement(
								"tbody",
								null,
								formData.map(function (_, idx) {
									var item = items[idx];
									var className = "";
									if ((0, _utils.filteredErrors)(errorSchema)[idx]) className = className ? className + " bg-danger" : "bg-danger";
									return [_react2.default.createElement(
										"tr",
										{ key: idx,
											onClick: changeActive(idx),
											className: className,
											tabIndex: 0,
											id: idx !== activeIdx ? "_laji-form_" + _this16.props.formContext.contextId + "_" + _this16.props.idSchema.$id + "_" + idx : undefined,
											ref: setItemRef(idx),
											style: idx === activeIdx ? _this16.state.activeTrStyle : undefined,
											onMouseEnter: onMouseEnter(idx),
											onMouseLeave: onMouseLeave(idx)
										},
										[].concat((0, _toConsumableArray3.default)(cols.map(function (col) {
											return _react2.default.createElement(
												"td",
												{ key: col },
												(0, _utils.formatValue)((0, _extends4.default)({}, that.props, { schema: schema.items.properties[col], uiSchema: (uiSchema.items || {})[col], formData: formData[idx][col] }), formatters[col], { formData: formData[idx] })
											);
										})), [idx !== activeIdx && _react2.default.createElement(
											"td",
											{ key: "delete", className: "delete-button-container" },
											getDeleteButtonFor(idx, item)
										)])
									)];
								})
							)
						)
					),
					_react2.default.createElement("div", { className: "laji-form-field-template-buttons" })
				),
				activeIdx !== undefined && items[activeIdx] ? _react2.default.createElement(
					"div",
					{ key: (0, _utils.getUUID)(formData[activeIdx]) || activeIdx, ref: this.setActiveRef, className: "laji-form-field-template-item keep-vertical", style: this.state.activeStyle },
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-schema" },
						items[activeIdx].children
					),
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-buttons" },
						getDeleteButtonFor(activeIdx, items[activeIdx])
					)
				) : null,
				_react2.default.createElement(ButtonsWrapper, { props: this.props })
			);
		}
	}]);
	return TableArrayFieldTemplate;
}(_react.Component)) || _class7;

var headerFormatters = {
	units: {
		component: function component(props) {
			var _props$that$props = props.that.props,
			    translations = _props$that$props.formContext.translations,
			    formData = _props$that$props.formData,
			    idx = props.idx;

			var item = formData[idx];
			var unitsLength = item && item.units && item.units.hasOwnProperty("length") ? item.units.filter(function (unit) {
				return unit && unit.identifications && unit.identifications[0] && unit.identifications[0].taxon;
			}).length : 0;

			return _react2.default.createElement(
				"span",
				{ className: "text-muted" },
				" (" + unitsLength + " " + translations.unitsPartitive + ")"
			);
		},
		onClick: function onClick(that, idx) {
			if (that.state.activeIdx === idx) {
				headerFormatters.units.onMouseEnter(that, idx, !!"use the force");
			} else {
				headerFormatters.units.onMouseLeave(that);
			}
		},
		onMouseEnter: function onMouseEnter(that, idx, force) {
			var formData = that.props.formData;

			var item = formData[idx];

			that.hoveredIdx = idx;
			if (!force && idx === that.state.activeIdx) return;
			var map = new _Context2.default(that.props.formContext.contextId + "_MAP").map;
			var gatheringGeometries = item && item.geometry && item.geometry.geometries ? item.geometry.geometries : [];

			var unitGeometries = [].concat((0, _toConsumableArray3.default)(item && item.units ? item.units : [])).filter(function (unit) {
				return unit.unitGathering && (0, _utils.hasData)(unit.unitGathering.geometry);
			}).map(function (unit) {
				return unit.unitGathering.geometry;
			});

			var geometries = [].concat((0, _toConsumableArray3.default)(gatheringGeometries), (0, _toConsumableArray3.default)(unitGeometries)).map(function (geometry) {
				return { type: "Feature", properties: {}, geometry: geometry };
			});

			map.addData({
				featureCollection: { type: "featureCollection", features: geometries },
				getFeatureStyle: function getFeatureStyle() {
					return { opacity: 0.6, color: "#888888" };
				},
				temp: true
			});
		},
		onMouseLeave: function onMouseLeave(that) {
			var map = new _Context2.default(that.props.formContext.contextId + "_MAP").map;
			var lastData = map.data[map.data.length - 1];
			if (lastData && lastData.temp) {
				map.removeData(map.data.length - 1);
			}
			that.hoveredIdx = undefined;
		}
	},
	namedPlace: {
		component: (_temp5 = _class8 = function (_Component7) {
			(0, _inherits3.default)(NamedPlaceHeader, _Component7);

			function NamedPlaceHeader(props) {
				(0, _classCallCheck3.default)(this, NamedPlaceHeader);

				var _this17 = (0, _possibleConstructorReturn3.default)(this, (NamedPlaceHeader.__proto__ || (0, _getPrototypeOf2.default)(NamedPlaceHeader)).call(this, props));

				_initialiseProps2.call(_this17);

				_this17.state = {};
				return _this17;
			}

			(0, _createClass3.default)(NamedPlaceHeader, [{
				key: "componentDidMount",
				value: function componentDidMount() {
					this.mounted = true;
					this.fetch(this.props);
				}
			}, {
				key: "componentWillUnmount",
				value: function componentWillUnmount() {
					this.mounted = false;
				}
			}, {
				key: "componentWillReceiveProps",
				value: function componentWillReceiveProps(props) {
					this.fetch(props);
				}
			}, {
				key: "render",
				value: function render() {
					var name = this.state.name;

					var _ref10 = (this.props.that.props.formData || {})[this.props.idx] || {},
					    locality = _ref10.locality;

					return _react2.default.createElement(
						"span",
						{ className: "text-muted" },
						!(0, _utils.isEmptyString)(name) ? name : locality
					);
				}
			}]);
			return NamedPlaceHeader;
		}(_react.Component), _initialiseProps2 = function _initialiseProps2() {
			var _this18 = this;

			this.fetch = function (props) {
				var _ref11 = (props.that.props.formData || {})[props.idx] || {},
				    namedPlaceID = _ref11.namedPlaceID;

				if (namedPlaceID) props.that.props.formContext.apiClient.fetchCached("/named-places/" + namedPlaceID, undefined, { failSilently: true }).then(function (response) {
					if (_this18.mounted && name !== _this18.state.name) _this18.setState({
						namedPlaceID: namedPlaceID,
						name: response.name
					});
				});
			};
		}, _temp5)
	},
	lineTransect: {
		component: function component(props) {
			var start = void 0,
			    end = void 0;
			var lineTransectFeature = (0, _keys2.default)(props.that.props.formData[0].geometry).length ? { type: "Feature", properties: {}, geometry: { type: "MultiLineString", coordinates: props.that.props.formData.map(function (item) {
						return item.geometry.coordinates;
					}) } } : undefined;
			if (lineTransectFeature) {
				;

				var _getLineTransectStart = (0, _utils3.getLineTransectStartEndDistancesForIdx)(lineTransectFeature, props.idx, 10);

				var _getLineTransectStart2 = (0, _slicedToArray3.default)(_getLineTransectStart, 2);

				start = _getLineTransectStart2[0];
				end = _getLineTransectStart2[1];
			}return props.idx !== undefined && end ? _react2.default.createElement(
				"span",
				{ className: "text-muted" },
				start + "-" + end + "m"
			) : null;
		}
	},
	number: {
		component: function component(props) {
			return props.idx !== undefined ? props.idx + 1 + "." : null;
		}
	},
	lolife: {
		onMouseEnter: function onMouseEnter(that, idx) {
			new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "startHighlight", { id: (0, _utils.getUUID)(that.props.formData[idx]) });
		},
		onMouseLeave: function onMouseLeave(that, idx) {
			new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "endHighlight", { id: (0, _utils.getUUID)(that.props.formData[idx]) });
		}
	}
};

var AccordionHeader = function (_Component8) {
	(0, _inherits3.default)(AccordionHeader, _Component8);

	function AccordionHeader() {
		var _ref12;

		var _temp6, _this19, _ret4;

		(0, _classCallCheck3.default)(this, AccordionHeader);

		for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
			args[_key5] = arguments[_key5];
		}

		return _ret4 = (_temp6 = (_this19 = (0, _possibleConstructorReturn3.default)(this, (_ref12 = AccordionHeader.__proto__ || (0, _getPrototypeOf2.default)(AccordionHeader)).call.apply(_ref12, [this].concat(args))), _this19), _this19.onHeaderClick = function () {
			var _this19$props = _this19.props,
			    that = _this19$props.that,
			    idx = _this19$props.idx,
			    _this19$props$canHave = _this19$props.canHaveUndefinedIdx,
			    canHaveUndefinedIdx = _this19$props$canHave === undefined ? true : _this19$props$canHave;

			var formatters = _this19.getFormatters();
			if (!canHaveUndefinedIdx) {
				return;
			}
			that.onActiveChange(idx);
			formatters.forEach(function (formatter) {
				formatter.onClick && formatter.onClick(that, idx);
			});
		}, _this19.onMouseEnter = function () {
			_this19.getFormatters().forEach(function (formatter) {
				formatter.onMouseEnter && formatter.onMouseEnter(_this19.props.that, _this19.props.idx);
			});
		}, _this19.onMouseLeave = function () {
			_this19.getFormatters().forEach(function (formatter) {
				formatter.onMouseLeave && formatter.onMouseLeave(_this19.props.that, _this19.props.idx);
			});
		}, _this19.getFormatters = function () {
			var that = _this19.props.that;
			var _that$props = that.props,
			    uiSchema = _that$props.uiSchema,
			    schema = _that$props.schema;

			var formData = (that.props.formData || {})[_this19.props.idx];

			// try both headerFormatters & headerFormatter for backward compatibility. TODO: Remove in future.
			var options = (0, _utils.getUiOptions)(uiSchema);
			var _headerFormatters = options.headerFormatters || options.headerFormatter || [];
			if (_headerFormatters && !Array.isArray(_headerFormatters)) _headerFormatters = [_headerFormatters];

			if (options.headerFormatter) {
				console.warn("laji-form warning: 'headerFormatter' is deprecated. Use 'headerFormatters' instead.");
			}
			return _headerFormatters.map(function (formatter) {
				if (headerFormatters[formatter]) return headerFormatters[formatter];else return {
					component: function component() {
						var _ref13 = (0, _utils.isObject)(formatter) ? formatter : { field: formatter },
						    field = _ref13.field,
						    _default = _ref13.default;

						var formattedValue = (0, _utils.formatValue)((0, _extends4.default)({}, that.props, { schema: (0, _utils.parseSchemaFromFormDataPointer)(schema.items, field), uiSchema: (0, _utils.parseUiSchemaFromFormDataPointer)(uiSchema.items, field), formData: (0, _utils.parseJSONPointer)(formData, field, !!"safely") }));
						var value = (0, _utils.isEmptyString)(formattedValue) ? _default : formattedValue;
						return _react2.default.createElement(
							"span",
							{ className: "text-muted" },
							value
						);
					}
				};
			});
		}, _temp6), (0, _possibleConstructorReturn3.default)(_this19, _ret4);
	}

	(0, _createClass3.default)(AccordionHeader, [{
		key: "render",
		value: function render() {
			var _props2 = this.props,
			    that = _props2.that,
			    idx = _props2.idx;

			var title = that.getTitle(idx);
			var popupData = that.state.popups[idx];
			var uiSchema = that.props.uiSchema;

			var hasHelp = uiSchema && uiSchema["ui:help"];

			var headerText = _react2.default.createElement(
				"span",
				null,
				title,
				this.getFormatters().map(function (formatter, i) {
					var Formatter = formatter.component;

					return Formatter && _react2.default.createElement(
						"span",
						{ key: i },
						" ",
						_react2.default.createElement(Formatter, { that: that, idx: idx })
					) || null;
				}),
				hasHelp ? _react2.default.createElement(_components.Help, null) : null
			);

			var headerTextComponent = hasHelp ? _react2.default.createElement(
				_components.TooltipComponent,
				{ tooltip: uiSchema["ui:help"] },
				headerText
			) : headerText;

			var header = _react2.default.createElement(
				"div",
				{ className: this.props.className,
					role: "tab",
					id: that.props.idSchema.$id + "_" + (0, _utils.getIdxWithOffset)(idx, (0, _utils.getUiOptions)(that.props.uiSchema).idxOffsets) + "-header",
					onClick: this.onHeaderClick,
					onMouseEnter: this.onMouseEnter,
					onMouseLeave: this.onMouseLeave },
				_react2.default.createElement(
					"div",
					{ className: this.props.wrapperClassName },
					headerTextComponent,
					this.props.children
				)
			);

			return (0, _utils.hasData)(popupData) ? _react2.default.createElement(
				_reactBootstrap.OverlayTrigger,
				{ placement: "left",
					overlay: _react2.default.createElement(
						_reactBootstrap.Tooltip,
						{ id: "nav-tooltip-" + idx },
						_react2.default.createElement(Popup, { data: popupData })
					) },
				header
			) : header;
		}
	}]);
	return AccordionHeader;
}(_react.Component);