"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SchemaField = require("@rjsf/core/dist/cjs/components/fields/SchemaField");

var _SchemaField2 = _interopRequireDefault(_SchemaField);

var _utils = require("../../utils");

var _reactBootstrap = require("react-bootstrap");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _NestField = require("./NestField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SplitField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(SplitField, _Component);

	function SplitField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, SplitField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = SplitField.__proto__ || (0, _getPrototypeOf2.default)(SplitField)).call.apply(_ref, [this].concat(args))), _this), _this.renderSplitField = function (_ref2) {
			var fields = _ref2.fields;

			return _react2.default.createElement(_SchemaField2.default, (0, _extends4.default)({}, _this.props, (0, _NestField.getPropsForFields)(_this.props, fields), {
				onChange: _this.onChange(fields),
				name: ""
			}));
		}, _this.onChange = function (fields) {
			return function (formData) {
				_this.props.onChange(fields.reduce(function (updatedFormData, field) {
					return (0, _extends4.default)({}, updatedFormData, (0, _defineProperty3.default)({}, field, formData[field]));
				}, _this.props.formData));
			};
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(SplitField, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props$registry$field = this.props.registry.fields,
			    TitleField = _props$registry$field.TitleField,
			    DescriptionField = _props$registry$field.DescriptionField;
			var _title = this.props.uiSchema["ui:title"];

			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(TitleField, {
					id: this.props.idSchema.$id + "__title",
					title: _title !== undefined ? _title : this.props.title,
					required: this.props.required || this.props.uiSchema["ui:required"],
					formContext: this.props.formContext,
					className: (0, _utils.getUiOptions)(this.props.uiSchema).titleClassName,
					help: this.props.uiSchema["ui:help"]
				}),
				_react2.default.createElement(DescriptionField, {
					id: this.props.idSchema.$id + "__description",
					description: this.props.description,
					formContext: this.props.formContext
				}),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					(0, _utils.getUiOptions)(this.props.uiSchema).splits.map(function (split, i) {
						return _react2.default.createElement(
							_reactBootstrap.Col,
							{ md: split.md, lg: split.lg, xs: split.xs, sm: split.sm, key: i },
							_this2.renderSplitField(split)
						);
					})
				)
			);
		}
	}]);
	return SplitField;
}(_react.Component)) || _class;

SplitField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			splits: _propTypes2.default.arrayOf(_propTypes2.default.shape({
				fields: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
				uiSchema: _propTypes2.default.object,
				name: _propTypes2.default.string,
				lg: _propTypes2.default.integer,
				md: _propTypes2.default.integer,
				sm: _propTypes2.default.integer,
				xs: _propTypes2.default.integer
			})).isRequired
		}).isRequired
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = SplitField;