"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sumPropType = _propTypes2.default.shape({
	resultField: _propTypes2.default.string.isRequired,
	summedFields: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
	summedProperty: _propTypes2.default.string
});

var SumField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(SumField, _Component);

	function SumField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, SumField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = SumField.__proto__ || (0, _getPrototypeOf2.default)(SumField)).call.apply(_ref, [this].concat(args))), _this), _this.getSums = function (formData) {
			var _this$getUiOptions = _this.getUiOptions(),
			    sums = _this$getUiOptions.sums;

			sums = Array.isArray(sums) ? sums : [sums];

			var results = {};

			sums.forEach(function (options) {
				var resultField = options.resultField,
				    summedFields = options.summedFields,
				    summedProperty = options.summedProperty;

				var resultType = _this.props.schema.properties[resultField].type;

				var result = 0;
				var allEmpty = true;
				summedFields.forEach(function (field) {
					if (formData[field] !== undefined) {
						if (summedProperty === "arrayLength") {
							result += formData[field].length;
						} else {
							result += Number(formData[field]);
						}
						allEmpty = false;
					}
				});

				result = allEmpty || isNaN(result) ? undefined : result;
				if (result !== undefined && resultType !== "number" && resultType !== "integer") {
					result = result + "";
				}

				results[resultField] = result;
			});

			return results;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(SumField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(_ref2) {
			var formData = _ref2.formData;

			return { prevResult: this.getSums(formData) };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _this2 = this;

			var _getUiOptions = this.getUiOptions(),
			    sums = _getUiOptions.sums;

			sums = Array.isArray(sums) ? sums : [sums];

			var newSums = this.getSums(formData);
			sums.forEach(function (options) {
				if (newSums[options.resultField] !== _this2.state.prevResult[options.resultField]) {
					formData = (0, _extends4.default)({}, formData, (0, _defineProperty3.default)({}, options.resultField, newSums[options.resultField]));
				}
			});

			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "SumField";
		}
	}]);
	return SumField;
}(_react.Component)) || _class;

SumField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": {
			"sums": _propTypes2.default.oneOfType([sumPropType, _propTypes2.default.arrayOf(sumPropType)]).isRequired
		},
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = SumField;