"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _components = require("../components");

var _reactBootstrap = require("react-bootstrap");

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UnitCountShorthandField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(UnitCountShorthandField, _Component);

	function UnitCountShorthandField(props) {
		(0, _classCallCheck3.default)(this, UnitCountShorthandField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (UnitCountShorthandField.__proto__ || (0, _getPrototypeOf2.default)(UnitCountShorthandField)).call(this, props));

		_this.parseCode = _this.parseCode.bind(_this);
		return _this;
	}

	(0, _createClass3.default)(UnitCountShorthandField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var uiSchema = props.uiSchema,
			    formData = props.formData;

			var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
			    shorthandField = _getUiOptions.shorthandField,
			    taxonIDField = _getUiOptions.taxonIDField;

			var shortHandUiSchema = (0, _deepmerge2.default)((0, _utils.parseJSONPointer)(props.uiSchema, shorthandField) || {}, {
				"ui:widget": CodeReader,
				"ui:options": {
					parseCode: this.parseCode,
					taxonID: (0, _utils.parseJSONPointer)(formData, taxonIDField)
				}
			});

			var _uiSchema = (0, _utils.updateSafelyWithJSONPointer)(uiSchema, shortHandUiSchema, shorthandField);

			return (0, _extends3.default)({}, props, { uiSchema: _uiSchema });
		}
	}, {
		key: "parseCode",
		value: function parseCode(value, taxonId) {
			var _this2 = this;

			var apiClient = this.props.formContext.apiClient;

			var formData = this.props.formData;

			var _getUiOptions2 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    shorthandField = _getUiOptions2.shorthandField,
			    pairCountField = _getUiOptions2.pairCountField;

			var timestamp = Date.now();
			this.promiseTimestamp = timestamp;

			return new _promise2.default(function (resolve) {
				if (!value || !taxonId) {
					formData = (0, _utils.updateSafelyWithJSONPointer)(formData, undefined, pairCountField);
					_this2.props.onChange(formData);
					resolve({ success: undefined });
					return;
				}

				apiClient.fetchCached("/autocomplete/pairCount", { q: value, taxonID: taxonId }).then(function (suggestion) {
					if (timestamp !== _this2.promiseTimestamp) {
						return;
					}
					formData = (0, _utils.updateSafelyWithJSONPointer)(formData, suggestion.key, shorthandField);
					formData = (0, _utils.updateSafelyWithJSONPointer)(formData, suggestion.value, pairCountField);
					_this2.props.onChange(formData);
					resolve({ success: suggestion.key ? true : undefined, value: suggestion.key });
				}).catch(function () {
					if (timestamp !== _this2.promiseTimestamp) {
						return;
					}
					formData = (0, _utils.updateSafelyWithJSONPointer)(formData, undefined, pairCountField);
					_this2.props.onChange(formData);
					resolve({ success: false, value: value });
				});
			});
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "UnitCountShorthandField";
		}
	}]);
	return UnitCountShorthandField;
}(_react.Component)) || _class;

UnitCountShorthandField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			shorthandField: _propTypes2.default.string.isRequired,
			pairCountField: _propTypes2.default.string.isRequired,
			taxonIDField: _propTypes2.default.string.isRequired
		}).isRequired
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = UnitCountShorthandField;

var CodeReader = (0, _BaseComponent2.default)(_class2 = function (_Component2) {
	(0, _inherits3.default)(CodeReader, _Component2);

	function CodeReader(props) {
		(0, _classCallCheck3.default)(this, CodeReader);

		var _this3 = (0, _possibleConstructorReturn3.default)(this, (CodeReader.__proto__ || (0, _getPrototypeOf2.default)(CodeReader)).call(this, props));

		_this3.onChange = function (_ref) {
			var value = _ref.target.value;

			_this3.props.onChange(value);
		};

		_this3.onKeyDown = function (e) {
			if (e.key === "Enter") {
				_this3.onBlur();
			}
		};

		_this3.state = { loading: false };

		_this3.onBlur = _this3.onBlur.bind(_this3);
		return _this3;
	}

	(0, _createClass3.default)(CodeReader, [{
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			if (prevProps.options.taxonID !== this.props.options.taxonID) {
				this.onBlur();
			}
		}
	}, {
		key: "render",
		value: function render() {
			var validationState = "default";
			if (this.state.success === false) {
				validationState = "error";
			} else if (this.state.success) {
				validationState = "success";
			}

			var formContext = this.props.formContext;
			var translations = formContext.translations;


			var inputElem = _react2.default.createElement(_components.FetcherInput, {
				id: this.props.id,
				loading: this.state.loading,
				value: this.props.value || "",
				validationState: validationState,
				onBlur: this.onBlur,
				onKeyDown: this.onKeyDown,
				onChange: this.onChange
			});

			return _react2.default.createElement(
				_reactBootstrap.FormGroup,
				{ validationState: this.state.success === false ? "error" : undefined },
				inputElem,
				this.state.success === false ? _react2.default.createElement(
					_reactBootstrap.HelpBlock,
					null,
					translations.InvalidUnitCode
				) : null,
				_react2.default.createElement("div", { className: "small text-muted", dangerouslySetInnerHTML: { __html: this.props.help } })
			);
		}
	}, {
		key: "onBlur",
		value: function onBlur() {
			var _this4 = this;

			var _props = this.props,
			    value = _props.value,
			    options = _props.options;
			var parseCode = options.parseCode,
			    taxonID = options.taxonID;


			if (!(value === this.state.value && taxonID === this.state.taxonID)) {
				this.setState({ value: value, taxonID: taxonID, loading: true, success: undefined });
				parseCode(value, taxonID).then(function (result) {
					_this4.setState({ loading: false, success: result.success, value: result.value });
				});
			}
		}
	}]);
	return CodeReader;
}(_react.Component)) || _class2;

CodeReader.propTypes = {
	options: _propTypes2.default.shape({
		parseCode: _propTypes2.default.func.isRequired,
		taxonID: _propTypes2.default.string
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};