"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Autosuggest = exports.default = undefined;

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _get2 = require("babel-runtime/helpers/get");

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class2, _class3;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAutosuggest = require("react-autosuggest");

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _reactBootstrap = require("react-bootstrap");

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _utils = require("../../utils");

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _InformalTaxonGroupChooserWidget = require("./InformalTaxonGroupChooserWidget");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renderFlag(suggestion) {
	return (suggestion && suggestion.payload || {}).finnish ? _react2.default.createElement("img", { src: new _Context2.default().staticImgPath + "/finnish-flag.png" }) : null;
}

var _AutosuggestWidget = function (_Component) {
	(0, _inherits3.default)(_AutosuggestWidget, _Component);

	function _AutosuggestWidget() {
		(0, _classCallCheck3.default)(this, _AutosuggestWidget);
		return (0, _possibleConstructorReturn3.default)(this, (_AutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(_AutosuggestWidget)).apply(this, arguments));
	}

	(0, _createClass3.default)(_AutosuggestWidget, [{
		key: "render",
		value: function render() {
			if (this.props.options) {
				switch (this.props.options.autosuggestField) {
					case "taxon":
						return _react2.default.createElement(TaxonAutosuggestWidget, this.props);
					case "unit":
						return _react2.default.createElement(UnitAutosuggestWidget, this.props);
					case "friends":
					case "person":
						return _react2.default.createElement(FriendsAutosuggestWidget, this.props);
					default:
						return _react2.default.createElement(RangeAutosuggestWidget, this.props);
				}
			}
			return _react2.default.createElement(Autosuggest, this.props);
		}
	}, {
		key: "formatValue",
		value: function formatValue(value, options, parentProps) {
			if (options) {
				var component = undefined;
				switch (options.autosuggestField) {
					case "taxon":
						component = TaxonAutosuggestWidget;
						break;
					case "unit":
						component = UnitAutosuggestWidget;
						break;
					case "friends":
					case "person":
						component = FriendsAutosuggestWidget;
						break;
					default:
						component = RangeAutosuggestWidget;
				}
				if (component) {
					return _react2.default.createElement(SimpleValueRenderer, { component: component, value: value, formContext: parentProps.formContext });
				}
			}
		}
	}]);
	return _AutosuggestWidget;
}(_react.Component);

_AutosuggestWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}).isRequired,
	value: _propTypes2.default.string
};
exports.default = _AutosuggestWidget;

var SimpleValueRenderer = function (_Component2) {
	(0, _inherits3.default)(SimpleValueRenderer, _Component2);

	function SimpleValueRenderer(props) {
		(0, _classCallCheck3.default)(this, SimpleValueRenderer);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (SimpleValueRenderer.__proto__ || (0, _getPrototypeOf2.default)(SimpleValueRenderer)).call(this, props));

		_this2.state = { value: _this2.props.value, loading: true };
		return _this2;
	}

	(0, _createClass3.default)(SimpleValueRenderer, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this3 = this;

			var _props$component$prot = this.props.component.prototype,
			    getSuggestionFromValue = _props$component$prot.getSuggestionFromValue,
			    isValueSuggested = _props$component$prot.isValueSuggested;

			if (getSuggestionFromValue && isValueSuggested) {
				this.isValueSuggested = isValueSuggested.bind(this);
				getSuggestionFromValue.call(this, this.props.value).then(function (suggestion) {
					_this3.setState({ value: suggestion.value, loading: false });
				}).catch(function () {
					return _this3.setState({ loading: false });
				});
			}
		}
	}, {
		key: "render",
		value: function render() {
			return this.state.loading ? _react2.default.createElement(_reactSpinner2.default, null) : _react2.default.createElement(
				"span",
				null,
				this.state.value
			);
		}
	}]);
	return SimpleValueRenderer;
}(_react.Component);

function TaxonAutosuggest(ComposedComponent) {
	var _class, _temp, _initialiseProps;

	return _temp = _class = function (_ComposedComponent) {
		(0, _inherits3.default)(TaxonAutosuggestWidget, _ComposedComponent);

		function TaxonAutosuggestWidget(props) {
			(0, _classCallCheck3.default)(this, TaxonAutosuggestWidget);

			var _this4 = (0, _possibleConstructorReturn3.default)(this, (TaxonAutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(TaxonAutosuggestWidget)).call(this, props));

			_initialiseProps.call(_this4);

			_this4.getSuggestionFromValue = _this4.getSuggestionFromValue.bind(_this4);
			_this4.isValueSuggested = _this4.isValueSuggested.bind(_this4);
			if ((0, _get3.default)(TaxonAutosuggestWidget.prototype.__proto__ || (0, _getPrototypeOf2.default)(TaxonAutosuggestWidget.prototype), "renderSuggestion", _this4)) _this4.renderSuggestion = (0, _get3.default)(TaxonAutosuggestWidget.prototype.__proto__ || (0, _getPrototypeOf2.default)(TaxonAutosuggestWidget.prototype), "renderSuggestion", _this4).bind(_this4);
			return _this4;
		}

		(0, _createClass3.default)(TaxonAutosuggestWidget, [{
			key: "componentDidMount",
			value: function componentDidMount() {
				this.mounted = true;
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				this.mounted = false;
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate(prevProps) {
				var _this5 = this;

				var _props = this.props,
				    value = _props.value,
				    _props$options = _props.options,
				    options = _props$options === undefined ? {} : _props$options;

				if (value !== prevProps.value && options.getSuggestionFromValue && options.chooseImages) {
					options.getSuggestionFromValue(value).then(function (suggestion) {
						if (!_this5.mounted) return;
						var found = _this5.parseChooseImages(options.chooseImages).find(function (_ref) {
							var id = _ref.id;
							return suggestion.key === id;
						});
						_this5.setState({ chooseImages: found ? [found] : undefined });
					});
				}
			}
		}, {
			key: "getSuggestionFromValue",
			value: function getSuggestionFromValue(value) {
				if (this.isValueSuggested(value)) {
					return this.props.formContext.apiClient.fetchCached("/taxa/" + value).then(function (_ref2) {
						var vernacularName = _ref2.vernacularName,
						    scientificName = _ref2.scientificName;

						if (vernacularName !== undefined) {
							return { value: vernacularName, key: value };
						}
						if (scientificName !== undefined) {
							return { value: scientificName, key: value };
						}
					});
				} else {
					return _promise2.default.reject();
				}
			}
		}, {
			key: "isValueSuggested",
			value: function isValueSuggested(value) {
				return !(0, _utils.isEmptyString)(value) && !!value.match(/MX\.\d+/);
			}
		}, {
			key: "parseValue",
			value: function parseValue(value) {
				return value.replace(/ sp(\.|p)?\.?$/, "");
			}
		}, {
			key: "renderSuggestion",
			value: function renderSuggestion(suggestion) {
				return _react2.default.createElement(
					"span",
					{ className: "simple-option" },
					suggestion.value,
					renderFlag(suggestion)
				);
			}
		}, {
			key: "render",
			value: function render() {
				var props = this.props;
				var propsOptions = props.options,
				    propsWithoutOptions = (0, _objectWithoutProperties3.default)(props, ["options"]);


				var options = {
					getSuggestionFromValue: this.getSuggestionFromValue,
					isValueSuggested: this.isValueSuggested,
					renderSuggested: this.renderSuggested,
					renderUnsuggested: this.renderUnsuggested(props),
					renderSuccessGlyph: this.renderSuccessGlyph,
					renderSuggestion: this.renderSuggestion,
					parseValue: this.parseValue
				};
				var _options = (0, _extends3.default)({}, options, propsWithoutOptions, propsOptions || {}, {
					query: (0, _extends3.default)({}, options.query || {}, propsWithoutOptions.query || {}, propsOptions.query || {})
				});

				if (propsOptions.chooseImages) {
					_options.renderExtra = this.renderChooseImages;
				}

				return _react2.default.createElement(Autosuggest, (0, _extends3.default)({ ref: this.setAutosuggestRef }, _options));
			}
		}]);
		return TaxonAutosuggestWidget;
	}(ComposedComponent), _initialiseProps = function _initialiseProps() {
		var _this6 = this;

		this.renderUnsuggested = function (props) {
			return function (input) {
				var tooltip = _react2.default.createElement(
					_reactBootstrap.Tooltip,
					{ id: props.id + "-tooltip" },
					props.formContext.translations.UnknownSpeciesName
				);
				return _react2.default.createElement(
					_components.OverlayTrigger,
					{ overlay: tooltip, placement: "top" },
					input
				);
			};
		};

		this.renderSuggested = function (input, suggestion) {
			var _getUiOptions = (0, _utils.getUiOptions)(_this6.props),
			    _getUiOptions$taxonCa = _getUiOptions.taxonCardPlacement,
			    placement = _getUiOptions$taxonCa === undefined ? "top" : _getUiOptions$taxonCa;

			return _react2.default.createElement(
				TaxonCardOverlay,
				{ value: suggestion.key, formContext: _this6.props.formContext, id: _this6.props.id, trigger: "hover", placement: placement },
				input
			);
		};

		this.renderSuccessGlyph = function () {
			return _react2.default.createElement(_reactBootstrap.Glyphicon, { style: { pointerEvents: "none" }, glyph: "ok", className: "form-control-feedback" });
		};

		this.parseChooseImages = function (chooseImages) {
			return chooseImages.map(function (taxonIDOrObj) {
				return typeof taxonIDOrObj === "string" ? { id: taxonIDOrObj } : taxonIDOrObj;
			});
		};

		this.renderChooseImages = function () {
			var chooseImages = _this6.state && _this6.state.chooseImages || _this6.props.options.chooseImages;

			var _getUiOptions2 = (0, _utils.getUiOptions)(_this6.props),
			    orWriteSpeciesNameLabel = _getUiOptions2.orWriteSpeciesNameLabel;

			return _react2.default.createElement(
				_reactBootstrap.Row,
				null,
				_react2.default.createElement(
					_reactBootstrap.Col,
					{ xs: 12 },
					_react2.default.createElement(
						"div",
						{ className: "laji-form-medias" },
						_this6.parseChooseImages(chooseImages).map(function (taxonIDObj) {
							return _react2.default.createElement(TaxonImgChooser, { id: taxonIDObj.id, key: taxonIDObj.id, url: taxonIDObj.url, onSelect: _this6.onTaxonImgSelected, formContext: _this6.props.formContext });
						})
					)
				),
				_react2.default.createElement(
					_reactBootstrap.Col,
					{ xs: 12 },
					_react2.default.createElement(
						"label",
						null,
						orWriteSpeciesNameLabel || _this6.props.formContext.translations.orWriteSpeciesName
					)
				)
			);
		};

		this.onTaxonImgSelected = function (taxonID, taxon) {
			_this6.autosuggestRef.selectSuggestion({
				key: taxonID,
				value: taxon.vernacularName,
				payload: taxon
			});
		};

		this.setAutosuggestRef = function (elem) {
			_this6.autosuggestRef = elem;
		};
	}, _temp;
}

var TaxonAutosuggestWidget = TaxonAutosuggest(_class2 = function (_Component3) {
	(0, _inherits3.default)(TaxonAutosuggestWidget, _Component3);

	function TaxonAutosuggestWidget() {
		(0, _classCallCheck3.default)(this, TaxonAutosuggestWidget);
		return (0, _possibleConstructorReturn3.default)(this, (TaxonAutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(TaxonAutosuggestWidget)).apply(this, arguments));
	}

	return TaxonAutosuggestWidget;
}(_react.Component)) || _class2;

var UnitAutosuggestWidget = TaxonAutosuggest(_class3 = function (_Component4) {
	(0, _inherits3.default)(UnitAutosuggestWidget, _Component4);

	function UnitAutosuggestWidget(props) {
		(0, _classCallCheck3.default)(this, UnitAutosuggestWidget);

		var _this8 = (0, _possibleConstructorReturn3.default)(this, (UnitAutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(UnitAutosuggestWidget)).call(this, props));

		_this8.renderSuggestion = _this8.renderSuggestion.bind(_this8);
		return _this8;
	}

	(0, _createClass3.default)(UnitAutosuggestWidget, [{
		key: "renderSuggestion",
		value: function renderSuggestion(suggestion) {
			var _suggestion$payload$i = suggestion.payload.interpretedFrom,
			    count = _suggestion$payload$i.count,
			    maleIndividualCount = _suggestion$payload$i.maleIndividualCount,
			    femaleIndividualCount = _suggestion$payload$i.femaleIndividualCount;

			var _map = [count, maleIndividualCount, femaleIndividualCount].map(function (val) {
				return val && _react2.default.createElement(
					"span",
					{ className: "text-muted" },
					val
				);
			}),
			    _map2 = (0, _slicedToArray3.default)(_map, 3),
			    countElem = _map2[0],
			    maleElem = _map2[1],
			    femaleElem = _map2[2];

			var taxonName = suggestion.payload.unit.identifications[0].taxon;
			var name = suggestion.payload.isNonMatching ? _react2.default.createElement(
				"span",
				{ className: "text-muted" },
				taxonName,
				" ",
				_react2.default.createElement(
					"i",
					null,
					"(",
					this.props.formContext.translations.unknownSpeciesName,
					")"
				)
			) : taxonName;
			return _react2.default.createElement(
				"span",
				null,
				countElem,
				countElem && " ",
				name,
				maleElem && " ",
				maleElem,
				femaleElem && " ",
				femaleElem,
				renderFlag(suggestion)
			);
		}
	}]);
	return UnitAutosuggestWidget;
}(_react.Component)) || _class3;

var FriendsAutosuggestWidget = function (_Component5) {
	(0, _inherits3.default)(FriendsAutosuggestWidget, _Component5);

	function FriendsAutosuggestWidget(props) {
		(0, _classCallCheck3.default)(this, FriendsAutosuggestWidget);

		var _this9 = (0, _possibleConstructorReturn3.default)(this, (FriendsAutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(FriendsAutosuggestWidget)).call(this, props));

		_this9.renderUnsuggested = function (input) {
			var tooltip = _react2.default.createElement(
				_reactBootstrap.Tooltip,
				{ id: _this9.props.id + "-tooltip" },
				_this9.props.formContext.translations.UnknownName
			);
			return _react2.default.createElement(
				_components.OverlayTrigger,
				{ overlay: tooltip, placement: "top" },
				input
			);
		};

		_this9.findExactMatch = function (suggestions, value) {
			return suggestions.find(function (suggestion) {
				return suggestion && suggestion.value.toLowerCase() === value.trim().toLowerCase();
			});
		};

		_this9.renderSuccessGlyph = function () {
			return _react2.default.createElement(_reactBootstrap.Glyphicon, { style: { pointerEvents: "none" },
				glyph: "user",
				className: "form-control-feedback" });
		};

		_this9.getSuggestionFromValue = _this9.getSuggestionFromValue.bind(_this9);
		_this9.isValueSuggested = _this9.isValueSuggested.bind(_this9);
		return _this9;
	}

	(0, _createClass3.default)(FriendsAutosuggestWidget, [{
		key: "getSuggestionFromValue",
		value: function getSuggestionFromValue(value) {
			var _getUiOptions3 = (0, _utils.getUiOptions)(this.props),
			    showID = _getUiOptions3.showID;

			var isAdmin = this.props.formContext.uiSchemaContext.isAdmin;

			if (this.isValueSuggested(value)) {
				return this.props.formContext.apiClient.fetchCached("/person/by-id/" + value).then(function (_ref3) {
					var fullName = _ref3.fullName,
					    group = _ref3.group,
					    id = _ref3.id;

					if (fullName) {
						var addGroup = function addGroup(str) {
							return group ? str + " (" + group + ")" : str;
						};
						var addID = function addID(str) {
							return isAdmin && showID ? str + " (" + id + ")" : str;
						};
						return {
							value: addID(addGroup(fullName)),
							key: value
						};
					}
				});
			} else {
				return _promise2.default.reject();
			}
		}
	}, {
		key: "isValueSuggested",
		value: function isValueSuggested(value) {
			return !(0, _utils.isEmptyString)(value) && value.match(/MA\.\d+/);
		}
	}, {
		key: "render",
		value: function render() {
			var _props2 = this.props,
			    propsOptions = _props2.options,
			    propsWithoutOptions = (0, _objectWithoutProperties3.default)(_props2, ["options"]);


			var options = {
				query: (0, _extends3.default)({
					includeSelf: true
				}, propsOptions.queryOptions),
				getSuggestionFromValue: this.getSuggestionFromValue,
				isValueSuggested: this.isValueSuggested,
				renderUnsuggested: this.renderUnsuggested,
				renderSuccessGlyph: this.renderSuccessGlyph,
				findExactMatch: this.findExactMatch
			};

			return _react2.default.createElement(Autosuggest, (0, _extends3.default)({}, options, propsWithoutOptions, propsOptions));
		}
	}]);
	return FriendsAutosuggestWidget;
}(_react.Component);

var RangeAutosuggestWidget = function (_Component6) {
	(0, _inherits3.default)(RangeAutosuggestWidget, _Component6);

	function RangeAutosuggestWidget() {
		(0, _classCallCheck3.default)(this, RangeAutosuggestWidget);
		return (0, _possibleConstructorReturn3.default)(this, (RangeAutosuggestWidget.__proto__ || (0, _getPrototypeOf2.default)(RangeAutosuggestWidget)).apply(this, arguments));
	}

	(0, _createClass3.default)(RangeAutosuggestWidget, [{
		key: "render",
		value: function render() {
			var _props3 = this.props,
			    propsOptions = _props3.options,
			    propsWithoutOptions = (0, _objectWithoutProperties3.default)(_props3, ["options"]);

			return _react2.default.createElement(Autosuggest, (0, _extends3.default)({ highlightFirstSuggestion: true }, propsWithoutOptions, propsOptions));
		}
	}]);
	return RangeAutosuggestWidget;
}(_react.Component);

var Autosuggest = exports.Autosuggest = function (_Component7) {
	(0, _inherits3.default)(Autosuggest, _Component7);

	function Autosuggest(props) {
		(0, _classCallCheck3.default)(this, Autosuggest);

		var _this11 = (0, _possibleConstructorReturn3.default)(this, (Autosuggest.__proto__ || (0, _getPrototypeOf2.default)(Autosuggest)).call(this, props));

		_initialiseProps2.call(_this11);

		var isSuggested = _this11.isValueSuggested(props.value, props);
		_this11.state = {
			isLoading: false,
			suggestions: [],
			unsuggested: false,
			focused: false,
			value: props.value !== undefined ? props.value : "",
			suggestion: isSuggested ? {} : undefined
		};
		_this11.state = (0, _extends3.default)({}, _this11.state, _this11.getStateFromProps(props));
		_this11.apiClient = _this11.props.formContext.apiClient;
		return _this11;
	}

	(0, _createClass3.default)(Autosuggest, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this12 = this;

			var value = props.value,
			    _props$suggestionRece = props.suggestionReceive,
			    suggestionReceive = _props$suggestionRece === undefined ? "key" : _props$suggestionRece;
			var suggestion = this.state.suggestion;

			if (this.state.value !== value || suggestion && suggestion[suggestionReceive] !== value && this.mounted) {
				if (this.mounted && this.state.value !== value) {
					this.setState({ value: value }, function () {
						_this12.triggerConvert(props);
					});
				} else {
					this.triggerConvert(props);
				}
			} else if (!suggestion) {
				return { value: props.value };
			}
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			var state = this.getStateFromProps(props);
			state && this.setState(state);
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.triggerConvert(this.props);
			new _Context2.default(this.props.formContext.contextId).addKeyHandler(this.props.id, this.keyFunctions);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			new _Context2.default(this.props.formContext.contextId).removeKeyHandler(this.props.id, this.keyFunctions);
		}

		// This is used, because the default behavior doesn't render the suggestions when focusing
		// a suggestion component that wants to render the suggestion when the input is empty.

	}, {
		key: "render",
		value: function render() {
			var props = this.props;
			var _state = this.state,
			    suggestions = _state.suggestions,
			    value = _state.value;

			if (value === undefined) value = "";

			var inputProps = (0, _extends3.default)({
				id: this.props.id,
				value: value,
				readonly: props.readonly,
				disabled: props.disabled,
				placeholder: props.placeholder
			}, this.props.inputProps || {}, {
				onChange: this.onInputChange,
				onBlur: this.onBlur,
				onFocus: this.onFocus,
				onKeyDown: this.onKeyDown
			});

			if (inputProps.value === undefined || inputProps.value === null) inputProps.value = "";

			var cssClasses = {
				suggestionsContainer: "rw-popup-container rw-popup-animation-box",
				suggestionsContainerOpen: "rw-popup",
				suggestionsList: "rw-list",
				suggestion: "rw-list-option",
				suggestionHighlighted: "rw-list-option rw-state-focus"
			};

			var highlightFirstSuggestion = "highlightFirstSuggestion" in this.props ? this.props.highlightFirstSuggestion : !this.props.allowNonsuggestedValue;

			var renderExtra = props.renderExtra;


			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				renderExtra && renderExtra(),
				_react2.default.createElement(
					"div",
					{ className: "autosuggest-wrapper" + (props.wrapperClassName ? " " + props.wrapperClassName : "") },
					_react2.default.createElement(_reactAutosuggest2.default, {
						ref: this.setRef,
						id: this.props.id + "-autosuggest",
						inputProps: inputProps,
						renderInputComponent: this.renderInput,
						suggestions: suggestions,
						getSuggestionValue: this.getSuggestionValue,
						renderSuggestion: this.renderSuggestion,
						renderSuggestionsContainer: this.renderSuggestionsContainer,
						onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
						onSuggestionsClearRequested: this.onSuggestionsClearRequested,
						onSuggestionSelected: this.onSuggestionSelected,
						focusInputOnSuggestionClick: false,
						highlightFirstSuggestion: highlightFirstSuggestion,
						alwaysRenderSuggestions: true,
						theme: cssClasses
					})
				)
			);
		}
	}]);
	return Autosuggest;
}(_react.Component);

Autosuggest.propTypes = {
	autosuggestField: _propTypes2.default.string,
	allowNonsuggestedValue: _propTypes2.default.bool,
	onSuggestionSelected: _propTypes2.default.func,
	onConfirmUnsuggested: _propTypes2.default.func,
	onInputChange: _propTypes2.default.func,
	uiSchema: _propTypes2.default.object,
	informalTaxonGroups: _propTypes2.default.string,
	onInformalTaxonGroupSelected: _propTypes2.default.func
};
Autosuggest.defaultProps = {
	allowNonsuggestedValue: true
};

var _initialiseProps2 = function _initialiseProps2() {
	var _this19 = this;

	this.isValueSuggested = function (value, props) {
		if (!props) props = _this19.props;
		var _props5 = props,
		    isValueSuggested = _props5.isValueSuggested,
		    suggestionReceive = _props5.suggestionReceive,
		    onSuggestionSelected = _props5.onSuggestionSelected;

		if (!onSuggestionSelected && suggestionReceive !== "key") return undefined;
		return isValueSuggested ? isValueSuggested(props.value) : undefined;
	};

	this.keyFunctions = {
		autosuggestToggle: function autosuggestToggle() {
			if (_this19.props.onToggle) {
				_this19.onToggle();
				return true;
			}
			return false;
		}
	};

	this.triggerConvert = function (props) {
		var value = props.value,
		    getSuggestionFromValue = props.getSuggestionFromValue;

		if ((0, _utils.isEmptyString)(value) || !getSuggestionFromValue) {
			if (_this19.state.suggestion && (0, _keys2.default)(_this19.state.suggestion).length > 0) {
				_this19.setState({ suggestion: undefined, value: value });
			}
			return;
		}

		_this19.setState({ isLoading: true });
		getSuggestionFromValue(value).then(function (suggestion) {
			if (!_this19.mounted) return;
			_this19.setState({ suggestion: suggestion, value: _this19.getSuggestionValue(suggestion), isLoading: false });
		}).catch(function () {
			if (!_this19.mounted) return;
			_this19.setState({ isLoading: false });
		});
	};

	this.getSuggestionValue = function (suggestion) {
		return suggestion.value;
	};

	this.renderSuggestion = function (suggestion) {
		var renderSuggestion = _this19.props.renderSuggestion;

		if (!renderSuggestion) renderSuggestion = function renderSuggestion(suggestion) {
			return suggestion.value;
		};
		return _react2.default.createElement(
			"span",
			{ className: "simple-option" },
			renderSuggestion(suggestion)
		);
	};

	this.onSuggestionsClearRequested = function () {
		_this19.clearRequested = true;
	};

	this.selectSuggestion = function (suggestion) {
		var _props6 = _this19.props,
		    onSuggestionSelected = _props6.onSuggestionSelected,
		    onChange = _props6.onChange,
		    suggestionReceive = _props6.suggestionReceive;

		var afterStateChange = function afterStateChange() {
			onSuggestionSelected ? onSuggestionSelected(suggestion, _this19.mounted) : onChange(suggestion[suggestionReceive || "key"]);
		};
		var state = { suggestion: suggestion, value: _this19.getSuggestionValue(suggestion) };
		if (_this19.clearRequested) state.suggestions = [];
		_this19.mounted ? _this19.setState(state, afterStateChange) : afterStateChange();
	};

	this.selectUnsuggested = function (value) {
		if ((0, _utils.isEmptyString)(value) && (0, _utils.isEmptyString)(_this19.props.value)) return;

		var _props7 = _this19.props,
		    onConfirmUnsuggested = _props7.onConfirmUnsuggested,
		    onChange = _props7.onChange;


		var state = { value: value, suggestion: undefined };
		if (_this19.clearRequested) state.suggestions = [];
		_this19.setState(state, function () {
			onConfirmUnsuggested ? onConfirmUnsuggested(value) : onChange(value);
		});
	};

	this.onSuggestionSelected = function (e, data) {
		// Input onBlur/onFocus isn't called without this hack.
		_this19.reactAutosuggestRef.justSelectedSuggestion = false;

		var suggestion = data.suggestion;

		e.preventDefault();
		if ("id" in _this19.props) {
			new _Context2.default(_this19.props.formContext.contextId).formInstance.onKeyDown(e);
			_this19.selectSuggestion(suggestion);
			// If event triggered for LajiForm didn't cause a navigation and thus blur, select the suggestion.
			if (document.activeElement !== (0, _reactDom.findDOMNode)(_this19.inputElem)) {
				_this19.selectSuggestion(suggestion);
			}
		}
	};

	this.findExactMatch = function (suggestions) {
		var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

		if (!Array.isArray(suggestions)) suggestions = [suggestions];
		var findExactMatch = _this19.props.findExactMatch;

		return findExactMatch ? findExactMatch(suggestions, value) : suggestions.find(function (suggestion) {
			return suggestion && suggestion.value.toLowerCase() === value.trim().toLowerCase() && (!suggestion.payload || !suggestion.payload.isNonMatching);
		});
	};

	this.findTheOnlyOneMatch = function (suggestions) {
		if (!Array.isArray(suggestions)) suggestions = [suggestions];
		var filtered = suggestions.filter(function (suggestion) {
			return !suggestion || !suggestion.payload || !suggestion.payload.isNonMatching;
		});
		if (filtered.length === 1) {
			return filtered[0];
		}
	};

	this.findNonMatching = function (suggestions) {
		if (!Array.isArray(suggestions)) suggestions = [suggestions];
		var filtered = suggestions.filter(function (suggestion) {
			return suggestion && suggestion.payload && suggestion.payload.isNonMatching;
		});
		if (filtered.length === 1) {
			return filtered[0];
		}
	};

	this.onInputChange = function (e, autosuggestEvent) {
		var value = autosuggestEvent.newValue;

		_this19.setState({ value: value }, function () {
			if (_this19.props.inputProps && _this19.props.inputProps.onChange) {
				e.persist();
				_this19.props.inputProps.onChange(e, autosuggestEvent);
			}
		});
	};

	this.onSuggestionsFetchRequested = function (_ref9) {
		var value = _ref9.value;
		var debounce = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

		if (value === undefined || value === null) value = "";
		value = _this19.props.parseValue ? _this19.props.parseValue(value) : value;
		if (value.length < (_this19.props.minFetchLength !== undefined ? _this19.props.minFetchLength : 2)) {
			_this19.setState({ suggestions: [] });
			return;
		}

		var _props8 = _this19.props,
		    autosuggestField = _props8.autosuggestField,
		    _props8$query = _props8.query,
		    query = _props8$query === undefined ? {} : _props8$query;


		_this19.setState({ isLoading: true });

		var request = function request() {
			var timestamp = Date.now();
			_this19.promiseTimestamp = timestamp;
			_this19.apiClient.fetchCached("/autocomplete/" + autosuggestField, (0, _extends3.default)({ q: value, includePayload: true, matchType: "exact,partial" }, query)).then(function (suggestions) {
				if (timestamp !== _this19.promiseTimestamp) {
					return;
				}
				_this19.mounted ? _this19.setState({ isLoading: false, suggestions: suggestions }, function () {
					return _this19.afterBlurAndFetch(suggestions);
				}) : _this19.afterBlurAndFetch(suggestions);
			}).catch(function () {
				_this19.mounted ? _this19.setState({ isLoading: false }, _this19.afterBlurAndFetch) : _this19.afterBlurAndFetch();
			});
		};

		var context = new _Context2.default(_this19.props.formContext.contextId);
		if (_this19.timeout) {
			clearTimeout(_this19.timeout);
		}
		if (debounce) {
			_this19.timeout = context.setTimeout(request, 100);
		} else {
			request();
		}
	};

	this.onFocus = function (e) {
		_this19.setState({ focused: true }, function () {
			return _this19.onSuggestionsFetchRequested({ value: _this19.state.value });
		});

		(0, _utils.triggerParentComponent)("onFocus", e, _this19.props.inputProps);
	};

	this.onBlur = function (e) {
		var _ref10 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
		    highlightedSuggestion = _ref10.highlightedSuggestion;

		_this19.highlightedSuggestionOnBlur = highlightedSuggestion;
		_this19._valueForBlurAndFetch = _this19.state.value;
		_this19.setState({ focused: false }, function () {
			return _this19.afterBlurAndFetch(_this19.state.suggestions);
		});
		(0, _utils.triggerParentComponent)("onBlur", e, _this19.props.inputProps);
	};

	this.onKeyDown = function (e) {
		(0, _utils.triggerParentComponent)("onKeyDown", e, _this19.props.inputProps);
	};

	this.renderSuggestionsContainer = function (_ref11) {
		var containerProps = _ref11.containerProps,
		    children = _ref11.children;

		if (!_this19.state.focused) {
			return null;
		}

		return _react2.default.createElement(
			"div",
			containerProps,
			children
		);
	};

	this.afterBlurAndFetch = function (suggestions, callback) {
		var _state$value = _this19.state.value,
		    value = _state$value === undefined ? "" : _state$value;

		var parsedValue = _this19.props.parseValue ? _this19.props.parseValue(value) : value;
		if (_this19._valueForBlurAndFetch === undefined) {
			_this19._valueForBlurAndFetch = "";
		}
		if (_this19.mounted && (_this19.state.focused || _this19.state.isLoading) || _this19.props.controlledValue && _this19._valueForBlurAndFetch !== value) {
			return;
		}

		var _props9 = _this19.props,
		    selectOnlyOne = _props9.selectOnlyOne,
		    _props9$selectOnlyNon = _props9.selectOnlyNonMatchingBeforeUnsuggested,
		    selectOnlyNonMatchingBeforeUnsuggested = _props9$selectOnlyNon === undefined ? true : _props9$selectOnlyNon,
		    informalTaxonGroups = _props9.informalTaxonGroups,
		    informalTaxonGroupsValue = _props9.informalTaxonGroupsValue,
		    allowNonsuggestedValue = _props9.allowNonsuggestedValue;


		var exactMatch = _this19.findExactMatch(suggestions, parsedValue);
		var onlyOneMatch = selectOnlyOne ? _this19.findTheOnlyOneMatch(suggestions) : undefined;
		var nonMatching = selectOnlyNonMatchingBeforeUnsuggested ? _this19.findNonMatching(suggestions) : undefined;
		var valueDidntChangeAndHasInformalTaxonGroup = _this19.props.value === value && informalTaxonGroups && informalTaxonGroupsValue && informalTaxonGroupsValue.length;

		if (_this19.highlightedSuggestionOnBlur) {
			_this19.selectSuggestion(_this19.highlightedSuggestionOnBlur);
		} else if (onlyOneMatch) {
			_this19.selectSuggestion(onlyOneMatch);
		} else if (exactMatch) {
			_this19.selectSuggestion((0, _extends3.default)({}, exactMatch, { value: value }));
		} else if (nonMatching && !valueDidntChangeAndHasInformalTaxonGroup) {
			_this19.selectSuggestion(nonMatching);
		} else if (!valueDidntChangeAndHasInformalTaxonGroup && allowNonsuggestedValue) {
			_this19.selectUnsuggested(parsedValue);
		} else if (!allowNonsuggestedValue) {
			_this19.setState({ value: "" }, function () {
				return _this19.props.onChange("");
			});
		}

		callback && callback();
	};

	this.setRef = function (ref) {
		_this19.reactAutosuggestRef = ref;
	};

	this.onInformalTaxonGroupsOpened = function (open) {
		_this19.setState({ informalTaxonGroupsOpen: open });
	};

	this.onInformalTaxonGroupSelected = function (id) {
		_this19.setState({ informalTaxonGroupsOpen: false, focused: false });
		_this19.props.onInformalTaxonGroupSelected && _this19.props.onInformalTaxonGroupSelected(id);
	};

	this.onInformalTaxonGroupHide = function () {
		_this19.setState({ informalTaxonGroupsOpen: false });
	};

	this.onToggle = function () {
		if (!_this19.mounted) return;
		_this19.props.onToggle(!_this19.props.toggled);
		(0, _setImmediate3.default)(function () {
			return (0, _utils.focusById)(_this19.props.formContext, _this19.props.id);
		}, 1); // Refocus input
	};

	this.setInputRef = function (elem) {
		_this19.inputElem = elem;
	};

	this.renderInput = function (inputProps) {
		var _props10 = _this19.props,
		    value = _props10.value,
		    renderSuccessGlyph = _props10.renderSuccessGlyph,
		    renderSuggested = _props10.renderSuggested,
		    renderUnsuggested = _props10.renderUnsuggested,
		    informalTaxonGroups = _props10.informalTaxonGroups,
		    _props10$renderInform = _props10.renderInformalTaxonGroupSelector,
		    renderInformalTaxonGroupSelector = _props10$renderInform === undefined ? true : _props10$renderInform,
		    taxonGroupID = _props10.taxonGroupID,
		    onToggle = _props10.onToggle;

		var validationState = null;
		var _props$formContext = _this19.props.formContext,
		    translations = _props$formContext.translations,
		    lang = _props$formContext.lang;
		var suggestion = _this19.state.suggestion;


		var isSuggested = _this19.isValueSuggested(value);
		if (isSuggested) isSuggested = isSuggested && !!suggestion;

		if (!(0, _utils.isEmptyString)(value) && isSuggested !== undefined) {
			validationState = isSuggested ? "success" : "warning";
		}

		var getGlyphNameFromState = function getGlyphNameFromState(state) {
			switch (state) {
				case "success":
					return "ok";
				case "warning":
					return "warning-sign";
				case "error":
					return "remove";
				default:
					return "";
			}
		};

		var getGlyph = function getGlyph(state) {
			var glyph = getGlyphNameFromState(state);

			return glyph ? _react2.default.createElement(_reactBootstrap.Glyphicon, {
				style: { pointerEvents: "none" },
				glyph: glyph,
				className: "form-control-feedback"
			}) : null;
		};

		// react-bootstrap components can't be used here because they require using form-group which breaks layout.
		var glyph = undefined;

		if (!_this19.state.focused && !_this19.state.isLoading && (!onToggle || !_this19.state.focused)) {
			glyph = validationState === "success" && renderSuccessGlyph ? renderSuccessGlyph(value) : getGlyph(validationState);
		}

		var addon = informalTaxonGroups && renderInformalTaxonGroupSelector ? _react2.default.createElement(InformalTaxonGroupsAddon, { taxonGroupID: taxonGroupID,
			onClear: _this19.onInformalTaxonGroupSelected,
			open: _this19.state.informalTaxonGroupsOpen,
			onOpen: _this19.onInformalTaxonGroupsOpened,
			formContext: _this19.props.formContext }) : null;

		var getTogglerTooltip = function getTogglerTooltip() {
			var tooltip = translations[_this19.props.toggled ? "StopShorthand" : "StartShorthand"] + ". " + translations.ShorthandHelp;

			var _ref12 = new _Context2.default(_this19.props.formContext.contextId),
			    _ref12$shortcuts = _ref12.shortcuts,
			    shortcuts = _ref12$shortcuts === undefined ? [] : _ref12$shortcuts;

			(0, _keys2.default)(shortcuts).some(function (keyCombo) {
				if (shortcuts[keyCombo].fn == "autosuggestToggle") {
					tooltip = "[" + (0, _utils.stringifyKeyCombo)(keyCombo) + "]: " + tooltip;
					return true;
				}
			});
			return tooltip;
		};

		var toggler = onToggle && _this19.state.focused ? _react2.default.createElement(
			_components.TooltipComponent,
			{ tooltip: getTogglerTooltip() },
			_react2.default.createElement(
				_reactBootstrap.InputGroup.Addon,
				{ className: "autosuggest-input-addon power-user-addon" + (_this19.props.toggled ? " active" : ""), onMouseDown: _this19.onToggle },
				_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "flash" })
			)
		) : null;

		var inputValue = (0, _utils.isEmptyString)(_this19.state.value) ? "" : _this19.state.value;
		var input = _react2.default.createElement(_components.FetcherInput, (0, _extends3.default)({
			value: inputValue,
			glyph: glyph,
			loading: _this19.state.isLoading,
			validationState: validationState,
			extra: addon,
			appendExtra: toggler,
			getRef: _this19.setInputRef,
			className: toggler && _this19.state.focused ? "has-toggler" : undefined
		}, inputProps));

		var component = input;
		if (value && isSuggested && renderSuggested) {
			component = renderSuggested(input, suggestion);
		} else if (value && isSuggested === false && renderUnsuggested) {
			component = renderUnsuggested(input);
		}
		if (informalTaxonGroups) {
			component = _react2.default.createElement(
				"div",
				null,
				component,
				_this19.state.informalTaxonGroupsOpen && _react2.default.createElement(_InformalTaxonGroupChooserWidget.InformalTaxonGroupChooser, { modal: true, onHide: _this19.onInformalTaxonGroupHide, onSelected: _this19.onInformalTaxonGroupSelected, formContext: _this19.props.formContext, lang: lang })
			);
		}
		return component;
	};
};

var TaxonCardOverlay = function (_Component8) {
	(0, _inherits3.default)(TaxonCardOverlay, _Component8);

	function TaxonCardOverlay(props) {
		(0, _classCallCheck3.default)(this, TaxonCardOverlay);

		var _this13 = (0, _possibleConstructorReturn3.default)(this, (TaxonCardOverlay.__proto__ || (0, _getPrototypeOf2.default)(TaxonCardOverlay)).call(this, props));

		_this13.state = { converted: false };
		return _this13;
	}

	(0, _createClass3.default)(TaxonCardOverlay, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.fetch(this.props.value);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(_ref4) {
			var value = _ref4.value;

			this.fetch(value);
		}
	}, {
		key: "fetch",
		value: function fetch(value) {
			var _this14 = this;

			if ((0, _utils.isEmptyString)(value)) {
				this.setState({ scientificName: "", cursiveName: false });
			} else {
				this.props.formContext.apiClient.fetchCached("/taxa/" + value).then(function (_ref5) {
					var scientificName = _ref5.scientificName,
					    cursiveName = _ref5.cursiveName,
					    vernacularName = _ref5.vernacularName,
					    taxonRank = _ref5.taxonRank,
					    informalTaxonGroups = _ref5.informalTaxonGroups,
					    finnish = _ref5.finnish;

					if (!_this14.mounted) return;
					_this14.setState({ value: value, taxonRank: taxonRank, informalTaxonGroups: informalTaxonGroups, taxon: { scientificName: scientificName, vernacularName: vernacularName, cursiveName: cursiveName, finnish: finnish } });

					(0, _InformalTaxonGroupChooserWidget.getInformalGroups)(_this14.props.formContext.apiClient).then(function (_ref6) {
						var informalTaxonGroupsById = _ref6.informalTaxonGroupsById;

						if (!_this14.mounted) return;
						_this14.setState({ informalTaxonGroupsById: informalTaxonGroupsById });
					});
				});
				this.props.formContext.apiClient.fetchCached("/taxa/" + value + "/parents").then(function (parents) {
					if (!_this14.mounted) return;
					var state = { order: undefined, family: undefined };
					var _iteratorNormalCompletion = true;
					var _didIteratorError = false;
					var _iteratorError = undefined;

					try {
						for (var _iterator = (0, _getIterator3.default)(parents), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
							var parent = _step.value;
							var vernacularName = parent.vernacularName,
							    scientificName = parent.scientificName,
							    cursiveName = parent.cursiveName;

							if (parent.taxonRank === "MX.order") {
								state.order = { vernacularName: vernacularName, scientificName: scientificName, cursiveName: cursiveName };
							} else if (parent.taxonRank === "MX.family") {
								state.family = { vernacularName: vernacularName, scientificName: scientificName, cursiveName: cursiveName };
							}
							if (state.order && state.family) {
								_this14.setState(state);
								break;
							}
						}
					} catch (err) {
						_didIteratorError = true;
						_iteratorError = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion && _iterator.return) {
								_iterator.return();
							}
						} finally {
							if (_didIteratorError) {
								throw _iteratorError;
							}
						}
					}

					_this14.setState((0, _extends3.default)({}, state, { higherThanOrder: !state.order && !state.family }));
				});
				this.props.formContext.apiClient.fetchCached("/metadata/ranges/MX.taxonRankEnum").then(function (taxonRanks) {
					if (!_this14.mounted) return;
					_this14.setState({ taxonRanks: (0, _utils.dictionarify)(taxonRanks, function getKey(rank) {
							return rank.id;
						}, function getValue(rank) {
							return rank.value;
						}) });
				});
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _props4 = this.props,
			    id = _props4.id,
			    formContext = _props4.formContext,
			    value = _props4.value,
			    children = _props4.children,
			    placement = _props4.placement;
			var _state2 = this.state,
			    _state2$taxon = _state2.taxon,
			    taxon = _state2$taxon === undefined ? {} : _state2$taxon,
			    taxonRanks = _state2.taxonRanks,
			    taxonRank = _state2.taxonRank,
			    order = _state2.order,
			    family = _state2.family,
			    higherThanOrder = _state2.higherThanOrder,
			    _state2$informalTaxon = _state2.informalTaxonGroupsById,
			    informalTaxonGroupsById = _state2$informalTaxon === undefined ? {} : _state2$informalTaxon,
			    _state2$informalTaxon2 = _state2.informalTaxonGroups,
			    informalTaxonGroups = _state2$informalTaxon2 === undefined ? [] : _state2$informalTaxon2;


			var tooltipElem = _react2.default.createElement(
				_reactBootstrap.Tooltip,
				{ id: id + "-popover-tooltip" },
				formContext.translations.OpenSpeciedCard
			);

			var imageID = informalTaxonGroups[0];
			if (informalTaxonGroupsById[imageID] && informalTaxonGroupsById[imageID].parent) {
				imageID = informalTaxonGroupsById[imageID].parent.id;
			}

			var loading = !taxonRank || !(order || family || higherThanOrder) || !taxonRanks;

			var popover = _react2.default.createElement(
				_reactBootstrap.Popover,
				{ id: id + "-popover" },
				_react2.default.createElement(
					"div",
					{ className: "laji-form taxon-popover informal-group-image " + imageID },
					_react2.default.createElement(
						"div",
						null,
						_react2.default.createElement(
							_components.OverlayTrigger,
							{ overlay: tooltipElem },
							_react2.default.createElement(
								"a",
								{ href: "http://tun.fi/" + value, target: "_blank", rel: "noopener noreferrer" },
								taxon.vernacularName && _react2.default.createElement(
									_react2.default.Fragment,
									null,
									_react2.default.createElement(TaxonName, taxon),
									_react2.default.createElement("br", null)
								)
							)
						),
						_react2.default.createElement(
							"strong",
							null,
							formContext.translations.taxonomicRank,
							":"
						),
						" ",
						taxonRanks && taxonRank ? taxonRanks[taxonRank] : "",
						_react2.default.createElement("br", null),
						!higherThanOrder ? _react2.default.createElement(
							_react2.default.Fragment,
							null,
							_react2.default.createElement(
								"strong",
								null,
								formContext.translations.taxonGroups,
								":"
							),
							_react2.default.createElement(
								"ul",
								null,
								order && _react2.default.createElement(
									"li",
									null,
									_react2.default.createElement(TaxonName, order)
								),
								family && _react2.default.createElement(
									"li",
									null,
									_react2.default.createElement(TaxonName, family)
								)
							)
						) : _react2.default.createElement(
							_react2.default.Fragment,
							null,
							_react2.default.createElement("br", null),
							_react2.default.createElement("br", null)
						)
					),
					loading && _react2.default.createElement(_reactSpinner2.default, null)
				)
			);

			return _react2.default.createElement(
				_components.OverlayTrigger,
				{ hoverable: true,
					placement: placement,
					_context: new _Context2.default(this.props.formContext.contextId),
					overlay: popover },
				children
			);
		}
	}]);
	return TaxonCardOverlay;
}(_react.Component);

var InformalTaxonGroupsAddon = function (_Component9) {
	(0, _inherits3.default)(InformalTaxonGroupsAddon, _Component9);

	function InformalTaxonGroupsAddon(props) {
		(0, _classCallCheck3.default)(this, InformalTaxonGroupsAddon);

		var _this15 = (0, _possibleConstructorReturn3.default)(this, (InformalTaxonGroupsAddon.__proto__ || (0, _getPrototypeOf2.default)(InformalTaxonGroupsAddon)).call(this, props));

		_this15.onClear = function (e) {
			e.stopPropagation();
			if (_this15.props.onClear) _this15.props.onClear(undefined);
		};

		_this15.toggle = function () {
			if (_this15.props.onOpen) _this15.props.onOpen(!_this15.props.open);
		};

		_this15.renderGlyph = function () {
			var taxonGroupID = _this15.props.taxonGroupID;

			var imageID = taxonGroupID;
			var _this15$state$informa = _this15.state.informalTaxonGroupsById,
			    informalTaxonGroupsById = _this15$state$informa === undefined ? {} : _this15$state$informa;

			if (informalTaxonGroupsById[taxonGroupID] && informalTaxonGroupsById[taxonGroupID].parent) {
				imageID = informalTaxonGroupsById[taxonGroupID].parent.id;
			}
			return taxonGroupID ? _react2.default.createElement(
				"span",
				null,
				_react2.default.createElement("div", { className: "informal-group-image " + imageID }),
				_react2.default.createElement(
					"button",
					{ className: "close", onClick: _this15.onClear },
					"\xD7"
				)
			) : _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "menu-hamburger" });
		};

		_this15.state = {};
		return _this15;
	}

	(0, _createClass3.default)(InformalTaxonGroupsAddon, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this16 = this;

			this.mounted = true;
			(0, _InformalTaxonGroupChooserWidget.getInformalGroups)(this.props.formContext.apiClient).then(function (_ref7) {
				var informalTaxonGroupsById = _ref7.informalTaxonGroupsById;

				if (!_this16.mounted) return;
				_this16.setState({ informalTaxonGroupsById: informalTaxonGroupsById });
			});
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			return _react2.default.createElement(
				_components.TooltipComponent,
				{ tooltip: this.props.taxonGroupID && this.state.informalTaxonGroupsById ? this.state.informalTaxonGroupsById[this.props.taxonGroupID].name : this.props.formContext.translations.PickInformalTaxonGroup },
				_react2.default.createElement(
					_reactBootstrap.InputGroup.Addon,
					{ className: "autosuggest-input-addon informal-taxon-group-chooser", onClick: this.toggle, tabIndex: 0 },
					this.renderGlyph()
				)
			);
		}
	}]);
	return InformalTaxonGroupsAddon;
}(_react.Component);

var TaxonImgChooser = function (_Component10) {
	(0, _inherits3.default)(TaxonImgChooser, _Component10);

	function TaxonImgChooser(props) {
		(0, _classCallCheck3.default)(this, TaxonImgChooser);

		var _this17 = (0, _possibleConstructorReturn3.default)(this, (TaxonImgChooser.__proto__ || (0, _getPrototypeOf2.default)(TaxonImgChooser)).call(this, props));

		_this17.showModal = function () {
			_this17.setState({ modal: true });
		};

		_this17.hideModal = function () {
			_this17.setState({ modal: false });
		};

		_this17.onSelected = function () {
			_this17.props.onSelect(_this17.props.id, _this17.state.taxon);
			_this17.hideModal();
		};

		_this17.state = {};
		return _this17;
	}

	(0, _createClass3.default)(TaxonImgChooser, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this18 = this;

			this.mounted = true;
			this.props.formContext.apiClient.fetchCached("/taxa/" + this.props.id, { includeMedia: true }).then(function (taxon) {
				if (!_this18.mounted) return;

				if (taxon.multimedia && taxon.multimedia.length) {
					var _taxon$multimedia = (0, _slicedToArray3.default)(taxon.multimedia, 1),
					    media = _taxon$multimedia[0];

					_this18.setState({
						taxon: taxon,
						thumbnail: _this18.props.url || media.squareThumbnailURL || media.thumbnailURL,
						large: _this18.props.url || media.largeURL
					});
				} else {
					_this18.setState({ taxon: taxon });
				}
			});
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var _state3 = this.state,
			    thumbnail = _state3.thumbnail,
			    taxon = _state3.taxon,
			    modal = _state3.modal;
			var translations = this.props.formContext.translations;

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-medias" },
				_react2.default.createElement(
					"div",
					{ className: "taxon-img media-container interactive", style: { backgroundImage: "url(" + thumbnail + ")" }, onClick: this.showModal, tabIndex: 0 },
					!taxon && _react2.default.createElement(
						"div",
						{ className: "media-loading" },
						_react2.default.createElement(_reactSpinner2.default, null)
					),
					_react2.default.createElement(
						"span",
						null,
						taxon && taxon.vernacularName || ""
					)
				),
				modal && _react2.default.createElement(
					_reactBootstrap.Modal,
					{ dialogClassName: "laji-form media-modal", show: true, onHide: this.hideModal },
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						_react2.default.createElement("img", { src: this.state.large }),
						_react2.default.createElement(
							"div",
							null,
							_react2.default.createElement(
								"h3",
								{ className: "text-center" },
								_react2.default.createElement(TaxonName, (0, _extends3.default)({}, this.state.taxon, { finnish: false }))
							),
							_react2.default.createElement(
								_components.Button,
								{ block: true, onClick: this.onSelected },
								translations.Select
							),
							_react2.default.createElement(
								_components.Button,
								{ block: true, onClick: this.hideModal },
								translations.Cancel
							)
						)
					)
				)
			);
		}
	}]);
	return TaxonImgChooser;
}(_react.Component);

var TaxonName = function TaxonName(_ref8) {
	var scientificName = _ref8.scientificName,
	    _ref8$vernacularName = _ref8.vernacularName,
	    vernacularName = _ref8$vernacularName === undefined ? "" : _ref8$vernacularName,
	    cursiveName = _ref8.cursiveName,
	    finnish = _ref8.finnish;

	var _scientificName = vernacularName && scientificName ? "(" + scientificName + ")" : scientificName || "";
	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		"" + vernacularName + (vernacularName ? " " : ""),
		cursiveName ? _react2.default.createElement(
			"i",
			null,
			_scientificName
		) : _scientificName,
		renderFlag({ payload: { finnish: finnish } })
	);
};