"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _reactBootstrapSwitch = require("react-bootstrap-switch");

var _reactBootstrapSwitch2 = _interopRequireDefault(_reactBootstrapSwitch);

var _reactBootstrap = require("react-bootstrap");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CheckboxWidget = function (_Component) {
	(0, _inherits3.default)(CheckboxWidget, _Component);

	function CheckboxWidget() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, CheckboxWidget);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CheckboxWidget.__proto__ || (0, _getPrototypeOf2.default)(CheckboxWidget)).call.apply(_ref, [this].concat(args))), _this), _this.getNextVal = function () {
			var value = _this.props.value;

			var _getUiOptions = (0, _utils.getUiOptions)(_this.props),
			    _getUiOptions$allowUn = _getUiOptions.allowUndefined,
			    allowUndefined = _getUiOptions$allowUn === undefined ? true : _getUiOptions$allowUn;

			var nextVal = true;
			if (value === true) nextVal = false;else if (allowUndefined && value === false) nextVal = undefined;
			return nextVal;
		}, _this.onKeyDown = function (e) {
			var _this$props = _this.props,
			    disabled = _this$props.disabled,
			    onChange = _this$props.onChange,
			    readonly = _this$props.readonly;


			if (!disabled && !readonly && e.key === " " && ["shift", "alt", "ctrl"].every(function (special) {
				return !e[special + "Key"];
			})) {
				e.preventDefault();
				onChange(_this.getNextVal());
			}
		}, _this.onClick = function (e) {
			var _this$props2 = _this.props,
			    disabled = _this$props2.disabled,
			    onChange = _this$props2.onChange,
			    readonly = _this$props2.readonly;


			e.preventDefault();
			if (disabled || readonly) return;
			onChange(_this.getNextVal());
		}, _this.onSelectChange = function (value) {
			var _value = value === "true" ? true : value === "false" ? false : undefined;
			_this.props.onChange(_value);
		}, _this.onButtonGroupChange = function (value) {
			if (value === "undefined") {
				value = undefined;
			}
			_this.props.onChange(value);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(CheckboxWidget, [{
		key: "render",
		value: function render() {
			var _props = this.props,
			    value = _props.value,
			    disabled = _props.disabled,
			    registry = _props.registry,
			    readonly = _props.readonly,
			    label = _props.label;
			var _registry$formContext = registry.formContext.translations,
			    Yes = _registry$formContext.Yes,
			    No = _registry$formContext.No,
			    Unknown = _registry$formContext.Unknown;


			var options = (0, _utils.getUiOptions)(this.props);
			var _options$allowUndefin = options.allowUndefined,
			    allowUndefined = _options$allowUndefin === undefined ? true : _options$allowUndefin,
			    _options$showUndefine = options.showUndefined,
			    showUndefined = _options$showUndefine === undefined ? true : _options$showUndefine,
			    _options$invert = options.invert,
			    invert = _options$invert === undefined ? false : _options$invert,
			    _options$trueLabel = options.trueLabel,
			    trueLabel = _options$trueLabel === undefined ? Yes : _options$trueLabel,
			    _options$falseLabel = options.falseLabel,
			    falseLabel = _options$falseLabel === undefined ? No : _options$falseLabel,
			    _options$unknownLabel = options.unknownLabel,
			    unknownLabel = _options$unknownLabel === undefined ? Unknown : _options$unknownLabel,
			    _options$required = options.required,
			    required = _options$required === undefined ? this.props.required : _options$required,
			    help = options.help,
			    helpHoverable = options.helpHoverable,
			    helpPlacement = options.helpPlacement,
			    uiOptionsLabel = options.label;

			var hasLabel = !(0, _utils.isEmptyString)(label) && uiOptionsLabel !== false;

			// "undefined" for silencing ToggleButton warning.
			var _value = value === undefined ? "undefined" : value;

			var checkbox = allowUndefined || value === undefined ? _react2.default.createElement(
				_reactBootstrap.ButtonToolbar,
				{ className: "tristate-buttons" },
				_react2.default.createElement(
					_reactBootstrap.ToggleButtonGroup,
					{ type: "radio", defaultValue: [_value], name: this.props.id, onChange: this.onButtonGroupChange },
					_react2.default.createElement(
						_reactBootstrap.ToggleButton,
						{ disabled: disabled || readonly, value: true },
						trueLabel
					),
					_react2.default.createElement(
						_reactBootstrap.ToggleButton,
						{ disabled: disabled || readonly, value: false },
						falseLabel
					),
					showUndefined ? _react2.default.createElement(
						_reactBootstrap.ToggleButton,
						{ disabled: disabled || readonly, value: "undefined" },
						unknownLabel
					) : null
				)
			) : _react2.default.createElement(
				"div",
				{ onClick: this.onClick, onKeyDown: this.onKeyDown, className: "checkbox-container" },
				_react2.default.createElement(_reactBootstrapSwitch2.default, {
					value: allowUndefined && (0, _utils.isNullOrUndefined)(value) ? null : invert ? !value : value,
					defaultValue: allowUndefined ? null : false,
					disabled: disabled,
					readonly: readonly,
					onText: trueLabel,
					offText: falseLabel,
					bsSize: "mini",
					tristate: allowUndefined
				})
			);

			var Label = this.props.formContext.Label;

			return !hasLabel ? checkbox : _react2.default.createElement(
				Label,
				{ label: label, required: required, help: help, helpHoverable: helpHoverable, helpPlacement: helpPlacement, _context: new _Context2.default(this.props.formContext.contextId) },
				checkbox
			);
		}
	}, {
		key: "formatValue",
		value: function formatValue(value, options, props) {
			return value === undefined ? "" : value === true ? props.formContext.translations.Yes : props.formContext.translations.No;
		}
	}]);
	return CheckboxWidget;
}(_react.Component);

CheckboxWidget.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			allowUndefined: _propTypes2.default.bool,
			showUndefined: _propTypes2.default.bool,
			invert: _propTypes2.default.bool,
			trueLabel: _propTypes2.default.string,
			falseLabel: _propTypes2.default.string,
			unknownLabel: _propTypes2.default.string
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["boolean"])
	}),
	value: _propTypes2.default.bool
};
exports.default = CheckboxWidget;