"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _utils = require("../../utils");

var _reactInlinesvg = require("react-inlinesvg");

var _reactInlinesvg2 = _interopRequireDefault(_reactInlinesvg);

var _SelectWidget = require("./SelectWidget");

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ImageSelectWidget = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ImageSelectWidget, _Component);

	function ImageSelectWidget(props) {
		(0, _classCallCheck3.default)(this, ImageSelectWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (ImageSelectWidget.__proto__ || (0, _getPrototypeOf2.default)(ImageSelectWidget)).call(this, props));

		_this.renderImg = function (enumName, fallback) {
			var imgName = (0, _utils.getUiOptions)(_this.props).images[enumName];
			if (imgName === undefined) return fallback;

			var path = _this._context[enumName] || {};

			try {
				path.svg = _this.staticImgPath + "/" + imgName + ".svg";
				path.png = _this.staticImgPath + "/" + imgName + ".png";
			} finally {
				_this._context[enumName] = path;
				return _react2.default.createElement(
					"span",
					{ className: "select-icon" },
					_react2.default.createElement(
						_reactInlinesvg2.default,
						{ key: enumName, src: path.svg, cacheGetRequests: true },
						_react2.default.createElement("img", { src: path.png })
					)
				);
			}
		};

		_this._context = new _Context2.default("IMAGES");
		_this.staticImgPath = new _Context2.default().staticImgPath;
		return _this;
	}

	(0, _createClass3.default)(ImageSelectWidget, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			return _react2.default.createElement(_SelectWidget2.default, (0, _extends3.default)({}, this.props, {
				selectProps: {
					renderValue: function renderValue(item) {
						return _this2.renderImg(item.value, item.label);
					},
					renderOption: function renderOption(item) {
						return _react2.default.createElement(
							"div",
							null,
							_this2.renderImg(item.value, item.label),
							" ",
							_react2.default.createElement(
								"span",
								null,
								item.label
							)
						);
					}
				}
			}));
		}
	}]);
	return ImageSelectWidget;
}(_react.Component)) || _class;

ImageSelectWidget.propTypes = {
	options: _propTypes2.default.object.isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};
exports.default = ImageSelectWidget;