"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.getUUID = exports.assignUUID = exports.formDataEquals = exports.formDataIsEmpty = exports.filterItemIdsDeeply = exports.filterItemId = exports.filterLajiFormId = exports.idSchemaIdToJSONPointer = exports.JSONPointerToId = exports.formatErrorMessage = exports.isObject = undefined;

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

exports.isHidden = isHidden;
exports.isDefaultData = isDefaultData;
exports.hasData = hasData;
exports.propertyHasData = propertyHasData;
exports.getUpdateObjectFromJSONPath = getUpdateObjectFromJSONPath;
exports.getUpdateObjectFromJSONPointer = getUpdateObjectFromJSONPointer;
exports.immutableDelete = immutableDelete;
exports.getUiOptions = getUiOptions;
exports.getInnerUiSchema = getInnerUiSchema;
exports.isNullOrUndefined = isNullOrUndefined;
exports.isEmptyString = isEmptyString;
exports.parseJSONPointer = parseJSONPointer;
exports.getReactComponentName = getReactComponentName;
exports.isMultiSelect = isMultiSelect;
exports.getTabbableFields = getTabbableFields;
exports.getSchemaElementById = getSchemaElementById;
exports.isTabbableInput = isTabbableInput;
exports.canFocusNextInput = canFocusNextInput;
exports.findNearestParentSchemaElem = findNearestParentSchemaElem;
exports.findNearestParentSchemaElemId = findNearestParentSchemaElemId;
exports.findNearestParentTabbableElem = findNearestParentTabbableElem;
exports.getNextInputInInputs = getNextInputInInputs;
exports.getNextInput = getNextInput;
exports.focusNextInput = focusNextInput;
exports.focusById = focusById;
exports.getNestedTailUiSchema = getNestedTailUiSchema;
exports.updateTailUiSchema = updateTailUiSchema;
exports.getNestedUiFieldsList = getNestedUiFieldsList;
exports.getBootstrapCols = getBootstrapCols;
exports.isDescendant = isDescendant;
exports.getKeyHandlerTargetId = getKeyHandlerTargetId;
exports.handleKeysWith = handleKeysWith;
exports.capitalizeFirstLetter = capitalizeFirstLetter;
exports.decapitalizeFirstLetter = decapitalizeFirstLetter;
exports.stringifyKeyCombo = stringifyKeyCombo;
exports.canAdd = canAdd;
exports.bsSizeToPixels = bsSizeToPixels;
exports.pixelsToBsSize = pixelsToBsSize;
exports.applyFunction = applyFunction;
exports.getWindowScrolled = getWindowScrolled;
exports.getScrollPositionForScrollIntoViewIfNeeded = getScrollPositionForScrollIntoViewIfNeeded;
exports.scrollIntoViewIfNeeded = scrollIntoViewIfNeeded;
exports.filter = filter;
exports.updateSafelyWithJSONPath = updateSafelyWithJSONPath;
exports.updateSafelyWithJSONPointer = updateSafelyWithJSONPointer;
exports.injectButtons = injectButtons;
exports.dictionarify = dictionarify;
exports.formatValue = formatValue;
exports.checkRules = checkRules;
exports.checkArrayRules = checkArrayRules;
exports.focusAndScroll = focusAndScroll;
exports.shouldSyncScroll = shouldSyncScroll;
exports.syncScroll = syncScroll;
exports.bringRemoteFormData = bringRemoteFormData;
exports.triggerParentComponent = triggerParentComponent;
exports.parseSchemaFromFormDataPointer = parseSchemaFromFormDataPointer;
exports.parseUiSchemaFromFormDataPointer = parseUiSchemaFromFormDataPointer;
exports.checkJSONPointer = checkJSONPointer;
exports.schemaJSONPointer = schemaJSONPointer;
exports.uiSchemaJSONPointer = uiSchemaJSONPointer;
exports.updateFormDataWithJSONPointer = updateFormDataWithJSONPointer;
exports.addLajiFormIds = addLajiFormIds;
exports.getAllLajiFormIdsDeeply = getAllLajiFormIdsDeeply;
exports.findPointerForLajiFormId = findPointerForLajiFormId;
exports.getRelativePointer = getRelativePointer;
exports.getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId = getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId;
exports.getJSONPointerFromLajiFormIdAndRelativePointer = getJSONPointerFromLajiFormIdAndRelativePointer;
exports.highlightElem = highlightElem;
exports.getRelativeTmpIdTree = getRelativeTmpIdTree;
exports.filteredErrors = filteredErrors;
exports.constructTranslations = constructTranslations;
exports.getIdxWithOffset = getIdxWithOffset;
exports.getIdxWithoutOffset = getIdxWithoutOffset;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _utils = require("@rjsf/core/dist/cjs/utils");

var _reactBootstrap = require("react-bootstrap");

var _Context = require("./Context");

var _Context2 = _interopRequireDefault(_Context);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _utils2 = require("laji-map/lib/utils");

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isObject = exports.isObject = _utils2.isObject;

function isHidden(uiSchema, property) {
	if (!uiSchema) return false;
	if (uiSchema[property]) uiSchema = uiSchema[property];
	return !uiSchema || uiSchema["ui:widget"] == "HiddenWidget" || uiSchema["ui:field"] == "HiddenField";
}

function isDefaultData(formData, schema) {
	var definitions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	switch (schema.type) {
		case "object":
			return (0, _keys2.default)(schema.properties).every(function (field) {
				return isDefaultData(formData[field], schema.properties[field], definitions);
			});
		case "array":
			return (Array.isArray(formData) || formData === undefined) && (formData || []).every(function (item) {
				return isDefaultData(item, schema.items, definitions);
			});
		default:
			return formData === (0, _utils.getDefaultFormState)(schema, undefined, definitions);
	}
}

/**
 * If you use this with schema data, note that this function doesn't check default data.
 */
function hasData(formData) {
	function hasValue(value) {
		return value !== undefined && value !== null && value !== "";
	}
	if (!formData && !hasValue(formData)) return false;else {
		if (!Array.isArray(formData)) formData = [formData];
		return formData.some(function (data) {
			if (isObject(data)) {
				return (0, _keys2.default)(data).some(function (_field) {
					return propertyHasData(_field, data);
				});
			} else return hasValue(data);
		});
	}
}

/**
 * If you use this with schema data, note that this function doesn't check default data.
 */
function propertyHasData(field, container) {
	if (!container) return false;
	var data = container[field];
	return !!(data && (!isObject(data) || (0, _keys2.default)(data).length > 0 && hasData(data)) && (!Array.isArray(data) || data.length > 0 && hasData(data)));
}

function getUpdateObjectFromJSONPath() {
	console.warn("'getUpdateObjectFromJSONPath' works with JSON pointers, not JSON path! This function is deprecated and will be removed in the future, please use 'getUpdateObjectFromJSONPointer' instead");
	return getUpdateObjectFromJSONPointer.apply(undefined, arguments);
}
function getUpdateObjectFromJSONPointer(path, injection) {
	var update = {};
	var updatePointer = update;
	var lastPathName = "";
	var splittedPath = path.split("/").filter(function (s) {
		return !isEmptyString(s);
	});
	splittedPath.forEach(function (pathStep, i) {
		updatePointer[pathStep] = {};
		if (i < splittedPath.length - 1) updatePointer = updatePointer[pathStep];
		lastPathName = pathStep;
	});

	updatePointer[lastPathName] = injection;
	return update;
}

function immutableDelete(_obj, _delProp) {
	var simple = function simple(obj, delProp) {
		if (!obj.hasOwnProperty(delProp)) {
			return obj;
		}
		var newObj = {};
		(0, _keys2.default)(obj).forEach(function (prop) {
			if (prop !== delProp) newObj[prop] = obj[prop];
		});
		return newObj;
	};

	if (_delProp[0] === "/") {
		var splits = _delProp.split("/");
		var last = splits.pop();
		var container = parseJSONPointer(_obj, splits.join("/"));
		return updateSafelyWithJSONPointer(_obj, simple(container, last), splits.join("/"));
	} else {
		return simple(_obj, _delProp);
	}
}

function getUiOptions(container) {
	if (container) {
		var options = container["ui:options"] || container.options;
		return options ? options : {};
	}
	return {};
}

function getInnerUiSchema(parentUiSchema) {
	var _ref = parentUiSchema || {},
	    uiSchema = _ref.uiSchema,
	    restOfUiSchema = (0, _objectWithoutProperties3.default)(_ref, ["uiSchema"]);

	if (uiSchema && (new _Context2.default("VIRTUAL_SCHEMA_NAMES")[uiSchema["ui:field"]] || new _Context2.default("SCHEMA_FIELD_WRAPPERS")[uiSchema["ui:field"]]) && parentUiSchema["ui:buttons"]) {
		uiSchema = (0, _extends3.default)({}, uiSchema, {
			"ui:buttons": [].concat((0, _toConsumableArray3.default)(uiSchema["ui:buttons"] || []), (0, _toConsumableArray3.default)(parentUiSchema["ui:buttons"]))
		});
	}
	return (0, _extends3.default)({}, restOfUiSchema, {
		"ui:field": undefined,
		"ui:settings": undefined,
		"ui:options": uiSchema ? undefined : restOfUiSchema["ui:options"],
		"ui:buttons": uiSchema ? undefined : parentUiSchema["ui:buttons"]
	}, uiSchema || {});
}

function isNullOrUndefined(val) {
	return val === null || val === undefined;
}

function isEmptyString(val) {
	return val === "" || isNullOrUndefined(val);
}

function parseJSONPointer(object, jsonPointer, safeMode) {
	var strictEmptyPath = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

	var splitPath = String(jsonPointer).split("/");
	if (jsonPointer[0] === "/") {
		splitPath = splitPath.splice(1);
	}
	if (!strictEmptyPath) {
		splitPath = splitPath.filter(function (s) {
			return !isEmptyString(s);
		});
	}
	return splitPath.reduce(function (o, s, i) {
		if (safeMode && !o || !(s in o)) {
			if (!o) o = {};
			if (safeMode === "createParents") {
				o[s] = {};
			} else if (i < splitPath.length - 1) {
				return {};
			}
		}
		return o[s];
	}, object);
}

function getReactComponentName(WrappedComponent) {
	return WrappedComponent.displayName || WrappedComponent.name || "Component";
}

function isMultiSelect(schema, uiSchema) {
	return (0, _utils.isMultiSelect)(schema) && !(schema.type === "array" && uiSchema && uiSchema.items && uiSchema.items["ui:field"]);
}

var SWITCH_CLASS = "bootstrap-switch";

var inputTypes = ["input", "select", "textarea"];
var tabbableSelectors = inputTypes.slice(0);
tabbableSelectors.push("." + SWITCH_CLASS + ":not(." + SWITCH_CLASS + "-disabled)");
tabbableSelectors = tabbableSelectors.map(function (type) {
	return type + ":not([type=\"hidden\"]):not(:disabled):not([readonly]):not([type=\"file\"]):not(.leaflet-control-layers-selector):not(.laji-map-input)";
});

function getTabbableFields(elem, reverse) {
	var fieldsNodeList = elem.querySelectorAll(tabbableSelectors.join(", "));
	var fields = [].concat((0, _toConsumableArray3.default)(fieldsNodeList));

	if (reverse) fields = fields.reverse();
	return fields;
}

function getSchemaElementById(contextId, id) {
	return document.getElementById("_laji-form_" + contextId + "_" + id);
}

function isTabbableInput(elem) {
	return elem.id.match(/^_laji-form_/) || inputTypes.indexOf(elem.tagName.toLowerCase()) !== -1 || elem.className.indexOf(SWITCH_CLASS) !== -1;
}

function canFocusNextInput(root, inputElem) {
	return (0, _reactDom.findDOMNode)(root).querySelectorAll && isTabbableInput(inputElem);
}

function findNearestParentSchemaElem(elem) {
	while (elem && !("id" in elem ? elem.id : "").match(/^_laji-form_/)) {
		elem = elem.parentNode;
	}
	return elem;
}

function findNearestParentSchemaElemId(contextId, elem) {
	var nearestParentSchemaElem = findNearestParentSchemaElem(elem) || document.getElementById("_laji-form_" + contextId + "_root");
	return nearestParentSchemaElem ? nearestParentSchemaElem.id.replace("_laji-form_" + contextId + "_", "") : undefined;
}

function findNearestParentTabbableElem(elem) {
	while (!isTabbableInput(elem)) {
		elem = elem.parentNode;
	}
	return elem;
}

function getNextInputInInputs(formReactNode, inputElem, reverseDirection, fields) {
	var formElem = (0, _reactDom.findDOMNode)(formReactNode);
	if (!inputElem) inputElem = findNearestParentTabbableElem(document.activeElement);
	if (reverseDirection) {
		fields = fields.reverse();
	}

	if (!canFocusNextInput(formElem, inputElem)) return;

	var found = false;
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = (0, _getIterator3.default)(fields), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var field = _step.value;

			if (field === inputElem) {
				found = true;
				continue;
			}

			if (found) {
				// Skip hidden fields.
				if (!field.offsetParent) {
					continue;
				}
				return field;
			}
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}
}

function getNextInput(formReactNode, inputElem, reverseDirection) {
	var formElem = (0, _reactDom.findDOMNode)(formReactNode);
	var fields = getTabbableFields(formElem);
	return getNextInputInInputs(formReactNode, inputElem, reverseDirection, fields);
}

function focusNextInput() {
	for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
		params[_key] = arguments[_key];
	}

	var _params$0$props$uiSch = params[0].props.uiSchema,
	    uiSchema = _params$0$props$uiSch === undefined ? {} : _params$0$props$uiSch;

	if (uiSchema.autoFocus === false) {
		return false;
	}
	var width = pixelsToBsSize(window.outerWidth);
	if (width === "xs") return false;
	var field = getNextInput.apply(undefined, params);
	if (field) {
		field.focus();
		return true;
	}
	return false;
}

function focusById() {
	var formContext = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var id = arguments[1];
	var focus = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

	var elem = getSchemaElementById(formContext.contextId, id);
	if (elem && document.body.contains(elem)) {
		var tabbableFields = getTabbableFields(elem);
		if (tabbableFields && tabbableFields.length) {
			focus && tabbableFields[0].focus();
			scrollIntoViewIfNeeded(elem, formContext.topOffset, formContext.bottomOffset);
			var _context = new _Context2.default(formContext.contextId);
			_context.lastIdToFocus = id; // Mark for components that manipulate scroll positions
			_context.windowScrolled = getWindowScrolled();
			return true;
		}
	}
	return false;
}

function getNestedTailUiSchema(uiSchema) {
	while (uiSchema && uiSchema.uiSchema) {
		uiSchema = uiSchema.uiSchema;
	}
	return uiSchema;
}

function updateTailUiSchema(uiSchema, updateObject) {
	var tailPointer = {};
	var root = tailPointer;
	var uiSchemaPointer = uiSchema;
	while (uiSchemaPointer.uiSchema) {
		uiSchemaPointer = uiSchemaPointer.uiSchema;
		tailPointer.uiSchema = {};
		if (uiSchemaPointer.uiSchema) tailPointer = tailPointer.uiSchema;
	}
	tailPointer.uiSchema = updateObject;
	return (0, _immutabilityHelper2.default)(uiSchema, root);
}

function getNestedUiFieldsList(uiSchema) {
	var list = [];
	while (uiSchema.uiSchema && uiSchema.uiSchema["ui:field"]) {
		list.push(uiSchema.uiSchema["ui:field"]);
		uiSchema = uiSchema.uiSchema;
	}
	return list;
}

function getBootstrapCols(width) {
	return ["lg", "md", "sm", "xs"].reduce(function (o, c) {
		o[c] = width;
		return o;
	}, {});
}

function isDescendant(parent, child) {
	var node = child.parentNode;
	while (node != null) {
		if (node == parent) {
			return true;
		}
		node = node.parentNode;
	}
	return false;
}

function getKeyHandlerTargetId() {
	var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
	var context = arguments[1];
	var formData = arguments[2];
	// eslint-disable-line no-unused-vars
	while (target.match(/%\{([^{}]*)\}/)) {
		var path = /%\{([^{}]*)\}/.exec(target)[1];
		if (!path.startsWith("context") && !path.startsWith("formData")) throw Error("Should evaluate 'context' or 'formData'");
		target = target.replace("%{" + path + "}", eval(path));
	}
	return target;
}

function handleKeysWith(context, id) {
	var keyFunctions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	var e = arguments[3];
	var additionalParams = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

	if (context.blockingLoaderCounter > 0 && !isDescendant(document.querySelector(".pass-block"), e.target)) {
		e.preventDefault();
		return;
	}

	if (isDescendant(document.querySelector(".laji-map"), e.target)) return;

	function handleKey(keyHandler) {
		var returnValue = keyFunctions[keyHandler.fn](e, (0, _extends3.default)({}, keyHandler, additionalParams));
		var eventHandled = returnValue !== undefined ? returnValue : true;
		if (eventHandled) {
			e.preventDefault();
			e.stopPropagation();
		}
		return eventHandled;
	}

	var highPriorityHandled = context.keyHandlers.some(function (keyHandler) {
		var target = getKeyHandlerTargetId(keyHandler.target, context);
		if (keyFunctions[keyHandler.fn] && "target" in keyHandler && id.match(target) && keyHandler.conditions.every(function (condition) {
			return condition(e);
		})) {
			if (!handleKey(keyHandler)) {
				e.preventDefault();
				e.stopPropagation();
			}
			return true;
		}
	});

	if (highPriorityHandled) return highPriorityHandled;

	return context.keyHandlers.some(function (keyHandler) {
		if (keyFunctions[keyHandler.fn] && keyHandler.conditions.every(function (condition) {
			return condition(e);
		})) {
			return handleKey(keyHandler);
		}
	});
}

function capitalizeFirstLetter(string) {
	return string.charAt(0).toUpperCase() + string.slice(1);
}
function decapitalizeFirstLetter(string) {
	return string.charAt(0).toLowerCase() + string.slice(1);
}

function stringifyKeyCombo() {
	var keyCombo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

	return keyCombo.split("+").map(function (key) {
		if (key === " ") key = "space";
		return capitalizeFirstLetter(key);
	}).join(" + ");
}

function canAdd(props) {
	return (!("canAdd" in props) || props.canAdd) && getUiOptions(props.uiSchema).canAdd !== false;
}

function bsSizeToPixels(bsSize) {
	switch (bsSize) {
		case "lg":
			return 1200;
		case "md":
			return 992;
		case "sm":
			return 768;
		case "xs":
			return 576;
		default:
			throw new Error("Unknown bootstrap size " + bsSize + ". Should be one of 'lg', 'md', 'sm' or 'xs'");
	}
}

function pixelsToBsSize(pixels) {
	if (pixels < 576) {
		return "xs";
	} else if (pixels < 768) {
		return "sm";
	} else if (pixels < 992) {
		return "md";
	} else if (pixels < 1200) {
		return "lg";
	}
}

function applyFunction(props) {
	var _ref2 = props.uiSchema || {},
	    functions = _ref2["ui:functions"],
	    childFunctions = _ref2["ui:childFunctions"];

	var objectOrArrayAsArray = function objectOrArrayAsArray(item) {
		return item ? Array.isArray(item) ? item : [item] : [];
	};

	if (childFunctions) {
		functions = [{ "ui:field": "UiFieldMapperArrayField", "ui:options": { functions: objectOrArrayAsArray(childFunctions) } }].concat((0, _toConsumableArray3.default)(objectOrArrayAsArray(functions)));
	}

	if (!functions) return props;

	var computedProps = (Array.isArray(functions) ? functions : [functions]).reduce(function (_props, _ref3) {
		var uiField = _ref3["ui:field"],
		    uiOptions = _ref3["ui:options"];

		_props = (0, _extends3.default)({}, _props, { uiSchema: (0, _extends3.default)({}, _props.uiSchema, { "ui:field": uiField, "ui:options": uiOptions, uiSchema: undefined }) });

		var _ref4 = new props.registry.fields[uiField](_props),
		    _ref4$state = _ref4.state,
		    state = _ref4$state === undefined ? {} : _ref4$state;

		return (0, _extends3.default)({}, _props, state);
	}, (0, _extends3.default)({}, props, { formContext: props.registry.formContext }));

	return (0, _extends3.default)({}, computedProps, {
		uiSchema: (0, _extends3.default)({}, computedProps.uiSchema, {
			"ui:functions": undefined,
			"ui:childFunctions": undefined,
			"ui:field": props.uiSchema["ui:field"],
			"ui:options": props.uiSchema["ui:options"],
			uiSchema: props.uiSchema.uiSchema
		})
	});
}

function getWindowScrolled() {
	return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
}

function getScrollPositionForScrollIntoViewIfNeeded(elem) {
	var topOffset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	var bottomOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

	if (!elem) return;
	var rect = elem.getBoundingClientRect();
	var html = document.documentElement;
	var height = elem.scrollHeight;
	var inView = rect.top >= topOffset && rect.bottom <= (window.innerHeight || html.clientHeight) - bottomOffset;
	var elemTopDistFromViewportTop = rect.top;
	var viewportHeight = window.innerHeight || html.clientHeight;
	var elemBottomDistFromViewportBottom = -(elemTopDistFromViewportTop + height - viewportHeight);
	var pageScrolled = getWindowScrolled();

	if (inView) return pageScrolled;

	// Priorize scrolling the top of the element into view if showing the bottom would obscure the top of the element.
	if (pageScrolled + elemTopDistFromViewportTop - topOffset > elemTopDistFromViewportTop) {
		return pageScrolled + elemTopDistFromViewportTop - topOffset;
	} else {
		return pageScrolled - elemBottomDistFromViewportBottom + bottomOffset;
	}
}

function scrollIntoViewIfNeeded(elem) {
	var topOffset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	var bottomOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

	window.scrollTo(0, getScrollPositionForScrollIntoViewIfNeeded(elem, topOffset, bottomOffset));
}

function filter(properties, filter) {
	var filterType = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "blacklist";
	var getValue = arguments[3];

	var filterDictionary = {};
	filter.forEach(function (_enum) {
		filterDictionary[_enum] = true;
	});
	var filterFn = function filterFn(item) {
		var value = getValue ? getValue(item) : item;
		return filterDictionary[value];
	};
	return properties.filter(filterType === "whitelist" ? filterFn : function (e) {
		return !filterFn(e);
	});
}

function updateSafelyWithJSONPath() {
	console.warn("'updateSafelyWithJSONPath' works with JSON pointers, not JSON path! This function is deprecated and will be removed in the future, please use 'updateSafelyWithJSONPointer' instead");
	return updateSafelyWithJSONPointer.apply(undefined, arguments);
}
function updateSafelyWithJSONPointer(obj, value, path) {
	var immutably = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
	var createNew = arguments[4];

	if (!createNew) {
		createNew = function createNew() {
			return {};
		};
	}
	if (!immutably) {
		var splitted = path.split("/").filter(function (s) {
			return !isEmptyString(s);
		});
		splitted.reduce(function (o, split, i) {
			if (i === splitted.length - 1) {
				o[split] = value;
				return;
			}
			if (!o[split]) {
				o[split] = createNew(o, split);
			}
			return o[split];
		}, obj);
		return obj;
	}

	var injectionTarget = false;
	try {
		injectionTarget = parseJSONPointer(obj, path);
	} catch (e) {
		injectionTarget = makePath(injectionTarget);
	}

	// If path for injection doesn't exist, we create it immutably.
	if (!injectionTarget) {
		injectionTarget = makePath(injectionTarget);
	}

	var updateObject = getUpdateObjectFromJSONPointer(path, { $set: value });
	return (0, _immutabilityHelper2.default)(obj, updateObject);

	function makePath(injectionTarget) {
		var splitPath = path.split("/").filter(function (s) {
			return !isEmptyString(s);
		});
		var _splitPath = "";
		splitPath.reduce(function (o, split) {
			_splitPath += "/" + split;
			if (process.env.NODE_ENV === "production") {
				// Fixes an uglifyJS bug on laji.fi-front. You gotta just show some love.
				console.log("i love uglifyjs!"); // eslint-disable-line no-console
			}
			if (!o[split]) {
				obj = (0, _immutabilityHelper2.default)(obj, getUpdateObjectFromJSONPointer(_splitPath, { $set: createNew(obj, _splitPath, o, split) }));
			}
			var next = parseJSONPointer(obj, _splitPath);
			injectionTarget = next;
			return next;
		}, obj);

		return injectionTarget;
	}
}

function injectButtons(uiSchema, buttons, buttonsPath) {
	var existingButtons = parseJSONPointer(uiSchema, buttonsPath + "/ui:options/buttons");
	return updateSafelyWithJSONPointer(uiSchema, existingButtons ? [].concat((0, _toConsumableArray3.default)(existingButtons), (0, _toConsumableArray3.default)(buttons)) : buttons, buttonsPath + "/ui:options/buttons");
}

function dictionarify(array, getKey, getValue) {
	return array.reduce(function (o, k) {
		o[getKey ? getKey(k) : k] = getValue ? getValue(k) : true;
		return o;
	}, {});
}

var tableFormatters = {
	unknownTaxon: function unknownTaxon(item, formatted, options) {
		var parentProps = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

		return isEmptyString(item) || (parentProps.formData || {})[options.idField] ? formatted : _react2.default.createElement(
			"span",
			null,
			formatted,
			" ",
			_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "warning-sign", bsClass: "glyphicon glyphicon-warning-sign text-warning" })
		);
	}
};
function formatValue(props, _formatter, parentProps) {
	var formData = props.formData,
	    _props$uiSchema = props.uiSchema,
	    uiSchema = _props$uiSchema === undefined ? {} : _props$uiSchema,
	    schema = props.schema,
	    registry = props.registry;


	var formatter = undefined;
	var formatterComponent = undefined;
	if (uiSchema["ui:widget"]) formatterComponent = registry.widgets[uiSchema["ui:widget"]];else if (schema.type === "boolean") formatterComponent = registry.widgets.CheckboxWidget;else if (uiSchema["ui:field"]) formatterComponent = registry.fields[uiSchema["ui:field"]];

	if (formatterComponent && formatterComponent.prototype && formatterComponent.prototype.formatValue) {
		formatter = formatterComponent.prototype.formatValue;
	} else if (formatterComponent && formatterComponent.prototype && formatterComponent.prototype.__proto__ && formatterComponent.prototype.__proto__.formatValue) {
		formatter = formatterComponent.prototype.__proto__.formatValue;
	}

	var arrayJoiner = function arrayJoiner(value, i, length) {
		var separator = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "; ";

		var comma = _react2.default.createElement(
			_react2.default.Fragment,
			{ key: "_" + i },
			separator
		);
		return i < length - 1 ? [value, comma] : [value];
	};

	var formatted = formData;
	if (formatter) {
		formatted = formatter(formData, getUiOptions(uiSchema), props, parentProps);
	} else if (isEmptyString(formData)) {
		formatted = "";
	} else if (isMultiSelect(schema)) {
		formatted = formData.map(function (_val) {
			return schema.items.enumNames[schema.items.enum.indexOf(_val)];
		}).join(", ");
	} else if (schema.type === "object") {
		var keys = (0, _keys2.default)(formData);
		return keys.map(function (_col, i) {
			var child = _react2.default.createElement(
				_react2.default.Fragment,
				{ key: _col },
				formatValue((0, _extends3.default)({}, props, { schema: schema.properties[_col], uiSchema: uiSchema[_col], formData: formData[_col] }))
			);
			return arrayJoiner(child, i, keys.length);
		});
	} else if (schema.type === "array") {
		formatted = _react2.default.createElement(
			"span",
			{ className: "single-active-array-table-array" },
			formData.map(function (_val, i) {
				var child = _react2.default.createElement(
					_react2.default.Fragment,
					{ key: i },
					formatValue((0, _extends3.default)({}, props, { schema: props.schema.items, uiSchema: uiSchema.items, formData: _val }))
				);

				return arrayJoiner(child, i, formData.length, "; ");
			})
		);
	} else if ((0, _utils.isSelect)(schema)) {
		formatted = isEmptyString(formData) ? formData : schema.enumNames[schema.enum.indexOf(formData)];
	} else if (schema.type === "boolean") {
		formatted = props.formContext.translations[formData ? "yes" : "no"];
	}

	if (_formatter) {
		formatted = tableFormatters[_formatter.formatter](formData, formatted, _formatter, parentProps);
	}

	return formatted;
}

var formatErrorMessage = exports.formatErrorMessage = function formatErrorMessage(msg) {
	return msg.replace(/^\[.*\]/, "");
};

function checkRules(rules, props, cache) {
	var prop = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "formData";

	var passes = (Array.isArray(rules) ? rules : [rules]).every(function (rule, idx) {
		var passes = void 0;
		if (rule === "isAdmin") {
			passes = props.formContext.uiSchemaContext.isAdmin;
		} else if (rule === "isEdit") {
			passes = props.formContext.uiSchemaContext.isEdit;
		} else {
			var field = rule.field,
			    regexp = rule.regexp,
			    valueIn = rule.valueIn,
			    valueIncludes = rule.valueIncludes,
			    valueLengthLessThan = rule.valueLengthLessThan;

			var value = parseJSONPointer(props[prop] || {}, field);
			if (value === undefined) value = "";
			if (regexp) {
				passes = ("" + value).match(new RegExp(regexp));
			} else if (valueIn) {
				if (cache) {
					if (!cache[idx]) {
						cache[idx] = dictionarify(valueIn);
					}
					passes = cache[idx][value];
				} else {
					passes = dictionarify(valueIn)[value];
				}
			} else if (valueIncludes !== undefined) {
				passes = value.indexOf(valueIncludes) !== -1;
			} else if (valueLengthLessThan !== undefined) {
				passes = value.length < valueLengthLessThan;
			}
		}
		return rule.complement ? !passes : passes;
	});

	return cache ? { passes: passes, cache: cache } : passes;
}

function checkArrayRules(rules, props, idx, cache) {
	var prop = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "formData";

	var arrayRules = (Array.isArray(rules) ? rules : [rules]).filter(function (rule) {
		return ["isLast", "idx"].some(function (r) {
			return r in rule;
		});
	});
	var passes = arrayRules.every(function (rule) {
		var passes = void 0;
		if ("isLast" in rule) {
			passes = idx === props.formData.length - 1 === rule.isLast;
		} else if ("idx" in rule) {
			passes = idx === rule.idx;
		}
		if (passes !== undefined) {
			return rule.complement ? !passes : passes;
		}
		return true;
	});
	var nonArrayRules = (Array.isArray(rules) ? rules : [rules]).filter(function (rule) {
		return !(arrayRules.indexOf(rule) !== -1);
	});
	if (nonArrayRules.length) {
		var nonArrayRulesCheck = checkRules(nonArrayRules, (0, _extends3.default)({}, props, { formData: props.formData[idx] }), cache, prop);
		var allPass = passes && nonArrayRulesCheck.passes;
		if (cache) {
			return { passes: allPass, cache: cache };
		} else {
			return allPass;
		}
	} else {
		return cache ? { cache: cache, passes: passes } : passes;
	}
}

function focusAndScroll(formContext, idToFocus, idToScroll) {
	var focus = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
	var contextId = formContext.contextId,
	    topOffset = formContext.topOffset,
	    bottomOffset = formContext.bottomOffset;

	var _context = new _Context2.default(contextId);
	if (idToFocus === undefined && idToScroll === undefined) return;
	if (idToFocus && !focusById(formContext, getKeyHandlerTargetId(idToFocus, _context), focus)) return false;
	if (idToScroll) {
		var elemToScroll = document.getElementById(getKeyHandlerTargetId(idToScroll, _context));
		var elemToFocus = getSchemaElementById(contextId, getKeyHandlerTargetId(idToFocus, _context));
		if (!elemToScroll || !elemToFocus) {
			return end();
		}
		var wouldScrollTo = getScrollPositionForScrollIntoViewIfNeeded(elemToScroll, topOffset, bottomOffset);
		var scrollAmount = wouldScrollTo - getWindowScrolled();

		var _elemToFocus$getBound = elemToFocus.getBoundingClientRect(),
		    top = _elemToFocus$getBound.top;

		var viewTopDistanceFromTop = top - scrollAmount;

		// Don't scroll if scrolling would hide focused elem top.
		if (viewTopDistanceFromTop < topOffset) {
			return end();
		} else {
			scrollIntoViewIfNeeded(elemToScroll, topOffset, bottomOffset);
		}
	}
	return end();

	function end() {
		_context.lastIdToScroll = idToScroll;
		_context.lastIdToFocus = idToFocus;
		_context.windowScrolled = getWindowScrolled();
		return true;
	}
}

function shouldSyncScroll(formContext) {
	return new _Context2.default(formContext.contextId).windowScrolled === getWindowScrolled();
}

function syncScroll(formContext) {
	var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

	if (force || shouldSyncScroll(formContext)) {
		var _ref5 = new _Context2.default(formContext.contextId),
		    lastIdToFocus = _ref5.lastIdToFocus,
		    lastIdToScroll = _ref5.lastIdToScroll;

		focusAndScroll(formContext, lastIdToFocus, lastIdToScroll, false);
	}
}

function bringRemoteFormData(formData, formContext) {
	if (formContext.formDataTransformers) {
		return formContext.formDataTransformers.reduce(function (formData, _ref6) {
			var uiField = _ref6["ui:field"],
			    fieldProps = _ref6.props;

			var _ref7 = new fieldProps.registry.fields[uiField]((0, _extends3.default)({}, fieldProps, { formData: formData })),
			    _ref7$state = _ref7.state,
			    state = _ref7$state === undefined ? {} : _ref7$state;

			return state.formData;
		}, formData);
	} else {
		return formData;
	}
}

function triggerParentComponent(eventName, e, props) {
	if (props && props[eventName]) {
		e.persist && e.persist();
		props[eventName](e);
	}
}

function parseSchemaFromFormDataPointer(schema, pointer) {
	var splits = pointer.split("/").filter(function (s) {
		return !isEmptyString(s);
	});
	var value = splits.reduce(function (o, s) {
		if (!isNaN(parseInt(s))) {
			return o.items;
		}
		if (o.type === "array" && o.items.properties[s]) return o.items.properties[s];
		if (o.type === "array") return o.items;
		return o.properties[s];
	}, schema);
	return value;
}

function parseUiSchemaFromFormDataPointer(uiSchema, pointer) {
	var splits = pointer.split("/").filter(function (s) {
		return !isEmptyString(s);
	});
	return splits.reduce(function (o, s) {
		if (!isNaN(parseInt(s))) {
			return o.items;
		}
		if (o && o.items) return o.items[s];
		return o ? o[s] : {};
	}, uiSchema);
}

function checkJSONPointer(obj, pointer) {
	if (!obj) return false;
	var splits = pointer.split("/").filter(function (s) {
		return !isEmptyString(s);
	});
	pointer = obj;
	try {
		return splits.every(function (split) {
			var exists = pointer.hasOwnProperty(split);
			pointer = pointer[split];
			return exists;
		});
	} catch (e) {
		return false;
	}
}

var JSONPointerToId = exports.JSONPointerToId = function JSONPointerToId(fieldName) {
	return fieldName[0] === "/" ? fieldName.replace(/(?!^)\//g, "_").substr(1) : fieldName;
};

var idSchemaIdToJSONPointer = exports.idSchemaIdToJSONPointer = function idSchemaIdToJSONPointer(id) {
	return id.replace(/root_|_/g, "/");
};

function schemaJSONPointer(schema, JSONPointer) {
	if (JSONPointer[0] !== "/") {
		JSONPointer = "/" + JSONPointer;
	}

	var schemaPointer = schema;
	return JSONPointer.split("/").filter(function (s) {
		return !isEmptyString(s);
	}).reduce(function (path, s) {
		if (schemaPointer[s]) {
			schemaPointer = schemaPointer[s];
			return path + "/" + s;
		} else if (!isNaN(s) && schemaPointer.items) {
			schemaPointer = schemaPointer.items;
			return path + "/items";
		} else if (schemaPointer.properties && schemaPointer.properties[s]) {
			schemaPointer = schemaPointer.properties[s];
			return path + "/properties/" + s;
		}
		return undefined;
	}, "");
}

function uiSchemaJSONPointer(schema, JSONPointer) {
	if (JSONPointer[0] !== "/") return JSONPointer;

	var schemaPointer = schema;
	return JSONPointer.split("/").filter(function (s) {
		return !isEmptyString(s);
	}).reduce(function (path, s) {
		if (schemaPointer[s]) {
			schemaPointer = schemaPointer[s];
			return path + "/" + s;
		} else if (schemaPointer.properties && schemaPointer.properties[s]) {
			schemaPointer = schemaPointer.properties[s];
			return path + "/" + s;
		} else if (schemaPointer.items.properties && schemaPointer.items.properties[s]) {
			schemaPointer = schemaPointer.items.properties[s];
			return path + "/items/" + s;
		} else if (!isNaN(s) && schemaPointer.items) {
			schemaPointer = schemaPointer.items;
			return path + "/items";
		}
		return undefined;
	}, "");
}

function updateFormDataWithJSONPointer(schemaProps, value, path) {
	if (path === "/") {
		return value;
	}
	return updateSafelyWithJSONPointer(schemaProps.formData, value, path, !!"immutably", function (__formData, _path) {
		var _schema = parseJSONPointer(schemaProps.schema, schemaJSONPointer(schemaProps.schema, _path));
		var _default = (0, _utils.getDefaultFormState)(_schema, undefined, schemaProps.registry.definitions);
		if (!_default && _schema.type === "array") {
			return [];
		}
		return _default;
	});
}

var filterLajiFormId = function filterLajiFormId(item) {
	if (item && item._lajiFormId) {
		var _item2 = item,
		    _lajiFormId = _item2._lajiFormId,
		    _item = (0, _objectWithoutProperties3.default)(_item2, ["_lajiFormId"]); // eslint-disable-line no-unused-vars


		item = _item;
	}
	return item;
};

exports.filterLajiFormId = filterLajiFormId;
var filterItemId = function filterItemId(item) {
	if (item && (item._lajiFormId || item.id)) {
		var _item3 = item,
		    _lajiFormId = _item3._lajiFormId,
		    id = _item3.id,
		    _item = (0, _objectWithoutProperties3.default)(_item3, ["_lajiFormId", "id"]); // eslint-disable-line no-unused-vars


		item = _item;
	}
	return item;
};

exports.filterItemId = filterItemId;
var filterItemIdsDeeply = exports.filterItemIdsDeeply = function filterItemIdsDeeply(item, contextId, idSchemaId) {
	var tmpIdTree = getRelativeTmpIdTree(contextId, idSchemaId);

	var _walkFormDataWithIdTr = walkFormDataWithIdTree(item, tmpIdTree, filterItemId),
	    _walkFormDataWithIdTr2 = (0, _slicedToArray3.default)(_walkFormDataWithIdTr, 1),
	    _item = _walkFormDataWithIdTr2[0];

	return _item;
};

var formDataIsEmpty = exports.formDataIsEmpty = function formDataIsEmpty(props) {
	var tmpIdTree = getRelativeTmpIdTree(props.formContext.contextId, props.idSchema.$id);

	var _walkFormDataWithIdTr3 = walkFormDataWithIdTree(props.formData, tmpIdTree, filterItemId),
	    _walkFormDataWithIdTr4 = (0, _slicedToArray3.default)(_walkFormDataWithIdTr3, 1),
	    item = _walkFormDataWithIdTr4[0];

	return (0, _deepEqual2.default)(item, (0, _utils.getDefaultFormState)(props.schema, undefined, props.registry.definitions));
};

var formDataEquals = exports.formDataEquals = function formDataEquals(f1, f2, formContext, id) {
	var tmpIdTree = getRelativeTmpIdTree(formContext.contextId, id);
	return _deepEqual2.default.apply(undefined, (0, _toConsumableArray3.default)([f1, f2].map(function (i) {
		return walkFormDataWithIdTree(i, tmpIdTree, filterItemId)[0];
	})));
};

var uuid = 0;
var assignUUID = exports.assignUUID = function assignUUID(item) {
	var immutably = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

	if (isObject(item) && !item.id && !item._lajiFormId) {
		uuid++;
		if (immutably) {
			return (0, _extends3.default)({}, item, { _lajiFormId: uuid });
		} else {
			item._lajiFormId = uuid;
			return item;
		}
	}
	return item;
};

var getUUID = exports.getUUID = function getUUID(item) {
	return item ? item.id || item._lajiFormId : undefined;
};

function walkFormDataWithIdTree(_formData, tree, itemOperator) {
	var ids = {};
	var walk = function walk(_formData, tree) {
		if (!tree) return _formData;

		var _hasId = tree._hasId,
		    _tree = (0, _objectWithoutProperties3.default)(tree, ["_hasId"]);

		if (_hasId && isObject(_formData)) {
			_formData = itemOperator ? itemOperator(_formData) : _formData;
		}
		if ((0, _keys2.default)(_tree).length && isObject(_formData)) {
			return (0, _keys2.default)(_formData).reduce(function (f, k) {
				if (tree[k]) {
					f[k] = walk(_formData[k], tree[k], itemOperator);
				} else {
					f[k] = _formData[k];
				}
				return f;
			}, {});
		} else if (tree && Array.isArray(_formData)) {
			return _formData.map(function (item) {
				item = walk(item, tree, itemOperator);
				item = itemOperator ? itemOperator(item) : item;
				if (getUUID(item)) {
					ids[getUUID(item)] = true;
				}
				return item;
			});
		}
		return _formData;
	};
	var formData = walk(_formData, tree);
	return [formData, ids];
}

function addLajiFormIds(_formData, tree) {
	var immutably = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

	var itemOperator = function itemOperator(item) {
		return assignUUID(item, immutably);
	};
	return walkFormDataWithIdTree(_formData, tree, itemOperator);
}

function getAllLajiFormIdsDeeply(_formData, tree) {
	return walkFormDataWithIdTree(_formData, tree)[1];
}

function findPointerForLajiFormId() {
	var tmpIdTree = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var formData = arguments[1];
	var lajiFormId = arguments[2];

	if (formData && getUUID(formData) === lajiFormId) {
		return "";
	}
	var _iteratorNormalCompletion2 = true;
	var _didIteratorError2 = false;
	var _iteratorError2 = undefined;

	try {
		for (var _iterator2 = (0, _getIterator3.default)((0, _keys2.default)(tmpIdTree)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
			var k = _step2.value;

			if (isObject(formData[k])) {
				var find = findPointerForLajiFormId(tmpIdTree[k], formData[k], lajiFormId);
				if (find !== undefined || find === "") {
					return "/" + k + find;
				}
			} else if (Array.isArray(formData[k])) {
				for (var i in formData[k]) {
					var item = formData[k][i];
					var _find = findPointerForLajiFormId(tmpIdTree[k], item, lajiFormId);
					if (_find !== undefined || _find === "") {
						return "/" + k + "/" + i + _find;
					}
				}
			}
		}
	} catch (err) {
		_didIteratorError2 = true;
		_iteratorError2 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion2 && _iterator2.return) {
				_iterator2.return();
			}
		} finally {
			if (_didIteratorError2) {
				throw _iteratorError2;
			}
		}
	}
}

function getRelativePointer(tmpIdTree, formData, idSchemaId, lajiFormId) {
	var containerPointer = findPointerForLajiFormId(tmpIdTree, formData, lajiFormId);
	if (!containerPointer) {
		return;
	}
	var indicesCount = containerPointer.match(/\/[0-9]+/g).length;
	var containerPointerWithoutArrayIndices = containerPointer.replace(/[0-9]+/g, "");
	var thisPointer = idSchemaId.replace("root", "").replace(/_/g, "/");
	var thisPointerWithoutContainerIndices = thisPointer;
	for (var i = indicesCount; i > 0; i--) {
		thisPointerWithoutContainerIndices = thisPointerWithoutContainerIndices.replace(/[0-9]+/, "");
	}
	return thisPointerWithoutContainerIndices.replace(containerPointerWithoutArrayIndices, "");
}

function getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId(tmpIdTree, formData, idSchemaId, lajiFormId) {
	var relativePointer = getRelativePointer(tmpIdTree, formData, idSchemaId, lajiFormId);
	return getJSONPointerFromLajiFormIdAndRelativePointer(tmpIdTree, formData, lajiFormId, relativePointer);
}

function getJSONPointerFromLajiFormIdAndRelativePointer(tmpIdTree, formData, lajiFormId, relativePointer) {
	var containerPointer = findPointerForLajiFormId(tmpIdTree, formData, lajiFormId);
	if (!containerPointer) {
		return "";
	}
	return containerPointer + relativePointer;
}

function highlightElem(elem) {
	if (!elem) return;
	if (elem.className.indexOf(" highlight-error-fire") !== -1) elem.className = elem.className.replace(" highlight-error-fire", "");
	(0, _setImmediate3.default)(function () {
		return elem.className = elem.className + " highlight-error-fire";
	});
}

function getRelativeTmpIdTree(contextId, id) {
	var rootTmpIdTree = new _Context2.default(contextId).formInstance.tmpIdTree;

	var tmpIdTree = void 0;
	if (rootTmpIdTree) {
		tmpIdTree = rootTmpIdTree;
		var treePath = id.replace(/root|_[0-9]+|_/g, "_").split("_").filter(function (i) {
			return i;
		});
		var _iteratorNormalCompletion3 = true;
		var _didIteratorError3 = false;
		var _iteratorError3 = undefined;

		try {
			for (var _iterator3 = (0, _getIterator3.default)(treePath), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
				var k = _step3.value;

				if (tmpIdTree[k]) {
					tmpIdTree = tmpIdTree[k];
				} else {
					tmpIdTree = undefined;
					break;
				}
			}
		} catch (err) {
			_didIteratorError3 = true;
			_iteratorError3 = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion3 && _iterator3.return) {
					_iterator3.return();
				}
			} finally {
				if (_didIteratorError3) {
					throw _iteratorError3;
				}
			}
		}
	}
	return tmpIdTree;
}

function filteredErrors(errorSchema) {
	return (0, _keys2.default)(errorSchema).reduce(function (_errorSchema, prop) {
		if (prop === "__errors") {
			if (errorSchema.__errors.length) {
				_errorSchema.__errors = errorSchema.__errors;
			}
			return _errorSchema;
		}
		var errors = filteredErrors(errorSchema[prop]);
		if ((0, _keys2.default)(errors).length) {
			_errorSchema[prop] = errors;
		}
		return _errorSchema;
	}, {});
}
function constructTranslations(translations) {
	var dictionaries = {};
	for (var word in translations) {
		var _loop = function _loop(lang) {
			var translation = translations[word][lang];
			if (!dictionaries.hasOwnProperty(lang)) dictionaries[lang] = {};
			if (typeof translation === "string") {
				dictionaries[lang][word] = decapitalizeFirstLetter(translation);
				dictionaries[lang][capitalizeFirstLetter(word)] = capitalizeFirstLetter(translation);
			} else {
				// is a function
				dictionaries[lang][word] = function (s) {
					return decapitalizeFirstLetter(translation(s));
				};
				dictionaries[lang][capitalizeFirstLetter(word)] = function (s) {
					return capitalizeFirstLetter(translation(s));
				};
			}
		};

		for (var lang in translations[word]) {
			_loop(lang);
		}
	}
	return dictionaries;
}

function getIdxWithOffset(idx, offsets, totalOffset) {
	var offset = idx in (offsets || {}) ? (offsets || {})[idx] : totalOffset;
	return (offset || 0) + idx;
}

function getIdxWithoutOffset(idx, offsets, totalOffset) {
	var offset = "_" + idx in (offsets || {}) ? (offsets || {})["_" + idx] : totalOffset;
	return idx - (offset || 0);
}